function createRowFromMetadata(dstTableId,dstRowCount){
	var tblBody = document.getElementById(dstTableId).tBodies[0];
	var newRow = tblBody.insertRow(dstRowCount-1);
	setSerialNumber(newRow)
	var newCell=[];
	for(i = 0; i <columns.length; i++ ){
		newCell[i] = newRow.insertCell(i+1);
		newCell[i].innerHTML=renderField(columns[i]);
	}

	var actions=0;
	if (metatable.allowEdit==1) {
		newCell[columns.length+actions]=newRow.insertCell(columns.length+actions+1);
		newCell[columns.length+actions].innerHTML= setActionEditColumn();
		actions++;
	}
	if (metatable.allowDelete==1) {
		newCell[columns.length+actions]=newRow.insertCell(columns.length+actions+1);
		newCell[columns.length+actions].innerHTML=setActionDeleteColumn();
		actions++;
	}
	newCell[columns.length+actions]=newRow.insertCell(columns.length+actions+1);
	newCell[columns.length+actions].innerHTML=setModeAndErrorColumn();
	document.forms[0].rowSize.value="1";
	return newRow;
}

function setModeAndErrorColumn(){
	var html="";
	html+="<td class='tableTextCell' style='border:none'>";
	html+="<div style='display:none'> ";
	html+="<input id='Mode' name='Mode' type='text' value='Add' readOnly=undefined style='border:none'>";
	html+="<input id='Error' name='Error' type='text' value='' readOnly='readOnly' style='border:none'>";
	html+="</div>";
	html+="</td>";
	return html;
}

function setSerialNumber(newRow){
	var html="";
	newRow.setAttribute("id",1);
	newRow.setAttribute("class", "dataRow1_tableRow");
	var newCell0 = newRow.insertCell(0);
	newCell0.innerHTML=constructNumericCellColumn();
}

function constructNumericCellColumn(){
	var html="<td class='imageTableCell' style='border-right:none;border-left:1px;border-left-style:solid;border-left-color:#E0E2E5;'>1</td>";
	return html;
}

function setActionColumn_obs(){
	var html="";
	if (metatable.allowDelete==1|| metatable.allowEdit==1){
		html="<td class='imageTableCell'";
		html+="style='border-right:none;border-left:1px;border-left-style:solid;border-left-color:#E0E2E5;'>";

		if(metatable.allowEdit==1){
//			html+="<img src='admin/images/edit.gif' ALT='Edit' onclick=\"editColumn(this, 'availableTable');\">";
			html+="<span class=\"sapUiBtnIco sapUiBtnIcoL sapUiIcon\" style=\"font-family: sas-icons; cursor: pointer\" data-sap-ui-icon-content=\"&#xf201;\" onclick=\"editColumn(this, 'availableTable');\"></span>";
		}
		if(metatable.allowDelete==1){
			html+="<span id='tooltip' style='display:none;position:absolute;padding:1px;border:1px solid #333333;;background-color:#fffedf;font-size:smaller;'></span>";
			html+="<input type='checkBox' name='Delete' onmousemove='showTooltip(this);' onmouseout='hideTooltip(this);' onclick=\"deleteRow(this, 'availableTable')\">";
			html+="</td>";
		}else {
			html+="<td class='imageTableCell' style='border:none'></td>";
		}
	}
	return html;
}


function setActionEditColumn(){
	var html="";
	if (metatable.allowEdit==1){
		html="<td class='imageTableCell'";
		html+="style='border-right:none;border-left:1px;border-left-style:solid;border-left-color:#E0E2E5;'>";

		html+="<span class=\"sapUiBtnIco sapUiBtnIcoL sapUiIcon\" style=\"font-family: sas-icons; cursor: pointer\" data-sap-ui-icon-content=\"&#xf201;\" onclick=\"editColumn(this, 'availableTable');\"></span>";
		html+="</td>";
	}
	return html;
}
function setActionDeleteColumn(){
	var html="";
	if(metatable.allowDelete==1){
		html="<td class='imageTableCell'";
		html+="style='border-right:none;border-left:1px;border-left-style:solid;border-left-color:#E0E2E5;'>";

		html+="<span id='tooltip' style='display:none;position:absolute;padding:1px;border:1px solid #333333;;background-color:#fffedf;font-size:smaller;'></span>";
		html+="<input type='checkBox' name='Delete' onmousemove='showTooltip(this);' onmouseout='hideTooltip(this);' onclick=\"deleteRow(this, 'availableTable')\">";
		html+="</td>";
	}
	return html;
}

function renderField(currentColumn){
	var html="";
	if(currentColumn.displayType.toUpperCase().indexOf('INPUT')!=-1) html=renderTextField(currentColumn);
	else if(currentColumn.displayType=='TEXTAREA') html=renderTextAreaField(currentColumn);
	else if(currentColumn.displayType=='SELECT') html=renderDropDownField(currentColumn);
	else if(currentColumn.displayType=='LABEL')html=renderLabelField(currentColumn);
	return html;
}

function renderTextField(currentColumn){
	var html="";
	html=setColumnStyle(currentColumn.visible);
	html+=startHiddenColumn(currentColumn.visible);
	html+=constructTextTag(currentColumn, false);
	html+=endHiddenColumn(currentColumn);
	return html;
}

function renderTextAreaField(currentColumn){
	var html="";
	html=setColumnStyle(currentColumn.visible);
	html+=startHiddenColumn(currentColumn.visible);
	html+=constructTextAreaTag(currentColumn, false);
	html+=endHiddenColumn(currentColumn);
	return html;
}

function renderDropDownField(currentColumn){
	var html="";
	html=setColumnStyle(currentColumn.visible);
	html+=startHiddenColumn(currentColumn.visible);
	html+=constructSelectTag(currentColumn, false);
	html+=endHiddenColumn(currentColumn);
	return html;
}

function renderLabelField(currentColumn){
	var html="";
	html=setColumnStyle(currentColumn.visible);
	html+=startHiddenColumn(currentColumn.visible);
	html+=constructTextTag(currentColumn);
	html+=endHiddenColumn(currentColumn);
	return html;
}

function setColumnStyle(visible){
	var html;
	if(visible){
		html="<td class='textCell' style='border:none' >";
	}
	else{
		html="<td class='textCell' style='border-right:none;border-left:1px;border-left-style:solid;border-left-color:#E0E2E5;'>";
	}
	return html;
}

function startHiddenColumn(visible){
	var html="";
	if(!visible){
		html="<div style='display:none'>";
	}
	return html;
}

function constructTextTag(currentColumn, useDisplayName){
	var maxLength=currentColumn.maxLength>50?50:currentColumn.maxLength;
	var html="<input class='textCell1' id='"+currentColumn.type+"' name='";
	if(useDisplayName) html+=currentColumn.displayName;
	else html+=currentColumn.name;
	html+="' type='text' value='' size='"+maxLength+ "' maxlength='"+maxLength+"'";
	if(currentColumn.isRequired && currentColumn.visible){
		html+=" required='true' ";
	}
	else{
		html+=" required='false' ";
	}
	if (currentColumn.displayType.toUpperCase().indexOf('AUTO')!=-1) {
		html+=" auto='true' ";
	}
	html+="style='border:none'>";
	return html;
}

function constructTextAreaTag(currentColumn, useDisplayName){
	var html="";
	html="<TEXTAREA id='"+ currentColumn.type.toLowerCase()+"' ";
	html+="class='textCell1' name='";
	if(useDisplayName) html+=currentColumn.displayName;
	else html+=currentColumn.name;
	html+="'  value='' readonly=undefined ROWS='3' COLS='20' style='border:none' onKeyDown='limitChars(this,"+ currentColumn.maxLength + ");' onKeyUp='limitChars(this,"+ currentColumn.maxLength + ",true);'></textarea>";
	return html;
}


function constructLabelTag(currentColumn){
	var html="";
	html="<td id='"+currentColumn.type.toLowerCase()+"' class='textCell1' name='"+currentColumn.name+"' style='border:none'>";
	return html;
}

function constructSelectTag(currentColumn,useDisplayName){
	var html="";
	html="<select id='"+currentColumn.type.toLowerCase()+"' class='textCell1' name='";
	if(useDisplayName) html+=currentColumn.displayName;
	else html+=currentColumn.name;
	html+="' style='border:none' onChange='enableDropDownText(this)'>";
	var options = eval(currentColumn.name+'lovs');
	if (Array.isArray(options))
	{
		for (cnt = 0; cnt < options.length; cnt++) {
			html="<option value='"+options[cnt].codeValue+"'>"+options[cnt].code+"</option>";
		}
	}
	html+="</select>";
	return html;
}

function getType(type) {
	if (type.toUpperCase()=="INTEGER"|| type.toUpperCase()=="SMALLINT") {
		type = "int";
	} else if (type.toUpperCase()=="VARCHAR"
			|| type.toUpperCase()=="CHARACTER"
			|| type.toUpperCase()=="BIGINT") {
		type = "str";
	} else if (type.toUpperCase()=="DATE") {
		type = "date";
	} else if (type.toUpperCase()=="TIMESTAMP") {
		type = "datetime";
	} else if (type.toUpperCase()=="BIGINT") {
		type = "long";
	}

	return type;
}

function endHiddenColumn(currentColumn){
	var html="";
	if (currentColumn.visible!=1) {
		html="</div>";
	}
	return html;
}
function resetInterface(){
//	document.getElementById("saveButton").disabled=true;
	document.getElementById("noRecordsMsg").innerHTML=$i18n("fcm.loaders.noRecordsFound.txt");
}