<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>

	<!-- ********************************** Begin Alert Info *********************************** -->
	<c:if test="${not empty displayEntity.systemBlock1.label && displayEntity.systemBlock1.label != ' '}">
		<c:set var="primaryBlockClassStr" value="class='primaryBlock'" />
	</c:if>
	<c:if test="${not empty displayEntity.systemBlock2.label && displayEntity.systemBlock2.label != ' '}">
		<c:set var="secondaryBlockClassStr" value="class='secondaryBlock'" />
	</c:if>
	<c:if test="${not empty displayEntity.transactionBlock.label && displayEntity.transactionBlock.label != ''}">
		<c:set var="transactionBlockClassStr" value="class='transactionBlock'" />
	</c:if>

<div id="entityGrid" style="border: 0px none;">

	<table class="mainTable minWidthTableX" border="0" cellspacing="0" cellpadding="2">
		<tbody>
		<%-- do not display alert information for entity view --%>
		<c:choose>
			<c:when test="${displayType == 'viewEntity'}">
				<tr class="dataRow2_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.transactionBlock.txt"/>:</td>
					<td style="white-space: nowrap" style="padding:0px"><span ${transactionBlockClassStr}>${esapi:encodeForHTML(displayEntity.transactionBlock.label)}</span></td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.transactionBlock.creationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}"/></esapi:encodeForHTML></td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.expiration.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell lastCol"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.transactionBlock.expirationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
				</tr>
				<tr class="dataRow1_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.systemBlock1.txt"/>:</td>
					<td style="white-space: nowrap" style="padding:0px"><span ${primaryBlockClassStr}>${esapi:encodeForHTML(displayEntity.systemBlock1.label)}</span></td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.systemBlock1.creationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.expiration.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell lastCol"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.systemBlock1.expirationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
				</tr>
				<tr class="dataRow2_tableRow">
					<td style="white-space: nowrap" ><fmt:message key="fcm.alert.systemBlock2.txt"/>:</td>
					<td style="white-space: nowrap" style="padding:0px"><span ${secondaryBlockClassStr}>${esapi:encodeForHTML(displayEntity.systemBlock2.label)}</span></td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.systemBlock2.creationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.expiration.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell lastCol"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.systemBlock2.expirationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
				</tr>
				<tr class="dataRow1_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.blockGroupAssigner.txt"/>:</td>
					<td style="white-space: nowrap" style="padding: 0px" ><span >${esapi:encodeForHTML(displayEntity.blockGroupCode)}</span></td>
					<td style="white-space: nowrap" class="textTableCell">&nbsp;</td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.multiOrg.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell lastCol">
					<c:choose>
						<c:when test="${(callCenterType eq 'P') or (displayEntity.tenantType eq 'P') or (displayEntity.tenantOrgNodeId eq displayEntity.orgNodeId)}">${esapi:encodeForHTML(displayEntity.orgNodeLabel)}</c:when>
						<c:otherwise>${esapi:encodeForHTML(displayEntity.tenantOrgNodeLabel)} : ${esapi:encodeForHTML(displayEntity.orgNodeLabel )}</c:otherwise>
					</c:choose>
					</td>
				</tr>
				<tr class="dataRow2_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.contactEntity.txt"/>:</td>
					<td style="white-space: nowrap" style="padding: 0px" >
						<c:if test="${not empty displayEntity.contactID and displayEntity.contactID ne displayEntity.entityID and displayEntity.contactType ne displayEntity.entityType}">
							<img src="<esapi:encodeForHTMLAttribute><fmt:message key="${displayEntity.contactType}" bundle="${alertTypeImageResourceBundle}"/></esapi:encodeForHTMLAttribute>" alt="<esapi:encodeForHTMLAttribute><fmt:message key="${displayEntity.contactType}" bundle="${alertTypeLabelResourceBundle}"/></esapi:encodeForHTMLAttribute>" class="icon" width="16" height="16"/>
							<a href="#" onclick="$('#nav_contact').click();"> <sfmmsk:maskData value="${displayEntity.contactID}" maskType="ID" /></a>
						</c:if> &nbsp;
					</td>
					<td style="white-space: nowrap" class="textTableCell">&nbsp;</td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.parentEntity.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell">
						<c:if test="${not empty displayEntity.parentEntityID}">
							<img src="<esapi:encodeForHTMLAttribute><fmt:message key="${displayEntity.parentEntityType}" bundle="${alertTypeImageResourceBundle}"/></esapi:encodeForHTMLAttribute>" alt="<esapi:encodeForHTMLAttribute><fmt:message key="${displayEntity.entityType}" bundle="${alertTypeLabelResourceBundle}"/></esapi:encodeForHTMLAttribute>" class="icon" width="16" height="16"/>
							<a href="#" onclick="$('#nav_parent').click();"> <sfmmsk:maskData value="${displayEntity.parentEntityID}" maskType="ID" /></a>
						</c:if> &nbsp;
					</td>
				</tr>
				<tr class="dataRow1_tableRow">
					<td style="white-space: nowrap">&nbsp;</td>
					<td style="white-space: nowrap">&nbsp;</td>
					<td style="white-space: nowrap" class="textTableCell">&nbsp;</td>
					<td style="white-space: nowrap">&nbsp;</td>
					<td style="white-space: nowrap" class="textTableCell lastCol">&nbsp;</td>
				</tr>
			</c:when>
			<c:otherwise>
				<tr class="dataRow2_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.transactionBlock.txt"/>:</td>
					<td style="white-space: nowrap" style="padding:0px"><span ${transactionBlockClassStr}>${esapi:encodeForHTML(displayEntity.transactionBlock.label)}</span></td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.transactionBlock.creationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.expiration.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.transactionBlock.expirationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
					<c:choose>
						<c:when test="${changedStrategy=='true'}">
							<td style="white-space: nowrap" style="color:#E00"><fmt:message key="fcm.alert.strategy.txt"/>***: (<fmt:message key="fcm.alert.changed.txt"/>)</td>
							<td class="textTableCell lastCol" color="red">${esapi:encodeForHTML(displayEntity.currentAlert.strategyDescription)}</td>
						</c:when>
						<c:otherwise>
							<td style="white-space: nowrap"><fmt:message key="fcm.alert.strategy.txt"/>:</td>
							<td class="textTableCell lastCol">${esapi:encodeForHTML(displayEntity.currentAlert.strategyDescription)}</td>
						</c:otherwise>
					</c:choose>
				</tr>
				<tr class="dataRow1_tableRow">
					<td><fmt:message key="fcm.alert.systemBlock1.txt"/>:</td>
					<td style="white-space: nowrap" style="padding:0px"><span ${primaryBlockClassStr}>${esapi:encodeForHTML(displayEntity.systemBlock1.label)}</span></td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.systemBlock1.creationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.expiration.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.systemBlock1.expirationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.queue.txt"/></td>
					<td class="textTableCell lastCol">${esapi:encodeForHTML(displayEntity.currentAlert.queue.name)}</td>
				</tr>
				<tr class="dataRow2_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.systemBlock2.txt"/>:</td>
					<td style="white-space: nowrap" style="padding:0px"><span ${secondaryBlockClassStr}>${esapi:encodeForHTML(displayEntity.systemBlock2.label)}</span></td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.systemBlock2.creationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.expiration.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.systemBlock2.expirationDateTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.alertId.txt"/>:</td>
					<td class="textTableCell lastCol">${displayEntity.currentAlert.id}</td>
				</tr>
				<tr class="dataRow1_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.blockGroupAssigner.txt"/>:</td>
					<td style="padding: 0px" >${esapi:encodeForHTML(displayEntity.blockGroupCode)}</td>
					<td class="textTableCell">&nbsp;</td>
					<td style="white-space: nowrap" ><fmt:message key="fcm.alert.multiOrg.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell">
					<c:choose>
						<c:when test="${(callCenterType eq 'P') or (displayEntity.currentAlert.tenantType eq 'P') or (displayEntity.currentAlert.tenantOrgNodeId eq displayEntity.currentAlert.orgNodeId)}">${esapi:encodeForHTML(displayEntity.currentAlert.orgNodeLabel)}</c:when>
						<c:otherwise>${esapi:encodeForHTML(displayEntity.currentAlert.tenantOrgNodeLabel)} : ${esapi:encodeForHTML(displayEntity.currentAlert.orgNodeLabel )}</c:otherwise>
					</c:choose>
					</td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.alertCreation.txt"/>:</td>
					<td class="textTableCell lastCol"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.currentAlert.creationTime}" pattern="${dateTimeFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
				</tr>
				<tr class="dataRow2_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.contactEntity.txt"/>:</td>
					<td style="padding: 0px" >
						<c:if test="${not empty displayEntity.contactID and displayEntity.contactID ne displayEntity.entityID and displayEntity.contactType ne displayEntity.entityType}">
							<img src="<esapi:encodeForHTMLAttribute><fmt:message key="${displayEntity.contactType}" bundle="${alertTypeImageResourceBundle}"/></esapi:encodeForHTMLAttribute>" alt="<esapi:encodeForHTMLAttribute><fmt:message key="${displayEntity.contactType}" bundle="${alertTypeLabelResourceBundle}"/></esapi:encodeForHTMLAttribute>" class="icon" width="16" height="16"/>
							<a href="#" onclick="$('#nav_contact').click();"> <sfmmsk:maskData value="${displayEntity.contactID}" maskType="ID" /></a>
						</c:if> &nbsp;
					</td>
					<td class="textTableCell">&nbsp;</td>
					<td style="white-space: nowrap" ><fmt:message key="fcm.alert.parentEntity.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell">
						<c:if test="${not empty displayEntity.parentEntityID}">
							<img src="<esapi:encodeForHTMLAttribute><fmt:message key="${displayEntity.parentEntityType}" bundle="${alertTypeImageResourceBundle}"/></esapi:encodeForHTMLAttribute>" alt="<esapi:encodeForHTMLAttribute><fmt:message key="${displayEntity.entityType}" bundle="${alertTypeLabelResourceBundle}"/></esapi:encodeForHTMLAttribute>" class="icon" width="16" height="16"/>
							<a href="#" onclick="$('#nav_parent').click();"> <sfmmsk:maskData value="${displayEntity.parentEntityID}" maskType="ID" /></a>
						</c:if> &nbsp;
					</td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.lastAction.txt"/>:</td>
					<td class="textTableCell lastCol"><esapi:encodeForHTML><fmt:formatDate value="${displayEntity.currentAlert.lastService}" pattern="${dateFormat}" timeZone="${userTimeZone}" /></esapi:encodeForHTML></td>
				</tr>
				<tr class="dataRow1_tableRow">
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.alertReason.txt"/>:</td>
					<td style="white-space: nowrap" class="textTableCell" colspan="4">${esapi:encodeForHTML(displayEntity.currentAlert.alertReason)}</td>
					<td style="white-space: nowrap"><fmt:message key="fcm.alert.alertStatus.txt"/>:</td>
					<td class="textTableCell lastCol"><sfmfmt:formatAlertStatus value="${displayEntity.currentAlert}"/></td>
				</tr>
			</c:otherwise>
		</c:choose>
		</tbody>
	</table>
</div>
	<%-- ********************************** End Alert Info *********************************** --%>
