<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>
<c:set var="VALID_PHONE_TYPES" value="H W M C B"/>

<%-- begin contact grid --%>
<div id="contactGrid"  style="display:none; border: 0px none; overflow-x: hidden; overflow-y: auto;">

<table class="mainTable minWidthTableX" border="0" cellspacing="2" cellpadding="0" style="border-top:none; background-color:#f0f1f2">
<tbody>
	<tr>
		<td style="vertical-align:top; width:25%; white-space:nowrap; border-top:none; padding:1px 2px;">
			<c:if test="${not empty contactDetails.businessName and contactDetails.businessName.notEmpty}">
				<sfmfmt:formatDetail detail="${contactDetails.businessName}" /><br/>
			</c:if>
			<sfmfmt:formatDetail detail="${contactDetails.fullName}" /><br/>
		</td>
		<td style="vertical-align:top; width:25%; border-top:none; padding:1px 2px;">
			<sfmfmt:formatDetail detail="${contactDetails.addressLine1}" />
			<c:if test="${not empty contactDetails.addressLine2 and contactDetails.addressLine2.notEmpty}"><br/><sfmfmt:formatDetail detail="${contactDetails.addressLine2}" /></c:if>
			<c:if test="${not empty contactDetails.addressLine3 and contactDetails.addressLine3.notEmpty}"><br/><sfmfmt:formatDetail detail="${contactDetails.addressLine3}" /></c:if>
			<c:if test="${not empty contactDetails.addressLine4 and contactDetails.addressLine4.notEmpty}"><br/><sfmfmt:formatDetail detail="${contactDetails.addressLine4}" /></c:if>
			<br/><sfmfmt:formatDetail detail="${contactDetails.city}" /><c:if test="${not empty contactDetails.stateProvinceName and contactDetails.stateProvinceName.notEmpty || not empty contactDetails.postalCode and contactDetails.postalCode.notEmpty}">, <sfmfmt:formatDetail detail="${contactDetails.stateProvinceName}" /> <sfmfmt:formatDetail detail="${contactDetails.postalCode}" /></c:if>
			<c:if test="${not empty contactDetails.country and contactDetails.country.notEmpty}"><br/><sfmfmt:formatDetail detail="${contactDetails.country}" /></c:if>
			<c:if test="${not empty contactDetails.addressLastUpdateDate}"><br/>
				<span class="lastUpdate" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.lastUpdateDate.txt"/></esapi:encodeForHTMLAttribute>">
				[<sfmfmt:formatDetail detail="${contactDetails.addressLastUpdateDate}" timeZone="${userTimeZone}" />]</span>
			</c:if>
		</td>
		<td style="vertical-align:top; width:25%; padding:1px; border-top:none;">
			<table border="0" cellspacing="0" cellpadding="0" style="padding:1px; width:100%; line-height:90%;">
		<c:choose>
			<c:when test="${not empty contactDetails.homePhone1 and contactDetails.homePhone1.notEmpty}">
				<tr>
					<td><fmt:message key="fcm.alert.home.txt"/>:</td>
					<td><sfmfmt:formatDetail detail="${contactDetails.homePhone1}" />
						<c:if test="${not empty contactDetails.homePhone1LastUpdateDate}">
						<span class="lastUpdate" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.lastUpdateDate.txt"/></esapi:encodeForHTMLAttribute>">
						[<sfmfmt:formatDetail detail="${contactDetails.homePhone1LastUpdateDate}" timeZone="${userTimeZone}" />]</span>
						</c:if>
					</td>
				</tr>
			</c:when>
			<c:otherwise>
				<c:if test="${not empty contactDetails.phone1 and contactDetails.phone1.notEmpty}">
					<c:set var="phoneTypeLabel">
						<fmt:message key="fcm.alert.phoneType.fmt.txt"><fmt:param>(${contactDetails.phone1Type.value})</fmt:param></fmt:message>
					</c:set>
					<c:if test="${not empty contactDetails.phone1Type and contactDetails.phone1Type.notEmpty and fn:indexOf(VALID_PHONE_TYPES, contactDetails.phone1Type.value) > -1}">
						<c:set var="phoneTypeLabel">
							<fmt:message key="fcm.alert.phoneType${contactDetails.phone1Type.value}.txt"/>
						</c:set>
					</c:if>
					<tr>
						<td>${phoneTypeLabel}:</td>
						<td><sfmfmt:formatDetail detail="${contactDetails.phone1}" /></td>
					</tr>
				</c:if>
			</c:otherwise>
		</c:choose>
		<c:choose>
			<c:when test="${not empty contactDetails.homePhone2 and contactDetails.homePhone2.notEmpty}">
				<tr>
					<td><fmt:message key="fcm.alert.home2.txt"/>:</td>
					<td><sfmfmt:formatDetail detail="${contactDetails.homePhone2}" />
						<c:if test="${not empty contactDetails.homePhone2LastUpdateDate}">
						<span class="lastUpdate" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.lastUpdateDate.txt"/></esapi:encodeForHTMLAttribute>">
						[<sfmfmt:formatDetail detail="${contactDetails.homePhone2LastUpdateDate}" timeZone="${userTimeZone}" />]</span>
						</c:if>
					</td>
				</tr>
			</c:when>
			<c:otherwise>
				<c:if test="${not empty contactDetails.phone2 and contactDetails.phone2.notEmpty}">
					<c:set var="phoneTypeLabel">
						<fmt:message key="fcm.alert.phoneType.fmt.txt"><fmt:param>(${contactDetails.phone2Type.value})</fmt:param></fmt:message>
					</c:set>
					<c:if test="${not empty contactDetails.phone2Type and contactDetails.phone2Type.notEmpty and fn:indexOf(VALID_PHONE_TYPES, contactDetails.phone2Type.value) > -1}">
						<c:set var="phoneTypeLabel">
							<fmt:message key="fcm.alert.phoneType${contactDetails.phone2Type.value}.txt"/>
						</c:set>
					</c:if>
					<tr>
						<td>${phoneTypeLabel}:</td>
						<td><sfmfmt:formatDetail detail="${contactDetails.phone2}" /></td>
					</tr>
				</c:if>
			</c:otherwise>
		</c:choose>
		<c:choose>
			<c:when test="${not empty contactDetails.workPhone1 and contactDetails.workPhone1.notEmpty}">
				<tr>
					<td><fmt:message key="fcm.alert.work.txt"/>:</td>
					<td><sfmfmt:formatDetail detail="${contactDetails.workPhone1}" />
						<c:if test="${not empty contactDetails.workPhone1LastUpdateDate}">
						<span class="lastUpdate" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.lastUpdateDate.txt"/></esapi:encodeForHTMLAttribute>">
						[<sfmfmt:formatDetail detail="${contactDetails.workPhone1LastUpdateDate}" timeZone="${userTimeZone}" />]</span>
						</c:if>
					</td>
				</tr>
			</c:when>
			<c:otherwise>
				<c:if test="${not empty contactDetails.phone3 and contactDetails.phone3.notEmpty}">
					<c:set var="phoneTypeLabel">
						<fmt:message key="fcm.alert.phoneType.fmt.txt"><fmt:param>(${contactDetails.phone3Type.value})</fmt:param></fmt:message>
					</c:set>
					<c:if test="${not empty contactDetails.phone3Type and contactDetails.phone3Type.notEmpty and fn:indexOf(VALID_PHONE_TYPES, contactDetails.phone3Type.value) > -1}">
						<c:set var="phoneTypeLabel">
							<fmt:message key="fcm.alert.phoneType${contactDetails.phone3Type.value}.txt"/>
						</c:set>
					</c:if>
					<tr>
						<td>${phoneTypeLabel}:</td>
						<td><sfmfmt:formatDetail detail="${contactDetails.phone3}" /></td>
					</tr>
				</c:if>
			</c:otherwise>
		</c:choose>
		<c:choose>
			<c:when test="${not empty contactDetails.workPhone2 and contactDetails.workPhone2.notEmpty}">
				<tr>
					<td><fmt:message key="fcm.alert.work2.txt"/>:</td>
					<td><sfmfmt:formatDetail detail="${contactDetails.workPhone2}" />
						<c:if test="${not empty contactDetails.workPhone2LastUpdateDate}">
						<span class="lastUpdate" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.lastUpdateDate.txt"/></esapi:encodeForHTMLAttribute>">
						[<sfmfmt:formatDetail detail="${contactDetails.workPhone2LastUpdateDate}" timeZone="${userTimeZone}" />]</span>
						</c:if>
					</td>
				</tr>
			</c:when>
			<c:otherwise>
				<c:if test="${not empty contactDetails.phone4 and contactDetails.phone4.notEmpty}">
					<c:set var="phoneTypeLabel">
						<fmt:message key="fcm.alert.phoneType.fmt.txt"><fmt:param>(${contactDetails.phone4Type.value})</fmt:param></fmt:message>
					</c:set>
					<c:if test="${not empty contactDetails.phone4Type and contactDetails.phone4Type.notEmpty and fn:indexOf(VALID_PHONE_TYPES, contactDetails.phone4Type.value) > -1}">
						<c:set var="phoneTypeLabel">
							<fmt:message key="fcm.alert.phoneType${contactDetails.phone4Type.value}.txt"/>
						</c:set>
					</c:if>
					<tr>
						<td>${phoneTypeLabel}:</td>
						<td><sfmfmt:formatDetail detail="${contactDetails.phone4}" /></td>
					</tr>
				</c:if>
			</c:otherwise>
		</c:choose>
		<c:choose>
			<c:when test="${not empty contactDetails.mobilePhone1 and contactDetails.mobilePhone1.notEmpty}">
				<tr>
					<td><fmt:message key="fcm.alert.mobile.txt"/>:</td>
					<td><sfmfmt:formatDetail detail="${contactDetails.mobilePhone1}" />
						<c:if test="${not empty contactDetails.mobilePhone1LastUpdateDate}">
						<span class="lastUpdate" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.lastUpdateDate.txt"/></esapi:encodeForHTMLAttribute>">
						[<sfmfmt:formatDetail detail="${contactDetails.mobilePhone1LastUpdateDate}" timeZone="${userTimeZone}" />]</span>
						</c:if>
					</td>
				</tr>
			</c:when>
			<c:otherwise>
				<c:if test="${not empty contactDetails.phone5 and contactDetails.phone5.notEmpty}">
					<c:set var="phoneTypeLabel">
						<fmt:message key="fcm.alert.phoneType.fmt.txt"><fmt:param>(${contactDetails.phone5Type.value})</fmt:param></fmt:message>
					</c:set>
					<c:if test="${not empty contactDetails.phone5Type and contactDetails.phone5Type.notEmpty and fn:indexOf(VALID_PHONE_TYPES, contactDetails.phone5Type.value) > -1}">
						<c:set var="phoneTypeLabel">
							<fmt:message key="fcm.alert.phoneType${contactDetails.phone5Type.value}.txt"/>
						</c:set>
					</c:if>
					<tr>
						<td>${phoneTypeLabel}:</td>
						<td><sfmfmt:formatDetail detail="${contactDetails.phone5}" /></td>
					</tr>
				</c:if>
			</c:otherwise>
		</c:choose>
		<c:choose>
			<c:when test="${not empty contactDetails.mobilePhone2 and contactDetails.mobilePhone2.notEmpty}">
				<tr>
					<td><fmt:message key="fcm.alert.mobile2.txt"/>:</td>
					<td><sfmfmt:formatDetail detail="${contactDetails.mobilePhone2}" />
						<c:if test="${not empty contactDetails.mobilePhone2LastUpdateDate}">
						<span class="lastUpdate" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.lastUpdateDate.txt"/></esapi:encodeForHTMLAttribute>">
						[<sfmfmt:formatDetail detail="${contactDetails.mobilePhone2LastUpdateDate}" timeZone="${userTimeZone}" />]</span>
						</c:if>
					</td>
				</tr>
			</c:when>
			<c:otherwise>
				<c:if test="${not empty contactDetails.phone6 and contactDetails.phone6.notEmpty}">
					<c:set var="phoneTypeLabel">
						<fmt:message key="fcm.alert.phoneType.fmt.txt"><fmt:param>(${contactDetails.phone6Type.value})</fmt:param></fmt:message>
					</c:set>
					<c:if test="${not empty contactDetails.phone6Type and contactDetails.phone6Type.notEmpty and fn:indexOf(VALID_PHONE_TYPES, contactDetails.phone6Type.value) > -1}">
						<c:set var="phoneTypeLabel">
							<fmt:message key="fcm.alert.phoneType${contactDetails.phone6Type.value}.txt"/>
						</c:set>
					</c:if>
					<tr>
						<td>${phoneTypeLabel}:</td>
						<td><sfmfmt:formatDetail detail="${contactDetails.phone6}" /></td>
					</tr>
				</c:if>
			</c:otherwise>
		</c:choose>
		</table>
		</td>
		<td style="vertical-align:top; width:25%; padding:1px; border-top:none;">
			<table border="0" cellspacing="0" cellpadding="0" style="padding:1px; width:100%; line-height:90%;">
				<tr>
					<td><fmt:message key="fcm.alert.language.txt"/>:</td>
					<td><sfmfmt:formatDetail detail="${contactDetails.languageCode}"  /></td>
				</tr>
				<tr>
					<td><fmt:message key="fcm.alert.email.txt"/>:</td>
					<td><sfmfmt:formatDetail detail="${contactDetails.email}"  />
					<c:if test="${not empty contactDetails.emailLastUpdateDate}">
						<br/><span class="lastUpdate" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.lastUpdateDate.txt"/></esapi:encodeForHTMLAttribute>">
						[<sfmfmt:formatDetail detail="${contactDetails.emailLastUpdateDate}" timeZone="${userTimeZone}" />]</span>
					</c:if>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</tbody>
</table>
</div>

<script type="text/javascript">
	$(document).ready(function(){
		if ($("#contactGrid").height() > refSize.height)
		{
			$("#contactGrid").height(refSize.height);
		}
	});
</script>
