var alertActionSelected=false;

sap.ui.jsview("sas.fscf.views.Actions", {

    getControllerName: function () {
        return "sas.fscf.views.Actions";
    },

    createContent: function(oController) {
    	var _this = this;

    	this.addStyleClass("cfActionsView");

    	jQuery.sap.require("sas.hc.m.CheckBox");
    	jQuery.sap.require("sas.hc.m.Button");

    	var actionsLabel = new sas.hc.ui.commons.Label({
		id: this.sId + "actionsLabel",
		text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.actions.Alert.txt"),
		required:false
    	});

        var alertActionCheckBox = new sap.ui.commons.CheckBox({
    	   id: this.sId + "alertActionCheckBox",
    	   text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.actions.CreateAnAlert.txt"),
    	   checked: false,
    	   //enabled: false
     	});

        alertActionCheckBox.attachChange(function(oEvent){
        	if(this.getChecked()){//create alert checked
        		if(sap.ui.getCore().byId(_this.sId + "configureButton1").getEnabled()==false){
	        		this.setValueState(sap.ui.core.ValueState.None);
		        	sap.ui.getCore().byId(_this.sId + "configureButton1").setIcon("sap-icon://hc/configuration");
		        	sap.ui.getCore().byId(_this.sId + "configureButton1").setEnabled(true);
        		}
	        	sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.push({id:50101});
        	}else{//create alert not checked
        		this.setValueState(sap.ui.core.ValueState.None);
        		//remove create alert from thenActions
	        	for(i=0;i<sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.length;i++){
        			if(sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions[i].id==50101){
        				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.splice(i, 1);
        			}
        		}
        		//if decision was "Hold" then keep alert configuration
        		var decision=sap.ui.getCore().byId(_this.sId+"decisionSelect");
        		if(decision.getSelectedKey()==''){
        			sap.ui.getCore().byId(_this.sId + "configureButton1").setIcon("sap-icon://hc/configuration");
        			sap.ui.getCore().byId(_this.sId + "configureButton1").setEnabled(false);
        			sas.fscf.getCurrentPageView().jsonRule.queueId=null;
    	        	sas.fscf.getCurrentPageView().jsonRule.alertTypeId=null;
    	        	sas.fscf.getCurrentPageView().jsonRule.alertReason=null;
        		}else{
	        		if (decision.getModel().getData().items) {
		            	for (var i = 0; i < decision.getModel().getData().items.length; i++) {
		            		if (decision.getModel().getData().items[i].id == decision.getSelectedKey()) {
		            			if(decision.getModel().getData().items[i].alertAction==false){// not "Hold" 
			            			sap.ui.getCore().byId(_this.sId + "configureButton1").setIcon("sap-icon://hc/configuration");
			            			sap.ui.getCore().byId(_this.sId + "configureButton1").setEnabled(false);
			            			sas.fscf.getCurrentPageView().jsonRule.queueId=null;
			        	        	sas.fscf.getCurrentPageView().jsonRule.alertTypeId=null;
			        	        	sas.fscf.getCurrentPageView().jsonRule.alertReason=null;
			            		}
		            		}
		            	}
		        	}
        		}
        	}
        sas.fscf.getCurrentPageView().setDirty(true);
        });

        var configureButton1 =  new sas.hc.m.Button({
        id: this.sId + "configureButton1",
	    icon : "sap-icon://hc/configuration",
	    enabled:false,
	    press: function(){_this.getActionConfiguration().open();}
        });
        this.getButtonSettings();
        this.getAlertActionSelection();
        var decisionsLabel = new sas.hc.ui.commons.Label({
    	id: this.sId + "decisionsLabel",
    	text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.actions.Decision.txt"),
    	required:false ,

        });

        var decisionOptions=this.getDecisionSelect();

        var oHLayout_alert = new sas.hc.ui.commons.layout.HorizontalLayout({
    	    id: this.sId + "HorizLayout_alert",
    		content: [
    		          alertActionCheckBox,
    		          configureButton1
    		]
    	});
        oHLayout_alert.addStyleClass("cfAlertHorizLayout");

         var aContent = [
                          actionsLabel,
                          oHLayout_alert,
                          decisionsLabel,
                          decisionOptions
         ];

    	ruleGuidedFormGrid2 =new sas.hc.ui.commons.layout.VerticalLayout({
    		width:"100%",
            content: aContent
        });

        return ruleGuidedFormGrid2;
    },

    getDecisionSelect: function(){
    	jQuery.sap.require("sap.ui.model.Sorter");
    	jQuery.sap.require("sas.hc.m.Select");
    	var alertCreationEnabled=true;

		var _this = this;
    	var decisionSelect = new  sas.hc.m.Select({
    		id: this.sId + "decisionSelect"
        });
    	buId=frames['overview'].getContent("workingBuId");
    	transId=sas.fscf.getCurrentPageView().jsonRule.transactionTypeId;

    	//sas.ajax({url:'rest/actions'})
    	sas.ajax({url:'rest/actions?businessUnit='+buId+'&transactionType='+transId })
		  .done(function(oData){

			var model = new sap.ui.model.json.JSONModel(oData);
	    	decisionSelect.setModel(model);
	    	decisionSelect.bindAggregation("items", {
	            path: "/items",
	            factory: function(sId, oContext) {
	                  return new sap.ui.core.ListItem(sId, {
	                	  key: oContext.getProperty("id"),
	                	  text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.actions." + oContext.getProperty("name") + ".txt"),
	                  });
	            },
	            sorter: new sap.ui.model.Sorter("name")
	        });
            //if alert creation is not enabled for transaction type disable in GUI
	    	if(decisionSelect.getItemByKey("50101")==null){
	    		alertCreationEnabled=false;
	    		sap.ui.getCore().byId(_this.sId + "alertActionCheckBox").setEnabled(false);
	    		sap.ui.getCore().byId(_this.sId + "configureButton1").setEnabled(false);
	    	}
	    	decisionSelect.removeItem(decisionSelect.getItemByKey("50101"));//remove Alert from List
	    	decisionSelect.insertItem(new sas.hc.ui.core.Item({key: "",text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.actions.none.txt"),}),0);
	    	
	    	decisionSelect.attachChange(function(oEvent){
	    		sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions=[];
	    		if(sap.ui.getCore().byId(_this.sId + "alertActionCheckBox").getChecked()==true)
	    			sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.push({id:"50101"});
	    		
	    		//only add decision action if its not blank
	    		if(this.getSelectedKey()!=""){

	    			//if decision is hold then enable the alert configuration
		    		if (this.getModel().getData().items) {
		            	for (var i = 0; i < this.getModel().getData().items.length; i++) {
		            		if (this.getModel().getData().items[i].id == this.getSelectedKey()){
		            			if(this.getModel().getData().items[i].alertAction==true){//hold is selected
		            				sap.ui.getCore().byId(_this.sId + "configureButton1").setEnabled(true);//want to enable configuration whether create alert is checked or not
		            			}
		            			else{//hold is not selected
		            				if(sap.ui.getCore().byId(_this.sId + "alertActionCheckBox").getChecked()==false){//alert creation is unchecked
		            					sap.ui.getCore().byId(_this.sId + "configureButton1").setIcon("sap-icon://hc/configuration");
		            					sap.ui.getCore().byId(_this.sId + "configureButton1").setEnabled(false);
		            					sas.fscf.getCurrentPageView().jsonRule.queueId=null;
			            	        	sas.fscf.getCurrentPageView().jsonRule.alertTypeId=null;
			            	        	sas.fscf.getCurrentPageView().jsonRule.alertReason=null;
		            				}
		            			}
		            		}
		            	}
		        	}
		    		sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.push({id:this.getSelectedKey()});
	    		}else{//None is selected
	    			if(sap.ui.getCore().byId(_this.sId + "alertActionCheckBox").getChecked()==false){//alert creation is unchecked
    					sap.ui.getCore().byId(_this.sId + "configureButton1").setIcon("sap-icon://hc/configuration");
    					sap.ui.getCore().byId(_this.sId + "configureButton1").setEnabled(false);
    					sas.fscf.getCurrentPageView().jsonRule.queueId=null;
        	        	sas.fscf.getCurrentPageView().jsonRule.alertTypeId=null;
        	        	sas.fscf.getCurrentPageView().jsonRule.alertReason=null;
    				}
	    		}
	    		sas.fscf.getCurrentPageView().setDirty(true);
	    	});

	    	for(i=0;i<sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.length;i++){
	    		if(sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions[i].id!=50101){
	    			var savedDecisionAction=sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions[i].id;
	    	    	decisionSelect.setSelectedKey(savedDecisionAction);
	    		}
	    	}
	    	/*saved decision is associated with an alert action */
	    	if (decisionSelect.getModel().getData().items) {
            	for (var i = 0; i < decisionSelect.getModel().getData().items.length; i++) {
            		if (decisionSelect.getModel().getData().items[i].id == decisionSelect.getSelectedKey()){
            			if(decisionSelect.getModel().getData().items[i].alertAction==true){//hold is selected
            				sap.ui.getCore().byId(_this.sId + "configureButton1").setEnabled(true);//want to enable configuration whether create alert is checked or not            				
            			}
            		}
            	}
	    	}
	    	


		 }).fail(function(oObj,textStatus){
	         console.info("Failed to get decision actions. ");
		 });

    	return decisionSelect;
    },
    getActionConfiguration: function(){
    	var view = sap.ui.jsfragment({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "AlertCreationConfigurationDialog",
            fragmentName: "sas.fscf.views.fragments.AlertCreationConfigurationDialog"
        });
    	return view.lazyLoadContent();
    },
    getDecisionSelectionConfiguration: function() {
         return sap.ui.jsfragment({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "DecisionSelectionDialog",
            fragmentName: "sas.fscf.views.fragments.DecisionSelectionDialog"
        });
   },
    getAlertActionSelection:function(){
    	for(i=0;i<sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.length;i++){
    		if(sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions[i].id==50101){
            	sap.ui.getCore().byId(this.sId + "alertActionCheckBox").setChecked(true);
            	sap.ui.getCore().byId(this.sId + "configureButton1").setIcon("sap-icon://hc/complete");
            	sap.ui.getCore().byId(this.sId + "configureButton1").setEnabled(true);
    		}
    	}
    },
    getButtonSettings:function(){	
    	if(sas.fscf.getCurrentPageView().jsonRule.queueId!=null && sas.fscf.getCurrentPageView().jsonRule.queueId!='' && sas.fscf.getCurrentPageView().jsonRule.alertTypeId!=null && sas.fscf.getCurrentPageView().jsonRule.alertTypeId!=''){
    		sap.ui.getCore().byId(this.sId + "configureButton1").setIcon("sap-icon://hc/complete");
        	sap.ui.getCore().byId(this.sId + "configureButton1").setEnabled(true);
    	}
    }

});


