sap.ui.jsview("sas.fscf.views.ConsolePageDetails", {
    getControllerName: function () {
        return "sas.fscf.views.ConsolePageDetails";
    },

    createContent: function(oController) {
        jQuery.sap.require("sap.m.Toolbar");
        jQuery.sap.require("sas.hc.m.Button");

        var oToolbar = new sap.m.Toolbar({
    	    id: this.sId + 'Toolbar'
    	});
        oToolbar.setContentFor = function(type,param) {
        	oToolbar.destroyContent();
        	if (type == 'deployment') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'DeployButton',
   				        text: sas.fscf.rb.getText("rules.deploymentDetailMenu.deploy.txt"),
   				        icon : "sap-icon://hc/deploy",
   				        press: function() {
   				        	frames['detail'].deployRules();
   				        }
         		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("rules.deploymentDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].processMultiSelectRequest('printRules', '', false);
    				    }
        		    })
        		);
        	}
        	else if (type == 'pingServers') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ResetButton',
    				    text: sas.fscf.rb.getText("console.monitor.reset.txt"),
    				    icon : "sap-icon://hc/reset",
    				    press: function() {
    				    	frames['detail'].location.href = frames['detail'].location.href;
    				    }
        		    })
        		);
        	}
        	else if (type == 'monPerf') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ResetButton',
    				    text: sas.fscf.rb.getText("console.monitor.reset.txt"),
    				    icon : "sap-icon://hc/reset",
    				    press: function() {
    				    	frames['detail'].location.href = frames['detail'].location.href;
    				    }
        		    })
        		);
        		if(param!='OSE'){
        			oToolbar.addContent(
        					new sas.hc.m.Button({
        						id: this.sId + 'RecordButton',
        						text: sas.fscf.rb.getText("console.monitor.record.txt"),
        						icon : "sap-icon://hc/conditionalHighlightingBullet",
        						press: function() {
        							var i18nStrings = {"resumeRecording":sas.fscf.rb.getText("console.monitor.resumeRecording.txt"),
							                   "newRecording":sas.fscf.rb.getText("console.monitor.newRecording.txt"),
							                   "recordingStarted":sas.fscf.rb.getText("console.monitor.recordingStarted.txt")
        							};
        							var webappDateFormat = frames['detail'].webappDateFormat;
        							this.setEnabled(false);
        							this.getParent().getContent()[3].setEnabled(false);
        							frames['detail'].startRecording(i18nStrings,webappDateFormat);
        							this.getParent().getContent()[2].setEnabled(true);
        						}
        					})
        			);
        			oToolbar.addContent(
        					new sas.hc.m.Button({
        						id: this.sId + 'PauseButton',
        						text: sas.fscf.rb.getText("console.monitor.pause.txt"),
        						icon : "sap-icon://hc/booleanData",
        						press: function() {
        							this.setEnabled(false);
        							frames['detail'].stopRecording();
        							frames['detail'].stopMonitor();
        							this.getParent().getContent()[1].setEnabled(true);
        							this.getParent().getContent()[3].setEnabled(true);
        						}
        					})
        			);
        			oToolbar.addContent(
        					new sas.hc.m.Button({
        						id: this.sId + 'RunButton',
        						text: sas.fscf.rb.getText("console.monitor.run.txt"),
        						icon : "sap-icon://hc/play",
        						enabled: false,
        						press: function() {
        							this.setEnabled(false);
        							frames['detail'].startMonitor();
        							this.getParent().getContent()[2].setEnabled(true);
        						}
        					})
        			);
        		}
        	}
        	else if (type == 'showLog') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'RefreshButton',
    				    text: sas.fscf.rb.getText("console.logs.refresh.txt"),
    				    icon : "sap-icon://hc/reset",
    				    press: function() {
    				    	if (!oToolbar._baseLogUrl) {
    				    		oToolbar._baseLogUrl = frames['detail'].location.href;
    				    	}
    				    	frames['detail'].location.href = oToolbar._baseLogUrl;
    				    }
        		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ShowMoreLinesButton',
       				    text: sas.fscf.rb.getText("console.logs.showMoreLines.txt"),
       				    icon : "sap-icon://hc/file",
       				    press: function() {
    				    	if (!oToolbar._baseLogUrl) {
    				    		oToolbar._baseLogUrl = frames['detail'].location.href;
    				    	}
    				    	frames['detail'].location.href = oToolbar._baseLogUrl + "&maxlines=8192";
       				    }
           		    })
           		);
        	}
            else if (type == 'playRecording') {
           		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ExportButton',
       				    text: sas.fscf.rb.getText("fcm.overview.export.txt"),
       				    icon : "sap-icon://hc/export",
       				    press: function() {
       				    	frames['detail'].doPlaybackAction('export');
       				    }
           		    })
           		);
           		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteButton',
       				    text: sas.fscf.rb.getText("fcm.overview.delete.txt"),
       				    icon : "sap-icon://hc/delete",
       				    press: function() {
       				    	frames['detail'].doPlaybackAction('delete');
       				    }
           		    })
           		);
        	}
            else if (type == 'viewProperties') {
           		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'SaveButton',
       				    text: sas.fscf.rb.getText("fcm.application.save.txt"),
       				    icon : "sap-icon://hc/save",
       				    press: function() {
       				    	frames['detail'].doSaveAction();
       				    }
           		    })
           		);
            }
            else if (type == 'viewMessageFailures') {
           		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'IgnoreButton',
       				    text: sas.fscf.rb.getText("console.messagefailures.ignore.txt"),
       				    icon : "sap-icon://hc/delete",
       				    press: function() {
       				    	frames['detail'].checkFFSelections('ignore');
       				    }
           		    })
           		);
           		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ResubmitButton',
       				    text: sas.fscf.rb.getText("console.messagefailures.resubmit.txt"),
       				    icon : "sap-icon://hc/reset",
       				    press: function() {
       				    	frames['detail'].checkFFSelections('resubmit');
       				    }
           		    })
           		);
        	}
        };
    	return oToolbar;
    }
});
