sap.ui.jsview("sas.fscf.views.Grid", {
    getControllerName: function () {
        return "sas.fscf.views.Grid";
    },

    _bExplore: false,

    isExplore: function() {
    	return this._bExplore;
    },

    setExplore: function(bExplore) {
    	this._bExplore = bExplore;
    },

    createContent: function(oController) {
    },

    lazyLoadContent: function() {
      if (this.getContent().length == 0) {
    	jQuery.sap.require('sas.hc.ui.commons.layout.HorizontalLayout');
    	jQuery.sap.require('sas.hc.ui.commons.Panel');
        jQuery.sap.require("sas.hc.ui.commons.Button");
    	jQuery.sap.require("sas.hc.ui.unified.Menu");
        jQuery.sap.require("sas.hc.ui.unified.MenuItem");
        jQuery.sap.require("sap.ui.commons.ListBox");
        jQuery.sap.require("sap.ui.core.ListItem");
        jQuery.sap.require("sap.ui.model.json.JSONModel");
        jQuery.sap.require("sas.hc.m.SearchField");
        jQuery.sap.require("sap.ui.model.Filter");
        jQuery.sap.require("sap.ui.model.FilterOperator");
        jQuery.sap.require("sas.hc.m.Label");
        jQuery.sap.require("sas.hc.m.Select");
        jQuery.sap.require("sas.hc.ui.core.Item");
        jQuery.sap.require("sap.m.InputType");
        jQuery.sap.require("sas.hc.m.Input");
        jQuery.sap.require("sas.hc.m.MultiInput");
        jQuery.sap.require("sas.hc.m.Token");
    	jQuery.sap.require("sas.hc.ui.commons.layout.VerticalLayout");
    	jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-core');
    	jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-widget');
    	jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-mouse');
    	jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-sortable');
    	jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-droppable');
    	jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-draggable');

    	var _this = this;

    	this.addStyleClass("cfGridView");

        var oHLayout = new sas.hc.ui.commons.layout.HorizontalLayout({
    	    id: this.sId + "HorizLayout",
    	    height: "100%",
    		content: [
    		]
    	});

		oHLayout.onAfterRendering = function() {
        	if (sas.hc.ui.commons.layout.HorizontalLayout.prototype.onAfterRendering) {
        		sas.hc.ui.commons.layout.HorizontalLayout.prototype.onAfterRendering.apply(this);
        	}
        	_this.refreshInlineMessage();
			$("#" + _this.sId + "HorizLayout").parent().droppable({
				accept: ".sapMLIB",
	            hoverClass: "cfGridViewDropHover",
				drop: function( event, ui ) {
					var oListItemId = ui.draggable.context.id;
					var oListItem = sap.ui.getCore().byId(oListItemId);
					_this.addPanel(null, _this.getContent()[0], "", oListItem.getTitle(), oListItem._fieldId, oListItem._variableType, "EQUAL", null, oListItem._min, oListItem._max);
                    $("#" + oListItem.sId).draggable("disable"); // turn off drag
                    var scrollPane = document.getElementById(_this.getParent().sId + "_firstPane");
                    setTimeout(function () {
                    	scrollPane.scrollLeft = scrollPane.scrollWidth + 1000;  // scroll all the way to the right/end
                    }, 5000);
				}
			});
		};

        this.addContent(oHLayout);
      }
    },
    _startMessage: "",
    getStartMessage: function() {
    	return this._startMessage;
    },
    setStartMessage: function(msg) {
    	this._startMessage = msg;
    },
    refreshInlineMessage: function() {
       	if (this.getContent()[0].getContent().length == 0) {
       		sas.fscf.showInlineMessage(this.sId, sas.fscf.MESSAGE_TYPE_INFO, this.getStartMessage(), true, "&#xf0f7;", true);
       	} else {
       		sas.fscf.hideInlineMessage(this.sId);
       	}
    },
    getNextId: function(parentHLayout, parentId) {
    	if (parentHLayout.getContent().length > 0) {
    		var pieces = parentHLayout.getContent()[parentHLayout.getContent().length - 1]._pId.split("-");
    		pieces[pieces.length - 1] = parseInt(pieces[pieces.length - 1]) + 1;
    		return pieces.join("-");
    	} else {
    		var pieces = parentId.split("-");
    		pieces[0] = "F";
    		pieces[pieces.length] = 1;
    		return pieces.join("-");
    	}
    },
    addGroup: function(id, parentHLayout, parentId, type) {
    	this.customSetBusy(true);

        var _this = this;
    	sas.fscf.hideInlineMessage(_this.sId);

    	var pId = id;
    	if (pId == null || pId == undefined) {
    		pId = _this.getNextId(parentHLayout, parentId);
    	}

    	var title;
    	if (type == "AND") {
    		title = sas.fscf.rb.getText("rules.rulesPage.guidedView.form.inclusionSets.all.txt");
    	} else if (type == "OR") {
    		title = sas.fscf.rb.getText("rules.rulesPage.guidedView.form.inclusionSets.any.txt");
    	} else if (type == "NOR") {
    		title = sas.fscf.rb.getText("rules.rulesPage.guidedView.form.inclusionSets.none.txt");
    	}

		var oPanel = new sas.hc.ui.commons.Panel({
			text: title,
			showCollapseIcon: false,
			applyContentPadding: true,
			content: [
			]
		});
        oPanel.addStyleClass("cfGroup");
        oPanel._pId = pId;
		oPanel._isGroup = true;
		oPanel._groupType = type;
		// set name attribute
    	oPanel.onAfterRendering = function() {
        	if (sas.hc.ui.commons.Panel.prototype.onAfterRendering) {
        		sas.hc.ui.commons.Panel.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
        	this.getDomRef().setAttribute("name", this._pId);
    	};

	    var oButton = new sas.hc.ui.commons.Button({
	    	id: oPanel.sId + "_CloseButton",
    		icon: 'sap-icon://hc/close',
    		tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.remove.txt"),
    		press: function() {
    			_this.removeGroup(oPanel);
    		}
		});
		// set name attribute
    	oButton.onAfterRendering = function() {
        	if (sas.hc.ui.commons.Button.prototype.onAfterRendering) {
        		sas.hc.ui.commons.Button.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
        	this.getDomRef().setAttribute("name", "CloseButton");
    	};
    	oPanel.addButton(oButton);

	   	var oHorizLayout = new sas.hc.ui.commons.layout.HorizontalLayout({
	   		id: oPanel.sId + "_HorizLayout",
    	    height: "100%",
    		content: [
    		]
        });
		// set name attribute
	   	oHorizLayout.onAfterRendering = function() {
        	if (sas.hc.ui.commons.layout.HorizontalLayout.prototype.onAfterRendering) {
        		sas.hc.ui.commons.layout.HorizontalLayout.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
        	this.getDomRef().setAttribute("name", "HorizLayout");
    	};
    	oPanel.addContent(oHorizLayout);

		var oMenu = new sas.hc.ui.unified.Menu(oPanel.sId + "_Menu");
		// set name attribute
    	oMenu.onAfterRendering = function() {
        	if (sas.hc.ui.unified.Menu.prototype.onAfterRendering) {
        		sas.hc.ui.unified.Menu.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
        	this.getDomRef().setAttribute("name", "Menu");
    	};
        oPanel.setAggregation("contextMenu", oMenu);

        var oMenuItem = new sas.hc.ui.unified.MenuItem({
        	id: oPanel.sId + "_RemoveMenuItem",
            text: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.remove.txt")
        });
        oMenuItem.attachSelect(function() {
            _this.removeGroup(oPanel);
        });
		// set name attribute
    	oMenuItem.onAfterRendering = function() {
        	if (sas.hc.ui.unified.MenuItem.prototype.onAfterRendering) {
        		sas.hc.ui.unified.MenuItem.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
        	this.getDomRef().setAttribute("name", "RemoveMenuItem");
    	};
        oMenu.addItem(oMenuItem);

        parentHLayout.addContent(oPanel);

    	_this.customSetBusy(false);

    	return oPanel;
    },
    removeGroup: function(oPanel) {
    	if ($.type(oPanel) === 'string') {
    		oPanel = sap.ui.getCore().byId(oPanel);
    	}
    	if (!oPanel) {
    		return;
    	}
    	var parentHLayout = sap.ui.getCore().byId(oPanel.sId + "_HorizLayout");
    	for (var i = parentHLayout.getContent().length - 1; i >= 0; i--) {
    		this.removePanel(parentHLayout.getContent()[i], parentHLayout, (i == 0));
    	}
    },
    updatePageButtonEnablement: function (lbox, pageUpButton, pageDownButton) {
   		var lb = document.getElementById(lbox.sId);
   		pageUpButton.setEnabled(lb.scrollTop > 0);
		pageDownButton.setEnabled(lb.scrollTop < lb.children[0].offsetHeight - lb.offsetHeight);
    },
    commonListBoxOnAfterRendering: function(lbox, panel, pageUpButton, pageDownButton) {
   		if (lbox.getItems().length == 0) {
            lbox.addStyleClass("topBorder");
       	} else {
            lbox.removeStyleClass("topBorder");
       	}
   		// remove page buttons before calculating available height for items
		// remove doesn't work the 1st time, so add first then remove
		panel.addStyleClass("pagable");
		panel.removeStyleClass("pagable");
		var visibleItems = Math.floor($("#" + lbox.sId).height() / 18);
		if (lbox.getItems().length > visibleItems) {
			// show search field
			if (panel._type == 0 && !panel._filtering && panel._searchable == null) {
				panel._searchable = true;
				panel.addStyleClass("searchable");
			}
			// show page buttons
			panel.addStyleClass("pagable");
    		this.updatePageButtonEnablement(lbox, pageUpButton, pageDownButton);
		} else {
    		// remove doesn't work the 1st time, so add first then remove
			panel.addStyleClass("pagable");
			panel.removeStyleClass("pagable");
			pageUpButton.setEnabled(false);
			pageDownButton.setEnabled(false);
		}
    },
    commonListBoxHandleSelect: function(oEvent, _this) {
    	var oPanel = _this.getPanelForListBox(this);
        var field = oPanel.getText();
        var fieldId = oPanel._fieldId;
        var variableType = oPanel._variableType;
        var value, exp;

       	// handle anything that was selected that is no longer selected
       	var bStillSelected = false;
       	if (this._priorSelectedIndices && this._priorSelectedIndices.length > 0) {
           	for (var i = 0; i < this._priorSelectedIndices.length; i++) {
           		bStillSelected = false;
           		for (var j = 0; j < oEvent.mParameters.selectedIndices.length; j++) {
           			if (oEvent.mParameters.selectedIndices[j] == this._priorSelectedIndices[i]) {
           				bStillSelected = true;
           				break;
           			}
           		}
           		if (!bStillSelected) {
           			if (this.getItems()[this._priorSelectedIndices[i]]) {
                        value = this.getItems()[this._priorSelectedIndices[i]].getKey();
                        _this.selectValueInData(this.getModel().getData(), value, false);
                        exp = this.getItems()[this._priorSelectedIndices[i]]._exp;
                        if (exp) {
           	               	_this.getForm().removeCondition(oPanel._pId, {
           	               		type: ((exp.leftValue != null) && (exp.leftValue != undefined)) ? "RANGE" : "COMPARE",
           	               		operator: exp.operator,
           	               		fieldId: fieldId,
           	               		fieldName: field,
           	               		fieldType: variableType,
           	               		value: exp.value,
           	               		leftValue: exp.leftValue,
           	               		rightValue: exp.rightValue,
           	               		leftOperator: exp.leftOperator,
           	               		rightOperator: exp.rightOperator
           	               	});
                        } else {
           	               	_this.getForm().removeCondition(oPanel._pId, {
           	               		type: "COMPARE",
           	               		operator: oPanel._bNot ? "NE" : "EQUAL",
           	               		fieldId: fieldId,
           	               		fieldName: field,
           	               		fieldType: variableType,
           	               		value: value
           	               	});
                        }
           			}
           		}
           	}
       	} else {
       		// if first selection in this list box, then clear the selection in the other list box if there is any
       		var other_lbox = _this.getOtherListBoxForPanel(oPanel);
       		if (other_lbox) {
       			_this.notifyDeselects(oPanel, other_lbox, false);
       	    	other_lbox.clearSelection();
       	    	other_lbox._priorSelectedIndices = null;
       		}
       		if (oPanel._rangeable) {
       			// turn off Not if it is on
        		_this.setNot(false, oPanel);
        		oPanel._oNotMenuItem.setEnabled(false);
       		} else {
        		oPanel._oNotMenuItem.setEnabled(true);
       		}
       	}

       	// handle anything newly selected
       	var bWasSelected = false;
       	for (var i = 0; i < oEvent.mParameters.selectedIndices.length; i++) {
       		bWasSelected = false;
           	if (this._priorSelectedIndices) {
               	for (var j = 0; j < this._priorSelectedIndices.length; j++) {
           			if (this._priorSelectedIndices[j] == oEvent.mParameters.selectedIndices[i]) {
           				bWasSelected = true;
           				break;
           			}
               	}
           	}
       		if (!bWasSelected) {
                value = this.getItems()[oEvent.mParameters.selectedIndices[i]].getKey();
                _this.selectValueInData(this.getModel().getData(), value, true);
                exp = this.getItems()[oEvent.mParameters.selectedIndices[i]]._exp;
                if (exp) {
   	               	_this.getForm().addCondition(oPanel._pId, {
   	               		type: ((exp.leftValue != null) && (exp.leftValue != undefined)) ? "RANGE" : "COMPARE",
   	               		operator: exp.operator,
   	               		fieldId: fieldId,
   	               		fieldName: field,
   	               		fieldType: variableType,
   	               		value: exp.value,
   	               		leftValue: exp.leftValue,
   	               		rightValue: exp.rightValue,
   	               		leftOperator: exp.leftOperator,
   	               		rightOperator: exp.rightOperator
   	               	}, true);
                } else {
   	               	_this.getForm().addCondition(oPanel._pId, {
   	               		type: "COMPARE",
   	               		operator: oPanel._bNot ? "NE" : "EQUAL",
   	               		fieldId: fieldId,
   	               		fieldName: field,
   	               		fieldType: variableType,
   	               		value: value
   	               	});
                }
       		}
       	}
       	
       	if (oEvent.mParameters.selectedIndices.length == 0) {
       		oPanel._value = "";
       		if (oPanel._bNot) {
       			oPanel._operator = "NE";
       		} else {
       			oPanel._operator = "EQUAL";
       		}  
       	} else if (oEvent.mParameters.selectedIndices.length == 1) {
       		oPanel._value = this.getItems()[oEvent.mParameters.selectedIndices[0]].getKey();
       		if (oPanel._bNot) {
       			oPanel._operator = "NE";
       		} else {
       			oPanel._operator = "EQUAL";
       		}  
       	} else {
       		oPanel._value = [];
           	for (var i = 0; i < oEvent.mParameters.selectedIndices.length; i++) {
           		oPanel._value[oPanel._value.length] = this.getItems()[oEvent.mParameters.selectedIndices[i]].getKey();
           	}
       		if (oPanel._bNot) {
       			oPanel._operator = "NOTIN";
       		} else {
       			oPanel._operator = "IN";
       		}  
       	}

       	_this.updateOperatorSelectEqualsItem(oPanel);
       	
    	_this.getRelatedRows().update();
       	_this.updateCounts();
    },
    setNot: function(bNot, oPanel) {
    	if (bNot) {
    		oPanel._bNot = true;
    		oPanel.getTitle().setIcon('sap-icon://hc/cancel');
    		oPanel.removeStyleClass("cfNot");
    		oPanel.addStyleClass("cfNot");
    		oPanel._operator = this.getNegativeOperator(oPanel._operator);
    	} else {
    		oPanel._bNot = false;
    		oPanel.getTitle().setIcon(null);
    		oPanel.removeStyleClass("cfNot");
    		oPanel._operator = this.getPositiveOperator(oPanel._operator);
    	}
    	this.updateOperatorSelect(oPanel);
    	this.updatePanelMenu(oPanel);
    },
    createOperatorInput: function(oPanel, value) {
    	var _this = this;
   		var oOperatorInput = new sas.hc.m.Input({
           	id: oPanel.sId + "_OperatorInput",
            value: value,
            placeholder: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.filter.txt")
        });
   		// set initial size and name attribute
   		oOperatorInput.onAfterRendering = function() {
           	if (sas.hc.m.Input.prototype.onAfterRendering) {
           		sas.hc.m.Input.prototype.onAfterRendering.apply(this);
           	}
   			$("#" + this.sId).find("input").attr("size", 16);
           	// must be set after rendering when the dom ref will exist
           	this.getDomRef().setAttribute("name", "OperatorInput");
   		};

        oOperatorInput.attachChange(function(oEvent) {            	
			_this.updateAfterOperatorInputChange(oPanel, oEvent.mParameters.newValue);
        });
        	        
        oOperatorInput.addStyleClass("cfGridCellOperatorInput");

        return oOperatorInput;
    },
    createOperatorMultiInput: function(oPanel, value) {
    	var _this = this;
   		var oOperatorInput = new sas.hc.m.MultiInput({
   			id: oPanel.sId + "_OperatorInput",
   			width: "100%"
        });            		
		for (var k in value) {
			oOperatorInput.addToken(new sas.hc.m.Token({key: value[k], text:value[k]}));
		}
   		// set initial name attribute
   		oOperatorInput.onAfterRendering = function() {
           	if (sas.hc.m.MultiInput.prototype.onAfterRendering) {
           		sas.hc.m.MultiInput.prototype.onAfterRendering.apply(this);
           	}
           	// must be set after rendering when the dom ref will exist
           	this.getDomRef().setAttribute("name", "OperatorInput");
   		};

        oOperatorInput.attachTokenChange(function(oEvent) {            		
			if (oEvent.mParameters.type == "removed" || oEvent.mParameters.type == "added") {
				if (oEvent.mParameters.type == "removed") {
					var value = [];
					for (var i = 0; i < this.getTokens().length; i++) {
						value[value.length] = this.getTokens()[i].getKey();
					}
					_this.updateAfterOperatorInputChange(oPanel, value);					
				}
			}
			return true;
        });                	
        
        // not getting the token added events under attachTokenChange for some reason, so this manually adds the tokens ourselves
        oOperatorInput.attachChange(function(oEvent) {
			this.addToken(new sas.hc.m.Token({key: oEvent.mParameters.newValue, text:oEvent.mParameters.newValue}));
			this.setValue("");
			this.focus();
			var value = [];
			for (var i = 0; i < this.getTokens().length; i++) {
				value[value.length] = this.getTokens()[i].getKey();
			}
			_this.updateAfterOperatorInputChange(oPanel, value);
        });
        	        
        oOperatorInput.addStyleClass("cfGridCellOperatorInput");

        return oOperatorInput;
    },
    updateOperatorSelect: function(oPanel) {
    	var oOperatorSelect = this.getOperatorSelectForPanel(oPanel); 
    	if (oOperatorSelect) {
    		var items = oOperatorSelect.getItems();
        	if (oPanel._bNot) {
        		for (var i = 0; i < items.length; i++) {
        			items[i].setKey(this.getNegativeOperator(items[i].getKey()));
        			items[i].setText(sas.fscf.getLocalizedOperatorVerbose(items[i].getKey()));
        		}
        	} else {
        		for (var i = 0; i < items.length; i++) {
        			items[i].setKey(this.getPositiveOperator(items[i].getKey()));
        			items[i].setText(sas.fscf.getLocalizedOperatorVerbose(items[i].getKey()));
        		}
        	}
    	}
    },
    updateOperatorSelectEqualsItem: function(oPanel) {
    	var oOperatorSelect = this.getOperatorSelectForPanel(oPanel); 
    	if (oOperatorSelect) {
    		var item = oOperatorSelect.getItems()[0];
        	if (oPanel._bNot) {
        		if (($.isArray(oPanel._value)) && (oPanel._value.length > 1)) {
        			item.setKey("NOTIN");
        			item.setText(sas.fscf.getLocalizedOperatorVerbose(item.getKey()));
        		} else {
        			item.setKey("NE");
        			item.setText(sas.fscf.getLocalizedOperatorVerbose(item.getKey()));
        		}
        	} else {
        		if (($.isArray(oPanel._value)) && (oPanel._value.length > 1)) {
        			item.setKey("IN");
        			item.setText(sas.fscf.getLocalizedOperatorVerbose(item.getKey()));
        		} else {
        			item.setKey("EQUAL");
        			item.setText(sas.fscf.getLocalizedOperatorVerbose(item.getKey()));
        		}
        	}
    	}
    },
    updateSelectedOperator: function(oPanel) {
    	var oOperatorSelect = this.getOperatorSelectForPanel(oPanel); 
    	if (oOperatorSelect) {
    		oOperatorSelect.setSelectedKey(oPanel._operator);
    	}
    },
    updatePanelMenu: function(oPanel) {
    	var _this = this;
    	
        oPanel.destroyAggregation("contextMenu");
        
		var oMenu = new sas.hc.ui.unified.Menu(oPanel.sId + "_Menu");
		// set name attribute
    	oMenu.onAfterRendering = function() {
        	if (sas.hc.ui.unified.Menu.prototype.onAfterRendering) {
        		sas.hc.ui.unified.Menu.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
        	this.getDomRef().setAttribute("name", "Menu");
    	};
        oPanel.setAggregation("contextMenu", oMenu);

        var oMenuItem = new sas.hc.ui.unified.MenuItem({
        	id: oPanel.sId + "_NotMenuItem",
            text: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.not.txt"),
            icon: (oPanel._bNot) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
            enabled: !oPanel._rangeable
        });
        oMenuItem.attachSelect(function() {
        	if (oPanel._bNot) {
        		_this.setNot(false, oPanel);
        	} else {
        		_this.setNot(true, oPanel);
        	}
        	_this.getForm().negateCondition(oPanel._pId);
        	var ret = _this.getForm().findCondition(oPanel._pId);
        	if (oPanel._filtering) {
            	_this.updatePanel(oPanel, _this.getListBoxForPanel(oPanel), ret.exp, false, function() {
                	_this.getRelatedRows().update();
                	_this.updateCounts();
            	});
        	} else {
            	_this.getRelatedRows().update();
            	_this.updateCounts();
        	}
        });
		// set name attribute
    	oMenuItem.onAfterRendering = function() {
        	if (sas.hc.ui.unified.MenuItem.prototype.onAfterRendering) {
        		sas.hc.ui.unified.MenuItem.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
        	this.getDomRef().setAttribute("name", "NotMenuItem");
    	};
        oMenu.addItem(oMenuItem);
        oPanel._oNotMenuItem = oMenuItem;

        var oMenuItem2 = new sas.hc.ui.unified.MenuItem({
        	id: oPanel.sId + "_RemoveMenuItem",
            text: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.remove.txt"),
            startsSection: true
        });
        oMenuItem2.attachSelect(function() {
            _this.removePanel(oPanel, _this.getParentHLayoutForPanel(oPanel), true);
        });
		// set name attribute
    	oMenuItem2.onAfterRendering = function() {
        	if (sas.hc.ui.unified.MenuItem.prototype.onAfterRendering) {
        		sas.hc.ui.unified.MenuItem.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
        	this.getDomRef().setAttribute("name", "RemoveMenuItem");
    	};
        oMenu.addItem(oMenuItem2);
    },
    addPanel: function(id, parentHLayout, parentId, fieldType, fieldId, variableType, operator, value, min, max, from, to, not, overrideRangeView, successCallback, failureCallback) {
    	this.customSetBusy(true);

        var _this = this;
    	sas.fscf.hideInlineMessage(_this.sId);
		var q = _this.getQForFilteringOperator(operator, fieldType, value);
        $.ajax({url:sas.fscf.getQueryUrl((_this.isExplore() ? "facets" : "risk"), (_this.isExplore() ? "esdb" : null), q, fieldType), contentType:"application/json; charset=utf-8", dataType:"json"})
          .done(function(oData){
        	var data = null;
        	if (oData && oData[Object.keys(oData)[0]]) {
            	if (oData[Object.keys(oData)[0]]['children']) {
            		data = oData[Object.keys(oData)[0]]['children'][0];
            	}
        	} else {
    	    	_this.customSetBusy(false);
            	sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, _this.getServerErrorMessage(), true, null, true);
        		_this.getPalette().enableListItem(fieldType, true);
                if (failureCallback) {
                	failureCallback.call();
                }
            	return;
        	}
        	if (q.length == 0) {		// don't merge if it is a filtering operator
            	data = _this.mergeValueIntoData(data, value);
        	}
        	var model = new sap.ui.model.json.JSONModel(data);
        	_this._totalPopulation = oData[Object.keys(oData)[0]]["total"];
        	var pId = id;
        	if (pId == null || pId == undefined) {
        		pId = _this.getNextId(parentHLayout, parentId);
        	}

        	var oPanelContent = null;
        	var type = 0;
        	if (variableType == "Numeric" || variableType == "Currency") {
        		type = 1; //range
        	}
    		var oPanel = new sas.hc.ui.commons.Panel({
    			showCollapseIcon: false,
    			applyContentPadding: false,
    			title: new sap.ui.core.Title({
    				icon: null,
    				text: fieldType
    			}),
    			content: [
    			]
    		});
    		oPanel._pId = pId;
    		oPanel._type = 0;
    		oPanel._fieldId = fieldId;
    		oPanel._variableType = variableType;
    		oPanel._operator = operator;
    		oPanel._value = value;
    		oPanel._searchable = null;
    		oPanel._rangeable = false;
           	oPanel._filtering = (q.length > 0);
    		if (type == 1) {
    			oPanel._type = 1;
    			oPanel.addStyleClass("range");
    			if (!overrideRangeView) {
        			oPanel._searchable = false;
        			oPanel._rangeable = true;
        			oPanel.addStyleClass("rangeable");
    			}
    		}
    		if (not) {
    			_this.setNot(true, oPanel);
    		}
			if (_this.isValuelessOperator(operator)) {	// add valueless class if it is a valueless operator
    			oPanel.addStyleClass("valueless");
			}
    		// set name attribute
        	oPanel.onAfterRendering = function() {
            	if (sas.hc.ui.commons.Panel.prototype.onAfterRendering) {
            		sas.hc.ui.commons.Panel.prototype.onAfterRendering.apply(this);
            	}
            	// must be set after rendering when the dom ref will exist
            	this.getDomRef().setAttribute("name", this._pId);
        	};

            var oListBox = new sap.ui.commons.ListBox({
            	id: oPanel.sId + "_ListBox",
              	allowMultiSelect: true,
               	displayIcons: false,
               	displaySecondaryValues: true,
               	secondaryValueTextAlign: sap.ui.core.TextAlign.End,
               	enabled: !oPanel._filtering     // don't allow selecting if it is a filtering operator
            });
            oListBox.addStyleClass("cfGridCellListBox");

            oListBox.setModel(model);
            oListBox.bindAggregation("items", {
               	path: "/children",
                factory: function(sId, oContext) {
                    var li = new sap.ui.core.ListItem(sId, {
                          key: oContext.getProperty("name"),
                          text: (oPanel._type == 1) ? _this.convertToFormattedNumber(oContext.getProperty("name")) : oContext.getProperty("name"),
                          additionalText: _this._bPercentages ? sas.fscf.percentFormatter.format(oContext.getProperty("pct") / 100) : ((oContext.getProperty("size") != undefined) ? sas.fscf.floatFormatter.format(oContext.getProperty("size")) : "")
                    });
                    li._fraudCount = (oContext.getProperty("subSize")) ? oContext.getProperty("subSize") : 0;
                    li._riskLevel = oContext.getProperty("scoreLevel");
                    return li;
                },
               	sorter: [
               	     _this.getSelSorter(),   // force selected ones always to the top
                     _this.getSorter(oPanel._variableType)
               	]
            });

            oListBox._fieldId = fieldId;
            oListBox.attachSelect(_this, _this.commonListBoxHandleSelect);

    		// set name attribute and adjust classes, visibility and enablement
        	oListBox.onAfterRendering = function() {
               	if (sap.ui.commons.ListBox.prototype.onAfterRendering) {
               		sap.ui.commons.ListBox.prototype.onAfterRendering.apply(this);
               	}
            	// must be set after rendering when the dom ref will exist
            	this.getDomRef().setAttribute("name", "ListBox");

            	_this.commonListBoxOnAfterRendering(this, oPanel, oPageUpButton, oPageDownButton);

   				var li, $li, cls;
   				for (var i = 0; i < this.getItems().length; i++) {
   					li = this.getItems()[i];
   					$li = $("#" + li.sId);
   				    $li.find('.cfUiLbxIBadge').remove(); // remove any badge that might already be there
   				    if (li._fraudCount == undefined || li._fraudCount <= 0) {
   				    	cls = " class='hidden'";
   				    } else if (li._riskLevel == 0) {
   				    	cls = " class='lowRisk'";
   				    } else if (li._riskLevel == 1) {
   				    	cls = " class='mediumRisk'";
   				    } else if (li._riskLevel >= 2) {
   				    	cls = " class='highRisk'";
   				    }
   					$("<span class='cfUiLbxIBadge'><span" + cls + ">" + li._fraudCount + "</span></span>").insertAfter($li.find(".sapUiLbxITxt"));
   				}
        	};

            var oSearch = new sas.hc.m.SearchField({
            	id: oPanel.sId + "_SearchField",
                placeholder: sas.fscf.rb.getText("rules.rulesPage.guidedView.search.txt"),
                width: "100%"
            });
            oSearch.addStyleClass("cfGridCellSearchField");
            oSearch.attachSearch(function(oEvent){
            	_this.customSetBusy(true);
            	sas.fscf.hideInlineMessage(_this.sId);
            	
         		var selItems = oListBox.getSelectedItems();

         		var q = "(" + fieldType + ":*" + sas.fscf.escapeSafeValue(oEvent.mParameters.query) + "*)"; 
                $.ajax({url:sas.fscf.getQueryUrl((_this.isExplore() ? "facets" : "risk"), (_this.isExplore() ? "esdb" : null), q, fieldType), contentType:"application/json; charset=utf-8", dataType:"json"})
                .done(function(oData){
      	            var data = null;
      	            if (oData && oData[Object.keys(oData)[0]]) {
      	           	    if (oData[Object.keys(oData)[0]]['children']) {
      	           		    data = oData[Object.keys(oData)[0]]['children'][0];
      	           	    } else {
      	           	    	data = {"children":[], "name": fieldType, "size": 0};
      	           	    }
      	            } else {
      	        	    _this.customSetBusy(false);
      	        	    sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, _this.getServerErrorMessage(), true, null, true);
      	        	    return;
      	            }

    				// merge what was selected before the search
                   	var key;
    				for (var j = 0; j < selItems.length; j++) {
    					key = selItems[j].getKey();
                    	data = _this.mergeValueIntoData(data, key);
    				}
                	
      	            var model = new sap.ui.model.json.JSONModel(data);
      	            oListBox.setModel(model);
      	            
					// re-select what was selected before the re-bind
					for (var j = 0; j < selItems.length; j++) {
						key = selItems[j].getKey();
						for (var k = 0; k < oListBox.getItems().length; k++) {
							if (oListBox.getItems()[k].getKey() == key) {
								_this.selectListBoxItem(oListBox, k);
								break;
							}
						}
					}
					
       	    	    _this.customSetBusy(false);	  	    	  
                }).fail(function(oObj,textStatus){
        	    	_this.customSetBusy(false);
                	sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, _this.getServerErrorMessage(), true, null, true);
                });         		
            });
    		// set name attribute
        	oSearch.onAfterRendering = function() {
            	if (sas.hc.m.SearchField.prototype.onAfterRendering) {
            		sas.hc.m.SearchField.prototype.onAfterRendering.apply(this);
            	}
            	// must be set after rendering when the dom ref will exist
            	this.getDomRef().setAttribute("name", "SearchField");
        	};

   	        var oPageUpButton = new sas.hc.ui.commons.Button({
            	id: oPanel.sId + "_PageUpButton",
   			  	icon: 'sap-icon://hc/arrowSmallUpBtn',
   			   	tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.pageUp.txt"),
   			   	width: "100%",
   			   	enabled: false,
   			   	press: function() {
   			   		var lbox = _this.getListBoxForPanel(oPanel);
  		    		var lb = document.getElementById(lbox.sId);
   		    		var lbi = document.getElementById(lbox.getItems()[0].sId);
   		    		lb.scrollTop = Math.max(lb.scrollTop - (Math.floor(lb.offsetHeight / lbi.offsetHeight) * lbi.offsetHeight), 0);
   		    		lb.scrollTop -= lb.scrollTop % lbi.offsetHeight;
   		    	    lbox.removeStyleClass("topBorder");
   		    		_this.updatePageButtonEnablement(lbox, oPageUpButton, oPageDownButton);
   		    	}
   		    });
   	        oPageUpButton.addStyleClass("cfGridCellPageButton");
    		// set name attribute
   	        oPageUpButton.onAfterRendering = function() {
            	if (sas.hc.ui.commons.Button.prototype.onAfterRendering) {
            		sas.hc.ui.commons.Button.prototype.onAfterRendering.apply(this);
            	}
            	// must be set after rendering when the dom ref will exist
            	this.getDomRef().setAttribute("name", "PageUpButton");
        	};

   	        var oPageDownButton = new sas.hc.ui.commons.Button({
            	id: oPanel.sId + "_PageDownButton",
   		    	icon: 'sap-icon://hc/arrowSmallDownBtn',
   		    	tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.pageDown.txt"),
   		    	width: "100%",
   		    	press: function() {
   			   		var lbox = _this.getListBoxForPanel(oPanel);
   		    		var lb = document.getElementById(lbox.sId);
   		    		var lbi = document.getElementById(lbox.getItems()[0].sId);
   		    		lb.scrollTop = Math.min(lb.scrollTop + (Math.floor(lb.offsetHeight / lbi.offsetHeight) * lbi.offsetHeight),
   		    								lb.children[0].offsetHeight - lb.offsetHeight);
   		    		if (lb.scrollTop % lbi.offsetHeight != 0) {
   		    	        lbox.addStyleClass("topBorder");
   		    		} else {
   		    	        lbox.removeStyleClass("topBorder");
   		    		}
   		    		// prevent slight scroll down of parent containers that happens when bottom is reached
   		    		if (lb.scrollTop == lb.children[0].offsetHeight - lb.offsetHeight) {
   		    			setTimeout(function () {
   		    	    		lb.parentElement.parentElement.scrollTop = 0;
   		    	    		lb.parentElement.parentElement.parentElement.scrollTop = 0;
   		    			}, 100);
   		    		}
   		    		_this.updatePageButtonEnablement(lbox, oPageUpButton, oPageDownButton);
   		    	}
   			});
   	        oPageDownButton.addStyleClass("cfGridCellPageButton");
    		// set name attribute
   	        oPageDownButton.onAfterRendering = function() {
            	if (sas.hc.ui.commons.Button.prototype.onAfterRendering) {
            		sas.hc.ui.commons.Button.prototype.onAfterRendering.apply(this);
            	}
            	// must be set after rendering when the dom ref will exist
            	this.getDomRef().setAttribute("name", "PageDownButton");
        	};

   	        var aVLContent = [
                   oSearch,
                   oPageUpButton,
                   oListBox,
                   oPageDownButton
            ];

        	if (type == 1) {
        		var oMinLabel = new sas.hc.m.Label({
                	id: oPanel.sId + "_MinLabel",
        		    text: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.min.fmt.txt", ((min == undefined) || (min == null)) ? " " : sas.fscf.floatFormatter.format(min))
        		});
        		var oMaxLabel = new sas.hc.m.Label({
                	id: oPanel.sId + "_MaxLabel",
        		    text: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.max.fmt.txt", ((max == undefined) || (max == null)) ? " " : sas.fscf.floatFormatter.format(max))
        		});

                var oRangeLabels = new sas.hc.ui.commons.layout.HorizontalLayout({
                	id: oPanel.sId + "_RangeLabels",
                    content: [
                        oMinLabel,
                        oMaxLabel
                    ]
                });
                oRangeLabels.addStyleClass("cfGridCellRangeLabels");

                if ((from == undefined) || (from == null) || isNaN(from)) {
            		if ((min == undefined) || (min == null)) {
                		from = 0;
                	} else {
        				from = min + Math.round(Math.abs(max - min) * 0.25);
        				from = Math.round(from * 100) / 100;	// limit to at most 2 decimal places
                	}
                }
                if ((to == undefined) || (to == null) || isNaN(to)) {
            		if ((max == undefined) || (max == null)) {
                		to = 1000;
                	} else {
                    	to = max - Math.round(Math.abs(max - min) * 0.25);
        				to = Math.round(to * 100) / 100;	// limit to at most 2 decimal places
                	}
                }
        		var oFromInput = new sas.hc.m.Input({
                	id: oPanel.sId + "_FromInput",
                    type: sap.m.InputType.Number,
                    value: sas.fscf.floatFormatter.format(from),
                    placeholder: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.from.txt")
                });
        		// set initial size and name attribute
        		oFromInput.onAfterRendering = function() {
                	if (sas.hc.m.Input.prototype.onAfterRendering) {
                		sas.hc.m.Input.prototype.onAfterRendering.apply(this);
                	}
        			$("#" + this.sId).find("input").attr("size", 8);
                	// must be set after rendering when the dom ref will exist
                	this.getDomRef().setAttribute("name", "FromInput");
        		};
        		var oToInput = new sas.hc.m.Input({
                	id: oPanel.sId + "_ToInput",
                    type: sap.m.InputType.Number,
                    value: sas.fscf.floatFormatter.format(to),
                    placeholder: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.to.txt")
                });
        		// set initial size and name attribute
        		oToInput.onAfterRendering = function() {
                	if (sas.hc.m.Input.prototype.onAfterRendering) {
                		sas.hc.m.Input.prototype.onAfterRendering.apply(this);
                	}
        			$("#" + this.sId).find("input").attr("size", 8);
                	// must be set after rendering when the dom ref will exist
                	this.getDomRef().setAttribute("name", "ToInput");
        		};

        		var handleInputChange = function (oEvent) {
        			_this.updateRangesAfterInputChange(oPanel._pId, true);
        		};
                oFromInput.attachLiveChange(handleInputChange);
                oToInput.attachLiveChange(handleInputChange);

                var oRangeInputs = new sas.hc.ui.commons.layout.HorizontalLayout({
                	id: oPanel.sId + "_RangeInputs",
                    content: [
                        oFromInput,
                        oToInput
                    ]
                });
                oRangeInputs.addStyleClass("cfGridCellRangeInputs");

                var oRangeListBox = new sap.ui.commons.ListBox({
                	id: oPanel.sId + "_RangeListBox",
                  	allowMultiSelect: (parentHLayout == _this.getContent()[0]),	// range lists in groups must be single select; others are multi-select
                   	displayIcons: true,
                   	displaySecondaryValues: true,
                   	secondaryValueTextAlign: sap.ui.core.TextAlign.End
                });
                oRangeListBox.addStyleClass("cfGridCellListBox");

                var dataRange = _this.getDataForRange(from, to);
            	var modelRange = new sap.ui.model.json.JSONModel(dataRange);

                oRangeListBox.setModel(modelRange);
                oRangeListBox.bindAggregation("items", {
                   	path: "/children",
                    factory: function(sId, oContext) {
                        var li = new sap.ui.core.ListItem(sId, {
                            key: oContext.getProperty("value"),
                      	    icon: oContext.getProperty("icon"),
                            text: oContext.getProperty("name")
                        });
                        li._exp = oContext.getProperty("exp");
                        return li;
                    }
                });

                if (!overrideRangeView) {
                    aVLContent.unshift(oRangeInputs); //prepend to beginning
                    aVLContent.unshift(oRangeLabels); //prepend to beginning                	
                    aVLContent.splice(4, 1, oRangeListBox); //swap list boxes
                }

        		// set name attribute and adjust classes, visibility and enablement
            	oRangeListBox.onAfterRendering = function() {
                   	if (sap.ui.commons.ListBox.prototype.onAfterRendering) {
                   		sap.ui.commons.ListBox.prototype.onAfterRendering.apply(this);
                   	}
                	// must be set after rendering when the dom ref will exist
                	this.getDomRef().setAttribute("name", "RangeListBox");

                	_this.commonListBoxOnAfterRendering(this, oPanel, oPageUpButton, oPageDownButton);
            	};

                oRangeListBox.attachSelect(_this, _this.commonListBoxHandleSelect);
        	}
        	
       		var oOperatorSelect = new sas.hc.m.Select({
	           	id: oPanel.sId + "_OperatorSelect",
	           	width: "100%"
	   		});

            var operators;
            var equalOperator = "EQUAL";
            if (sas.fscf.isInOperator(oPanel._operator)) {
            	equalOperator = "IN";
            }
            if (oPanel._variableType == "Character") {
              	operators = [equalOperator,"MISSING","SW","SWANY","EW","EWANY","CO","COANY"];
            } else {
               	operators = [equalOperator,"MISSING"];
            }
            var oSelectItemI;
            var key;
            for (var i = 0; i < operators.length; i++) {
               	key = oPanel._bNot ? _this.getNegativeOperator(operators[i]): operators[i];
               	oSelectItemI = new sas.hc.ui.core.Item({
               		key: key,
                  	text: sas.fscf.getLocalizedOperatorVerbose(key)
               	});
               	oOperatorSelect.addItem(oSelectItemI);
               	if (oPanel._operator == key) {
               		oOperatorSelect.setSelectedKey(key);
               	}
            }
            oOperatorSelect.attachChange(function(oEvent) {
                _this.updateOperator(oPanel, this.getSelectedKey());
            });
            
            oOperatorSelect.addStyleClass("cfGridCellOperatorSelect");
        		
       		var oOperatorInput;
        		
           	if ($.isArray(value)) {
           		oOperatorInput = _this.createOperatorMultiInput(oPanel, value);                	
           	} else {
           		oOperatorInput = _this.createOperatorInput(oPanel, value);                	
            }

            if (type == 0 || (type == 1 && overrideRangeView)) {
                aVLContent.splice(1, 0, oOperatorInput);	//insert after search field
                aVLContent.splice(1, 0, oOperatorSelect);	//insert after search field
        	}

        	if (type == 1) {
        		var oButton = new sas.hc.ui.commons.Button({
                	id: oPanel.sId + "_RangeViewButton",
   		    		icon: 'sap-icon://hc/autocompleteOptionValues',
   		    		tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.rangeView.txt"),
   		    		press: function() {
   		    			_this.toggleRange(oPanel);
   		    		}
   				});
        		oButton.addStyleClass("range");
        		if (!overrideRangeView) {
            		oButton.addStyleClass("toggled");
        		}
        		// set name attribute
            	oButton.onAfterRendering = function() {
                	if (sas.hc.ui.commons.Button.prototype.onAfterRendering) {
                		sas.hc.ui.commons.Button.prototype.onAfterRendering.apply(this);
                	}
                	// must be set after rendering when the dom ref will exist
                	this.getDomRef().setAttribute("name", "RangeViewButton");
            	};
            	oPanel.addButton(oButton);
        	}
		    var oButton2 = new sas.hc.ui.commons.Button({
               	id: oPanel.sId + "_CloseButton",
	    		icon: 'sap-icon://hc/close',
	    		tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.remove.txt"),
	    		press: function() {
	    			_this.removePanel(oPanel, parentHLayout, true);
	    		}
			})
			// set name attribute
	    	oButton2.onAfterRendering = function() {
	        	if (sas.hc.ui.commons.Button.prototype.onAfterRendering) {
	        		sas.hc.ui.commons.Button.prototype.onAfterRendering.apply(this);
	        	}
	        	// must be set after rendering when the dom ref will exist
	        	this.getDomRef().setAttribute("name", "CloseButton");
	    	};
        	oPanel.addButton(oButton2);

        	_this.updatePanelMenu(oPanel);
        	
		   	var oVertLayout = new sas.hc.ui.commons.layout.VerticalLayout({
	    	    id: oPanel.sId + "_VertLayout",
                content: aVLContent
            });
   	    	oPanel.addContent(oVertLayout);

            parentHLayout.addContent(oPanel);

            if (_this._anySelected) {
            	_this.updateCounts();
            } else {
        		_this.setPopulationIndicator(_this._totalPopulation, _this._totalPopulation);
            }

	    	_this.customSetBusy(false);

            if (successCallback) {
            	successCallback.call(oPanel);  //oPanel will be this inside the successCallback function
            }
        }).fail(function(oObj,textStatus){
	    	_this.customSetBusy(false);
        	sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, _this.getServerErrorMessage(), true, null, true);
    		_this.getPalette().enableListItem(fieldType, true);
            if (failureCallback) {
            	failureCallback.call();
            }
        });
    },
    updatePanel: function(oPanel, lbox, exp, bReset, successCallback) {
    	if ($.type(oPanel) === 'string') {
    		oPanel = sap.ui.getCore().byId(oPanel);
    	}
    	if (!oPanel) {
    		return;
    	}
    	if (!exp) {
    		bReset = true;
    	}
    	
    	this.customSetBusy(true);
        var _this = this;
    	sas.fscf.hideInlineMessage(_this.sId);
    	var fieldType;
    	if (exp) {
    		fieldType = exp.fieldName;
    	}
    	var value;
    	if (exp) {
        	value = (sas.fscf.isInOperator(exp.operator)) ? exp.values : exp.value;
    	}
		var q = (bReset) ? "" : _this.getQForFilteringOperator(exp.operator, fieldType, value);
        $.ajax({url:sas.fscf.getQueryUrl((_this.isExplore() ? "facets" : "risk"), (_this.isExplore() ? "esdb" : null), q, fieldType), contentType:"application/json; charset=utf-8", dataType:"json"})
          .done(function(oData){
	          var data = null;
	          if (oData && oData[Object.keys(oData)[0]]) {
	           	  if (oData[Object.keys(oData)[0]]['children']) {
	           		  data = oData[Object.keys(oData)[0]]['children'][0];
	           	  }
	          } else {
	        	  _this.customSetBusy(false);
	        	  sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, _this.getServerErrorMessage(), true, null, true);
	        	  return;
	          }
	          oPanel._filtering = _this.isFilteringOperator(oPanel._operator);
        	  if (!oPanel._filtering) {		// don't merge if it is a filtering operator
        		  lbox.setEnabled(true);
				  if (oPanel._variableType == "Numeric" || oPanel._variableType == "Currency") {
	        		  oPanel.addStyleClass("searchable");
	        		  oPanel.removeStyleClass("searchable");
				  } else {
	        		  oPanel.removeStyleClass("searchable");
	        		  oPanel.addStyleClass("searchable");
				  }
        		  data = _this.mergeValueIntoData(data, value);
        	  } else {
        		  lbox.setEnabled(false);
        		  oPanel.addStyleClass("searchable");
        		  oPanel.removeStyleClass("searchable");
        	  }
        	  if (_this.isValuelessOperator(oPanel._operator)) {
        		  oPanel.removeStyleClass("valueless");
        		  oPanel.addStyleClass("valueless");        		  
        	  } else {
        		  oPanel.addStyleClass("valueless");        		  
        		  oPanel.removeStyleClass("valueless");
        	  }
	          var model = new sap.ui.model.json.JSONModel(data);
	          lbox.setModel(model);
	          oPanel._value = value;

	          if (!oPanel._filtering && value != undefined && value != null && value != "") {
		          	// select values if not filtering
      	    		var key;
	        	    if ($.isArray(value)) {
						for (var j = 0; j < value.length; j++) {
							key = value[j];
							for (var k = 0; k < lbox.getItems().length; k++) {
								if (lbox.getItems()[k].getKey() == key) {
									_this.selectListBoxItem(lbox, k);
									break;
								}
							}
						}	        	  
	        	    } else {
						key = value;
						for (var k = 0; k < lbox.getItems().length; k++) {
							if (lbox.getItems()[k].getKey() == key) {
								_this.selectListBoxItem(lbox, k);
								break;
							}
						}	        	    	
	        	    }
	          }

	          _this.updateOperatorInput(oPanel);
	          
  	    	  _this.customSetBusy(false);	  	    	  

              if (successCallback) {
            	  successCallback.call(_this, oPanel);  //oPanel will be the first argument to the successCallback function
              }
          }).fail(function(oObj,textStatus){
  	    	_this.customSetBusy(false);
          	sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, _this.getServerErrorMessage(), true, null, true);
          });
    },
    update: function() {
    	this.updateCounts();
    },
    updateOperator: function(oPanel, operator) {
		var previousOperator = oPanel._operator;
		oPanel._operator = operator;
		if (this.isValuelessOperator(operator)) {
			oPanel.removeStyleClass("valueless");
			oPanel.addStyleClass("valueless");
		} else {
			oPanel.addStyleClass("valueless");
			oPanel.removeStyleClass("valueless");
		}
		this.updateOperatorInput(oPanel);
		oPanel._filtering = this.isFilteringOperator(operator);
		
		var ret = this.getForm().findCondition(oPanel._pId);
		if (ret.exp) {
			ret.exp.operator = operator;
			if ($.isArray(oPanel._value)) {
				ret.exp.values = oPanel._value;
			} else {
				ret.exp.value = oPanel._value;
			}
		}
		var bBlank = ($.isArray(oPanel._value)) ? (oPanel._value.length == 0) : ((oPanel._value == undefined) || (oPanel._value == null) || (oPanel._value == ""));
		if (bBlank) {
			if (ret.exp) {
				this.getForm().removeCondition(oPanel._pId, ret.exp);
			} else {
				if (oPanel._operator == "MISSING" || oPanel._operator == "NOTMISSING") {
					ret.exp = {
	   	               		type: "COMPARE",
	   	               		operator: oPanel._operator,
	   	               		fieldId: oPanel._fieldId,
	   	               		fieldName: oPanel.getText(),
	   	               		fieldType: oPanel._variableType,
	   	               		value: ""
	   	               	};
					this.getForm().addCondition(oPanel._pId, ret.exp);
					bBlank = false;
				}
			}
		} else {
			if (ret.exp) {
				if (ret.exp.type == "RANGE") {
					ret.exp = {
	   	               		type: "COMPARE",
	   	               		operator: oPanel._operator,
	   	               		fieldId: oPanel._fieldId,
	   	               		fieldName: oPanel.getText(),
	   	               		fieldType: oPanel._variableType,
	   	               		value: ""
	   	               	};
					this.getForm().updateCondition(oPanel._pId, ret.exp);					
				} else {
					if (oPanel._variableType == "Numeric" || oPanel._variableType == "Currency") {
						if ((ret.exp.value != undefined && ret.exp.value != null) && ((ret.exp.value[0] == " " && ret.exp.value[1] == "{") || ret.exp.value[0] == "[")) {
							ret.exp.value = "";							
						}
					}
					this.getForm().updateCondition(oPanel._pId, ret.exp);
				}
			} else {
				ret.exp = {
   	               		type: "COMPARE",
   	               		operator: oPanel._operator,
   	               		fieldId: oPanel._fieldId,
   	               		fieldName: oPanel.getText(),
   	               		fieldType: oPanel._variableType,
   	               		value: (!$.isArray(oPanel._value)) ? oPanel._value : undefined,
   	               		values: ($.isArray(oPanel._value)) ? oPanel._value : undefined
   	               	};
				this.getForm().addCondition(oPanel._pId, ret.exp);
			}
		}

		var bReset = bBlank || (this.isFilteringOperator(previousOperator) && !this.isFilteringOperator(ret.exp.operator));
      	this.updatePanel(oPanel, this.getListBoxForPanel(oPanel), ret.exp, bReset, function() {
           	this.getRelatedRows().update();
           	this.updateCounts();
       	});
    },
    updateOperatorInput: function(oPanel) {
		var oInput = this.getOperatorInputForPanel(oPanel);
		if (sas.fscf.isInOperator(oPanel._operator)) {
			if (!(oInput instanceof sas.hc.m.MultiInput)) {
	        	var vl = this.getVerticalLayoutForPanel(oPanel);
	        	oInput = vl.removeContent(2); 	//remove current filter input
	        	oInput.destroy();				//destroy current filter input
	        	oInput = null;
	        	if (!$.isArray(oPanel._value)) {
	        		if (oPanel._value != null && oPanel._value.length > 0) {
		        		oPanel._value = new Array(oPanel._value);
	        		} else {
	        			oPanel._value = new Array();
	        		}
	        	}
	            oInput = this.createOperatorMultiInput(oPanel, oPanel._value);
	            vl.insertContent(oInput, 2);	//insert new filter input
			} else {
				oInput.destroyTokens();
				for (var k in oPanel._value) {
					oInput.addToken(new sas.hc.m.Token({key: oPanel._value[k], text:oPanel._value[k]}));
				}
			}					
		} else {
			if (oInput instanceof sas.hc.m.MultiInput) {
	        	var vl = this.getVerticalLayoutForPanel(oPanel);
	        	oInput = vl.removeContent(2); 	//remove current filter input
	        	oInput.destroy();				//destroy current filter input
	        	oInput = null;
	        	if ($.isArray(oPanel._value)) {
	        		if (oPanel._value.length > 0) {
		        		oPanel._value = oPanel._value[0];
	        		} else {
	        			oPanel._value = "";
	        		}
	        	}
	            oInput = this.createOperatorInput(oPanel, oPanel._value);
	            vl.insertContent(oInput, 2);	//insert new filter input
			} else {
				if ($.isArray(oPanel._value)) {
					oPanel._value = oPanel._value[0];
				}
				oInput.setValue(oPanel._value);
			}
		}
		this.updateOperatorSelectEqualsItem(oPanel);
    },
    removePanel: function(oPanel, parentHLayout, bUpdateCounts) {
    	if ($.type(oPanel) === 'string') {
    		oPanel = sap.ui.getCore().byId(oPanel);
    	}
    	if (!oPanel) {
    		return;
    	}
    	sas.fscf.hideInlineMessage(this.sId);
    	var fieldType = oPanel.getText();
    	var iof = parentHLayout.indexOfContent(oPanel);
    	var indices = oPanel._pId.split("-");
    	var level = indices.length - 1;
    	parentHLayout.removeContent(oPanel);
    	var lbox = this.getListBoxForPanel(oPanel);
    	var bIsFiltered = this.isFilteringOperator(oPanel._operator);
		if (!bIsFiltered) {
	    	if (lbox.getSelectedIndices().length == 0) {
	        	lbox = this.getOtherListBoxForPanel(oPanel);
	    	}
		}
    	var bAnySelectedThisPanel = this.notifyDeselects(oPanel, lbox, true);
    	oPanel.destroy();
    	// remove any parent group panel if there is one and it is empty
    	if (level > 1 && parentHLayout.getContent().length == 0) {
    		indices.length = indices.length - 1;
    		var oGroup = this.getPanelNamed(indices.join("-"));
    		var g_parentHLayout;
    		if (level > 2) {
    			indices.length = indices.length - 1;
    			g_parentHLayout = sap.ui.getCore().byId(this.getPanelNamed(indices.join("-")).sId + "_HorizLayout");
    		} else {
    			g_parentHLayout = this.getContent()[0];
    		}
    		iof = g_parentHLayout.indexOfContent(oGroup);
    		g_parentHLayout.removeContent(oGroup);
    		oGroup.destroy();
    		parentHLayout = g_parentHLayout;
    		level--;
    	}
    	this.modifyIds(parentHLayout, iof, level, -1);
    	if (bUpdateCounts && (bAnySelectedThisPanel || bIsFiltered)) {
        	if (this.getContent()[0].getContent().length > 0) {
            	this.getRelatedRows().update();
            	this.updateCounts();
        	} else {
        		this.setPopulationIndicator(this._totalPopulation, this._totalPopulation);
            	this.getRelatedRows().update();
        		this._anySelected = false;
        	}
    	}
    	if (!this.containsField(fieldType)) {
    		this.getPalette().enableListItem(fieldType, true);
    	}
    },
    modifyIds: function(parent, startIndex, level, delta){
    	var oPanel;
    	var pId;
    	var indices;
    	var subPanels;
    	var subPanel;
    	for (var i = startIndex; i < parent.getContent().length; i++) {
    		oPanel = parent.getContent()[i];
    		pId = oPanel._pId;
        	indices = pId.split("-");
        	if (level > indices.length - 1) {
        		return;
        	}
        	indices[level] = parseInt(indices[level]) + delta;
    		pId = indices.join("-");
    		oPanel._pId = pId;
    		// get sub-panels if there are any
    		subPanels = oPanel.getDomRef().getElementsByClassName("sapUiPanel");
    		for (var j = 0; j < subPanels.length; j++) {
    			subPanel = sap.ui.getCore().byId(subPanels[j].id);
        		pId = subPanel._pId;
            	indices = pId.split("-");
            	indices[level] = parseInt(indices[level]) + delta;
        		pId = indices.join("-");
        		subPanel._pId = pId;
    		}
    	}
    },
    removeAllPanels: function(bSkipNotify) {
    	sas.fscf.hideInlineMessage(this.sId);
    	var panels = this.getContent()[0].removeAllContent();
		this.setPopulationIndicator(this._totalPopulation, this._totalPopulation);
		var palette = this.getPalette();
		var bAnyFiltered = false;
		for (var i = panels.length - 1; i >=0; i--) {
			bAnyFiltered = bAnyFiltered || this.isFilteringOperator(panels[i]._operator);
    		palette.enableListItem(panels[i].getText(), true);
    		if (!bSkipNotify) {
    			this.getForm().removeAllConditions();
    		}
			panels[i].destroy();
		}
		if (this._anySelected || bAnyFiltered) {
			sas.fscf.getCurrentPageView().setDirty(true);
	    	this.getRelatedRows().update();
		}
		this._anySelected = false;
    },
	updateRangesAfterInputChange: function (pId, bNotifyForm) {
		var oPanel = this.getPanelNamed(pId);
		var oListBox = this.getListBoxForPanel(oPanel);
		var oFromInput = sap.ui.getCore().byId(oPanel.sId + "_FromInput");
		var oToInput = sap.ui.getCore().byId(oPanel.sId + "_ToInput");

		if ((oFromInput.getValueState() != sap.ui.core.ValueState.Error) &&
			(oToInput.getValueState() != sap.ui.core.ValueState.Error)) {
			var from = sas.fscf.floatFormatter.parse(oFromInput.getValue());
			var to = sas.fscf.floatFormatter.parse(oToInput.getValue());

        	// get all of the selections
    		var selIndices = oListBox.getSelectedIndices();
    		var selItems = oListBox.getSelectedItems();
    		var itemCount = oListBox.getItems().length;

            var dataRange = this.getDataForRange(from, to);
			// replace and re-bind
            oListBox.getModel().setData(dataRange);

    		var itemCountAfter = oListBox.getItems().length;
    		if (itemCountAfter < itemCount) {
    			for (var j = 0; j < selIndices.length; j++) {
    				if (selIndices[j] == 5) selIndices[j] = 3;
    				if (selIndices[j] == 6) selIndices[j] = 4;
    				if (selIndices[j] == 7) selIndices[j] = 2;
    				if (selIndices[j] == 8) selIndices[j] = 3;
    				if (selIndices[j] == 9) selIndices[j] = 4;
    			}
    		}

			// re-select what was selected before the re-bind
			for (var j = 0; j < selIndices.length; j++) {
				this.selectListBoxItem(oListBox, selIndices[j]);
			}
			oListBox._priorSelectedIndices = selIndices;

			// notify the form
			if (bNotifyForm || selIndices.length > 1) {
				var exp;
	            var field = oPanel.getText();
	            var fieldId = oPanel._fieldId;
	            var variableType = oPanel._variableType;
				for (var j = 0; j < selItems.length; j++) {
	                exp = oListBox.getItems()[selIndices[j]]._exp;
	                if (exp) {
						this.getForm().replaceCondition(oPanel._pId, {
    	               		type: ((exp.leftValue != null) && (exp.leftValue != undefined)) ? "RANGE" : "COMPARE",
    	               		operator: exp.operator,
    	               		fieldId: fieldId,
    	               		fieldName: field,
    	               		fieldType: variableType,
    	               		value: exp.value,
    	               		leftValue: exp.leftValue,
    	               		rightValue: exp.rightValue,
    	               		leftOperator: exp.leftOperator,
    	               		rightOperator: exp.rightOperator
    	               	});
	                }
				}
				this.getForm().initSplitForm();
			}
		}
	},
	updateAfterOperatorInputChange: function (oPanel, value) {
		oPanel._value = value;
		var ret = this.getForm().findCondition(oPanel._pId);
		if (ret.exp) {
			if ($.isArray(oPanel._value)) {
				ret.exp.values = oPanel._value;
			} else {
				ret.exp.value = oPanel._value;
			}
		}

		var bBlank = ($.isArray(oPanel._value)) ? (oPanel._value.length == 0) : ((oPanel._value == undefined) || (oPanel._value == null) || (oPanel._value == ""));
		if (bBlank) {
			if (ret.exp) {
				this.getForm().removeCondition(oPanel._pId, ret.exp);
			}
		} else {
			if (ret.exp) {
				this.getForm().updateCondition(oPanel._pId, ret.exp);
			} else {
				ret.exp = {
   	               		type: "COMPARE",
   	               		operator: oPanel._operator,
   	               		fieldId: oPanel._fieldId,
   	               		fieldName: oPanel.getText(),
   	               		fieldType: oPanel._variableType,
   	               		value: (!$.isArray(oPanel._value)) ? oPanel._value : undefined,
   	               		values: ($.isArray(oPanel._value)) ? oPanel._value : undefined
   	               	};
				this.getForm().addCondition(oPanel._pId, ret.exp);
			}
		}

		var bReset = bBlank;
      	this.updatePanel(oPanel, this.getListBoxForPanel(oPanel), ret.exp, bReset, function() {
           	this.getRelatedRows().update();
           	this.updateCounts();
       	});		
	},
	notifyDeselects: function(panel, lbox, bModifyIds) {
    	if (lbox) {
    		if (lbox.getSelectedIndices().length > 0) {
               	this.getForm().removeCondition(panel._pId, null, bModifyIds);
        		return true;
    		} else {
    			// attempt to remove a matching expression in the model anyways, as the user may have created
    			// an expression in the full form using a field that has no data, in which case there will be
    			// a panel with nothing selected for that expression
               	this.getForm().removeCondition(panel._pId, null, bModifyIds);
    			return false;
    		}
    	}
    },
    selectListBoxItem: function(oListBox, index) {
    	if (oListBox.getItems()[index]) {
    		$lbi = $(oListBox.getItems()[index].getDomRef());
    		$lbi.addClass("sapUiLbxISel");
    		$lbi.attr("aria-selected", true);
    		oListBox.addSelectedIndex(index);
    	}
    },
    deselectListBoxItem: function(oListBox, index) {
    	if (oListBox.getItems()[index]) {
    		$lbi = $(oListBox.getItems()[index].getDomRef());
    		$lbi.removeClass("sapUiLbxISel");
    		$lbi.attr("aria-selected", false);
    		oListBox.removeSelectedIndex(index);
    	}
    },
    selectListBoxItemFromExp: function(bSelect, lbox, exp) {
    	var _this = this;
    	if (lbox && exp && !_this.isFilteringOperator(exp.operator)) {
    		if ((exp.type == "COMPARE" && sas.fscf.isInOperator(exp.operator)) && !(exp.value && exp.value.length > 0)) {
        		var value;
				var bFound = false;
        		for (var j = 0; j < exp.values.length; j++) {
        			value = exp.values[j];
            		var li;
            		_this.selectValueInData(lbox.getModel().getData(), value, bSelect);
					bFound = false;
            		for (var i = 0; i < lbox.getItems().length; i++) {
       					li = lbox.getItems()[i];
       					if (li.getKey() == value) {
	   						bFound = true;
       						bSelect ? this.selectListBoxItem(lbox, i) : this.deselectListBoxItem(lbox, i);
       						break;
       					}
            		}
	        		if (!bFound && bSelect) {
    					var newItem = new sap.ui.core.ListItem({
                              key: value,
                              text: value,
                              additionalText: _this._bPercentages ? sas.fscf.percentFormatter.format(0) : sas.fscf.floatFormatter.format(0)
                        });
    					lbox.addItem(newItem);
    					this.selectListBoxItem(lbox, lbox.indexOfItem(newItem));
	        		}
        		}
        	}
    		else if (((exp.type == "COMPARE") && ((exp.fieldType == "Numeric") || (exp.fieldType == "Currency"))) ||
    			((exp.type == "RANGE") && (exp.leftValue == exp.rightValue))) {
    			    var operator;
        			if (exp.type == "COMPARE") {
        				operator = exp.operator;
        			} else {
        				operator = exp.leftOperator;
        			}
        			if ((lbox.getItems().length == 5) && (lbox.getItems()[0]._exp)) {
            			if (operator == "GT") {
            				bSelect ? this.selectListBoxItem(lbox, 0) : this.deselectListBoxItem(lbox, 0);
            			} else if (operator == "GTE") {
    						bSelect ? this.selectListBoxItem(lbox, 1) : this.deselectListBoxItem(lbox, 1);
            			} else if (operator == "EQUAL") {
    						bSelect? this.selectListBoxItem(lbox, 2) : this.deselectListBoxItem(lbox, 2);
            			} else if (operator == "LTE") {
    						bSelect ? this.selectListBoxItem(lbox, 3) : this.deselectListBoxItem(lbox, 3);
            			} else if (operator == "LT") {
    						bSelect ? this.selectListBoxItem(lbox, 4) : this.deselectListBoxItem(lbox, 4);
            			}
        			} else if ((lbox.getItems().length == 10) && (lbox.getItems()[0]._exp)) {
            			if (operator == "GT") {
            				bSelect ? this.selectListBoxItem(lbox, 0) : this.deselectListBoxItem(lbox, 0);
            			} else if (operator == "GTE") {
    						bSelect ? this.selectListBoxItem(lbox, 1) : this.deselectListBoxItem(lbox, 1);
            			} else if ((operator == "EQUAL") && (lbox.getItems()[2]._exp.value == exp.value)) {
    						bSelect? this.selectListBoxItem(lbox, 2) : this.deselectListBoxItem(lbox, 2);
            			} else if ((operator == "EQUAL") && (lbox.getItems()[7]._exp.value == exp.value)) {
    						bSelect? this.selectListBoxItem(lbox, 2) : this.deselectListBoxItem(lbox, 7);
            			} else if (operator == "LTE") {
    						bSelect ? this.selectListBoxItem(lbox, 3) : this.deselectListBoxItem(lbox, 8);
            			} else if (operator == "LT") {
    						bSelect ? this.selectListBoxItem(lbox, 4) : this.deselectListBoxItem(lbox, 9);
            			}
        			} else {
    	        		var li;
   						_this.selectValueInData(lbox.getModel().getData(), parseFloat(exp.value), bSelect);
   						var bFound = false;
    	        		for (var i = 0; i < lbox.getItems().length; i++) {
    	   					li = lbox.getItems()[i];
    	   					if (parseFloat(li.getKey()) == parseFloat(exp.value)) {
    	   						bFound = true;
    	   						bSelect ? this.selectListBoxItem(lbox, i) : this.deselectListBoxItem(lbox, i);
    	   						break;
    	   					}
    	        		}
    	        		if (!bFound && bSelect) {
	    					var newItem = new sap.ui.core.ListItem({
	                              key: parseFloat(exp.value),
	                              text: _this.convertToFormattedNumber(parseFloat(exp.value)),
                                  additionalText: _this._bPercentages ? sas.fscf.percentFormatter.format(0) : sas.fscf.floatFormatter.format(0)
	                        });
	    					lbox.addItem(newItem);
	    					this.selectListBoxItem(lbox, lbox.indexOfItem(newItem));
    	        		}
        			}
        	} else if (exp.type == "RANGE") {
        			if ((exp.leftOperator == "LTE") && (exp.rightOperator == "LTE")) {
						bSelect ? this.selectListBoxItem(lbox, 3) : this.deselectListBoxItem(lbox, 3);
        			} else if ((exp.leftOperator == "LT") && (exp.rightOperator == "LTE")) {
						bSelect ? this.selectListBoxItem(lbox, 4) : this.deselectListBoxItem(lbox, 4);
        			} else if ((exp.leftOperator == "LTE") && (exp.rightOperator == "LT")) {
						bSelect ? this.selectListBoxItem(lbox, 5) : this.deselectListBoxItem(lbox, 5);
        			} else if ((exp.leftOperator == "LT") && (exp.rightOperator == "LT")) {
						bSelect ? this.selectListBoxItem(lbox, 6) : this.deselectListBoxItem(lbox, 6);
        			}
        	} else {
	        		var li;
					_this.selectValueInData(lbox.getModel().getData(), exp.value, bSelect);
					var bFound = false;
	        		for (var i = 0; i < lbox.getItems().length; i++) {
	   					li = lbox.getItems()[i];
	   					if (li.getKey() == exp.value) {
	   						bFound = true;
	   						bSelect ? this.selectListBoxItem(lbox, i) : this.deselectListBoxItem(lbox, i);
	   						break;
	   					}
	        		}
	        		if (!bFound && bSelect) {
    					var newItem = new sap.ui.core.ListItem({
                              key: exp.value,
                              text: exp.value,
                              additionalText: _this._bPercentages ? sas.fscf.percentFormatter.format(0) : sas.fscf.floatFormatter.format(0)
                        });
    					lbox.addItem(newItem);
    					this.selectListBoxItem(lbox, lbox.indexOfItem(newItem));
	        		}
        	}
    	}
    },
    conditionModified: function(pId, expBefore, expAfter) {
    	var _this = this;
    	if (!expAfter || !expAfter.fieldName) {
    		return;
    	}
		//console.info("conditionModified, pId = " + pId + ", expBefore = " + JSON.stringify(expBefore) + ", expAfter = " + JSON.stringify(expAfter));
		sas.fscf.getCurrentPageView().setDirty(true);
    	var oPanel = this.getPanelNamed(pId);
    	if (!oPanel) {
    		// could be a multi-select OR block, so try the parent
    		var id_indices = pId.split("-");
    		id_indices.length = id_indices.length - 1;
    		pId = id_indices.join("-");
    		oPanel = this.getPanelNamed(pId);
    	}
    	if (oPanel) {
        	var lbox = this.getListBoxForPanel(oPanel);
        	if (this.isFilteringOperator(expAfter.operator)) {
        		this.updatePanel(oPanel, lbox, expAfter, false, this.finishConditionModified);
        	} else {
	    		if (expAfter.type == "COMPARE" && !sas.fscf.isInOperator(expAfter.operator)) {
	    			if ((oPanel._rangeable) && ((expAfter.fieldType == "Numeric") || (expAfter.fieldType == "Currency"))) {
		    			var inp = sap.ui.getCore().byId(oPanel.sId + "_FromInput");
		    			if (inp) {
		    				inp.setValue(sas.fscf.floatFormatter.format(expAfter.value));
		    			}
		    			inp = sap.ui.getCore().byId(oPanel.sId + "_ToInput");
		    			if (inp) {
		    				inp.setValue(sas.fscf.floatFormatter.format(expAfter.value));
		    			}
		    			this.updateRangesAfterInputChange(oPanel._pId, false);
	    			} else {
	    				this.selectListBoxItemFromExp(false, lbox, expBefore);
	    				this.selectListBoxItemFromExp(true, lbox, expAfter);
	    			}
	    		}
	    		else if (expAfter.type == "COMPARE" && sas.fscf.isInOperator(expAfter.operator)) {
	    			if (expBefore.value && expBefore.value.length > 0) {
	    				this.selectListBoxItemFromExp(false, lbox, expBefore);
	    			} else if (expAfter.value && expAfter.value.length > 0) {
	    				this.selectListBoxItemFromExp(true, lbox, expAfter);
	    			}
	    		}
	    		else if (expAfter.type == "RANGE") {
	    			var inp = sap.ui.getCore().byId(oPanel.sId + "_FromInput");
	    			if (inp) {
	    				inp.setValue(sas.fscf.floatFormatter.format(expAfter.leftValue));
	    			}
	    			inp = sap.ui.getCore().byId(oPanel.sId + "_ToInput");
	    			if (inp) {
	    				inp.setValue(sas.fscf.floatFormatter.format(expAfter.rightValue));
	    			}
	    			this.updateRangesAfterInputChange(oPanel._pId, false);
	    		}
                this.finishConditionModified(oPanel);
        	}
    	}
    },
    finishConditionModified: function(oPanel) {
    	this.getRelatedRows().update();
       	this.updateCounts(function () {
       		// success callback
    		sas.fscf.getCurrentPageView().setDirty(true);
       	});
    },
    conditionDeleted: function(pId, exp) {
    	if (!pId || !exp) {
    		return;
    	}
		//console.info("conditionDeleted, pId = " + pId + ", exp = " + JSON.stringify(exp));
    	var oPanel = this.getPanelNamed(pId);
    	if (!oPanel) {
    		// could be a multi-select OR block, so try the parent
    		var id_indices = pId.split("-");
    		id_indices.length = id_indices.length - 1;
    		pId = id_indices.join("-");
    		oPanel = this.getPanelNamed(pId);
    	}
    	if (oPanel) {
            oPanel._operator = "EQUAL";   	// reset operator
        	var lbox = this.getListBoxForPanel(oPanel);
        	if (this.isFilteringOperator(exp.operator)) {
        		exp.value = undefined;		// reset value
        		exp.values = undefined;		// reset value
        		this.updatePanel(oPanel, lbox, exp, true, this.finishConditionDeleted);
        	} else {
                this.selectListBoxItemFromExp(false, lbox, exp);
                this.finishConditionDeleted(oPanel);
        	}
        }
    },
    finishConditionDeleted: function(oPanel) {
        this.setNot(false, oPanel);   // turn off not if it is on
        oPanel._value = null;		  // reset value
        oPanel._filtering = false;	  // reset filtering
    	var lbox = this.getListBoxForPanel(oPanel);
        lbox.setEnabled(true);
    	lbox = this.getOtherListBoxForPanel(oPanel);
    	if (lbox) {
            lbox.setEnabled(true);
    	}
       	this.updateOperatorSelectEqualsItem(oPanel);
       	this.updateSelectedOperator(oPanel);
       	this.getRelatedRows().update();
       	this.updateCounts(function () {
       		// success callback
    		sas.fscf.getCurrentPageView().setDirty(true);
       	});
    },
    containsField: function(fieldType) {
    	if (this.getContent()[0]) {
        	for (var i = 0; i < this.getContent()[0].getContent().length; i++) {
        		if (this.getContent()[0].getContent()[i].getText() == fieldType) {
        			return true;
        		}
        	}
    	}
    	return false;
    },
    getPanelNamed: function(name) {
    	var elems = document.getElementsByName(name);
    	if (elems.length > 0) {
        	return sap.ui.getCore().byId(elems[0].id);
    	} else {
    		return null;
    	}
    },
    getPalette: function() {
    	return sap.ui.getCore().byId(this.sId.substr(0, this.sId.indexOf("GridView")) + "PaletteView");
    },
    getForm: function() {
    	return sap.ui.getCore().byId(this.sId.substr(0, this.sId.indexOf("GridView")) + "FormView");
    },
    getRelatedRows: function() {
    	return sap.ui.getCore().byId(this.sId.substr(0, this.sId.indexOf("GridView")) + "RelatedRowsView");
    },
    _oData: null,
    _anySelected: false,
    _totalPopulation: 0,
    _bPercentages: false,
    updateCounts: function(successCallback, failureCallback) {
    	this.customSetBusy(true);

    	var _this = this;
    	_this.refreshInlineMessage();

    	// get all of the selections
    	var panel;
    	var allSelItems = [];
    	var fields = [];
    	var qsegments = [];
    	var ret;

		this._anySelected = false;
    	for (var i = 0; i < this.getContent()[0].getContent().length; i++) {
    		panel = this.getContent()[0].getContent()[i];
    		if (panel._isGroup) {
    			ret = this.processSelItemsForGroup(panel);
    		} else {
    			ret = this.processSelItemsForPanel(panel);
    		}
    		if (ret) {
    			$.merge(fields, ret.fields);
    			allSelItems[allSelItems.length] = ret.selItems;
    			if (ret.anySelected) {
    				this._anySelected = true;
    			}
    			if (ret.qsegment && ret.qsegment.length > 0) {
        	    	qsegments[qsegments.length] = ret.qsegment;
    			}
    		}
    	}

    	// and update the counts and re-bind the data models
    	var q = "*:*";
		if (qsegments.length > 0) {
			var ruleOverallType = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition.type;
			if (ruleOverallType == "OR") {
				q = encodeURIComponent(qsegments.join(" OR "));
			} else if (ruleOverallType == "NOR") {
	   			q = "*:* NOT (" + encodeURIComponent(qsegments.join(" OR ")) + ")";
			} else {
				q = encodeURIComponent(qsegments.join(" AND "));
			}
		}
        $.ajax({url:sas.fscf.getQueryUrl((_this.isExplore() ? "facets" : "risk"), (_this.isExplore() ? "esdb" : null), q, fields), contentType:"application/json; charset=utf-8", dataType:"json"})
          .done(function(oData){
        	_this._oData = oData;
        	var panel;
			for (var i = 0; i < _this.getContent()[0].getContent().length; i++) {
				panel = _this.getContent()[0].getContent()[i];
				if (panel._isGroup) {
					_this.postProcessSelItemsForGroup(panel, allSelItems[i]);
				} else {
					_this.postProcessSelItemsForPanel(panel, allSelItems[i]);
				}
			}
			if (oData && oData[Object.keys(oData)[0]]) {
	        	_this._totalPopulation = oData[Object.keys(oData)[0]]["total"];
				_this.setPopulationIndicator(_this._totalPopulation, oData[Object.keys(oData)[0]]["match"]);
			}
	    	_this.customSetBusy(false);

            if (successCallback) {
            	successCallback.call();
            }
        }).fail(function(oObj,textStatus){
	    	_this.customSetBusy(false);
        	sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, _this.getServerErrorMessage(), true, null, true);
            if (failureCallback) {
            	failureCallback.call();
            }
        });
    },
    processSelItemsForPanel: function(oPanel) {
    	if (!oPanel._isGroup) {
        	var panel, lbox, selItems;
        	var fields = [];
        	var qsegment = "";
        	var qsegments = [];
        	var bAnySelected = false;
        	panel = oPanel;
    		fields[fields.length] = panel.getText();
    		lbox = this.getListBoxForPanel(panel);
    		selItems = lbox.getSelectedItems();
    		if (selItems.length > 0) {
    			bAnySelected = true;
    	    	for (var j = 0; j < selItems.length; j++) {
    	    		qsegment = panel.getText() + ":";
    	    		if (panel._type != 1) {
        	    		qsegment += "\"";
    	    		}
    	    		if ((oPanel._type == 1) && !oPanel._rangeable) {
        	    		qsegment += "[" + selItems[j].getKey() + " TO " + selItems[j].getKey() + "]";
    	    		} else {
        	    		qsegment += selItems[j].getKey();
    	    		}
    	    		if (panel._type != 1) {
        	    		qsegment += "\"";
    	    		}
        	    	qsegments[qsegments.length] = qsegment;
    	    	}
				if (panel._bNot) {
        			qsegment = panel.getText() + ":* NOT (";
					qsegment += qsegments.join(" AND ");
        		} else {
					qsegment = "(";
					qsegment += qsegments.join(" OR ");
				}
    			qsegment += ")";
    		} else {
    			qsegment = this.getQForFilteringOperator(panel._operator, panel.getText(), panel._value);
    		}
			return {fields: fields, selItems: selItems, anySelected: bAnySelected, qsegment: qsegment};
    	}
    },
    processSelItemsForGroup: function(oPanel) {
    	if (oPanel._isGroup) {
        	var panel, lbox, selItems;
        	var allSelItems = [];
        	var fields = [];
        	var qsegment = "";
        	var qsegments = [];
        	var bAnySelected = false;
        	for (var i = 0; i < sap.ui.getCore().byId(oPanel.sId + "_HorizLayout").getContent().length; i++) {
        		panel = sap.ui.getCore().byId(oPanel.sId + "_HorizLayout").getContent()[i];
        		fields[fields.length] = panel.getText();
        		lbox = this.getListBoxForPanel(panel);
        		selItems = lbox.getSelectedItems();
        		allSelItems[allSelItems.length] = selItems;
        		if (selItems.length > 0) {
        			bAnySelected = true;
       	    		qsegment = panel.getText() + ":";
       	    		if (panel._type != 1) {
           	    		qsegment += "\"";
       	    		}
       	    		qsegment += selItems[0].getKey();
       	    		if (panel._type != 1) {
           	    		qsegment += "\"";
       	    		}
        	    	qsegments[qsegments.length] = qsegment;
        		}
        	}
			qsegment = "(";
			if (oPanel._groupType == "NOR") {
				qsegment += "*:* NOT (";
				qsegment += qsegments.join(" OR ");
				qsegment += ")";

			} else {
				qsegment += qsegments.join(" " + oPanel._groupType + " ");
			}
			qsegment += ")";
			return {fields: fields, selItems: allSelItems, anySelected: bAnySelected, qsegment: qsegment};
    	}
    },
    postProcessSelItemsForPanel: function(oPanel, selItems) {
    	if (!oPanel._isGroup) {
    		var panel = oPanel;
        	var lbox, dataForField, sourceArray, mergeArray, mergeData, key, $lbi;
    		lbox = this.getListBoxForPanel(panel);
			dataForField = this.getDataForField(panel.getText());
			if (this._anySelected) {
				// merge
				if (dataForField) {
					mergeArray = dataForField['children'];
				} else {
					mergeArray = null;
				}
				try {
					sourceArray = lbox.getModel().getData()['children'];
				} catch (ex) {
					sourceArray = null;
				}
				if (sourceArray) {
					for (var j = 0; j < sourceArray.length; j++) {
						mergeData = this.getMergeArrayDataForName(mergeArray, sourceArray[j]['name']);
						sourceArray[j]['size'] = mergeData['size'];
						sourceArray[j]['pct'] = mergeData['pct'];
					}
					// any still left in mergeArray were not found and need to be added
					if (mergeArray) {
						for (var j = 0; j < mergeArray.length; j++) {
							sourceArray.push(mergeArray[j]);
						}
					}
					if (!panel._rangeable) {
						// re-bind
						lbox.getModel().refresh();
						lbox.getBinding("items").sort(lbox.getBinding("items").aSorters);

						// re-select what was selected before the re-bind
						for (var j = 0; j < selItems.length; j++) {
							key = selItems[j].getKey();
							for (var k = 0; k < lbox.getItems().length; k++) {
								if (lbox.getItems()[k].getKey() == key) {
									this.selectListBoxItem(lbox, k);
									break;
								}
							}
						}
					}
				}
			} else {
				if (!panel._rangeable) {
					// replace and re-bind
					lbox.getModel().setData(dataForField);
				}
			}
			lbox._priorSelectedIndices = lbox.getSelectedIndices();
    	}
    },
    postProcessSelItemsForGroup: function(oPanel, selItems) {
    	if (oPanel._isGroup) {
    		var panel;
        	for (var i = 0; i < sap.ui.getCore().byId(oPanel.sId + "_HorizLayout").getContent().length; i++) {
        		panel = sap.ui.getCore().byId(oPanel.sId + "_HorizLayout").getContent()[i];
        		this.postProcessSelItemsForPanel(panel, selItems[i]);
        	}
    	}
    },
    mergeValueIntoData: function(oData, value) {
    	if (value == undefined || value == null || value == "" || oData == undefined || oData == null || oData['children'] == undefined) {
    		return oData;
    	}
    	var bFound = false;
    	if ($.isArray(value)) {
    		for (var j = 0; j < value.length; j++) {
    			bFound = false;
        		for (var i = 0; i < oData['children'].length; i++) {
        			if (oData['children'][i].name == value[j]) {
        				bFound = true;
        				oData['children'][i].sel = 1;
        				break;
        			}
        		}
        		if (!bFound) {
        			oData['children'][oData['children'].length] = {"name": value[j], "pct": 0, "size": 0, "sel": 1};
        			oData['size'] = oData['size'] + 1;
        		}
    		}
    	} else {
    		for (var i = 0; i < oData['children'].length; i++) {
    			if (oData['children'][i].name == value) {
    				bFound = true;
    				oData['children'][i].sel = 1;
    				break;
    			}
    		}
    		if (!bFound) {
    			oData['children'][oData['children'].length] = {"name": value, "pct": 0, "size": 0, "sel": 1};
    			oData['size'] = oData['size'] + 1;
    		}
    	}
    	return oData;
    },
    selectValueInData: function(oData, value, bSelect) {
    	if (value == undefined || value == null || oData == undefined || oData == null || oData['children'] == undefined) {
    		return;
    	}
    	var bFound = false;
   		for (var i = 0; i < oData['children'].length; i++) {
   			if (oData['children'][i].name == value) {
				bFound = true;
   				oData['children'][i].sel = (bSelect) ? 1 : 0;
   				break;
   			}
   		}
   		if (!bFound && bSelect) {
			oData['children'][oData['children'].length] = {"name": value, "pct": 0, "size": 0, "sel": 1};
			oData['size'] = oData['size'] + 1;   			
   		}
    },
    getDataForField: function(fieldType) {
    	if (!this._oData || !this._oData[Object.keys(this._oData)[0]]) {
    		return null;
    	}
    	var fields = this._oData[Object.keys(this._oData)[0]]['children'];
    	if (!fields) {
    		return null;
    	}
    	for (var i = 0; i < fields.length; i++) {
    		if (fields[i]['name'] == fieldType) {
    			return fields[i];
    		}
    	}
    	return null;
    },
    getMergeArrayDataForName: function(mergeArray, name) {
    	if (!mergeArray) {
    		return {"size":0, "pct":0};
    	}
    	for (var i = 0; i < mergeArray.length; i++) {
    		if (mergeArray[i]['name'] == name) {
    			var item = mergeArray.splice(i, 1)[0];		// remove the item from mergeArray after it is found
    			return {"size":item['size'], "pct":item['pct']};
    		}
    	}
		return {"size":0, "pct":0};
    },
    setPopulationIndicator: function(total, current) {
		var oProgIndicator = sap.ui.getCore().byId(this.sId.substr(0, this.sId.indexOf("GridView")) + "GridToolbarViewGridToolbarPopulationIndicator");
		if (oProgIndicator) {
			if (total != 0) {
				oProgIndicator.setPercentValue((current / total) * 100);
				oProgIndicator.setDisplayValue(sas.fscf.percentFormatter.format(current / total) + " " + sas.fscf.rb.getText("rules.rulesPage.guidedView.population.xofy.fmt.txt", [sas.fscf.floatFormatter.format(current), sas.fscf.floatFormatter.format(total)]));
			} else {
				oProgIndicator.setPercentValue(100);
				oProgIndicator.setDisplayValue(sas.fscf.percentFormatter.format(1));
			}
		}
    },
    getDataForRange: function(low, high) {
    	if (typeof low != "number") {
    		low = parseFloat(low);
    	}
    	if (typeof high != "number") {
    		high = parseFloat(high);
    	}
    	var data = {};
    	var children = [];
    	var child = {};
    	if (isNaN(low) || isNaN(high) || (low == high)) {
    		if (!(isNaN(low) && isNaN(high))) {
    			var one = isNaN(low) ? high : low;
            	child["icon"] = "resources/sas/fscf/views/range1-1.png";
            	child["name"] = "n > " + sas.fscf.floatFormatter.format(one);
            	child["value"] = " {" + one + " TO *}";
            	child["exp"] = {operator:"GT", value:one};
            	children[children.length] = child;
            	child = {};
            	child["icon"] = "resources/sas/fscf/views/range1-2.png";
            	child["name"] = "n >= " + sas.fscf.floatFormatter.format(one);
            	child["value"] = "[" + one + " TO *]";
            	child["exp"] = {operator:"GTE", value:one};
            	children[children.length] = child;
            	child = {};
            	child["icon"] = "resources/sas/fscf/views/range1-3.png";
            	child["name"] = "n = " + sas.fscf.floatFormatter.format(one);
            	child["value"] = "[" + one + " TO " + one + "]";
            	child["exp"] = {operator:"EQUAL", value:one};
            	children[children.length] = child;
            	child = {};
            	child["icon"] = "resources/sas/fscf/views/range1-4.png";
            	child["name"] = "n <= " + sas.fscf.floatFormatter.format(one);
            	child["value"] = "[* TO " + one + "]";
            	child["exp"] = {operator:"LTE", value:one};
            	children[children.length] = child;
            	child = {};
            	child["icon"] = "resources/sas/fscf/views/range1-5.png";
            	child["name"] = "n < " + sas.fscf.floatFormatter.format(one);
            	child["value"] = " {* TO " + one + "}";
            	child["exp"] = {operator:"LT", value:one};
            	children[children.length] = child;
    		}
    	} else {
    		if (high < low) {
    			var temp = high;
    			high = low;
    			low = temp;
    		}
        	child["icon"] = "resources/sas/fscf/views/range2-1.png";
        	child["name"] = "n > " + sas.fscf.floatFormatter.format(high);
        	child["value"] = " {" + high + " TO *}";
        	child["exp"] = {operator:"GT", value:high};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-2.png";
        	child["name"] = "n >= " + sas.fscf.floatFormatter.format(high);
        	child["value"] = "[" + high + " TO *]";
        	child["exp"] = {operator:"GTE", value:high};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-3.png";
        	child["name"] = "n = " + sas.fscf.floatFormatter.format(high);
        	child["value"] = "[" + high + " TO " + high + "]";
        	child["exp"] = {operator:"EQUAL", value:high};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-4.png";
        	child["name"] = sas.fscf.floatFormatter.format(low) + " <= n <= " + sas.fscf.floatFormatter.format(high);
        	child["value"] = "[" + low + " TO " + high + "]";
        	child["exp"] = {leftOperator:"LTE", leftValue:low, rightOperator:"LTE", rightValue:high};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-5.png";
        	child["name"] = sas.fscf.floatFormatter.format(low) + " < n <= " + sas.fscf.floatFormatter.format(high);
        	child["value"] = "{" + low + " TO " + high + "]";
        	child["exp"] = {leftOperator:"LT", leftValue:low, rightOperator:"LTE", rightValue:high};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-6.png";
        	child["name"] = sas.fscf.floatFormatter.format(low) + " <= n < " + sas.fscf.floatFormatter.format(high);
        	child["value"] = "[" + low + " TO " + high + "}";
        	child["exp"] = {leftOperator:"LTE", leftValue:low, rightOperator:"LT", rightValue:high};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-7.png";
        	child["name"] = sas.fscf.floatFormatter.format(low) + " < n < " + sas.fscf.floatFormatter.format(high);
        	child["value"] = " {" + low + " TO " + high + "}";
        	child["exp"] = {leftOperator:"LT", leftValue:low, rightOperator:"LT", rightValue:high};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-8.png";
        	child["name"] = "n = " + sas.fscf.floatFormatter.format(low);
        	child["value"] = "[" + low + " TO " + low + "]";
        	child["exp"] = {operator:"EQUAL", value:low};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-9.png";
        	child["name"] = "n <= " + sas.fscf.floatFormatter.format(low);
        	child["value"] = "[* TO " + low + "]";
        	child["exp"] = {operator:"LTE", value:low};
        	children[children.length] = child;
        	child = {};
        	child["icon"] = "resources/sas/fscf/views/range2-10.png";
        	child["name"] = "n < " + sas.fscf.floatFormatter.format(low);
        	child["value"] = " {* TO " + low + "}";
        	child["exp"] = {operator:"LT", value:low};
        	children[children.length] = child;
    	}
       	data["children"] = children;
       	return data;
    },
    getParentHLayoutForPanel: function(oPanel) {
    	return oPanel.getParent();
    },
    getVerticalLayoutForPanel: function(oPanel) {
    	return sap.ui.getCore().byId(oPanel.sId + "_VertLayout");
    },
    getListBoxForPanel: function(oPanel) {
    	if (oPanel._rangeable) {
        	return sap.ui.getCore().byId(oPanel.sId + "_RangeListBox");
    	}
    	return sap.ui.getCore().byId(oPanel.sId + "_ListBox");
    },
    getOtherListBoxForPanel: function(oPanel) {
    	if (oPanel._rangeable) {
        	return sap.ui.getCore().byId(oPanel.sId + "_ListBox");
    	}
    	return sap.ui.getCore().byId(oPanel.sId + "_RangeListBox");
    },
    getPanelForListBox: function(oListBox) {
    	return sap.ui.getCore().byId(oListBox.sId.substring(0, oListBox.sId.lastIndexOf("_"))); // remove the last _ and everything after
    },
    getRangeLabelsForPanel: function(oPanel) {
    	return sap.ui.getCore().byId(oPanel.sId + "_RangeLabels");
    },
    getRangeInputsForPanel: function(oPanel) {
    	return sap.ui.getCore().byId(oPanel.sId + "_RangeInputs");
    },
    getOperatorSelectForPanel: function(oPanel) {
    	return sap.ui.getCore().byId(oPanel.sId + "_OperatorSelect");
    },
    getOperatorInputForPanel: function(oPanel) {
    	return sap.ui.getCore().byId(oPanel.sId + "_OperatorInput");
    },
    toggleRange: function(oPanel) {
    	var _this = this;
    	sas.fscf.hideInlineMessage(_this.sId);
    	if (oPanel._rangeable) {
        	var vl = this.getVerticalLayoutForPanel(oPanel);
            vl.removeContent(4); 		//remove current list box
            vl.removeContent(1); 		//remove range inputs
            vl.removeContent(0); 		//remove range labels
            setTimeout(function() {		// slight delay for current list box to disappear
        		oPanel._searchable = null;
        		oPanel._rangeable = false;
        		// remove doesn't work the 1st time, so add first then remove
            	oPanel.addStyleClass("rangeable");
            	oPanel.removeStyleClass("rangeable");
        		// remove doesn't work the 1st time, so add first then remove
        		sap.ui.getCore().byId(oPanel.sId + "_RangeViewButton").addStyleClass("toggled");
        		sap.ui.getCore().byId(oPanel.sId + "_RangeViewButton").removeStyleClass("toggled");
            	var lbox = _this.getListBoxForPanel(oPanel);
                vl.insertContent(_this.getOperatorInputForPanel(oPanel), 1);	//insert operator input
                vl.insertContent(_this.getOperatorSelectForPanel(oPanel), 1);	//insert operator select
                vl.insertContent(lbox, 4);	//insert other list box
            }, 100);
    	} else {
        	var vl = this.getVerticalLayoutForPanel(oPanel);
            vl.removeContent(4); 		//remove current list box
            vl.removeContent(1); 		//remove operator input
            vl.removeContent(0); 		//remove operator select
            setTimeout(function() {		// slight delay for current list box to disappear
	    		oPanel._searchable = false;
	    		oPanel.removeStyleClass("searchable");
	    		oPanel._rangeable = true;
	        	oPanel.addStyleClass("rangeable");
	   			sap.ui.getCore().byId(oPanel.sId + "_RangeViewButton").addStyleClass("toggled");
	        	var lbox = _this.getListBoxForPanel(oPanel);
                vl.insertContent(_this.getRangeInputsForPanel(oPanel), 1);	//insert range inputs
                vl.insertContent(_this.getRangeLabelsForPanel(oPanel), 1);	//insert range labels
	            vl.insertContent(lbox, 4);	//insert other list box
            }, 100);
   		}
    },
    togglePercentages: function(bPercentages) {
    	this._bPercentages = bPercentages;
    	var _this = this;
    	_this.refreshInlineMessage();

    	// get all of the selections
    	var panel, lbox, selItems;
    	var allSelItems = [];

    	var panels = $("#"+this.getContent()[0].sId).find(".sapUiPanel");
		for (var i = 0; i < panels.length; i++) {
			panel = sap.ui.getCore().byId(panels[i].id);
			if (!panel._isGroup) {
	    		lbox = _this.getListBoxForPanel(panel);
	    		if (panel._rangeable) {
	    			lbox = _this.getOtherListBoxForPanel(panel);
	    		}
	    		selItems = lbox.getSelectedItems();
	    		allSelItems[allSelItems.length] = selItems;
			} else {
	    		allSelItems[allSelItems.length] = null;
			}
    	}
    	// re-bind
		for (var i = 0; i < panels.length; i++) {
			panel = sap.ui.getCore().byId(panels[i].id);
			if (!panel._isGroup) {
	    		lbox = _this.getListBoxForPanel(panel);
	    		if (panel._rangeable) {
	    			lbox = _this.getOtherListBoxForPanel(panel);
	    		}
        		lbox.bindAggregation("items", {
                   	path: "/children",
                    factory: function(sId, oContext) {
                        var li = new sap.ui.core.ListItem(sId, {
                              key: oContext.getProperty("name"),
                              text: (panel._type == 1) ? _this.convertToFormattedNumber(oContext.getProperty("name")) : oContext.getProperty("name"),
                              additionalText: _this._bPercentages ? sas.fscf.percentFormatter.format(oContext.getProperty("pct") / 100) : sas.fscf.floatFormatter.format(oContext.getProperty("size"))
                        });
                        li._fraudCount = (oContext.getProperty("subSize")) ? oContext.getProperty("subSize") : 0;
                        li._riskLevel = oContext.getProperty("scoreLevel");
                        return li;
                    },
                   	sorter: [
                       	 _this.getSelSorter(),   // force selected ones always to the top
                         _this.getSorter(panel._variableType)
                   	]
                });
			}
    	}
		// re-select what was selected before the re-bind
		for (var i = 0; i < panels.length; i++) {
			panel = sap.ui.getCore().byId(panels[i].id);
			if (!panel._isGroup) {
	    		lbox = _this.getListBoxForPanel(panel);
	    		if (panel._rangeable) {
	    			lbox = _this.getOtherListBoxForPanel(panel);
	    		}
				for (var j = 0; j < allSelItems[i].length; j++) {
					key = allSelItems[i][j].getKey();
					for (var k = 0; k < lbox.getItems().length; k++) {
						if (lbox.getItems()[k].getKey() == key) {
							_this.selectListBoxItem(lbox, k);
							break;
						}
					}
				}
			}
    	}
    },

    customSetBusy: function(bBusy) {
    	if (!bBusy) {
    		this.setBusy(false);
    	} else {
    		// only set the busy on this if the parent is not already busy
    		if (!sap.ui.getCore().byId(this.sId.substr(0, this.sId.indexOf("GridView"))).isBusy()) {
    			this.setBusy(true);
    		}
    	}
    },

    SORT_BY_COUNT_DESCENDING: 0,
    SORT_BY_COUNT_ASCENDING: 1,
    SORT_BY_VALUE_DESCENDING: 2,
    SORT_BY_VALUE_ASCENDING: 3,
    SORT_BY_FRAUD_DESCENDING: 4,
    SORT_BY_FRAUD_ASCENDING: 5,

    getSortOrder: function() {
 		if (this._sortOrder == undefined) {
 			this._sortOrder = this.SORT_BY_COUNT_DESCENDING;
 		}
    	return this._sortOrder;
    },

    setSortOrder: function(sortOrder) {
    	if ((sortOrder == this.SORT_BY_COUNT_DESCENDING) ||
    		(sortOrder == this.SORT_BY_COUNT_ASCENDING) ||
    		(sortOrder == this.SORT_BY_VALUE_DESCENDING) ||
    		(sortOrder == this.SORT_BY_VALUE_ASCENDING) ||
    		(sortOrder == this.SORT_BY_FRAUD_DESCENDING) ||
    		(sortOrder == this.SORT_BY_FRAUD_ASCENDING)) {
        	this._sortOrder = sortOrder;
        	var panel, lbox, selItems, sorter, bFound, newItem;
        	var panels = $("#"+this.getContent()[0].sId).find(".sapUiPanel");
			for (var i = 0; i < panels.length; i++) {
				panel = sap.ui.getCore().byId(panels[i].id);
				if (!panel._isGroup) {
		    		lbox = this.getListBoxForPanel(panel);
		    		if (panel._rangeable) {
		    			lbox = this.getOtherListBoxForPanel(panel);
		    		}

		        	// get all of the selections
		    		selItems = lbox.getSelectedItems();

		    		sorter = [this.getSelSorter(), this.getSorter(panel._variableType)];
		        	lbox.getBinding("items").sort(sorter);

		    		// re-select what was selected before the sort
	    			for (var j = 0; j < selItems.length; j++) {
	    				key = selItems[j].getKey();
	    				bFound = false;
	    				for (var k = 0; k < lbox.getItems().length; k++) {
	    					if (lbox.getItems()[k].getKey() == key) {
	    						this.selectListBoxItem(lbox, k);
	    						bFound = true;
	    						break;
	    					}
	    				}
	    				if (!bFound) {
	    					var newItem = new sap.ui.core.ListItem({
	                              key: key,
	                              text: selItems[j].getText(),
	                              additionalText: selItems[j].getAdditionalText()
	                        });
	    					lbox.addItem(newItem);
    						this.selectListBoxItem(lbox, lbox.indexOfItem(newItem));
	    				}
	    			}
				}
			}
        }
    },

    getSelSorter: function() {
    	var sorter;
		sorter = new sap.ui.model.Sorter("sel", true);
		sorter.fnCompare = function(a, b) {
            if (a == b) return 0;
			if (a == undefined || a < b) return -1;
            if (b == undefined || a > b) return  1;
		};
		return sorter;
    },

    getSorter: function(variableType) {
    	var sorter;
		switch (this.getSortOrder()) {
			case this.SORT_BY_VALUE_DESCENDING:
				sorter = new sap.ui.model.Sorter("name", true);
	        	if (variableType == "Numeric" || variableType == "Currency") {
					sorter.fnCompare = function(a, b) {
				    	var an = parseFloat(a);
				    	var bn = parseFloat(b);
			            if (an == bn) return 0;
						if (isNaN(an) || an < bn) return -1;
			            if (isNaN(bn) || an > bn) return  1;
					};
	        	}
				break;
			case this.SORT_BY_VALUE_ASCENDING:
				sorter = new sap.ui.model.Sorter("name", false);
	        	if (variableType == "Numeric" || variableType == "Currency") {
					sorter.fnCompare = function(a, b) {
				    	var an = parseFloat(a);
				    	var bn = parseFloat(b);
			            if (an == bn) return 0;
						if (isNaN(an) || an < bn) return -1;
			            if (isNaN(bn) || an > bn) return  1;
					};
	        	}
				break;
			case this.SORT_BY_FRAUD_DESCENDING:
				sorter = new sap.ui.model.Sorter("subSize", true);
				sorter.fnCompare = function(a, b) {
		            if (a == b) return 0;
					if (a == undefined || a < b) return -1;
		            if (b == undefined || a > b) return  1;
				};
				break;
			case this.SORT_BY_FRAUD_ASCENDING:
				sorter = new sap.ui.model.Sorter("subSize", false);
				sorter.fnCompare = function(a, b) {
		            if (a == b) return 0;
					if (a == undefined || a < b) return -1;
		            if (b == undefined || a > b) return  1;
				};
				break;
			case this.SORT_BY_COUNT_ASCENDING:
				sorter = new sap.ui.model.Sorter(this._bPercentages ? "pct" : "size", false);
				break;
			case this.SORT_BY_COUNT_DESCENDING:
			default:
				sorter = new sap.ui.model.Sorter(this._bPercentages ? "pct" : "size", true);
		}
		return sorter;
    },

    getServerErrorMessage: function() {
    	if (this.isExplore()) {
        	return sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.ess.error.txt")
    	}
    	return sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.tas.error.txt")
    },

    convertToFormattedNumber: function(str) {
    	var n = parseFloat(str);
    	if (!isNaN(n)) {
    		return sas.fscf.floatFormatter.format(n);
    	}
		return str;
    },

    isFilteringOperator: function(operator) {
    	return (operator == "MISSING" ||
    		operator == "NOTMISSING" ||
    		operator == "SW" ||
    		operator == "NOTSW" ||
    		operator == "SWANY" ||
    		operator == "NOTSWANY" ||
    		operator == "EW" ||
    		operator == "NOTEW" ||
    		operator == "EWANY" ||
    		operator == "NOTEWANY" ||
    		operator == "CO" ||
    		operator == "NOTCO" ||
    		operator == "COANY" ||
    		operator == "NOTCOANY");
    },
    
    isValuelessOperator: function(operator) {
    	return (operator == undefined ||
    		operator == "EQUAL" ||
       		operator == "NE" ||
       		operator == "IN" ||
       		operator == "NOTIN" ||
    		operator == "MISSING" ||
    		operator == "NOTMISSING");
    },
    
    getQForFilteringOperator: function(operator, fieldType, value) {
    	if (value == undefined || value == null || ($.isArray(value) && value.length == 0)) {
    		if (operator != "MISSING" && operator != "NOTMISSING") {
        		return "";
    		}
    	}
    	switch(operator) {
	        case "MISSING":
				return "(*:* NOT (" + fieldType + ":?*))";
	            break;
	        case "NOTMISSING":
				return "(" + fieldType + ":?*)";
	            break;
	        case "SW":
				return "(" + fieldType + ":" + sas.fscf.escapeSafeValue(value) + "*)";
	            break;
	        case "NOTSW":
				return "(" + fieldType + ":* NOT (" + fieldType + ":" + sas.fscf.escapeSafeValue(value) + "*))";
	            break;
	        case "SWANY":
	        	var ret = [];
	        	for (var i = 0; i < value.length; i++) {
	        		ret[ret.length] = "(" + fieldType + ":" + sas.fscf.escapeSafeValue(value[i]) + "*)"; 
	        	}
				return "(" + ret.join(" OR ") + ")";
	            break;
	        case "NOTSWANY":
	        	var ret = [];
	        	for (var i = 0; i < value.length; i++) {
	        		ret[ret.length] = "(" + fieldType + ":" + sas.fscf.escapeSafeValue(value[i]) + "*)"; 
	        	}
				return "(" + fieldType + ":* NOT (" + ret.join(" OR ") + "))";
	            break;
	        case "EW":
				return "(" + fieldType + ":*" + sas.fscf.escapeSafeValue(value) + ")";
	            break;
	        case "NOTEW":
				return "(" + fieldType + ":* NOT (" + fieldType + ":*" + sas.fscf.escapeSafeValue(value) + "))";
	            break;
	        case "EWANY":
	        	var ret = [];
	        	for (var i = 0; i < value.length; i++) {
	        		ret[ret.length] = "(" + fieldType + ":*" + sas.fscf.escapeSafeValue(value[i]) + ")"; 
	        	}
				return "(" + ret.join(" OR ") + ")";
	            break;
	        case "NOTEWANY":
	        	var ret = [];
	        	for (var i = 0; i < value.length; i++) {
	        		ret[ret.length] = "(" + fieldType + ":*" + sas.fscf.escapeSafeValue(value[i]) + ")"; 
	        	}
				return "(" + fieldType + ":* NOT (" + ret.join(" OR ") + "))";
	            break;
	        case "CO":
				return "(" + fieldType + ":*" + sas.fscf.escapeSafeValue(value) + "*)";
	            break;
	        case "NOTCO":
				return "(" + fieldType + ":* NOT (" + fieldType + ":*" + sas.fscf.escapeSafeValue(value) + "*))";
	            break;
	        case "COANY":
	        	var ret = [];
	        	for (var i = 0; i < value.length; i++) {
	        		ret[ret.length] = "(" + fieldType + ":*" + sas.fscf.escapeSafeValue(value[i]) + "*)"; 
	        	}
				return "(" + ret.join(" OR ") + ")";
	            break;
	        case "NOTCOANY":
	        	var ret = [];
	        	for (var i = 0; i < value.length; i++) {
	        		ret[ret.length] = "(" + fieldType + ":*" + sas.fscf.escapeSafeValue(value[i]) + "*)"; 
	        	}
				return "(" + fieldType + ":* NOT (" + ret.join(" OR ") + "))";
	            break;
	        default:
	        	return "";
	    }
    },

    getNegativeOperator: function(operator) {
    	switch(operator) {
	        case "EQUAL":
	            return "NE";
	            break;
	        case "IN":
	            return "NOTIN";
	            break;
	        case "MISSING":
	            return "NOTMISSING";
	            break;
	        case "SW":
	            return "NOTSW";
	            break;
	        case "SWANY":
	            return "NOTSWANY";
	            break;
	        case "EW":
	            return "NOTEW";
	            break;
	        case "EWANY":
	            return "NOTEWANY";
	            break;
	        case "CO":
	            return "NOTCO";
	            break;
	        case "COANY":
	            return "NOTCOANY";
	            break;
	        default:
	            return operator;
	    }
    },

    getPositiveOperator: function(operator) {
    	switch(operator) {
	        case "NE":
	            return "EQUAL";
	            break;
	        case "NOTIN":
	            return "IN";
	            break;
	        case "NOTMISSING":
	            return "MISSING";
	            break;
	        case "NOTSW":
	            return "SW";
	            break;
	        case "NOTSWANY":
	            return "SWANY";
	            break;
	        case "NOTEW":
	            return "EW";
	            break;
	        case "NOTEWANY":
	            return "EWANY";
	            break;
	        case "NOTCO":
	            return "CO";
	            break;
	        case "NOTCOANY":
	            return "COANY";
	            break;
	        default:
	            return operator;
	    }
    }
});
