sap.ui.jsview("sas.fscf.views.GridToolbar", {
    getControllerName: function () {
        return "sas.fscf.views.GridToolbar";
    },

    _grid: null,
    
    getGrid: function() {
    	return this._grid;
    },
    
    setGrid: function(grid) {
    	this._grid = grid;
    },
    
    _bExplore: false,

    isExplore: function() {
    	return this._bExplore;
    },

    setExplore: function(bExplore) {
    	this._bExplore = bExplore;
    },

    createContent: function(oController) {
    },

    lazyLoadContent: function() {
      if (this.getContent().length == 0) {
        jQuery.sap.require("sap.m.Toolbar");
        jQuery.sap.require("sap.m.ToolbarSpacer");
        jQuery.sap.require("sap.m.Label");
        jQuery.sap.require("sas.hc.m.Button");
        jQuery.sap.require("sas.hc.m.ToggleButton");
        jQuery.sap.require("sas.hc.m.ProgressIndicator");
		jQuery.sap.require("sas.hc.m.ActionSheet");
		
    	var _this = this;

    	this.addStyleClass("cfGridToolbarView");

    	var oTogglePercentagesButton = new sas.hc.m.ToggleButton({
	       	id: this.sId + "GridToolbarPercentagesButton",
	    	icon: 'sap-icon://hc/autocompleteMacroStatements',
	   		tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.percentages.txt"),
	   		ariaLabel: sas.fscf.rb.getText("rules.rulesPage.guidedView.percentages.txt"),
	   		press: function(oEvent) {
	   			_this.getGrid().togglePercentages(oEvent.mParameters.pressed);
	   		}
		});
    	// Workaround a ToggleButton bug where the icon on the button does
    	// not inherit the title and aria label of the button
    	oTogglePercentagesButton.onAfterRendering = function() {
	    	if (sas.hc.m.ToggleButton.prototype.onAfterRendering) {
        		sas.hc.m.ToggleButton.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
	    	var icon = $("#"+this.getDomRef().id+"-img")[0]; 
        	icon.setAttribute("title", sas.fscf.rb.getText("rules.rulesPage.guidedView.percentages.txt"));
        	icon.setAttribute("aria-label", sas.fscf.rb.getText("rules.rulesPage.guidedView.percentages.txt"));
    	};

    	var oProgIndicator = new sas.hc.m.ProgressIndicator({
		    id: this.sId + 'GridToolbarPopulationIndicator',
		    width : "33%",
		    percentValue : 100,
		    displayValue : sas.fscf.percentFormatter.format(1),
		    showValue : true,
		    state: sap.ui.core.ValueState.None
		}); 
    		
        var oToolbar = new sap.m.Toolbar({
        	id: this.sId + "GridToolbar",
    	    content: [
   			      	new sas.hc.m.Button({
   			        	id: this.sId + "GridToolbarSortButton",
   			    		icon: 'sap-icon://hc/sortGeneric',
 	   			    	tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.sort.txt"),
   	   			    	ariaLabel: sas.fscf.rb.getText("rules.rulesPage.guidedView.sort.txt"),
   				        press: function(e) {
   				        	var grid = _this.getGrid();
   			       		    var sortActionSheet = new sas.hc.m.ActionSheet({
   			       		       title: sas.fscf.rb.getText('rules.rulesListDetailMenu.chooseYourAction.txt'),
   			       		       showCancelButton: true,
   			       		       placement: sap.m.PlacementType.Bottom,
   			       		       buttons: [
   			       		           new sas.hc.m.Button({
   			                   	       id: _this.sId + 'SortByCountDescendingButton',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byCountDescending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_COUNT_DESCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       		               press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_COUNT_DESCENDING);
   			       		               }
   			       		           }).addStyleClass("cfSortByButton"),
   			       		           new sas.hc.m.Button({
   			                           id: _this.sId + 'SortByCountAscendingButton',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byCountAscending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_COUNT_ASCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_COUNT_ASCENDING);
   			      	    			   }
   			       		           }),
   			       		           new sas.hc.m.Button({
   			                           id: _this.sId + 'SortByValueDescendingButton',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byValueDescending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_VALUE_DESCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_VALUE_DESCENDING);
   			      	    			   }
   			       		           }),
   			       		           new sas.hc.m.Button({
   			                     	   id: _this.sId + 'SortByValueAscendingButton',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byValueAscending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_VALUE_ASCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_VALUE_ASCENDING);
   			      	    			   }
   			       		           }),
   			       		           new sas.hc.m.Button({
   			                     	   id: _this.sId + 'SortByFraudDescendingButton',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byFraudDescending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_FRAUD_DESCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_FRAUD_DESCENDING);
   			      	    			   }
   			       		           }),
   			       		           new sas.hc.m.Button({
   			                     	   id: _this.sId + 'SortByFraudAscendingButton',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byFraudAscending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_FRAUD_ASCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_FRAUD_ASCENDING);
   			      	    			   }
   			       		           })
   			       		       ]
   			       		    });
   			       		    sortActionSheet.attachAfterClose(function(oEvent) {
   			       		    	this.destroy();
   			       		    });
       				    	sortActionSheet.openBy(e.getSource());
   				        }
   					}),
   			      	new sas.hc.m.Button({
   			        	id: this.sId + "GridToolbarRemoveAllButton",
   			    		icon: 'sap-icon://hc/clearAll',
   			    		tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.removeAll.txt"),
   			    		ariaLabel: sas.fscf.rb.getText("rules.rulesPage.guidedView.removeAll.txt"),
   			    		press: function() {
   			    			_this.getGrid().removeAllPanels();
   			    		}
   					}),
   					oTogglePercentagesButton,
  			      	new sap.m.ToolbarSpacer({
					}),
    	      		new sap.m.Label({
    	                text: sas.fscf.rb.getText("rules.rulesPage.guidedView.population.txt")
    	    		}),
    	    		oProgIndicator
    	    ]
    	});
        
        $.ajax({url:sas.fscf.getQueryUrl((_this.isExplore() ? "facets" : "risk"), (_this.isExplore() ? "esdb" : null), "*:*", ""), contentType:"application/json; charset=utf-8", dataType:"json"})
          .done(function(oData){
			if (oData && oData[Object.keys(oData)[0]]) {
				var current = oData[Object.keys(oData)[0]]["match"];
				var total = oData[Object.keys(oData)[0]]["total"];
				var percent = (total === 0) ? 0 : (current / total);
				oProgIndicator.setPercentValue(percent * 100);
				oProgIndicator.setDisplayValue(sas.fscf.percentFormatter.format(percent) + " " + sas.fscf.rb.getText("rules.rulesPage.guidedView.population.xofy.fmt.txt", [sas.fscf.floatFormatter.format(current), sas.fscf.floatFormatter.format(total)]));
			}
        }).fail(function(oObj,textStatus){
        });
        
        this.addContent(oToolbar);
      }
    }
});
