// mix some guided view helper functions into sas.fscf if they are not already there
// loaded (only) by guided views, such as Rules and Explore, that need them
if (!sas.fscf.getQueryUrl) {
		sas.fscf.getQueryUrl = function(type, schema, q, fields) {
        	// type should be "facets", "search", "risk", "fraud", etc.
        	if (type == undefined || type == null) {
        		type = "risk";		// default to "risk"
        	}
        	var urlSegments = [];
        	urlSegments[urlSegments.length] = "rest/transactions/" + type + "?";
        	if (schema != null && schema != undefined) {
            	urlSegments[urlSegments.length] = "schema=" + encodeURIComponent(schema);
        		try {
        			urlSegments[urlSegments.length] = "&tsperiod=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsperiod());        		
        		} catch (e) {}
        		try {
        			if (sas.fscf.getCurrentPageView().getGuidedView().getTsoffset() != null)  {
        				urlSegments[urlSegments.length] = "&tsoffset=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsoffset());
        			}
        		} catch (e) {}
            	urlSegments[urlSegments.length] = "&";
        	}
        	urlSegments[urlSegments.length] = "q=" + q;
        	if ($.isArray(fields)) {
        		urlSegments[urlSegments.length] = "&fields=" + encodeURIComponent(fields.join(","));
        	} else {
        		urlSegments[urlSegments.length] = "&fields=" + encodeURIComponent(fields);
        	}
        	if (schema == null || schema == undefined) {
	        	urlSegments[urlSegments.length] = "&name=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.transactionTypeId);
	        	urlSegments[urlSegments.length] = "&scope=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.multiOrgNodeId);
        	}
        	return urlSegments.join("");
        };
		sas.fscf.getQueryUrlFromRuleModel = function(type, schema, overrideFields) {
        	// type should be "facets", "search", "risk", "fraud", etc.
        	if (type == undefined || type == null) {
        		type = "risk";		// default to "risk"
        	}
        	var ret = sas.fscf.getQueryUriComponentsFromRuleModel();
        	var urlSegments = [];
        	urlSegments[urlSegments.length] = "rest/transactions/" + type + "?";
        	if (schema != null && schema != undefined) {
            	urlSegments[urlSegments.length] = "schema=" + encodeURIComponent(schema);
        		try {
        			urlSegments[urlSegments.length] = "&tsperiod=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsperiod());        		
        		} catch (e) {}
        		try {
        			if (sas.fscf.getCurrentPageView().getGuidedView().getTsoffset()) {
        				urlSegments[urlSegments.length] = "&tsoffset=" + encodeURIComponent(sas.fscf.getCurrentPageView().getGuidedView().getTsoffset());
        			}
        		} catch (e) {}
            	urlSegments[urlSegments.length] = "&";
        	}
        	urlSegments[urlSegments.length] = "q=";
    		var ruleOverallType = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition.type;
    		if (ruleOverallType == "OR") {
    			urlSegments[urlSegments.length] = encodeURIComponent(ret.qsegments.join(" OR "));
    		} else if (ruleOverallType == "NOR") {
       			urlSegments[urlSegments.length] = "*:* NOT (" + encodeURIComponent(ret.qsegments.join(" OR ")) + ")";
    		} else {
    			urlSegments[urlSegments.length] = encodeURIComponent(ret.qsegments.join(" AND "));
    		}
        	if (overrideFields == null || overrideFields == undefined) {
        		urlSegments[urlSegments.length] = "&fields=" + encodeURIComponent(ret.fields.join(","));
        	} else if (overrideFields.length > 0) {
        		urlSegments[urlSegments.length] = "&fields=" + encodeURIComponent(overrideFields.join(","));
        	}
        	if (schema == null || schema == undefined) {
	        	urlSegments[urlSegments.length] = "&name=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.transactionTypeId);
	        	urlSegments[urlSegments.length] = "&scope=" + encodeURIComponent(sas.fscf.getCurrentPageView().jsonRule.multiOrgNodeId);
        	}
        	return urlSegments.join("");
        };
        sas.fscf.getQueryUriComponentsFromRuleModel = function() {
    		var ruleModel = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition;
    		var exps = ruleModel["expressions"];

    		var exp;
    		var ret;
    		var fields = [];
    		var qsegments = [];
        	for (var i = 0; i < exps.length; i++) {
        		exp = exps[i];
        		if (exp.type == "AND" || exp.type == "OR" || exp.type == "NOR") {
        			ret = sas.fscf.processGroupForQuery(exp);
        		} else {
        			ret = sas.fscf.processExpressionForQuery(exp);
        		}
        		if (ret) {
        			$.merge(fields, ret.fields);
        			if (ret.qsegment) {
               	    	qsegments[qsegments.length] = ret.qsegment;
        			}
        		}
        	}
        	var uniqueFields = [];
        	$.each(fields, function(i, el){
        	    if ($.inArray(el, uniqueFields) === -1) uniqueFields.push(el);
        	});
        	if (qsegments.length == 0) {
       	    	qsegments[qsegments.length] = "*:*";  // all
        	}
        	return {qsegments: qsegments, fields: uniqueFields};
        };
        sas.fscf.quoteSafeValue = function(value) {
        	// put double-quotes around the value so that certain special characters 
        	// such as spaces, forward-slashes, asterisks, etc. will work
        	return "\"" + value + "\"";
        };
        sas.fscf.escapeSafeValue = function(value) {
        	// put backslashes before certain special characters 
        	// such as spaces, forward-slashes, asterisks, ampersands and question marks
        	return value.replace(/ /g, "\\ ").replace(/\//g, "\\/").replace(/\*/g, "\\*").replace(/&/g, "\\&").replace(/\?/g, "\\?");
        };
        sas.fscf.processExpressionForQuery = function(exp) {
        	if (!(exp.type == "AND" || exp.type == "OR" || exp.type == "NOR")) {
            	var fields = [];
            	var qsegment = "";
        		fields[fields.length] = exp.fieldName;
        		qsegment += "(";
        		if (exp.operator == "NE" || exp.operator == "NOTIN" || exp.operator == "MISSING" || exp.operator == "NOTSW" || exp.operator == "NOTEW" || exp.operator == "NOTCO" || exp.operator == "NOTSWANY" || exp.operator == "NOTEWANY" || exp.operator == "NOTCOANY") {
        			qsegment += ((exp.operator == "MISSING") ? "*" : exp.fieldName) + ":* NOT (";
        		}
        		if (exp.operator == "IN" || exp.operator == "NOTIN" || exp.operator == "SWANY" || exp.operator == "EWANY" || exp.operator == "COANY" || exp.operator == "NOTSWANY" || exp.operator == "NOTEWANY" || exp.operator == "NOTCOANY") {
        			var qsegments = [];
        			for (var i = 0; i < exp.values.length; i++) {
        				if (exp.operator == "SWANY" || exp.operator == "NOTSWANY") {
            				qsegments[qsegments.length] = "(" + exp.fieldName + ":" + sas.fscf.escapeSafeValue(exp.values[i]) + "*)";
        				} else if (exp.operator == "EWANY" || exp.operator == "NOTEWANY") {
               				qsegments[qsegments.length] = "(" + exp.fieldName + ":*" + sas.fscf.escapeSafeValue(exp.values[i]) + ")";
        				} else if (exp.operator == "COANY" || exp.operator == "NOTCOANY") {
               				qsegments[qsegments.length] = "(" + exp.fieldName + ":*" + sas.fscf.escapeSafeValue(exp.values[i]) + "*)";
        				} else {
            				qsegments[qsegments.length] = "(" + exp.fieldName + ":" + sas.fscf.quoteSafeValue(exp.values[i]) + ")";
        				}
        			}
        			if (exp.operator == "IN" || exp.operator == "NOTIN" || exp.operator == "SWANY" || exp.operator == "NOTSWANY" || exp.operator == "EWANY" || exp.operator == "NOTEWANY" || exp.operator == "COANY" || exp.operator == "NOTCOANY") {
        				qsegment += qsegments.join(" OR ");
        			} else {
        				qsegment += qsegments.join(" AND ");
        			}
        		} else {
            		qsegment += exp.fieldName + ":";
            		if (exp.type == "COMPARE") {
            			if (exp.operator == "MISSING" || exp.operator == "NOTMISSING") {
            				qsegment += "?*";
            			} else if (exp.operator == "SW" || exp.operator == "NOTSW") {
               				qsegment += sas.fscf.escapeSafeValue(exp.value) + "*";
            			} else if (exp.operator == "EW" || exp.operator == "NOTEW") {
               				qsegment += "*" + sas.fscf.escapeSafeValue(exp.value);
            			} else if (exp.operator == "CO" || exp.operator == "NOTCO") {
               				qsegment += "*" + sas.fscf.escapeSafeValue(exp.value) + "*";
            			} else if (exp.fieldType == "Numeric" || exp.fieldType == "Currency") {
            				if (exp.operator == "EQUAL" || exp.operator == "NE") {
            					qsegment += "[" + exp.value + " TO " + exp.value + "]";
            				} else if (exp.operator == "LT") {
            					qsegment += "{* TO " + exp.value + "}";
            				} else if (exp.operator == "LTE") {
            					qsegment += "[* TO " + exp.value + "]";
            				} else if (exp.operator == "GT") {
            					qsegment += "{" + exp.value + " TO *}";
            				} else if (exp.operator == "GTE") {
            					qsegment += "[" + exp.value + " TO *]";
            				}
            			} else {
            				qsegment += sas.fscf.quoteSafeValue(exp.value);
            			}
            		} else if (exp.type == "RANGE") {
            			if (exp.leftOperator == "LT") {
            				qsegment += "{";
            			} else {
            				qsegment += "[";
            			}
            			qsegment += exp.leftValue;
            			qsegment += " TO ";
            			qsegment += exp.rightValue;
            			if (exp.rightOperator == "LT") {
            				qsegment += "}";
            			} else {
            				qsegment += "]";
            			}
            		}
        		}
        		if (exp.operator == "NE" || exp.operator == "NOTIN" || exp.operator == "MISSING" || exp.operator == "NOTSW" || exp.operator == "NOTEW" || exp.operator == "NOTCO" || exp.operator == "NOTSWANY" || exp.operator == "NOTEWANY" || exp.operator == "NOTCOANY") {
        			qsegment += ")";
        		}
        		qsegment += ")";
    			return {fields: fields, qsegment: qsegment};
        	}
        };
        sas.fscf.processGroupForQuery = function(exp) {
        	if (exp.type == "AND" || exp.type == "OR" || exp.type == "NOR") {
        		var exps = exp.expressions;
        		if (!exps) {
        			return {fields: [], qsegment: null};
        		}
        		var subexp;
        		var ret;
            	var fields = [];
            	var qsegment = "";
            	var qsegments = [];
            	for (var i = 0; i < exps.length; i++) {
            		subexp = exps[i];
        			ret = sas.fscf.processExpressionForQuery(subexp);
            		if (ret) {
            			$.merge(fields, ret.fields);
               	    	qsegments[qsegments.length] = ret.qsegment;
            		}
            	}
    			qsegment = "(";
    			if (exp.type == "NOR") {
    				qsegment += "*:* NOT (";
    				qsegment += qsegments.join(" OR ");
    				qsegment += ")";

    			} else {
    				qsegment += qsegments.join(" " + exp.type + " ");
    			}
    			qsegment += ")";
    			return {fields: fields, qsegment: qsegment};
        	}
        };
        sas.fscf.loadRule= function(view) {
        	view.setBusyIndicatorDelay(500).setBusy(true);
        	var grid = view.getGrid();
        	var form = view.getForm();
        	if (sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties &&
           		sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.view &&
           		sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.view == "form") {
        		// start in form view
        		view.toggleFormView(true);
        		setTimeout(function () {
            		sap.ui.getCore().byId(view.sId + "ToolbarFormViewButton").setPressed(true);
            		form.somethingChangedInFullForm();
        			sas.fscf.getCurrentPageView().setDirty(false);
        	    	view._bDirtySinceLastFormView = true;
                	view.setBusy(false);
        		}, 300);
            	return;
           	}
        	// start in grid view
        	var relatedRows = view.getRelatedRows();
        	relatedRows.update();
        	var oPanel;
        	var lbox;
        	var condition = null;
        	try {
        		condition = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition;
        	} catch (ex) {
        		condition = null;
        	}
        	if (condition) {
        		var exps = condition.expressions;
        		if (exps) {
            		sas.fscf.loadExpression(view, view.getGrid().getContent()[0], "", exps, 0, 0);
        		} else {
                	view.setBusy(false);
        		}
        	} else {
            	view.setBusy(false);
        	}
        };
        sas.fscf.loadExpression = function(view, parentHLayout, parentId, exps, expi, level, prior_parentHLayout, prior_parentId, prior_exps, prior_expi) {
        	var grid = view.getGrid();
        	var palette = view.getPalette();
        	if (level == null || level == undefined) {
        		level = 0;
        	}
    		var exp = exps[expi];
    		if (exp) {
    			if ((exp.type == "COMPARE" || exp.type == "RANGE") && !sas.fscf.isInOperator(exp.operator)) {
    				var min, max, from, to = null;
    				if (exp.type == "RANGE") {
    					from = exp.leftValue;
    					to = exp.rightValue;
    					var fi = palette.getFieldInfoForFieldId(exp.fieldId);
    					if (fi) {
    						min = fi.min;
    						max = fi.max;
    					}
    				} else {
    					if ((exp.fieldType == "Numeric") || (exp.fieldType == "Currency")) {
    						from = parseFloat(exp.value);
    						to = from;
    						var fi = palette.getFieldInfoForFieldId(exp.fieldId);
    						if (fi) {
    							min = fi.min;
    							max = fi.max;
    						}
    					}
    				}
    				var not = ((exp.type == "COMPARE") && ((exp.operator == "NE") || (exp.operator == "NOTMISSING") || (exp.operator == "NOTSW") || (exp.operator == "NOTEW") || (exp.operator == "NOTCO")));
    				var overrideRangeView = not || ((exp.type == "COMPARE") && ((exp.operator == "MISSING") || (exp.operator == "SW") || (exp.operator == "EW") || (exp.operator == "CO")));
    				grid.addPanel(exp.id, parentHLayout, parentId, exp.fieldName.toUpperCase(), exp.fieldId, exp.fieldType, exp.operator, exp.value, min, max, from, to, not, overrideRangeView, function() {
    					// success callback
    	        		var lbox = grid.getListBoxForPanel(this);
    	                grid.selectListBoxItemFromExp(true, lbox, exp);
    					sas.fscf.loadExpression(view, parentHLayout, parentId, exps, expi + 1, level, prior_parentHLayout, prior_parentId, prior_exps, prior_expi);
    				}, function () {
    	        		// failure callback
    	            	view.setBusy(false);
    	        	});
    			} else if (exp.type == "COMPARE" && sas.fscf.isInOperator(exp.operator)) {
    				var not = (exp.operator == "NOTIN") || (exp.operator == "NOTSWANY") || (exp.operator == "NOTEWANY") || (exp.operator == "NOTCOANY");
    				var overrideRangeView = true;
    				grid.addPanel(exp.id, parentHLayout, parentId, exp.fieldName.toUpperCase(), exp.fieldId, exp.fieldType, exp.operator, exp.values, min, max, from, to, not, overrideRangeView, function() {
    					// success callback
    	        		var lbox = grid.getListBoxForPanel(this);
		        		for (var j = 0; j < exp.values.length; j++) {
			        		for (var k = 0; k < lbox.getItems().length; k++) {
			        			if (lbox.getItems()[k].getKey() == exp.values[j]) {
									grid.selectListBoxItem(lbox, k);
									break;
			        			}
			        		}
		        		}
    					sas.fscf.loadExpression(view, parentHLayout, parentId, exps, expi + 1, level, prior_parentHLayout, prior_parentId, prior_exps, prior_expi);
    				}, function () {
    	        		// failure callback
    	            	view.setBusy(false);
    	        	});
    			} else if ((exp.type == "OR") || (exp.type == "AND")) {
    				var subexps = exp.expressions;
    				var firstFieldId = subexps[0].fieldId;
    				var bAllSameField = true;
    				for (var i = 0; i < subexps.length; i++) {
    					// to collapse to single list with multiselect, must be all same field, not numeric or currency,
    					// and all equals operator with OR or all not equals operator with AND
    					if ((subexps[i].fieldId != firstFieldId) ||
    						(subexps[i].fieldType == "Numeric") ||
    						(subexps[i].fieldType == "Currency") ||
    						((exp.type == "OR") && (subexps[i].operator != "EQUAL")) ||
    						((exp.type == "AND") && (subexps[i].operator != "NE"))) {
    						bAllSameField = false;
    						break;
    					}
    				}
    				if (bAllSameField) {
    					var id = exp.id;
    					exp = subexps[0];
        				var not = ((exp.type == "COMPARE") && ((exp.operator == "NE") || (exp.operator == "NOTMISSING") || (exp.operator == "NOTSW") || (exp.operator == "NOTEW") || (exp.operator == "NOTCO")));
        				var overrideRangeView = not || ((exp.type == "COMPARE") && ((exp.operator == "MISSING") || (exp.operator == "SW") || (exp.operator == "EW") || (exp.operator == "CO")));
    					grid.addPanel(id, parentHLayout, parentId, exp.fieldName.toUpperCase(), exp.fieldId, exp.fieldType, exp.operator, exp.value, null, null, exp.leftValue, exp.rightValue, not, overrideRangeView, function() {
    						// success callback
    		        		var lbox = grid.getListBoxForPanel(this);
    		        		for (var j = 0; j < subexps.length; j++) {
    			        		for (var k = 0; k < lbox.getItems().length; k++) {
    			        			if (lbox.getItems()[k].getKey() == subexps[j].value) {
    									grid.selectListBoxItem(lbox, k);
    									break;
    			        			}
    			        		}
    		        		}
    						sas.fscf.loadExpression(view, parentHLayout, parentId, exps, expi + 1, level, prior_parentHLayout, prior_parentId, prior_exps, prior_expi);
    					}, function () {
    		        		// failure callback
    		            	view.setBusy(false);
    		        	});
    				} else {
    					var oPanel = grid.addGroup(exp.id, parentHLayout, parentId, exp.type);
    					sas.fscf.loadExpression(view, sap.ui.getCore().byId(oPanel.sId + "_HorizLayout"), oPanel._pId, subexps, 0, level + 1, parentHLayout, parentId, exps, expi);
    				}
    			} else if (exp.type == "NOR") {
    				var oPanel = grid.addGroup(exp.id, parentHLayout, parentId, exp.type);
    				var subexps = exp.expressions;
    				sas.fscf.loadExpression(view, sap.ui.getCore().byId(oPanel.sId + "_HorizLayout"), oPanel._pId, subexps, 0, level + 1, parentHLayout, parentId, exps, expi);
    			} else {
    				sas.fscf.loadExpression(view, parentHLayout, parentId, exps, expi + 1, prior_parentHLayout, prior_parentId, prior_exps, prior_expi);
    			}
    		} else {
    			if (level == 0) {
    	    		grid.updateCounts(function () {
    	        		// success callback
    	            	view.setBusy(false);
    	    		}, function () {
    	        		// failure callback
    	            	view.setBusy(false);
    	    		});
    			} else {
    				// go back up a level
    				sas.fscf.loadExpression(view, prior_parentHLayout, prior_parentId, prior_exps, prior_expi + 1, level - 1);
    			}
    		}
        };
        sas.fscf.getLocalizedOperator = function(operatorKey) {
        	switch(operatorKey) {
		        case "EQUAL":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.equals.txt");
		            break;
		        case "NE":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notEquals.txt");
		            break;
		        case "GT":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.greaterThan.txt");
		            break;
		        case "GTE":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.greaterThanOrEqualTo.txt");
		            break;
		        case "LT":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.lessThan.txt");
		            break;
		        case "LTE":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.lessThanOrEqualTo.txt");
		            break;
		        case "MISSING":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.missing.txt");
		            break;
		        case "NOTMISSING":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notMissing.txt");
		            break;
		        case "IN":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.in.txt");
		            break;
		        case "NOTIN":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notIn.txt");
		            break;
		        case "SW":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.startsWith.txt");
		            break;
		        case "NOTSW":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotStartWith.txt");
		            break;
		        case "SWANY":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.startsWithAny.txt");
		            break;
		        case "NOTSWANY":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotStartWithAny.txt");
		            break;
		        case "EW":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.endsWith.txt");
		            break;
		        case "NOTEW":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotEndWith.txt");
		            break;
		        case "EWANY":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.endsWithAny.txt");
		            break;
		        case "NOTEWANY":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotEndWithAny.txt");
		            break;
		        case "CO":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.contains.txt");
		            break;
		        case "NOTCO":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotContain.txt");
		            break;
		        case "COANY":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.containsAny.txt");
		            break;
		        case "NOTCOANY":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotContainAny.txt");
		            break;
		        default:
		            return "";
		    }
       };
       sas.fscf.getLocalizedOperatorVerbose = function(operatorKey) {
       		switch(operatorKey) {
		        case "EQUAL":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.equals.verbose.txt");
		            break;
		        case "NE":
		            return sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notEquals.verbose.txt");
		            break;
		        default:
		            return sas.fscf.getLocalizedOperator(operatorKey);
		    }
       };
       sas.fscf.getOperatorKey = function(operatorText) {
       		switch(operatorText) {
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.equals.txt"):
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.equals.verbose.txt"):
		            return "EQUAL";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notEquals.txt"):
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notEquals.verbose.txt"):
		            return "NE";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.greaterThan.txt"):
		            return "GT";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.greaterThanOrEqualTo.txt"):
		            return "GTE";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.lessThan.txt"):
		            return "LT";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.lessThanOrEqualTo.txt"):
		            return "LTE";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.missing.txt"):
		            return "MISSING";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notMissing.txt"):
		            return "NOTMISSING";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.in.txt"):
		            return "IN";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.notIn.txt"):
		            return "NOTIN";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.startsWith.txt"):
		            return "SW";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotStartWith.txt"):
		            return "NOTSW";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.startsWithAny.txt"):
		            return "SWANY";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotStartWithAny.txt"):
		            return "NOTSWANY";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.endsWith.txt"):
		            return "EW";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotEndWith.txt"):
		            return "NOTEW";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.endsWithAny.txt"):
		            return "EWANY";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotEndWithAny.txt"):
		            return "NOTEWANY";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.contains.txt"):
		            return "CO";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotContain.txt"):
		            return "NOTCO";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.containsAny.txt"):
		            return "COANY";
		            break;
		        case sas.fscf.rb.getText("rules.rulesPage.guidedView.form.operators.doesNotContainAny.txt"):
		            return "NOTCOANY";
		            break;
		        default:
		            return "";
		    }
       };
       sas.fscf.isInOperator = function(operatorKey) {
	       	return (operatorKey == "IN" ||
	       			operatorKey == "NOTIN" ||
	       			operatorKey == "SWANY" ||
	       			operatorKey == "EWANY" ||
	       			operatorKey == "COANY" ||
	       			operatorKey == "NOTSWANY" ||
	       			operatorKey == "NOTEWANY" ||
	       			operatorKey == "NOTCOANY");
       };
}