sap.ui.jsview("sas.fscf.views.PreferencePageOverview", {
    getControllerName: function () {
        return "sas.fscf.views.PreferencePageOverview";
    },

    createContent: function(oController) {
        jQuery.sap.require("sap.m.Toolbar");
        jQuery.sap.require("sas.hc.m.Button");

        var oToolbar = new sap.m.Toolbar({
    	    id: this.sId + 'Toolbar'
    	});
        oToolbar.setContentFor = function(type, canModify) {
        	if (canModify === undefined) {
        		canModify = false;
        	}
        	oToolbar.destroyContent();
        	if (type == 'any') {
        		oToolbar.addContent(
        				new sas.hc.m.Button({
					        id: this.sId + 'NewGridButton',
					        text: sas.fscf.rb.getText("fcm.preferences.new.gridTemplate.txt"),
					        icon : "sap-icon://hc/newStarburst",
							enabled: canModify,
					        press: function() {
					        	frames['overview'].doPreferenceAction('preference.sj?method=create');
					        }
        				})
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'RefreshButton',
   				        text: sas.fscf.rb.getText("fcm.preferences.refreshCache.txt"),
   				        icon : "sap-icon://hc/refresh",
    					enabled: canModify,
   				        press: function() {
   				        	frames['overview'].doPreferenceAction('refreshCache');
   				        }
        		    })
            	);

        	}
        }

    	return oToolbar;
    }
});
