sap.ui.jsview("sas.fscf.views.RulesPageGuided", {
    getControllerName: function () {
        return "sas.fscf.views.RulesPageGuided";
    },

    createContent: function(oController) {
    	jQuery.sap.require("sap.ui.commons.layout.BorderLayout");
    	jQuery.sap.require("sap.ui.commons.layout.BorderLayoutArea");
        jQuery.sap.require("sap.m.Toolbar");
        jQuery.sap.require("sap.m.ToolbarSpacer");
        jQuery.sap.require("sas.hc.m.Link");
        jQuery.sap.require("sap.m.Label");
        jQuery.sap.require("sas.hc.m.Button");
        jQuery.sap.require("sas.hc.m.ToggleButton");
        jQuery.sap.require("sas.hc.ui.commons.Splitter");
		jQuery.sap.require("sas.hc.m.MessageBox");
        jQuery.sap.require("sas.fscf.views.GuidedHelper");

    	var _this = this;

    	this.addStyleClass("cfGuidedView");

    	var oRulesLink = new sas.hc.m.Link({
		    id: this.sId + "ToolbarRulesLink",
			text : sas.fscf.rb.getText('creditfraud.tab.rules.txt'),
			press: function (e) {
				_this.back();
			}
		});
    	oRulesLink.addStyleClass("cfRulesLink");

    	var oRuleNameLabel = new sap.m.Label({
  			id: this.sId + "ToolbarRuleNameLabel",
            text: "> " + sas.fscf.getCurrentPageView().jsonRule.name
		});
    	oRuleNameLabel.addStyleClass("cfRuleNameLabel");

    	var oSaveButton = new sas.hc.m.Button({
        	id: this.sId + "ToolbarSaveButton",
    		icon: 'sap-icon://hc/save',
	    	tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.save.txt"),
	    	ariaLabel: sas.fscf.rb.getText("rules.rulesPage.guidedView.save.txt"),
	    	enabled: false,
     		press: function (oEvent) {
     			var _tButton = oEvent.oSource;
    			var _pressed = oEvent.mParameters.pressed;
    			var ruleFormGrid = sap.ui.getCore().byId("RulesPageGuidedViewFormView_RuleGuidedFormGrid");
    			if(ruleFormGrid.getVisible()){
    				var oFormView = sap.ui.getCore().byId(_this.sId + 'FormView');
    				oFormView.updateModelFromFullForm(true);
    				if(sas.fscf.getCurrentPageView().jsonRuleIncomplete==true){
    					//do nothing
    				}
    				else{
    					_this.save();
    				}
    			}
    			else{
    				_this.validateAlertAction();
    				if(sas.fscf.getCurrentPageView().jsonRuleIncomplete==true){
    					//do nothing
    				}
    				else{
    					_this.save();
    				}
    				// since changing the form view steps on the press state of the toggle button,
    				// re-do the press state of the toggle button after slight delay
    			}
    		}
		});
    	oSaveButton.addStyleClass("cfSaveButton");

    	var oToggleFormButton = new sas.hc.m.ToggleButton({
        	id: this.sId + "ToolbarFormViewButton",
    		icon: 'sap-icon://hc/form',
   			tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.formView.txt"),
   			ariaLabel: sas.fscf.rb.getText("rules.rulesPage.guidedView.formView.txt"),
    		press: function(oEvent) {
    			var _tButton = oEvent.oSource;
    			var _pressed = oEvent.mParameters.pressed;
    			var ruleFormGrid = sap.ui.getCore().byId("RulesPageGuidedViewFormView_RuleGuidedFormGrid");
    			if(ruleFormGrid.getVisible()){
    				var oFormView = sap.ui.getCore().byId(_this.sId + 'FormView');
    				oFormView.updateModelFromFullForm(true);
    				if(sas.fscf.getCurrentPageView().jsonRuleIncomplete==true){
    					_tButton.setPressed(true);
    				}
    				else{
	    				setTimeout(function () {
	    					_this.toggleFormView(_pressed);
	    					_tButton.setPressed(!_pressed);
	    					_tButton.setPressed(_pressed);
	    				}, 100);
    				}
    			}
    			else{
    				_this.toggleFormView(_pressed);
    				setTimeout(function () {
    					_tButton.setPressed(!_pressed);
    					_tButton.setPressed(_pressed);
    				}, 100);
    				// since changing the form view steps on the press state of the toggle button,
    				// re-do the press state of the toggle button after slight delay
    			}
    		}
		});
    	// Workaround a ToggleButton bug where the icon on the button does
    	// not inherit the title and aria label of the button
    	oToggleFormButton.onAfterRendering = function() {
	    	if (sas.hc.m.ToggleButton.prototype.onAfterRendering) {
        		sas.hc.m.ToggleButton.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
	    	var icon = $("#"+this.getDomRef().id+"-img")[0]; 
        	icon.setAttribute("title", sas.fscf.rb.getText("rules.rulesPage.guidedView.formView.txt"));
        	icon.setAttribute("aria-label", sas.fscf.rb.getText("rules.rulesPage.guidedView.formView.txt"));
    	};

        var oToolbar1 = new sap.m.Toolbar({
        	id: this.sId + "Toolbar",
    	    content: [
    	            oRulesLink,
    	            oRuleNameLabel,
    	      		new sap.m.Label({
    	      			id: this.sId + "ToolbarBusinessUnitLabel",
    	                text: sas.fscf.rb.getText("rules.rulesPage.guidedView.businessUnit.txt") + " " + sas.fscf.getCurrentPageView().jsonRule.businessUnitName
    	    		}),
    	    		oSaveButton,
					new sas.hc.m.Button({
   			        	id: this.sId + "ToolbarPreviewButton",
			    		icon: 'sap-icon://hc/code',
		   			    tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.preview.txt"),
		   			    ariaLabel: sas.fscf.rb.getText("rules.rulesPage.guidedView.preview.txt"),
   			     		press: function (e) {
   			     			_this.preview();
   			    		}
					}),
					oToggleFormButton
    	    ]
    	});

        var oSplitter1 = new sas.hc.ui.commons.Splitter({
            id: this.sId + 'Splitter1',
            splitterOrientation: sap.ui.commons.Orientation.vertical,
            splitterPosition: "17%",
            width: '100%',
            height: '99%'
        });

        var oPaletteView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "PaletteView",
            viewName: "sas.fscf.views.Palette",
            height: "99%"
        });
        oPaletteView.lazyLoadContent();

        var oGridToolbarView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "GridToolbarView",
            viewName: "sas.fscf.views.GridToolbar"
        });
        oGridToolbarView.lazyLoadContent();

        var oSplitter2 = new sas.hc.ui.commons.Splitter({
            id: this.sId + 'Splitter2',
            splitterOrientation: sap.ui.commons.Orientation.horizontal,
            splitterPosition: "60%",
            width: '100%',
            height: '99%'
        });
        oSplitter2.addStyleClass("cfSplitter2");

        var oGridView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "GridView",
            viewName: "sas.fscf.views.Grid"
        });
        oGridView.setStartMessage(sas.fscf.rb.getText("rules.rulesPage.guidedView.grid.start.txt"));
        oGridView.lazyLoadContent();

        oGridToolbarView.setGrid(oGridView);

        oSplitter2.addFirstPaneContent(oGridView);

        var oIconTabBarInfo = new sas.hc.m.IconTabBar({
        	id: this.sId + "TabBar",
        	height: '100%'
        });
        oIconTabBarInfo.addStyleClass("cfGuidedTabBar");

        var oFormView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "FormView",
            viewName: "sas.fscf.views.Form"
        });

        var oActionsView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "ActionsView",
            viewName: "sas.fscf.views.Actions"
        });

    	var oSplitter3 = new sas.hc.ui.commons.Splitter({
   		 	id: this.sId + 'Splitter3',
            splitterOrientation: sap.ui.commons.Orientation.vertical,
            splitterPosition: "80%",
            width: '100%',
            height: '99%'
        });
        oSplitter3.addStyleClass("cfSplitter3");
    	oSplitter3.addFirstPaneContent(oFormView);
    	oSplitter3.addSecondPaneContent(oActionsView);

        var oIconActionsTab = new sas.hc.m.IconTabFilter( this.sId + "ActionsTab", {
        	text:sas.fscf.rb.getText("rules.rulesPage.guidedView.tabs.conditionsAndActions.txt"),
        	closable:false
        });
        oIconActionsTab.addContent( oSplitter3 );
        oIconTabBarInfo.addItem( oIconActionsTab );

        var oRelatedRowsView = sap.ui.view({
        	type: sap.ui.core.mvc.ViewType.JS,
        	id: this.sId + "RelatedRowsView",
        	viewName: "sas.fscf.views.RelatedRows"
        });
        oRelatedRowsView.lazyLoadContent();

        var oIconRelatedRowsTab = new sas.hc.m.IconTabFilter( this.sId + "RelatedRowsTab", {
        	text:sas.fscf.rb.getText("rules.rulesPage.guidedView.tabs.relatedRows.txt"),
        	closable:false
        });
        oIconRelatedRowsTab.addContent( oRelatedRowsView );
        oIconTabBarInfo.addItem( oIconRelatedRowsTab );

        // attach tab change event handler
        oIconTabBarInfo.attachSelect(function(e){_this.handleTabChange(e.mParameters.key)});

        oSplitter2.addSecondPaneContent(oIconTabBarInfo);

        var oBorderLayoutTop2 = new sap.ui.commons.layout.BorderLayoutArea({
            id: this.sId + "BorderLayoutTop2",
			size: "3rem",
			content: [
			          oGridToolbarView
			]
		});
        oBorderLayoutTop2.addStyleClass("cfGridToolbarArea");

        var oBorderLayout2 = new sap.ui.commons.layout.BorderLayout({
            id: this.sId + "BorderLayout2",
    		top: oBorderLayoutTop2,
    	    center: new sap.ui.commons.layout.BorderLayoutArea({
                id: this.sId + "BorderLayoutCenter2",
    			content: [
    			          oSplitter2
      			]
      		})
    	});

        oSplitter1.addFirstPaneContent(oPaletteView);
        oSplitter1.addSecondPaneContent(oBorderLayout2);

        var oBorderLayout1 = new sap.ui.commons.layout.BorderLayout({
            id: this.sId + "BorderLayout1",
    		top: new sap.ui.commons.layout.BorderLayoutArea({
                id: this.sId + "BorderLayoutTop1",
    			size: "3rem",
    			content: [
    			          oToolbar1
    			]
    		}),
    	    center: new sap.ui.commons.layout.BorderLayoutArea({
                id: this.sId + "BorderLayoutCenter1",
    			content: [
    			          oSplitter1
      			]
      		})
    	});

        return oBorderLayout1;
    },

    handleTabChange: function(tabKey) {
    	if (tabKey == this.sId + "RelatedRowsTab") {
    		// update the Related Rows if/when the Related Rows tab is surfaced
    		this.getRelatedRows().update();
    	}
    },

    getCurrentTab: function() {
    	return sap.ui.getCore().byId(this.sId + "TabBar").getSelectedKey();
    },

    toggleFormView: function(bFormView) {
    	var oBorderLayoutCenter1 = sap.ui.getCore().byId(this.sId + 'BorderLayoutCenter1');
    	var oBorderLayoutCenter2 = sap.ui.getCore().byId(this.sId + 'BorderLayoutCenter2');
    	var oSplitter1 = sap.ui.getCore().byId(this.sId + 'Splitter1');
    	var oSplitter2 = sap.ui.getCore().byId(this.sId + 'Splitter2');
    	var oGridView = sap.ui.getCore().byId(this.sId + 'GridView');
    	var oActionsTab = sap.ui.getCore().byId(this.sId + 'ActionsTab');
    	var oSplitter3 = sap.ui.getCore().byId(this.sId + 'Splitter3');
    	var oFormView = sap.ui.getCore().byId(this.sId + 'FormView');
    	var oActionsView = sap.ui.getCore().byId(this.sId + 'ActionsView');
    	if (bFormView) {
				oSplitter1.setVisible(false);
				oBorderLayoutCenter2.removeContent(oSplitter2);
				oSplitter2.removeFirstPaneContent(oGridView);
		    	oSplitter3.removeFirstPaneContent(oFormView);
				this.addStyleClass("cfFullFormView");
				oSplitter2.addFirstPaneContent(oFormView);
				oBorderLayoutCenter1.addContent(oSplitter2);
				oActionsTab.setText(sas.fscf.rb.getText("rules.rulesPage.guidedView.tabs.actions.txt"));
				oSplitter3.setVisible(false);
				oSplitter3.removeSecondPaneContent(oActionsView);
				oSplitter3.getParent().addContent(oActionsView);
				var expressionsFormGrid = sap.ui.getCore().byId("RulesPageGuidedViewFormView_RuleExpressionsFormGrid");
				expressionsFormGrid.removeContent();
				expressionsFormGrid.destroyContent(true);
				expressionsFormGrid.setVisible(false);
				var ruleFormGrid = sap.ui.getCore().byId("RulesPageGuidedViewFormView_RuleGuidedFormGrid");
				ruleFormGrid.setVisible(true);
				ruleFormGrid.destroyContent();
				//oFormView.updateModelFromSplitForm();
				oFormView.initForm(ruleFormGrid);
				oFormView.synchPopulationIndicator(sap.ui.getCore().byId(this.sId + 'GridToolbarViewGridToolbarPopulationIndicator'));
				if (!sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties) {
					sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties = {};
				}
				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.view = "form";
				sas.fscf.getCurrentPageView().setDirty(true);
		    	this._bDirtySinceLastFormView = false;

		} else {
	    		oActionsTab.setText(sas.fscf.rb.getText("rules.rulesPage.guidedView.tabs.conditionsAndActions.txt"));
				oSplitter3.getParent().removeContent(oActionsView);
				oSplitter3.addSecondPaneContent(oActionsView);
				oSplitter3.setVisible(true);
	    		oSplitter2.removeFirstPaneContent(oFormView);
				this.removeStyleClass("cfFullFormView");
				oSplitter2.addFirstPaneContent(oGridView);
		    	oSplitter3.addFirstPaneContent(oFormView);
				oBorderLayoutCenter1.removeContent(oSplitter2);
				oBorderLayoutCenter2.addContent(oSplitter2);
				oSplitter1.setVisible(true);
				//oFormView.updateModelFromFullForm();
				var ruleFormGrid = sap.ui.getCore().byId("RulesPageGuidedViewFormView_RuleGuidedFormGrid");
				ruleFormGrid.setVisible(false);
				ruleFormGrid.destroyContent();
				var expressionsFormGrid = sap.ui.getCore().byId("RulesPageGuidedViewFormView_RuleExpressionsFormGrid");
				expressionsFormGrid.removeContent();
				expressionsFormGrid.destroyContent(true);
				if (!sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties) {
					sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties = {};
				}
				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.view = "grid";
		    	if (this._bDirtySinceLastFormView) {
					// reset the grid and palette
					oGridView.removeAllPanels(true);
					// reload the grid
					sas.fscf.loadRule(this);
		    	}
				oFormView.initSplitForm();
				expressionsFormGrid.setVisible(true);
				sas.fscf.getCurrentPageView().setDirty(true);
		    	this._bDirtySinceLastFormView = false;
		}
	},

	getActionsView:function(){
		return sap.ui.getCore().byId("RulesPageGuidedViewActionsView");
	},
//	getAlertCreationConfigurationDialog:function(){
//		return sap.ui.getCore().byId("RulesPageGuidedViewActionsViewAlertCreationConfigurationDialog");
//	},
    getPalette: function() {
    	return sap.ui.getCore().byId("RulesPageGuidedViewPaletteView");
    },

    getGrid: function() {
    	return sap.ui.getCore().byId("RulesPageGuidedViewGridView");
    },

    getForm: function() {
    	return sap.ui.getCore().byId("RulesPageGuidedViewFormView");
    },

    getRelatedRows: function() {
    	return sap.ui.getCore().byId("RulesPageGuidedViewRelatedRowsView");
    },

    back: function() {
    	var _this = this;
    	if (sas.fscf.getCurrentPageView().isDirty()) {
    		sas.hc.m.MessageBox.warning(sas.fscf.rb.getText('rules.rulesPage.guidedView.confirm.back.txt'),
				 sas.fscf.rb.getText('rules.rulesPage.guidedView.confirm.save.txt'),
			     [sas.hc.m.MessageBox.Action.YES, sas.hc.m.MessageBox.Action.NO, sas.hc.m.MessageBox.Action.CANCEL],
			     null,
			     function(response) {
    				if (response == sas.hc.m.MessageBox.Action.YES) {
    		   			_this.save(function () {
    		   				// success callback
    		   		    	sas.fscf.getCurrentPageView().switchToMainContent();
    		   		    	return;
    		   			}, function () {
    		   				// failure callback
    		   		    	sas.fscf.getCurrentPageView().switchToMainContent();
    		   				return;
    		   			});
    				} else if (response == sas.hc.m.MessageBox.Action.NO) {
    			    	sas.fscf.getCurrentPageView().switchToMainContent();
    					return;
    				}
				 });
    	} else {
	    	sas.fscf.getCurrentPageView().switchToMainContent();
			return;
    	}
    },

    save: function(successCallback, failureCallback) {
    	var _this = this;
    	_this.validateAlertAction();
		if(sas.fscf.getCurrentPageView().jsonRuleIncomplete==true){
			//do nothing
		}
		else{

		    	var ruleFormGrid = sap.ui.getCore().byId("RulesPageGuidedViewFormView_RuleGuidedFormGrid");
		   	    if (ruleFormGrid.getVisible()){
		   	    	var oFormView = sap.ui.getCore().byId(this.sId + 'FormView');
		   	    	oFormView.updateModelFromFullForm();
		   	    };
				var jsonRule = {
					"id":sas.fscf.getCurrentPageView().jsonRule.id,
					"lastUpdateNumber": sas.fscf.getCurrentPageView().jsonRule.lastUpdateNumber,
					"queueId":sas.fscf.getCurrentPageView().jsonRule.queueId,
					"alertTypeId":sas.fscf.getCurrentPageView().jsonRule.alertTypeId,
					"alertReason": sas.fscf.getCurrentPageView().jsonRule.alertReason,
					"expressions":sas.fscf.getCurrentPageView().jsonRule.expressions
				};
				var urlString = 'rest/businessunits/' + sas.fscf.getCurrentPageView().jsonRule.businessUnitId + '/rules/'+ jsonRule.id;
				var requestType = "PUT";
		   		sas.ajax({url:urlString, type: requestType, data: jsonRule})
		   		  .done(function(oData){
		   			  sas.fscf.getCurrentPageView().jsonRule.lastUpdateNumber = oData.lastUpdateNumber;
		   			  sas.fscf.getCurrentPageView().setDirty(false);
		   			  if (successCallback) {
		   				  successCallback.call();
		   			  }
		   		  }).fail(function(oObj,textStatus,errorThrown){
		   			  if(errorThrown == "Conflict"){
		   		  			sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, sas.fscf.rb.getText('rules.rulesPage.guidedView.cannotSaveEditedElsewhere.txt'));
		   			  } else if (oObj.responseJSON.message) {
		   		  			sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, oObj.responseJSON.message);
		   			  } else {
		   		  			sas.fscf.showInlineMessage(_this.sId, sas.fscf.MESSAGE_TYPE_ERROR, sas.fscf.rb.getText('rules.rulesPage.guidedView.errorSavingRule.txt') + " - " + errorThrown);
		   			  }
		  			  if (failureCallback) {
		   				  failureCallback.call();
		   			  }
				});
		}
    },

    preview: function() {
    	var _this = this;
    	if (sas.fscf.getCurrentPageView().isDirty()) {
    		sas.hc.m.MessageBox.warning(sas.fscf.rb.getText('rules.rulesPage.guidedView.confirm.preview.txt'),
				 sas.fscf.rb.getText('rules.rulesPage.guidedView.confirm.save.txt'),
			     [sas.hc.m.MessageBox.Action.OK, sas.hc.m.MessageBox.Action.CANCEL],
			     null,
			     function(response) {
    				if (response == sas.hc.m.MessageBox.Action.OK) {
	    				//_this.validateAlertAction();
    					var canSave = true;
    					var ruleFormGrid = sap.ui.getCore().byId("RulesPageGuidedViewFormView_RuleGuidedFormGrid");
    	    			if(ruleFormGrid.getVisible()){
    	    				var oFormView = sap.ui.getCore().byId(_this.sId + 'FormView');
    						oFormView.updateModelFromFullForm(true);
    						if(sas.fscf.getCurrentPageView().jsonRuleIncomplete==true){
    							canSave = false;
    						}
    					}
	    				if(!canSave){
	    					//do nothing
	    				}
	    				else{
	    					_this.save(function () {
    		   				// success callback
    	    				sas.fscf.getCurrentPageView().getPreviewRuleDialog().open();
    		   		    	return;
    		   			}, function () {
    		   				// failure callback
    		   				return;
    		   			});
	    				}
    				}
				 });
    	} else {
			sas.fscf.getCurrentPageView().getPreviewRuleDialog().open();
			return;
    	}
    },

/*    finish: function() {
    	var _this = this;
    	if (sas.fscf.getCurrentPageView().isDirty()) {
    		sas.hc.m.MessageBox.warning(sas.fscf.rb.getText('rules.rulesPage.guidedView.confirm.finish.txt'),
				 sas.fscf.rb.getText('rules.rulesPage.guidedView.confirm.save.txt'),
			     [sas.hc.m.MessageBox.Action.YES, sas.hc.m.MessageBox.Action.NO, sas.hc.m.MessageBox.Action.CANCEL],
			     null,
			     function(response) {
    				if (response == sas.hc.m.MessageBox.Action.YES) {
			    				_this.validateAlertAction();
			    				if(sas.fscf.getCurrentPageView().jsonRuleIncomplete==true){
			    					//do nothing
			    				}
			    				else{
			    					_this.save(function () {
		    		   				// success callback
									sas.fscf.getCurrentPageView().switchToMainContent();
    		   				    	return;


    		   						}, function () {
    		   						// failure callback
    	    						sas.fscf.getCurrentPageView().switchToMainContent();
    		   						return;
    		   						});
    							}
    				} else if (response == sas.hc.m.MessageBox.Action.NO) {
        				//sas.fscf.getCurrentPageView().getPromoteRuleDialog().open();
    					sas.fscf.getCurrentPageView().switchToMainContent();
    					return;
    				}
				 });
    	} else {
			//sas.fscf.getCurrentPageView().getPromoteRuleDialog().open();
    		sas.fscf.getCurrentPageView().switchToMainContent();
			return;
    	}
    },*/

    _dirtySet: function(bDirty) {
    	sap.ui.getCore().byId(this.sId + "ToolbarSaveButton").setEnabled(bDirty);
    	if (bDirty) {
        	this._bDirtySinceLastFormView = bDirty;
    	}
    },

    _destroyAll: function() {
    	this.getPalette().destroy();
    	this.getGrid().destroy();
    	this.getForm().destroy();
        this.getActionsView().destroy();
        //this.getAlertCreationConfigurationDialog.destroy();
        if(sap.ui.getCore().byId("RulesPageGuidedViewAlertCreationConfigurationDialogalertDestinationLabel"))
        	sap.ui.getCore().byId("RulesPageGuidedViewAlertCreationConfigurationDialogalertDestinationLabel").destroy();
        if(sap.ui.getCore().byId("RulesPageGuidedViewAlertCreationConfigurationDialogalertTypeLabel"))
        	sap.ui.getCore().byId("RulesPageGuidedViewAlertCreationConfigurationDialogalertTypeLabel").destroy();
        var i=0;
        for(i=0;i<100;i++){
        	if (sap.ui.getCore().byId("RulesPageGuidedViewActionsViewdecisionSelect-"+i)) {
            sap.ui.getCore().byId("RulesPageGuidedViewActionsViewdecisionSelect-"+i).destroy();
        	}else{break;}
        }

        for(i=0;i<100;i++){
        	if(sap.ui.getCore().byId("RulesPageGuidedViewActionsViewAlertCreationConfigurationDialogalertDestinationSelect-"+i)){
        		sap.ui.getCore().byId("RulesPageGuidedViewActionsViewAlertCreationConfigurationDialogalertDestinationSelect-"+i).destroy();
        	}else{break;}
        }

    },
    getActionConfiguration: function() {
    	var view = sap.ui.jsfragment({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "AlertCreationConfigurationDialog",
            fragmentName: "sas.fscf.views.fragments.AlertCreationConfigurationDialog"
        });
    	return view;
    },
    validateAlertAction: function(){
    		sas.fscf.getCurrentPageView().jsonRuleIncomplete=false;
    		var alertCnfgBtn=sap.ui.getCore().byId("RulesPageGuidedViewActionsViewconfigureButton1");
    		var alertCnfg=alertCnfgBtn.getEnabled();
	    	var alertDestination=sas.fscf.getCurrentPageView().jsonRule.queueId;
	    	var alertType=sas.fscf.getCurrentPageView().jsonRule.alertTypeId;
	    	if(alertType!=null)alertType=alertType.trim();
	    	if(alertCnfg && (alertDestination==null || alertDestination=="" || alertType==null || alertType=="")){
	    		var view =this.getActionConfiguration();
	    		view.setValidate(true);
	    		var validateView=view.lazyLoadContent();
	    		validateView.open();
	    		sas.fscf.getCurrentPageView().jsonRuleIncomplete=true;

	    	}
	 }

});
