sap.ui.jsfragment("sas.fscf.views.fragments.AlertCreationConfigurationDialog", {

    _bExplore: false,
    _bValidate: false,

    isExplore: function() {
    	return this._bExplore;
    },

    setExplore: function(bExplore) {
    	this._bExplore = bExplore;
    },

    getExploreContext: function() {
    	return this._oExploreContext;
    },

    setExploreContext: function(oExploreContext) {
    	this._oExploreContext = oExploreContext;
    },

	createContent: function(oController) {
	},

    isValidate: function() {
	    	return this._bValidate;
	},
    setValidate: function(bValidate) {
	    	this._bValidate = bValidate;
	 },


	lazyLoadContent: function() {
		var _this = this;
		//console.log("on load: sas.fscf.getCurrentPageView().jsonRule.alertReason"+ sas.fscf.getCurrentPageView().jsonRule.alertReason);
        var oDialog = new sas.hc.m.Dialog({
        	id: "AlertCreationConfigurationDialog",
        	title: _this.isExplore() ? sas.fscf.rb.getText('rules.rulesPage.guidedView.relatedRows.createAlert.fmt.txt', _this.getExploreContext().txnId) : sas.fscf.rb.getText('rules.rulesPage.guidedView.form.alertCreationConfiguration.txt'),
    	    content: [
    	              new sas.hc.ui.layout.Grid({
      	  				hSpacing: 1,
      	  				vSpacing: 1,
      	  				content: [

		        alertDestinationLabel = new sas.hc.ui.commons.Label({
					id: this.sId + "alertDestinationLabel",
					text: sas.fscf.rb.getText('rules.rulesPage.guidedView.form.alertDestination.txt'),
					required:true,
					width:"395px",
					layoutData : new sas.hc.ui.layout.GridData({
						span : "L5 M5 S5"
					})
			    }),

			    alertDestinationSelect=this.getAlertDestinationSelect(),

			    alertTypeLabel = new sas.hc.ui.commons.Label({
					id: this.sId + "alertTypeLabel",
					text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.alertType.txt"),
					required:true,
					width:"395px",
					layoutData : new sap.ui.layout.GridData({
							linebreakL: true,
							linebreakM: true,
							linebreakS: true,
							span:"L5 M5 S5"
					})
			    }),

			    alertTypeSelect=this.getAlertTypeSelect(),

			    alertReasonLabel= new sas.hc.ui.commons.Label({
			    	id:this.sId + "alertReasonLabel",
			    	text : sas.fscf.rb.getText("rules.rulesPage.guidedView.form.alertReason.txt"),
			    	required : false,
					width: "395px",
					visible: !_this.isExplore(),
					layoutData : new sap.ui.layout.GridData({
							linebreakL: true,
							linebreakM: true,
							linebreakS: true,
							span:"L5 M5 S5"
					})
			    }),

			    alertReasonText = new sas.hc.m.TextArea({
					 	id: this.sId + "alertReasonText",
					 	value: sas.fscf.getCurrentPageView().jsonRule.alertReason,
						width:"350px",
						rows:3,
						maxLength:300,
						visible: !_this.isExplore(),
						layoutData : new sas.hc.ui.layout.GridData({
							span : "L7 M7 S7"
						})
				})

	    	    ],
    	    }),

    	    ],
    	    leftButton: new sas.hc.m.Button({
    	    	text: sas.fscf.rb.getText('rules.rulesPage.ok.txt'),
    	        press: function() {
    	        	var alertDestinationSelected=alertDestinationSelect.getSelectedItem().getKey();
    	        	var alertTypeSelected=alertTypeSelect.getSelectedItem().getKey();
    	         	var alertReasonTextValue=alertReasonText.getValue();

    	         	if (!_this.isExplore()) {
	    	        	if(alertDestinationSelected!="" && alertTypeSelected!=""){
		    	        	sap.ui.getCore().byId("RulesPageGuidedViewActionsViewconfigureButton1").setIcon("sap-icon://hc/complete");
		    	        	sap.ui.getCore().byId("RulesPageGuidedViewActionsViewconfigureButton1").setEnabled(true);
		    	        	sap.ui.getCore().byId("RulesPageGuidedViewActionsViewalertActionCheckBox").setValueState(sap.ui.core.ValueState.None);
		    	        	sas.fscf.getCurrentPageView().jsonRule.queueId=alertDestinationSelected;
		    	        	sas.fscf.getCurrentPageView().jsonRule.alertTypeId=alertTypeSelected;
		    	        	sas.fscf.getCurrentPageView().jsonRule.alertReason=alertReasonTextValue;
	
	    	        	}else{//alert action not configured
		    	        	sap.ui.getCore().byId("RulesPageGuidedViewActionsViewalertActionCheckBox").setValueState(sap.ui.core.ValueState.None);
		    	        	sap.ui.getCore().byId("RulesPageGuidedViewActionsViewconfigureButton1").setIcon("sap-icon://hc/configuration");
		    	        	for(i=0;i<sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.length;i++){
		    	        		if(sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions[i].id=="50101"){
		    	        			sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].thenActions.splice(i,1);//remove alert action
		    	        		}
		    	        	}
		    	        	sas.fscf.getCurrentPageView().jsonRule.queueId=null;
		    	        	sas.fscf.getCurrentPageView().jsonRule.alertTypeId=null;
		    	        	sas.fscf.getCurrentPageView().jsonRule.alertReason=null;
	    	        	}
	
	    	        	sas.fscf.getCurrentPageView().setDirty(true);
	        	        oDialog.close();
    	         	} else {
        	        	if(alertDestinationSelected!="" && alertTypeSelected!=""){
        	        		sas.ajax({url:"rest/alerts?transactionId=" + _this.getExploreContext().txnId + "&transactionStorageType=" + _this.getExploreContext().txnAcronym + "&alertTypeId=" + alertTypeSelected + "&queueId=" + alertDestinationSelected, type: "POST", contentType:"application/json; charset=utf-8", dataType:"json"})
      	        		  	  .done(function(oData){
      	            	         oDialog.close();
     	        		  		 sas.fscf.showInlineMessage(sas.fscf.getCurrentPageView().sId + "GuidedViewSplitter1_secondPane", sas.fscf.MESSAGE_TYPE_COMPLETE, sas.fscf.rb.getText("explore.explorePage.guidedView.createdAlert.fmt.txt", oData.id));
      		        		  }).fail(function(oObj,textStatus,errorThrown){
      		        			 if (oObj.responseJSON.message) {
      		        				  sas.fscf.showInlineMessage(oDialog.sId + "-scrollCont", sas.fscf.MESSAGE_TYPE_ERROR, oObj.responseJSON.message);
      		        			 }
      		        		});
        	        	} else {
        	        		if(alertDestinationSelected=="" ||alertDestinationSelected==null ){
        	        			alertDestinationSelect.setValueState(sap.ui.core.ValueState.Error);
        	        			alertDestinationSelect.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.guidedView.form.missingAlertDestination.error.txt"));
        	        		}
        	        		if(alertTypeSelected=="" || alertTypeSelected==null){
        	        			alertTypeSelect.setValueState(sap.ui.core.ValueState.Error);
        	        			alertTypeSelect.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.guidedView.form.missingAlertType.error.txt"));
        	        		}        	        		
        	        	}
    	        	}
    	        }
    	    }),
    	    rightButton:  new sas.hc.m.Button({
    	    	text: sas.fscf.rb.getText('rules.rulesPage.cancel.txt'),
    	        press: function() {
    	        	oDialog.close();
    	        }
    	    })
        });

        if (!this.isExplore() && this.isValidate()) {
		    this.validateForm(alertDestinationSelect,alertTypeSelect);
		}

        oDialog.attachAfterClose(function(oEvent) {
        	this.destroy();
        });

        return oDialog;
    },
    getAlertDestinationSelect: function(){
    	jQuery.sap.require("sap.ui.model.Sorter");
    	jQuery.sap.require("sap.ui.commons.ListBox");
    	var _this = this;
    	var alertDestinationList = new sas.hc.m.Select({
    		id: this.sId + "alertDestinationSelect",
    		selectedKey : sas.fscf.getCurrentPageView().jsonRule.queueId,
    		layoutData : new sas.hc.ui.layout.GridData({
    		span : "L7 M7 S7",
    		width:"350px"
    		})
    	});
    	sas.ajax({url:'rest/queues?fields=id,name'})
		  .done(function(oData){

			var model = new sap.ui.model.json.JSONModel(oData);
			alertDestinationList.setModel(model);
			alertDestinationList.bindAggregation("items", {
	            path: "/items",
	            factory: function(sId, oContext) {
	                  return new sap.ui.core.ListItem(sId, {
	                	  key:  oContext.getProperty("id"),
	                	  text: oContext.getProperty("name"),
	                  });
	            },
	            sorter: new sap.ui.model.Sorter("name")
	        });
			alertDestinationList.insertItem(new sas.hc.ui.core.Item({key: "",text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.actions.none.txt")}),0);

			alertDestinationList.attachChange(function(oEvent){
				var alertDestinationSelected=this.getSelectedItem().getKey();
				if(alertDestinationSelected!="")this.setValueState(sap.ui.core.ValueState.None);
				sas.fscf.getCurrentPageView().jsonRule.queueId=alertDestinationSelected;
	    		sas.fscf.getCurrentPageView().setDirty(true);
	    	});


		 }).fail(function(oObj,textStatus){
	         console.info("Failed to get queues. ");
		 });
    	return alertDestinationList;
    },

    getAlertTypeSelect: function(){
    	jQuery.sap.require("sap.ui.model.Sorter");
    	jQuery.sap.require("sap.ui.commons.ListBox");

    	var _this = this;
    	var alertTypeList = new sas.hc.m.Select({
    		id: this.sId + "alertTypeSelect",
    		selectedKey : sas.fscf.getCurrentPageView().jsonRule.alertTypeId,
    		layoutData : new sas.hc.ui.layout.GridData({
    		span : "L7 M7 S7",
    		width:"350px"
    		})
    	});
    	sas.ajax({url:'rest/alerttypes?fields=id,name'})
		  .done(function(oData){

			var model = new sap.ui.model.json.JSONModel(oData);
			alertTypeList.setModel(model);
			alertTypeList.bindAggregation("items", {
	            path: "/items",
	            factory: function(sId, oContext) {
	                  return new sap.ui.core.ListItem(sId, {
	                	  key:  oContext.getProperty("id"),
	                	  text: oContext.getProperty("name"),
	                  });
	            },
	            sorter: new sap.ui.model.Sorter("name")
	        });
			alertTypeList.insertItem(new sas.hc.ui.core.Item({key: "",text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.actions.none.txt")}),0);

			alertTypeList.attachChange(function(oEvent){
				var alertTypeSelected=this.getSelectedKey();
				if(alertTypeSelected!="")this.setValueState(sap.ui.core.ValueState.None);
				sas.fscf.getCurrentPageView().jsonRule.alertTypeId=alertTypeSelected;
		        if (_this.isExplore()) {
		        	_this.updateAlertDestinationBasedOnAlertType(sap.ui.getCore().byId(_this.sId + "alertDestinationSelect"),this,sap.ui.getCore().byId("AlertCreationConfigurationDialog"));				
		        }
	    		sas.fscf.getCurrentPageView().setDirty(true);
	    	});

			if (_this.isExplore()) {
				if (_this.getExploreContext().alertType != null) {
					alertTypeList.setSelectedKey(_this.getExploreContext().alertType.id);
				}
				if (alertTypeList.getSelectedKey()) {
					alertTypeList.fireChange({selectedItem: alertTypeList.getItemByKey(alertTypeList.getSelectedKey())});
				}
			}


		 }).fail(function(oObj,textStatus){
	         console.info("Failed to get alert types.");
		 });

    	return alertTypeList;
    },
    updateAlertDestinationBasedOnAlertType: function(alertDestinationSelect,alertTypeSelect,oDialog) {
    	var _this = this;
    	var leftButton = sap.ui.getCore().byId(oDialog.getLeftButton());
    	sas.ajax({url:"rest/alerts?transactionId=" + _this.getExploreContext().txnId + "&transactionStorageType=" + _this.getExploreContext().txnAcronym + "&alertTypeId=" + alertTypeSelect.getSelectedKey(), type: "GET", contentType:"application/json; charset=utf-8", dataType:"json"})
		  .done(function(oData){
			  if (oData && oData.alertId && oData.queueId) {
				  alertDestinationSelect.setSelectedKey(oData.queueId);
  				  sas.fscf.showInlineMessage(oDialog.sId + "-scrollCont", sas.fscf.MESSAGE_TYPE_INFO, sas.fscf.rb.getText("explore.explorePage.guidedView.alertExists.fmt.txt", oData.alertId));
				  alertDestinationSelect.setEnabled(false);
				  leftButton.setEnabled(false);
			  } else {
  				  sas.fscf.hideInlineMessage(oDialog.sId + "-scrollCont");
				  alertDestinationSelect.setEnabled(true);
				  leftButton.setEnabled(true);				  
			  }
		  }).fail(function(oObj,textStatus){
			  sas.fscf.hideInlineMessage(oDialog.sId + "-scrollCont");
			  alertDestinationSelect.setEnabled(true);
			  leftButton.setEnabled(true);				  
		  });  	
    },
    validateForm: function(alertDestinationSelect,alertTypeSelect){
    	var alertDestinationSelected=sas.fscf.getCurrentPageView().jsonRule.queueId;
    	var alertTypeSelected=sas.fscf.getCurrentPageView().jsonRule.alertTypeId;
    	if(alertTypeSelected!=null) alertTypeSelected=alertTypeSelected.trim();
    	if(sap.ui.getCore().byId("RulesPageGuidedViewActionsViewconfigureButton1").getEnabled()==true){
    		if(alertDestinationSelected=="" ||alertDestinationSelected==null ){
    			alertDestinationSelect.setValueState(sap.ui.core.ValueState.Error);
    			alertDestinationSelect.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.guidedView.form.missingAlertDestination.error.txt"));
    		}
    		if(alertTypeSelected=="" || alertTypeSelected==null){
    			alertTypeSelect.setValueState(sap.ui.core.ValueState.Error);
    			alertTypeSelect.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.guidedView.form.missingAlertType.error.txt"));
    		}
    	}
    }

});
