
// Values used by addRow() to store current monitor display values
var displayedBars = new Array();
var isHiddenColor = new Array();
var nextRowToAdd = 0;
var timeOut = 0;
var maxBarTotal = 0;
var oldMaxBarTotal = 0;

// Does processing needed upon completion of page load for the Console tab
function consoleTabOnLoadHandler()
{
  if (window.removeBusy) removeBusy();

  // For the Activity screen
  if (document.getElementById("showBarsCheckBox")) {
     var updateInterval = getCookie("monitor_updateInterval");
     document.getElementById("updateInterval").selectedIndex = (updateInterval) ? updateInterval : 7;

     var showBars = getCookie("console_showBars");
     if (!showBars)
        showBars = "N";
     if (showBars=='N')
        for (var i=0; i<barNames.length; i++)
            setVisibles("num",barNames[i]);
     for (var i=0; i<configNames.length; i++)
         setVisibles("config",configNames[i]);
     for (var i=0; i<counterNames.length; i++)
         setVisibles("counter",counterNames[i]);
     for (var i=0; i<gaugeNames.length; i++)
         setVisibles("gauge",gaugeNames[i]);
     for (var i=0; i<rateNames.length; i++)
         if (i%2 == 0) setVisibles("rate",rateNames[i]);

     document.getElementById("showBarsCheckBox").checked = showBars=="Y" ? true : false;
  }

  // For recordings, logs, and status displays
  if (document.getElementById('consoleTabScrollableDiv') || document.getElementById('consoleTabScrollableToBottomDiv')) {
    // Establish the onResize handler (complain immediately if someone else is using it)
//    if (window.onresize && window.onresize != rulesTabResizeHandler)
//      alert('Resize handler for window already exists and is not rulesTabResizeHandler: ' + window.onresize);
//    else
//      window.onresize = rulesTabResizeHandler;
//    rulesTabResizeHandler();

    // For log displays
    if (document.getElementById('consoleTabScrollableToBottomDiv')) {
      // Scroll to the bottom
      var div = document.getElementById('consoleTabScrollableToBottomDiv');
      div.scrollTop = div.scrollHeight;
    }
  }


}


// Hide or show metrics based on current visibility settings
function setVisibles(metricType,metricName) {
   var hiddenCookie = getCookie("console_hidden_"+metricType);
   if (!hiddenCookie)
      return;
   var visibility = hiddenCookie.match('\\b'+metricName+'\\b') ? 'none' : 'inline';
   var colDisp = document.getElementById("head_"+metricType+metricName).columnDisplay;
   if (colDisp && visibility!=colDisp)
      showHideConsoleMonitorColumn(metricType,metricName,document.getElementById("select_"+metricType+"_"+metricName));
}


// Return the sum of the difference between new and old stats for all processors
function getProcessorIncrement(name,newStats)
{
  var total = 0;
  for (var p=0; p<processorCount; p++)
  {
    var oldProcStats = oldStats["processor"+p];
    var newProcStats = newStats["processor"+p];
    if (oldProcStats && newProcStats)
    {
      var diff = (newProcStats[name]?newProcStats[name]:0) - (oldProcStats[name]?oldProcStats[name]:0);
      if (diff < 0)
      {
        //alert(newProcStats[name] + " < " + oldProcStats[name] + " for " + name + " processor" + p + "\n" + newProcStats["PROCESS_NAME"] + "\n" + oldProcStats["PROCESS_NAME"]);
        //total = '.';
        //break;
      }
      else
        total = total + diff;
    }
  }
  return total;
}


// Return the sum of the values of the indicated stat for all processors
function getProcessorSum(name,newStats)
{
  var total = 0;
  for (var p=0; p<processorCount; p++)
  {
    var newProcStats = newStats["processor"+p];
    if (newProcStats) {
      var value = newProcStats[name];
      if (value)
        total += (value-0); // Turn into number
    }
  }
  return total;
}


// Adds an hbar to the chart on the page, sleeps, and re-requests stats by reloading the child iframe
function addRow(newStats, tod, newJStats, paramType, oldRowTime)
{
	var tod1 = new Date(tod);
	var rowTime1 = new Date(oldRowTime);
    // Do nothing if we are paused
    if (document.getElementById("pausedArea").style.display != "none")
      return;

    if (newJStats!=null)
    {
      if(newJStats.length > 0)
      {
	  	var intervalElapsedMillisec = tod1.getTime() - rowTime1.getTime();
    	intervalElapsedMillisec = (intervalElapsedMillisec-0)<0 ? 999999 : intervalElapsedMillisec;
    	// Shift rows up one when page is full
    	if (nextRowToAdd == document.getElementById("barsPerPage").value)
    	{
    	nextRowToAdd--;
      	var thisRowTDs = document.getElementById("row0").getElementsByTagName("TD");
      	for (var i=1; i <= nextRowToAdd; i++)
      	{
    	  var nextRowTDs = document.getElementById("row"+i).getElementsByTagName("TD");
        	for (var td=0; td < thisRowTDs.length; td++)
        	{
        	// If this cell is a bar, get slice definitions, else just copy cell contents up one
        	if (thisRowTDs[td].id.substr(0,3) == "bar" && thisRowTDs[td].id.substr(0,8) != "barTotal")
        	  thisRowTDs[td].innerHTML = getSlices(i);
          	else
        	  thisRowTDs[td].innerHTML = nextRowTDs[td].innerHTML;
          	if (thisRowTDs[td].amount)
        	  thisRowTDs[td].amount = nextRowTDs[td].amount;
        	}
        	thisRowTDs = nextRowTDs;
      	}
      	displayedBars.shift();
    	}

    	document.getElementById("tod" + nextRowToAdd).innerHTML = tod.getHours() + ":" + get2Digits(tod.getMinutes()) + ":" + get2Digits(tod.getSeconds());

    	for (i=0; i<newJStats.length; i++)
    	{
    		document.getElementById('newJose' + i + 'Stat' + nextRowToAdd).innerHTML = newJStats[i];
    	}

    	var transProcessed = document.getElementById('newJose' + 0 + 'Stat' + nextRowToAdd).innerHTML;
    	var transProcessTime = parseInt(document.getElementById('newJose' + 1 + 'Stat' + nextRowToAdd).innerHTML);

    	if(transProcessTime!=0){
    		document.getElementById('TPS' + 0 + nextRowToAdd).innerHTML = Math.round((transProcessed/transProcessTime) * 1000);
    	}
    	else{
    		document.getElementById('TPS' + 0 + nextRowToAdd).innerHTML = 0;
    	}

    	// Add new row next time
    	nextRowToAdd++;
    	oldRowTime = tod;
      }
   }

   else if (paramType=="OSE" && newJStats==null){

	   toggleBarNums();
     // Update config info at top of report
	   for (var i=0; i<configNames.length; i++)
	   {
		   document.getElementById(configNames[i]).innerHTML = (newStats[configNames[i]]) ? newStats[configNames[i]] : "?";
	   }

	   // Update header info
	   var totalProcCount = getProcessorSum("procCount", newStats);
	   var elapsedMsec = newStats["elapsedMsec"];
	   document.getElementById("quiescingArea").style.display = newStats['quiescing']=='true' ? "" : "none";
	   document.getElementById("stoppingArea").style.display = newStats['stopping']=='true' ? "" : "none";
	   var errorMsg = newStats['errorMsg'];
	   if (errorMsg && errorMsg.replace(/\s/g,'').length>0) {
		   document.getElementById("errorArea").style.display='inline';
		   document.getElementById("errorArea").title=errorMsg;
	   } else if (document.getElementById("errorArea").title!='') {
		   document.getElementById("errorArea").style.display='none';
		   document.getElementById("errorArea").title='';
	   }

	   // Update trailer info
	   for (var p=0; p<processorCount; p++)
	   {
		   var newProcStats = newStats["processor"+p];
		   if (newProcStats)
		   {
			   var t = document.getElementById(newProcStats["PROCESS_NAME"] + "_ProcCount");
			   if (t && t.innerHTML)
				   t.innerHTML = newProcStats["PROCESS_PROC_COUNT"];
			   else
				   document.getElementById("resetNeeded").style.display="";
			   t = document.getElementById(newProcStats["PROCESS_NAME"] + "_ReadCount");
			   if (t && t.innerHTML)
				   t.innerHTML = newProcStats["PROCESS_READ_COUNT"];
			   else
				   document.getElementById("resetNeeded").style.display="";
			   var c = newProcStats["PROCESS_UNSAF_COUNT"];
			   t = document.getElementById(newProcStats["PROCESS_NAME"] + "_UnsafCount");
			   if (t && t.innerHTML && c && c>0)
				   t.innerHTML = c;
			   c = newProcStats["PROCESS_SAF_COUNT"];
			   t = document.getElementById(newProcStats["PROCESS_NAME"] + "_SafCount");
			   if (t && t.innerHTML && c && c>0)
				   t.innerHTML = c;
		   }
	   }

	   // If stats do not match, ignore them because numbers are bogus anyway (happens during engine restart sometimes)
	   var statsOK = true;
	   for (var p=0; p<processorCount; p++)
	   {
		   var oldProcStats = oldStats["processor"+p];
		   var newProcStats = newStats["processor"+p];
		   if (oldProcStats && newProcStats && newProcStats["PROCESS_NAME"] != oldProcStats["PROCESS_NAME"])
		   {
			   //alert("Invalid processor statistics ignored because new stats #" + p + " from " + newProcStats["PROCESS_NAME"] + " and old from " + oldProcStats["PROCESS_NAME"]);
			   statsOK = false;
			   break;
		   }
	   }

	   // Update rows only if a good response came back
	   var procCount = getProcessorIncrement("procCount", newStats);
	   if (statsOK && procCount >= 0)
	   {
		   var intervalElapsedMillisec = tod1.getTime() - rowTime1.getTime();
		   intervalElapsedMillisec = (intervalElapsedMillisec-0)<0 ? 999999 : intervalElapsedMillisec;

		   // Create bar slices and total for the new row
		   var barTotal = 0;
		   var slices = new Array(sliceCount);
		   for (var s=0; s<slices.length; s++)
		   {
			   slices[s] = (procCount==0) ? 0 : (getProcessorIncrement(barNames[s],newStats) / procCount);
			   if (!isHiddenColor[colors[s]])
				   barTotal += slices[s];
		   }
		   maxBarTotal = getMaxBarTotal(barTotal);

		   // Calculate rates (in pairs) for the new row
		   var rates = new Array();
		   for (var i=0; i < rateNames.length; i++)
		   {
			   var numerName = rateNames[i];
			   var denomName = rateNames[i+1];
			   var numerator = getProcessorIncrement(numerName,newStats);
			   var denominator = (denomName=='deltaMsec') ? intervalElapsedMillisec : getProcessorIncrement(denomName,newStats);
			   // When is numerator is elapsed time, express as hh:mm:ss (when big), when denominator is time, express as number, else show as percent
			   if (numerName.substr(numerName.length-4).toLowerCase()=='msec')
				   rates[i] = (!denominator || denominator==0) ? '.&nbsp;' : getPrintableMsecs(numerName, numerator/denominator);
			   else if (denomName.substr(denomName.length-4).toLowerCase()=='msec')
				   rates[i] = (!denominator || denominator==0) ? '.&nbsp;' : Math.round((numerator*10000)/denominator);
			   else
				   rates[i] = (!denominator || denominator==0) ? ".&nbsp;" : (Math.floor((100*numerator)/denominator) + "%");
			   //rates[i] = (!denominator || denominator==0) ? ".&nbsp;" : (Math.min(100,Math.round((100*numerator)/denominator)) + "%");
			   rates[i] = "<span title='" + numerator + "/" + denominator + "'>" + rates[i] + "</span>";
			   rates[++i] = denominator;
		   }

		   // Shift rows up one when page is full
		   if (nextRowToAdd == document.getElementById("barsPerPage").value)
		   {
			   nextRowToAdd--;
			   var thisRowTDs = document.getElementById("row0").getElementsByTagName("TD");
			   for (var i=1; i <= nextRowToAdd; i++)
			   {
				   var nextRowTDs = document.getElementById("row"+i).getElementsByTagName("TD");
				   for (var td=0; td < thisRowTDs.length; td++)
				   {
					   // If this cell is a bar, get slice definitions, else just copy cell contents up one
					   if (thisRowTDs[td].id.substr(0,3) == "bar" && thisRowTDs[td].id.substr(0,8) != "barTotal")
						   thisRowTDs[td].innerHTML = getSlices(i);
					   else
						   thisRowTDs[td].innerHTML = nextRowTDs[td].innerHTML;
					   if (thisRowTDs[td].amount)
						   thisRowTDs[td].amount = nextRowTDs[td].amount;
				   }
				   thisRowTDs = nextRowTDs;
			   }
			   displayedBars.shift();
		   }
		   // Else not full, so just resize bars in displayed rows (nop if max has not changed)
		   else if (maxBarTotal != oldMaxBarTotal)
			   resizeBars();

		   // Add the new bottom row
		   displayedBars[nextRowToAdd] = slices;
		   document.getElementById("tod" + nextRowToAdd).innerHTML = tod.getHours() + ":" + get2Digits(tod.getMinutes()) + ":" + get2Digits(tod.getSeconds());

		   //document.getElementById("tps" + nextRowToAdd).innerHTML = (diff*10000)/intervalElapsedMillisec;
//		   document.getElementById("bar" + nextRowToAdd).innerHTML = getSlices(nextRowToAdd);
		   var i;
		   /*for (i=0; i<barNames.length; i++)
		   {
			   document.getElementById('num'+barNames[i] + nextRowToAdd).amount = slices[i];
			   document.getElementById('num'+barNames[i] + nextRowToAdd).innerHTML = getPrintableMsecs(barNames[i], slices[i]);
		   }*/
		   var visibleSliceLength = getVisibleSliceLengthsTotal(nextRowToAdd);
		   //document.getElementById("visibleBarTotal" + nextRowToAdd).innerHTML = getPrintableMsecs("Msec", visibleSliceLength);
//		   setVisibleBreakdownSum(document.getElementById("barTotal" + nextRowToAdd).parentNode, nextRowToAdd);
		   for (i=0; i<counterNames.length; i++)
		   {
			   //document.getElementById('counter'+counterNames[i] + nextRowToAdd).innerHTML = getProcessorIncrement(counterNames[i],newStats);
		   }
		   for (i=0; i<rateNames.length; i++){
			   if(rateNames[i]=='oseEngineTrxProc'){
				   if(intervalElapsedMillisec>0){
					   document.getElementById("tps" + nextRowToAdd).innerHTML = Math.round((rates[i]*1000)/intervalElapsedMillisec);
				   }
				   else{
					   document.getElementById("tps" + nextRowToAdd).innerHTML = 0;
				   }
			   }
		   }
		   for (i=0; i<rateNames.length; i++)
		   {
			   document.getElementById('rate'+rateNames[i] + nextRowToAdd).innerHTML = rates[i++];
		   }
		   for (i=0; i<gaugeNames.length; i++)
		   {
			   var gauge = newStats[gaugeNames[i]];
			   if (gauge==undefined)
				   document.getElementById('gauge'+gaugeNames[i] + nextRowToAdd).innerHTML = ".";
			   else
				   document.getElementById('gauge'+gaugeNames[i] + nextRowToAdd).innerHTML = newStats[gaugeNames[i]];
		   }

		   // Add new row next time
		   nextRowToAdd++;
		   oldMaxBarTotal = maxBarTotal;
		   oldRowTime = tod;

        // Preserve counters for next time and bump row pointer to next row
  		oldStats = newStats;

	   }
   	}

    // Queue up another request with the child (unless we are paused)
    if (document.getElementById("pausedArea").style.display.replace(/^\s*|\s*$/g,"") != "")
    {
    	if (timeOut && timeOut != 0)
    	{
    		clearTimeout(timeOut);
    		timeOut = 0;
    	}
    	timeOut = setTimeout("frames['childFrame'].location.href='" + childURL + "&fois=1&recordingGuid=" + recordingGuid + "&prettyRecordingGuid=" + getPrettyGuid(recordingGuid) + "&oldRowTime=" + oldRowTime + "'", getUpdateMilliseconds(0));
    }
}



// Resize bars based on current max bar size
function resizeBars()
{
  for (var i=0; i < nextRowToAdd; i++)
  {
    var thisRowTDs = document.getElementById("row"+i).getElementsByTagName("TD");
    for (var t=0; t < thisRowTDs.length; t++)
    {
      var td = thisRowTDs[t];
      var visibleSliceLength = getVisibleSliceLengthsTotal(i);
      if (td.id.substr(0,3) == "bar" && td.id.substr(0,8) != "barTotal")
        td.innerHTML = getSlices(i);
      if (td.id.substr(0,15) == "visibleBarTotal")
      {
        td.innerHTML = getPrintableMsecs("Msec", visibleSliceLength);
      }
    }
  }
}



// Return the length of the longest bar we need to display (used to size all bars)
function getMaxBarTotal(newBarTotal)
{
  var newMax = (newBarTotal) ? newBarTotal : -1;
  for (var d = 0; d < displayedBars.length; d++)
  {
    var slices = displayedBars[d];
    var visibleBarLength = getVisibleSliceLengthsTotal(d);
    if (visibleBarLength > newMax)
      newMax = visibleBarLength;
  }
  return newMax;
}



// Returns total length of visible slices in a row
function getVisibleSliceLengthsTotal(rowNum)
{
  var slices = displayedBars[rowNum];
  var total = 0;
  for (var s=0; s<slices.length; s++)
    if (!isHiddenColor[colors[s]])  total += slices[s];
  return total;
}

// Sets the sum of the visible response breakdown numbers in a row
function setVisibleBreakdownSum(tr,rowNum)
{
  if (rowNum>=displayedBars.length)
    return
  var slices = displayedBars[rowNum];
  var total = 0;
  var barTotalTD;
  var debug = '';
  var s = 0;
  var hiding = false;
  var tds = tr.getElementsByTagName("TD");
  for (var d=0; d<tds.length; d++) {
      var td = tds[d];
      var id = td.id;
      if (!id) continue;
      if (id.substr(0,3)=='num') {
          if (td.columnDisplay && td.columnDisplay!='none') {
             total += slices[s];
             // debug += ' '+Math.round(slices[s]);
          }
          else
              hiding = true;
          s++;
      }
      else if (id.substr(0,8)=='barTotal')
         barTotalTD = td;
  }
  barTotalTD.amount = total;
  barTotalTD.innerHTML = getPrintableMsecs("Msec", total) + ' ' + debug;
  barTotalTD.style.color = hiding ? 'red' : 'black';
}

// Returns total length of all slices in a row
function getSliceLengthsTotal(rowNum)
{
  var slices = displayedBars[rowNum];
  var total = 0;
  for (var s=0; s<slices.length; s++)
    total += slices[s];
  return total;
}


// Calculate SPANS for the slices of a bar for the indicated row
function getSlices(rowNum)
{
  var slices = displayedBars[rowNum];
  var spans = new Array();
  for (var s=0; s<slices.length; s++)
  {
      var sliceWidth = Math.round((slices[s]*90)/maxBarTotal);
    if (!sliceWidth || sliceWidth<0)
      sliceWidth = 0;
    sliceWidth = sliceWidth + "%;";
    spans[s] = "<span style='width:" + sliceWidth +
               "float:left;" +
               "background-color:" + colors[s] + ";" +
               "display:" + (isHiddenColor[colors[s]] ? "none" : "") + ";'" +
               " title='" + Math.round(slices[s]) + " milliseconds in " + barTitles[s] + "'>" + "</span>";
  }
  var slices = "<div style='width:100%;white-space:nowrap;'>" + spans.join("") + "</div>";
  return slices;
}



// Suppresses or reveals the slice of the indicated color in all rows
function showHideSlices(legend)
{
  var backColor = legend.style.backgroundColor;
  var textColor = legend.style.color;
  if (textColor=="white")
    isHiddenColor[backColor] = true;
  else
    delete isHiddenColor[textColor];
  legend.style.backgroundColor = textColor;
  legend.style.color = backColor;
  maxBarTotal = getMaxBarTotal();
  resizeBars();
}


// Starts recording of stats
function startRecording(i18nStrings,webappDateFormat)
{
  startMonitor();
  var dt = new Date();
  if (previousRecordingGuid && confirm(i18nStrings.resumeRecording + " " + getPrettyGuid(previousRecordingGuid) + "\n" + i18nStrings.newRecording))
      recordingGuid=previousRecordingGuid;
  else {
      recordingGuid=formatDate(dt,webappDateFormat);
      previousRecordingGuid=recordingGuid;
  }
  var area = document.getElementById('recordingArea');
  area.innerHTML = i18nStrings.recordingStarted + ' ' + getPrettyGuid(recordingGuid);
  area.style.display='';
}


// Returns attractively reformatted recording GUID
function getPrettyGuid(guid) {
    if (guid && guid.length==15)
       return guid.substring(0,8)+ ' '+ guid.substring(9,11)+':'+ guid.substring(11,13)+':'+ guid.substring(13,15);
    else
       return "";
}

// Stops recording of stats
function stopRecording()
{
  recordingGuid='';
  document.getElementById('recordingArea').style.display='none';
}


// Stops auto-update of monitor display
function stopMonitor()
{
   // stopRecording();
   //document.getElementById("pausedArea").style.display = "";
   if (timeOut && timeOut != 0)
   {
      clearTimeout(timeOut);
      timeOut = 0;
   }
}



// Starts auto-update of monitor display
function startMonitor( doItNow )
{
   stopMonitor();
   //document.getElementById("pausedArea").style.display = "none";
   if (doItNow)
   {
      frames['childFrame'].location.href = childURL + "&fois=2&recordingGuid=" + recordingGuid + "&prettyRecordingGuid=" + getPrettyGuid(recordingGuid);
   }
   else
   {
      if (timeOut && timeOut != 0)
      {
          clearTimeout(timeOut);
          timeOut = 0;
      }
      timeOut = setTimeout("frames['childFrame'].location.href='" + childURL + "&fois=3&recordingGuid=" + recordingGuid + "&prettyRecordingGuid=" + getPrettyGuid(recordingGuid) + "'", getUpdateMilliseconds(0));
   }
}



// Stops auto-refresh of log display
function pauseLog()
{
   if (showLogTimeOut && showLogTimeOut != 0)
   {
      clearTimeout(showLogTimeOut);
      showLogTimeOut = 0;
   }
}



// Returns a number as 2 digits, zero-filling on the left as necessary
function get2Digits( num )
{
   if (num < 10)
      return "0" + num;
   return "" + num;
}



// Returns number with name suffixed "Msec" as hh:mm:ss if greater than 10000, else just returns number
function getPrintableMsecs(name,msecs)
{
  if (name.length>=4 && name.substr(name.length-4).toLowerCase()=="msec" && msecs >= 10000)
  {
    var hh = Math.floor(msecs/3600000);
    var mm = Math.floor((msecs - (hh*3600000))/60000);
    var ss = Math.round(msecs/1000) % 60;
    return "" + hh + ":" + get2Digits(mm) + ":" + get2Digits(ss);
  }
  return Math.round(msecs);
}


// Changes a number (possibly with decimal point) to have separators (commas in US)
function addSepToNum(nStr)
{
  var sep = ',';
  var dec = (sep==',') ? '.' : ',';
  nStr += '';
  x = nStr.split(dec);
  x1 = x[0];
  x2 = x.length > 1 ? dec + x[1] : '';
  var rgx = /(\d+)(\d{3})/;
  while (rgx.test(x1)) {
  	x1 = x1.replace(rgx, '$1' + sep + '$2');
  }
  return x1 + x2;
}


// Toggles display of bars or numbers in cells that bave "barNum=barNum" or "barBar=barBar"
function toggleBarNums()
{
   var showBarsCheckBox = document.getElementById("showBarsCheckBox");
   var showBars = showBarsCheckBox.checked;
   setCookie("console_showBars", showBars ? "Y" : "N",cookieRetentionPeriod);
   var legend = document.getElementById("legend");
   legend.style.display = (showBars) ? "" : "none";
   var procStatsTable = document.getElementById("procStatsTable");
   procStatsTable.style.display = (showBars) ? "none" : "";
   var tags = document.getElementsByTagName("TH");
   for (var t in tags)
   {
      if (tags[t].barNum == "barNum") {
         tags[t].style.display = (showBars) ? "none" : tags[t].columnDisplay;
      } else if (tags[t].barBar == "barBar")
         tags[t].style.display = (showBars) ? "" : "none";
   }
   tags = document.getElementsByTagName("TD");
   for (var t in tags)
   {
      if (tags[t].barNum == "barNum") {
         tags[t].style.display = (showBars) ? "none" : tags[t].columnDisplay;
      } else if (tags[t].barBar == "barBar") {
         tags[t].style.display = (showBars) ? "" : "none";
      }
   }
   showBarsCheckBox.style.visibility = "visible";
}


