
var _highlightedRowMap = new Array();

// Setting these attributes instead of the class was 10+ times faster
var ODD_UNSELECTED_BACKGROUND_COLOR = '#FFFFFF';
var EVEN_UNSELECTED_BACKGROUND_COLOR = '#F0F1F2';
var UNSELECTED_TEXT_COLOR = '#000000';
var SELECTED_BACKGROUND_COLOR = '#C7E3F2';
var SELECTED_TEXT_COLOR = '#287EAB';


function unhighlightAllRows()
{
   for(var i in _highlightedRowMap)
   {
      var selection = _highlightedRowMap[i];
      if(selection != null) {
        selection.row.style.backgroundColor = selection.unselectedClassName.indexOf('1')>=0 ? ODD_UNSELECTED_BACKGROUND_COLOR : EVEN_UNSELECTED_BACKGROUND_COLOR;
        selection.row.style.color = UNSELECTED_TEXT_COLOR;
      }
   }
   _highlightedRowMap = new Array();
}

function highlightRow(row,classNameValue, event, mappedObject)
{
   if(event != null && (event.ctrlKey || event.shiftKey))
   {
      // alert("Inside ctrl/Alt: " + row.id);
      var rowInMap = _highlightedRowMap[row.id];
      if(rowInMap != null && isDefined(rowInMap) && rowInMap.row == row)
      {
         row.style.backgroundColor = rowInMap.unselectedClassName.indexOf('1')>=0 ? ODD_UNSELECTED_BACKGROUND_COLOR : EVEN_UNSELECTED_BACKGROUND_COLOR;
         row.style.color = UNSELECTED_TEXT_COLOR;
         _highlightedRowMap[row.id] = null;
      }
      else
      {
         _addNewSelection(row, classNameValue, mappedObject);

         // If shiftKey and another row is highlighted, highlight all rows between
         if (event.shiftKey)
           selectRowsBetween(row.id, classNameValue, mappedObject);
      }
   }
   else
   {
      for(var i in _highlightedRowMap)
      {
         var selection = _highlightedRowMap[i];
         if(selection != null) {
            selection.row.style.backgroundColor = selection.unselectedClassName.indexOf('1')>=0 ? ODD_UNSELECTED_BACKGROUND_COLOR : EVEN_UNSELECTED_BACKGROUND_COLOR;;
            selection.row.style.color = UNSELECTED_TEXT_COLOR;
         }
      }
      _highlightedRowMap = new Array();
      _addNewSelection(row,classNameValue, mappedObject);
   }
   //rulesTabFrameResizeHandler();
   //clearLog();
   //for (var r in _highlightedRowMap) log(r+"="+_highlightedRowMap[r].row.className);
}

function _addNewSelection(row,classNameValue, mappedObject)
{
   // alert("Adding selection: " + mappedObject.baseRuleId);
   var newSelection = new Object();
   newSelection.row = row;
   newSelection.unselectedClassName = row.className;
   // row.className = classNameValue;
   row.style.backgroundColor = SELECTED_BACKGROUND_COLOR;
   row.style.color = SELECTED_TEXT_COLOR;
   newSelection.selectedClassName = row.className;
   newSelection.mappedObject = mappedObject;

   _highlightedRowMap[row.id] = newSelection;
   // alert(_highlightedRowMap.length);
}
var _highlightedRow = undefined;
var _highlightedRowClassName = "";

function highlightSingleRow(row,classNameValue)
{
   if(isDefined(_highlightedRow))
   {
      _highlightedRow.style.backgroundColor = _highlightedRowClassName.indexOf('1')>=0 ? ODD_UNSELECTED_BACKGROUND_COLOR : EVEN_UNSELECTED_BACKGROUND_COLOR;
      _highlightedRow.style.color = UNSELECTED_TEXT_COLOR;
       // alert("isDefined " + _highlightedRowClassName);
   }
   if(_highlightedRow != row)
   {
      // alert("Inside If");
      _highlightedRow = row;
      _highlightedRowClassName = row.className;
      _highlightedRow.style.backgroundColor = SELECTED_BACKGROUND_COLOR;
      _highlightedRow.style.color = SELECTED_TEXT_COLOR;
     //  alert(classNameValue);

   }
   else
   {
      // alert("Inside else");
      _highlightedRow = _highlightedRowClassName;
   }

}


// Select all displayed rows between this row and any adjacent selected rows
function selectRowsBetween(rowid, classNameValue, mappedObject)
{
  // Find the index of this row
  var thisrow = document.getElementById(rowid);
  var table = getParentByTagName(thisrow, 'table');
  var rows = table.rows;
  var rowIndex;
  for (rowIndex=0; rowIndex<rows.length; rowIndex++)
  {
    if (rows[rowIndex] && rows[rowIndex].id==rowid) break;
  }
  if (!rowIndex) return;  // Huh?

  // See if a row was selected above this one
  var otherRowIndex;
  for (var r=rowIndex-1; r>-1; r--)
  {
    if (rows[r] && _highlightedRowMap[rows[r].id])
    {
      otherRowIndex = r;
      break;
    }
  }

  // If none above, see if a row was selected below this one
  if (!otherRowIndex)
  {
    for (var r=rowIndex+1; r<rows.length; r++)
    {
      if (rows[r] && _highlightedRowMap[rows[r].id])
      {
        otherRowIndex = r;
        break;
      }
    }
  }

  // If another row was selected, select all displayed rows between
  if (otherRowIndex)
  {
    // Simulate cntlKey down instead of shiftKey
    var fakeEvent = new Object();
    fakeEvent.ctrlKey = 1;

    // Select intervening rows
    var lo = Math.min(rowIndex,otherRowIndex) + 1;
    var hi = Math.max(rowIndex,otherRowIndex);
    for (var r=lo; r<hi; r++)
    {
      if (rows[r] && 'none'!=(rows[r].style ? rows[r].style.display : ''))
      {
        // Call this row's onclick to select it
        var func = rows[r].onclick.toString();
        func = func.substr(func.indexOf("{")+1);
        func = func.substr(0,func.length-1);
        //need to match the last occurrence of the whole word "this"
        var pat = new RegExp('(\\b' + "this" + '\\b)(?!.*\\b\\1\\b)');
        func = func.replace(pat, "rows[r]");
        func = func.replace("event","fakeEvent");
        //if (!window.XMLHttpRequest) eval(func);  // Avoid FF syntax error
        eval(func);
      }
    }
  }
}

// Return the parent of an element
function getParentByTagName(el, pTagName) {
  if (el == null) return null;	//passed the root node
  else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase())
    // nodeType==1 checks if the node is an actual element
    return el;
  else
    return getParentByTagName(el.parentNode, pTagName); // traverse up
}

