<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2005-2006, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/tiles/sasEditor.jsp
|DESCRIPTION: JSP page to allow edit and submit of SAS code for a rule
|---------------------------------------------------------------------------------------*/%>


<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%-- ----------------------------------------------------------------------------- --%>
<%-- These array assignment statements load up the values used to populate         --%>
<%-- selection lists for ruleTypes, transactions, segments, and fields.  For the   --%>
<%-- moment, all values are set when the page loads.  We may use delayed loading   --%>
<%-- later if this pre-loading proves to cause a performance problem.              --%>
<%--                                                                               --%>
<SCRIPT language="JavaScript1.2">
//<!--

// For cntl-space constant values
var CommonFieldValues = new Array();
<c:forEach var='v' items='${fieldValues}'>
  CommonFieldValues["${v.key}"] = ${v.value};
</c:forEach>
var CommonFieldValueTypes = new Array();
<c:forEach var='t' items='${fieldValueTypes}'>
  CommonFieldValueTypes["${t.key}"] = "${t.value}";
</c:forEach>


// Load user variable segment key segment IDs
var UserVarSegmentKeys = new Object();
<c:forEach var="userSeg" items="${userVariableSegments}">
  <c:if test="${userSeg.segmentKeyFieldCount>0}">
    UserVarSegmentKeys['${userSeg.segmentId}'] = ['<%= ((com.sas.finserv.creditfraud.rules.domain.UserSegment) pageContext.getAttribute("userSeg")).getSegmentKeySegmentIds("','") %>'];
  </c:if>
</c:forEach>

var ClientInputVarSegments = new Array();
<c:forEach var="clientSeg" items="${clientInputVariableSegments}">
  ClientInputVarSegments.push('${clientSeg.segmentId}');
</c:forEach>

var ClientOutputVarSegments = new Array();
<c:forEach var="clientSeg" items="${clientOutputVariableSegments}">
  ClientOutputVarSegments.push('${clientSeg.segmentId}');
</c:forEach>

// Load valid transaction-to-component mapping
var TransactionComponentsMap = new Array();
<c:forEach var="t" items="${sasEditorSelectorMaps.tranLabelMap}"> TransactionComponentsMap["${t.key}"]=new Array();
</c:forEach>
<c:forEach var="t" items="${sasEditorSelectorMaps.tranLabelMap}"><c:forEach var="c" items="${sasEditorSelectorMaps.tranCompsMap[t.key]}">TransactionComponentsMap["${t.key}"]["${c}"]="${c}";
</c:forEach></c:forEach>

// Load valid component-to-segment mapping
var ComponentSegmentsMap = new Array();
<c:forEach var="c" items="${sasEditorSelectorMaps.compSegsMap}">ComponentSegmentsMap["${c.key}"]=${c.value};
</c:forEach>

// Load System component ids
var SystemComponentIds = new Array();
<c:forEach var="s" items="${sasEditorSelectorMaps.compLabelMap.SYSTEM}"> <c:if test="${s.value=='TRX'}">SystemComponentIds.push("${s.id}");</c:if>
</c:forEach>

// Load possible prereqs
<% pageContext.setAttribute("newLine", "\n"); %>
<% pageContext.setAttribute("return", "\r"); %>
var preRequisiteLabelMap = new Array();
<c:forEach var="p" items="${Possibles}"> preRequisiteLabelMap["#${p.baseRuleId}"]="<c:out value='${p.label}' escapeXml='false'/>";
</c:forEach>

// Load transactionKey to label mapping
var TransactionLabelMap = new Array();
<c:forEach var="t" items="${sasEditorSelectorMaps.tranLabelMap}">TransactionLabelMap["<c:out value='${t.key}'/>"]="<c:out value='${t.value}' escapeXml='false'/>";
</c:forEach>

// Load segmentId to label mapping (also note ID of RUV segment for ruleType=uservar)
var SegmentLabelMap = new Array();
<c:forEach var="s" items="${sasEditorSelectorMaps.segLabelMapEscaped}">SegmentLabelMap["<c:out value='${s.key}'/>"]="<c:out value='${s.value}' escapeXml='false'/>";
</c:forEach>

// Load fieldId to fieldLabel mapping
var FieldLabelMap = new Array();
<c:forEach var="f" items="${sasEditorSelectorMaps.fieldLabelMapEscaped}">FieldLabelMap["<c:out value='${f.key}'/>"]="<c:out value='${f.value}' escapeXml='false'/>";
</c:forEach>

// Load transactionKey to segmentId mapping (negative tranIds are for R/C common segment lists)
var TransactionSegmentsMap=new Array();
<c:forEach var="t" items="${sasEditorSelectorMaps.tranSegsMap}">TransactionSegmentsMap["<c:out value='${t.key}'/>"]=<c:out value='${t.value}' escapeXml='false'/>;
</c:forEach>

// Load segmentId to fieldId mapping
var SegmentFieldsMap=new Array();
<c:forEach var="s" items="${sasEditorSelectorMaps.segFieldsMap}">SegmentFieldsMap["<c:out value='${s.key}'/>"]=<c:out value='${s.value}' escapeXml='false'/>;
</c:forEach>

// Load lists of segments legal in each engine
var oseRuleSegmentIds = new Array();
<c:forEach var="c" items="${sasEditorSelectorMaps.consumerSegmentIds.OSE}">oseRuleSegmentIds["${c}"]=true;
</c:forEach>

// Load ruleTypeKey to label mapping
var ruleTypeLabelMap = new Array();
<c:forEach var="r" items="${sasEditorSelectorMaps.ruleTypeLabelMap}">ruleTypeLabelMap["<c:out value='${r.key}'/>"]="<c:out value='${r.value}' escapeXml='false'/>";
</c:forEach>

// Load ruleTypeKey to ruleTypeCode mapping
var ruleTypeCodeMap = new Array();
<c:forEach var="r" items="${sasEditorSelectorMaps.ruleTypeCodeMap}">ruleTypeCodeMap["<c:out value='${r.key}'/>"]="<c:out value='${r.value}' escapeXml='false'/>";
</c:forEach>

// Load available actions
var actionCode=new Array();
var actionLabel=new Array();
var actionTranType=new Array();
var tranActionCode=new Array();
var tranActionLabel=new Array();

var i=0;

<c:forEach var="ruleType" items='${sasEditorSelectorMaps.lookupListMap}'>
   <c:forEach var="lvbean" items="${ruleType.value}">
      <c:if test="${fn:indexOf(lvbean.value,'%')>=0}">
         actionCode[i] ='<c:out value="${ruleType.key} ${lvbean.value}" escapeXml="false"/>';
         actionLabel[i++] = "<c:out value='${lvbean.label}' escapeXml='false'/>";
      </c:if>
   </c:forEach> 
</c:forEach>

//reset i for actions
i=0;
//new for filtering actions by transaction type
<c:forEach var="tranType" items='${sasEditorSelectorMaps.tranActionMap}'>
	<c:forEach var="ruleType" items='${tranType.value}'>
		<c:forEach var="lvbean" items="${ruleType.value}">
		    actionTranType[i]="<c:out value='${tranType.key}' escapeXml='false'/>";
		    tranActionCode[i] = "<c:out value='${ruleType.key} ${lvbean.value}' escapeXml='false'/>";
			tranActionLabel[i++] = "<c:out value='${lvbean.label}' escapeXml='false'/>";
		</c:forEach>
	</c:forEach>
</c:forEach>

// Create method for looking up alert key fields
function getSegmentForAlertType(alertTypeCode) {
<c:forEach var="alertType" items="${alertTypes}">if (alertTypeCode=="${alertType.key}") return "${alertType.value.requiredSegmentAcronym}";
</c:forEach>
return "SMH";
}

//-->
</SCRIPT>



<TABLE name="sasEditorTable" style="border:0px;margin-left:0px;margin-right:0px"
       class="configurationTable" cellspacing="0" cellpadding="0" width="100%">


  <%-- Include appropriate controls for this tab at the top --%>
  <tiles:insert page="/rules/tiles/sasTabControls.jsp">
    <tiles:put name="prefix"               value="sasEditor" />
    <tiles:put name="showSaveButton"       value="${empty rule || rule.workflow.state == 'Coding' }" />
    <tiles:put name="showSasRunButtons"    value="true" />
    <tiles:put name="showEditorControls"   value="${empty rule || rule.workflow.state == 'Coding' }" />
    <tiles:put name="showBuilderControls"  value="false" />
    <tiles:put name="showSubsetter"        value="true" />
    <tiles:put name="showFinder"           value="true" />
    <tiles:put name="showHistoryCheck"     value="true" />
    <tiles:put name="showResultsControls"  value="false" />
  </tiles:insert>


  <%-- SAS code entered by the user displays in a textarea (with selector sometimes overlaying) --%>
  <tr id="editableCodeArea" style="display:block" class="configurationTableDataRow" valign="top">
    <td>&nbsp;</td>
    <td width="100%" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px" nowrap >
      <div id="expansionSelectorDiv" onkeydown="noteKey(event)" onkeyup="noteKey(event)"
         style="z-index:200; display:; border:1px solid; background-color:#e0e2e5; position:absolute; top:105px; left:-10000px; height:100px; width:100px; overflow:auto;">
      </div>
      <tt id='gutter' name='gutter' style="position:absolute; top:140px; height:100px; font-family:courier,serif;font-size:12px;line-height:1.2; margin-left:-12px; overflow:hidden;">&nbsp;&nbsp;</tt>
      <textarea id='code' name='code' wrap="off" spellcheck="false"
                onkeyup="expand(event,this,'expansionSelectorDiv')" onkeydown="noteKey(event)" onchange="enableSaveButton(event);" oncontextmenu="noteMouseClick(event)"
                onfocus="setKeysUp();" <%-- S1053953 --%>
                onscroll="document.getElementById('gutter').scrollTop=this.scrollTop;"
                style="position:absolute; top:140px; height:100px; font-family:courier,serif;font-size:12px;line-height:1.2; border-top:1px solid gray;"><c:out value="${rule.code}"/>
</textarea>
    </td>
    <td>&nbsp;</td>
  </tr>

  <%-- Generated SAS code displays in a readonly textarea --%>
  <tr id="generatedCodeArea" style="display:none" class="configurationTableDataRow" >
    <td>&nbsp;</td>
    <td width="100%" style="padding-top:1px;padding-bottom:1px;padding-left:0px;padding-right:0px;" nowrap >
      <textarea name='IGNORE_generatedCode' id="IGNORE_generatedCode"
                style="position:absolute; width:100%; height:100px; top:120px; background:white; color:gray; font-size:12px; border-top:1px solid gray;" readonly="readonly">
      </textarea>
      <textarea id='generatedCode'></textarea>
    </td>
    <td>&nbsp;</td>
  </tr>

</table>


<%-- Cache of useful fields manipulated elsewhere (see setFormsReadOnly for doNotDisable notes) --%>
<input type="hidden" value=""         name="account"       id="account" />
<input type="hidden" value="1"        name="samplePercent" id="samplePercent" />
<input type="hidden" value="${defaultRandDigName}" name="sampleKey" id="sampleKey" />
<input type="hidden" value=""         name="errorCount"    id="errorCount" />
<input type="hidden" value=""         name="warningCount"  id="warningCount" />
<input type="hidden" value="10"       name="obsCount"      id="obsCount" />
<input type="hidden" value=<fmt:message key="rules.rule.sasTabControl.earliest.txt"/> name="earlyDate"     id="earlyDate" />
<input type="hidden" value=<fmt:message key="rules.rule.sasTabControl.latest.txt"/>   name="lateDate"      id="lateDate" />
<input type="hidden" value=""         name="codeGenOnly"   id="codeGenOnly" />
<input type="hidden" value=".*(${queuedResponseMacros}).*" name="queuedResponseMacros" id="queuedResponseMacros" /> <%-- S1046564 --%>

