
-----------------------------------------------
-- DDL Statements for table FCM_LOOKUP_LIST_FIELD
------------------------------------------------


CREATE TABLE FCM_LOOKUP_LIST_FIELD (
        HOTLIST_ID BIGINT NOT NULL
,       FIELD_ID BIGINT NOT NULL
,       SORT_ORDER SMALLINT NOT NULL
,       ANALYST_DISPLAY_IND CHARACTER(1) NOT NULL  WITH DEFAULT '0'
,       CREATE_TIMESTAMP TIMESTAMP NOT NULL  WITH DEFAULT CURRENT_TIMESTAMP
,       CREATE_USER CHARACTER(60) NOT NULL
)
 IN TS_CORE_8K INDEX IN IX_CORE_8K
 COMPRESS YES ;

ALTER TABLE FCM_LOOKUP_LIST_FIELD
     ADD CONSTRAINT CK_LOOKUP_LIST_FIELD1
    CHECK (ANALYST_DISPLAY_IND IN ('0', '1')) ENFORCED ENABLE QUERY OPTIMIZATION;

CREATE UNIQUE INDEX PKX_LOOKUP_FIELD
 ON FCM_LOOKUP_LIST_FIELD ( HOTLIST_ID,FIELD_ID,SORT_ORDER ASC )
  ALLOW REVERSE SCANS PCTFREE 10 CLUSTER COMPRESS YES;


ALTER TABLE FCM_LOOKUP_LIST_FIELD
     ADD CONSTRAINT PKX_LOOKUP_FIELD PRIMARY KEY ( HOTLIST_ID,FIELD_ID,SORT_ORDER );



ALTER TABLE FCM_LOOKUP_LIST_FIELD
  ADD CONSTRAINT FK_LKUPLSTFLD_FLDDEF FOREIGN KEY
     (FIELD_ID)
  REFERENCES FCM_FIELD_DEFINITION
    (FIELD_ID)
    ON DELETE RESTRICT
    ON UPDATE NO ACTION
    ENFORCED ENABLE QUERY OPTIMIZATION;

ALTER TABLE FCM_LOOKUP_LIST_FIELD
  ADD CONSTRAINT FK_FIELD_LKUPLDEF FOREIGN KEY
     (HOTLIST_ID)
  REFERENCES FCM_LOOKUP_LIST_DEFINITION
    (HOTLIST_ID)
    ON DELETE CASCADE
    ON UPDATE NO ACTION
    ENFORCED ENABLE QUERY OPTIMIZATION;

GRANT INSERT ON TABLE FCM_LOOKUP_LIST_FIELD TO ROLE SAS_SOR_APP ;
GRANT SELECT ON TABLE FCM_LOOKUP_LIST_FIELD TO ROLE SAS_SOR_APP ;
GRANT UPDATE ON TABLE FCM_LOOKUP_LIST_FIELD TO ROLE SAS_SOR_APP ;
GRANT DELETE ON TABLE FCM_LOOKUP_LIST_FIELD TO ROLE SAS_SOR_APP ;
GRANT SELECT ON TABLE FCM_LOOKUP_LIST_FIELD TO ROLE SAS_SOR_BATCH ;
GRANT SELECT ON TABLE FCM_LOOKUP_LIST_FIELD TO ROLE SAS_SOR_ODE ;
GRANT SELECT ON TABLE FCM_LOOKUP_LIST_FIELD TO ROLE SAS_SOR_TAS ;
