---------------------------------------------------------------------------------
--
-- Insert new FCM_PROPERTY 
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY
USING TABLE(values('ANALYTIC_EXTRACT_RECLAIM_PATH'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_USER,PROPERTY_EDITABLE_IND)
VALUES
('ANALYTIC_EXTRACT_RECLAIM_PATH', '', 'Full path to the analytic extract backup directory', 'Full path to the analytic extract backup directory', 'etl', CURRENT USER,'1')
ELSE IGNORE;

merge into FCM_PROPERTY
USING TABLE(values('webapp.decimal.format'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_USER,PROPERTY_EDITABLE_IND,property_visible_ind)
VALUES
('webapp.decimal.format', '#.##'
, 'Specifies the pattern to be applied to decimal formats'
, 'Decimal pattern', 'WebApplication', CURRENT USER,'1','1')
ELSE IGNORE;

merge into FCM_PROPERTY
USING TABLE(values('DBMAINT_BLOCK_LABEL_FILE'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_USER,PROPERTY_EDITABLE_IND)
VALUES
('DBMAINT_BLOCK_LABEL_FILE', ''
, 'Name and Location for language-specific FCM_BLOCK_CODE.BLOCK_LABEL properties'
, 'file	Name and Location for language-specific FCM_BLOCK_CODE.BLOCK_LABEL properties file', 'sordbmaint', CURRENT USER,'1')
ELSE IGNORE;

merge into FCM_PROPERTY
USING TABLE(values('DBMAINT_COMP_VALUE_DESC_FILE'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_USER,PROPERTY_EDITABLE_IND)
VALUES
('DBMAINT_COMP_VALUE_DESC_FILE', ''
, 'Name and Location for language-specific FCM_COMPONENT_VALUE.COMPONENT_VALUE_DESC properties'
, 'file	Name and Location for language-specific FCM_COMPONENT_VALUE.COMPONENT_VALUE_DESC properties file', 'sordbmaint', CURRENT USER,'1')
ELSE IGNORE;



---------------------------------------------------------------------------------
--
-- Insert new ECM Events
--
---------------------------------------------------------------------------------
merge into FCM_ECM_EVENT p
USING TABLE(values(0))
                     ac(ECM_EVENT_ID)
                  ON (p.ECM_EVENT_ID=ac.ECM_EVENT_ID)
when not matched then
insert (
    ECM_EVENT_ID, EVENT_NAME, EVENT_TYPE, SEND_ECM_IND, SEND_ACTION_IND, SEND_TRAN_IND, CREATE_USER) 
VALUES (
 		0, 'CHECKIN.UPDATE', 'CHECKIN', '0', '0', '0', CURRENT_USER)
;

commit;

merge into FCM_ECM_EVENT p
USING TABLE(values(-3))
                     ac(ECM_EVENT_ID)
                  ON (p.ECM_EVENT_ID=ac.ECM_EVENT_ID)
when not matched then
insert (
    ECM_EVENT_ID, EVENT_NAME, EVENT_TYPE, SEND_ECM_IND, SEND_ACTION_IND, SEND_TRAN_IND, CREATE_USER) 
VALUES (
 		-3, 'AUTOFULFILLMENT', 'CHECKIN', '0', '0', '0', CURRENT_USER)
;

commit;


---------------------------------------------------------------------------------
--
-- Insert version release 4.4.0.1 
--
---------------------------------------------------------------------------------

merge into FCM_VERSION p
USING TABLE(values('SOR Base DDL', '4.4.0.1'))
                     ac(VERSION_NAME , VERSION_NUM)
                  ON (p.VERSION_NAME = ac.VERSION_NAME
                      AND p.VERSION_NUM=ac.VERSION_NUM)
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT)
VALUES (
        'SOR Base DDL', '4.4.0.1', current_date, '4.4 M0 HF1 DDL', 'SOR DDL')
;

commit;