---------------------------------------------------------------------------------
--
-- UPDATES FOR FCM_UI_TABLE_DEFINITIONS 
--
---------------------------------------------------------------------------------
UPDATE FCM_UI_TABLE_DEFINITIONS SET TABLE_ALLOW_EDIT =1, TABLE_ALLOW_DELETE =1 WHERE TABLE_NAME IN ('FCM_ENUM', 'FCM_LOV', 'FCM_BLOCK_CODE');
commit;

---------------------------------------------------------------------------------
--
-- UPDATES FOR FCM_UI_COLUMN_DEFINITIONS 
--
---------------------------------------------------------------------------------
UPDATE FCM_UI_COLUMN_DEFINITIONS SET COLUMN_DISPLAY_NAME='Data Pop Name', COLUMN_DISPLAY_TYPE='INPUT:AUTO' WHERE COLUMN_NAME='ENUM_SEGMENT_VARIABLE';
UPDATE FCM_UI_COLUMN_DEFINITIONS SET COLUMN_DISPLAY_NAME='Code' WHERE COLUMN_NAME='ENUM_SEGMENT_CODE';
UPDATE FCM_UI_COLUMN_DEFINITIONS SET COLUMN_DISPLAY_NAME='Description' WHERE COLUMN_NAME='ENUM_SEGMENT_DESC';
UPDATE FCM_UI_COLUMN_DEFINITIONS SET COLUMN_VISIBLE_IND='0' WHERE COLUMN_NAME='ENUM_LOCALE';
commit;

---------------------------------------------------------------------------------
--
-- UPDATE FCM_PROPERTY for  analyst.alert.uncheckout.interval
--
---------------------------------------------------------------------------------
UPDATE FCM_PROPERTY SET PROPERTY_DESC = 'The maximum time interval (in minutes) that an alert can be checked out. If this time is exceeded, then the alert is automatically checked in.'
WHERE PROPERTY_NAME= 'analyst.alert.uncheckout.interval';
commit;

---------------------------------------------------------------------------------
--
-- UPDATE FCM_PROPERTY for ose_os_type make property visible
--
---------------------------------------------------------------------------------
UPDATE FCM_PROPERTY SET PROPERTY_VISIBLE_IND='1'
WHERE PROPERTY_NAME= 'ose_os_type';
commit;
 
---------------------------------------------------------------------------------
--
-- UPDATE FCM_PROPERTY change YXX properties to IXX
--
---------------------------------------------------------------------------------
UPDATE FCM_PROPERTY
SET PROPERTY_NAME = REPLACE(PROPERTY_NAME,'YXX','IXX'),
	PROPERTY_DESC = REPLACE(PROPERTY_DESC,'YXX','IXX'),
	PROPERTY_LABEL = REPLACE(PROPERTY_LABEL,'YXX','IXX')
WHERE PROPERTY_NAME LIKE '%YXX%';
commit;

---------------------------------------------------------------------------------
--
-- UPDATE FCM_FIELD_DEFINITION XML_FIELD_NAME from NOT SUPPORTED for User variables 
--
---------------------------------------------------------------------------------
UPDATE FCM_FIELD_DEFINITION 
	SET FIELD_BUSINESSNAME_EDIT = FIELD_BUSINESSNAME
	, XML_FIELD_NAME = FIELD_BUSINESSNAME
	, FIELD_VISIBLE_IND='1'
	WHERE SEGMENT_ID IN (SELECT SEGMENT_ID FROM FCM_SEGMENT_DEFINITION WHERE TENANT_MULTI_ORG_ID IS NOT NULL);
commit;

---------------------------------------------------------------------------------
--
-- Insert new FCM_ENTITY_DETAIL_METADATA 
--
---------------------------------------------------------------------------------
merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('verification','DOBLastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
          ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert   (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('verification',      'DOBLastUpdateDate', 'date',     null,       0,            0,            0, 'system')
ELSE IGNORE;

merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('contact','addressLastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'addressLastUpdateDate', 'date',              null,       0,            0,            0, 'system')
ELSE IGNORE;

merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('contact','homePhone1LastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'homePhone1LastUpdateDate', 'date',  null,       0,            0,            0, 'system')
ELSE IGNORE;

merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('contact','homePhone2LastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'homePhone2LastUpdateDate', 'date',  null,       0,            0,            0, 'system')
ELSE IGNORE;

merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('contact','workPhone1LastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'workPhone1LastUpdateDate', 'date',    null,       0,            0,            0, 'system')
ELSE IGNORE;

merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('contact','workPhone2LastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'workPhone2LastUpdateDate', 'date',    null,       0,            0,            0, 'system')
ELSE IGNORE;

merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('contact','mobilePhone1LastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'mobilePhone1LastUpdateDate', 'date', null,       0,            0,            0, 'system')
ELSE IGNORE;

merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('contact','mobilePhone2LastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'mobilePhone2LastUpdateDate', 'date', null,       0,            0,            0, 'system')
ELSE IGNORE;

merge into FCM_ENTITY_DETAIL_METADATA 
USING TABLE(values('contact','emailLastUpdateDate'))
                     ac(GROUP_NAME,PROPERTY)
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'emailLastUpdateDate', 'date',   null,       0,            0,            0, 'system')
ELSE IGNORE;


---------------------------------------------------------------------------------
--
-- Insert new FCM_LOV 
--
---------------------------------------------------------------------------------
merge into FCM_LOV
USING TABLE(values('verification.DOBLastUpdateDate','entityDetail'))
                     ac(LOV_CODE,LOV_TYPE)
                  ON (FCM_LOV.LOV_CODE = ac.LOV_CODE and FCM_LOV.LOV_TYPE=ac.LOV_TYPE)
when not matched then
INSERT
(LOV_CODE,        LOV_TYPE,          LOV_LOCALE,    LOV_SORT_ORDER,        LOV_DESC,                LOV_STATUS_IND,          LOV_INTERNAL_USE_IND,          CREATE_USER)
VALUES
('verification.DOBLastUpdateDate', 'entityDetail', 'en_US', 72, 'DOB Last Update Date',                '1',            '0',            'system')
ELSE IGNORE;



---------------------------------------------------------------------------------
--
-- Update FCM_PROPERTY with new API Version Number
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY
USING TABLE(values('msg_api_version'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when  matched then
UPDATE 
set PROPERTY_VALUE='M040403'

 ELSE IGNORE
 ;
commit;

---------------------------------------------------------------------------------
--
-- Insert new FCM_PROPERTY 
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY
USING TABLE(values('analyst.disableRealTimeFetch'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, PROPERTY_SUB_TYPE,  PROPERTY_SUB_TYPE_LABEL,CREATE_USER,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND)
VALUES
('analyst.disableRealTimeFetch', 'false', 'Turn off real time fetch of demographics if value is set to true.', 'Disable Real Time Fetch', 'AnalystWorkstation', 'DEFAULT', 'DEFAULT','system','0','1')
ELSE IGNORE;

merge into FCM_PROPERTY
USING TABLE(values('max_client_input_segment_length'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_type,property_label,property_name,property_value,property_desc,property_editable_ind,property_visible_ind,property_sub_type,property_sub_type_label,CREATE_USER)
VALUES
('RuleTesting','Maximum client input variable segment length','max_client_input_segment_length','22000','The maximum client input variable segment length','0','1','DEFAULT','DEFAULT','system')
ELSE IGNORE;

merge into FCM_PROPERTY
USING TABLE(values('max_client_input_segments'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_type,property_label,property_name,property_value,property_desc,property_editable_ind,property_visible_ind,property_sub_type,property_sub_type_label,CREATE_USER)
VALUES
('RuleTesting','Maximum # of client input variable segments','max_client_input_segments','8','The maximum # of client input variable segments','0','1','DEFAULT','DEFAULT','system')
ELSE IGNORE;

merge into FCM_PROPERTY
USING TABLE(values('max_client_input_segments_total_length'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_type,property_label,property_name,property_value,property_desc,property_editable_ind,property_visible_ind,property_sub_type,property_sub_type_label,CREATE_USER)
VALUES
('RuleTesting','The overall maximum total length for all client input segments','max_client_input_segments_total_length','22000','max_client_input_segments_total_length','0','1','DEFAULT','DEFAULT','system')
ELSE IGNORE;

commit;

--------------------------------------------------------------------------------
--
-- Insert I## segment into FCM_SEGMENT_DEFINITION 
--
---------------------------------------------------------------------------------
merge into FCM_SEGMENT_DEFINITION p
USING TABLE(values('I##'))
                     ac(SEGMENT_ACRONYM )
                  ON (p.SEGMENT_ACRONYM = ac.SEGMENT_ACRONYM)                  
when not matched then
insert (
    SEGMENT_ID, SEGMENT_ID_VERSION, SEGMENT_SORT_ORDER, SEGMENT_LENGTH, SEGMENT_ACRONYM, 
    BASE_SEGMENT_ID, SEGMENT_DESC, SEGMENT_RULE_ACCESSIBLE_IND, SEGMENT_PREFIX_CHAR, SEGMENT_USC_IO_TYPE, 
    SEGMENT_OSE_IO_TYPE, SEGMENT_AGS_IO_TYPE, SEGMENT_TDR_IO_TYPE, SEGMENT_CONSORT_IO_TYPE, TENANT_MULTI_ORG_ID, 
    BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_NBR, LSTUPDT_USER, 
    LSTUPDT_TIMESTAMP, LOGICAL_DEL_IND) 
VALUES (
 	93, '1400##00', 87, 32, ac.SEGMENT_ACRONYM, 
    NULL, 'Client Input Flexible Variable Segment ##', '1', NULL, 'r', 
    'r', 'r', 'r', 'r', NULL, 
    NULL, CURRENT_USER, CURRENT_TIMESTAMP, 0, CURRENT_USER, 
    CURRENT_TIMESTAMP, '0')
;
commit;
--------------------------------------------------------------------------------
--
-- Insert I## segment into FCM)FIELD_DEFINITION 
--
---------------------------------------------------------------------------------

merge into fcm_Field_definition
USING TABLE(values('i##_seg_id_version'))
                     ac(FIELD_NAME)
        ON (ac.field_name=fcm_field_definition.field_name)
when not matched then
insert   (  SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT) VALUES 
( (select segment_id from fcm_segment_definition where segment_acronym='I##'), 0, 8, ac.field_name
	,'i##_seg_id_version'
	, 'i##_seg_id_version', 'i##SegIdVersion'
	,'"1400##xx" - Uniquely identifies the Ixx segment where xx is the version', '"1400##00"', 'Character', '$char8.', '$char8.'
	, '0', NULL, NULL, 'VARCHAR2(8)', NULL, 1, '0', '0', '0', '0', 'i##_seg_id_version', NULL, NULL, NULL, NULL, NULL,  'system', current_timestamp, NULL, NULL, 0, '0', NULL, NULL)
ELSE IGNORE;


merge into fcm_Field_definition
USING TABLE(values('i##_variable_data_length'))
                     ac(FIELD_NAME)
        ON (ac.field_name=fcm_field_definition.field_name)
when not matched then
insert   ( SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT) VALUES 
( (select segment_id from fcm_segment_definition where segment_acronym='I##'), 8, 8, ac.field_name
, 'Length of the ixx_variable_data field', 'Length of the ixx_variable_data field', 'i##VariableDataLength'
, 'Length of the ixx_variable_data field', '"16000"', 'Numeric', '8.', 'Z8.', '0', NULL, NULL, 'NUMBER(10)', NULL, 3, '0', '0', '0', '0'
, 'i##_variable_data_length', NULL, NULL, NULL, NULL, NULL,  'system', current_timestamp, NULL, NULL, 0, '0', NULL, NULL)
ELSE IGNORE;


merge into fcm_Field_definition
USING TABLE(values('i##_build_num'))
                     ac(FIELD_NAME)
        ON (ac.field_name=fcm_field_definition.field_name)
when not matched then
insert   ( SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT) VALUES 
( (select segment_id from fcm_segment_definition where segment_acronym='I##'), 16, 8, ac.field_name
, 'I## Build Number', 'I## Build Number', 'i##BuildNum'
, 'Incoming Build Number from the Customer. This build number is used to read the variable', NULL
, 'Numeric', '8.', 'Z8.', '0', NULL, NULL, 'NUMBER(10)', NULL, 4, '0', '0', '0', '0', 'i##_build_num', NULL, NULL, NULL, NULL, NULL, 'system', current_timestamp, NULL, NULL, 0, '0', NULL, NULL)
ELSE IGNORE;

merge into fcm_Field_definition
USING TABLE(values('i##_execution_build_num'))
                     ac(FIELD_NAME)
        ON (ac.field_name=fcm_field_definition.field_name)
when not matched then
insert   (SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT) VALUES 
((select segment_id from fcm_Segment_definition where segment_acronym='I##') , 24,8,ac.field_name 
,  'i## Execution Build Number','i## Execution Build Number'  ,  'i##ExecutionBuildNum'  
,  'Executing Build Number returned from the OSE, if the segment data defined by i##_build_num provided by the customer does not match the segment data definition currently executing within the OSE'  ,null,'Numeric', '8.', 'Z8.', '0', NULL, NULL, 'NUMBER(10)', NULL, 4, '0', '0', '0', '0'
, 'i##_excution_build_num', NULL, NULL, NULL, NULL, NULL, 'system', current_timestamp, NULL, NULL, 0, '0', NULL, NULL)
ELSE IGNORE;
commit;

--------------------------------------------------------------------------------
--
-- Insert O## segment into FCM_SEGMENT_DEFINITION 
--
---------------------------------------------------------------------------------

merge into FCM_SEGMENT_DEFINITION p
USING TABLE(values('O##'))
                     ac(SEGMENT_ACRONYM )
                  ON (p.SEGMENT_ACRONYM = ac.SEGMENT_ACRONYM)                  
when not matched then
insert (
     SEGMENT_ID_VERSION, SEGMENT_SORT_ORDER, SEGMENT_LENGTH, SEGMENT_ACRONYM, 
    BASE_SEGMENT_ID, SEGMENT_DESC, SEGMENT_RULE_ACCESSIBLE_IND, SEGMENT_PREFIX_CHAR, SEGMENT_USC_IO_TYPE, 
    SEGMENT_OSE_IO_TYPE, SEGMENT_AGS_IO_TYPE, SEGMENT_TDR_IO_TYPE, SEGMENT_CONSORT_IO_TYPE, TENANT_MULTI_ORG_ID, 
    BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_NBR, LSTUPDT_USER, 
    LSTUPDT_TIMESTAMP, LOGICAL_DEL_IND) 
VALUES (
 	 '1500##00', 122, 32, ac.SEGMENT_ACRONYM, 
    NULL, 'Client Output Flexible Variable Segment ##', '1', NULL, 'r', 
    'u', 'r', 'r', NULL, NULL, 
    NULL, 'system', CURRENT_TIMESTAMP, 0, 'system', 
    CURRENT_TIMESTAMP, '0')
;    
commit;

--------------------------------------------------------------------------------
--
-- Insert O## segment into FCM)FIELD_DEFINITION 
--
---------------------------------------------------------------------------------

merge into fcm_Field_definition
USING TABLE(values('o##_seg_id_version'))
                     ac(FIELD_NAME)
        ON (ac.field_name=fcm_field_definition.field_name)
when not matched then
insert   (  SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT) VALUES 
( (select segment_id from fcm_segment_definition where segment_acronym='O##'), 0, 8, ac.field_name, 'o##_seg_id_version', 'o##_seg_id_version'
, 'o##SegIdVersion', '"1500##xx" - Uniquely identifies the Oxx segment where xx is the version'
, '"1500##00"', 'Character', '$char8.', '$char8.', '0', NULL, NULL, 'VARCHAR2(8)', NULL, 1, '0', '0', '0', '0'
, 'o##_seg_id_version', NULL, NULL, NULL, NULL, NULL,  'system', current_timestamp, NULL, NULL, 0, '0', NULL, NULL)
ELSE IGNORE;



merge into fcm_Field_definition
USING TABLE(values('o##_variable_data_length'))
                     ac(FIELD_NAME)
        ON (ac.field_name=fcm_field_definition.field_name)
when not matched then
insert   ( SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT) VALUES 
( (select segment_id from fcm_segment_definition where segment_acronym='O##'), 8, 8, ac.field_name
, 'Length of the oxx_variable_data field', 'Length of the oxx_variable_data field', 'o##VariableDataLength'
, 'Length of the oxx_variable_data field', '"16000"', 'Numeric', '8.', 'Z8.', '0', NULL, NULL, 'NUMBER(10)', NULL, 3, '0', '0', '0', '0'
, 'o##_variable_data_length', NULL, NULL, NULL, NULL, NULL,  'system', current_timestamp, NULL, NULL, 0, '0', NULL, NULL)
ELSE IGNORE;


merge into fcm_Field_definition
USING TABLE(values('o##_build_num'))
                     ac(FIELD_NAME)
        ON (ac.field_name=fcm_field_definition.field_name)
when not matched then
insert   ( SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT) VALUES 
( (select segment_id from fcm_segment_definition where segment_acronym='O##'), 16, 8, ac.field_name
, 'o## Build Number', 'o## Build Number', 'o##BuildNum'
, 'Build Number from the Customer. This build number is used by the OSE to know the structure to serialize back', NULL, 'Numeric', '8.', 'Z8.', '0', NULL, NULL
, 'NUMBER(10)', NULL, 4, '0', '0', '0', '0', 'o##_build_num', NULL, NULL, NULL, NULL, NULL, 'system', current_timestamp, NULL, NULL, 0, '0', NULL, NULL)
ELSE IGNORE;

merge into fcm_Field_definition
USING TABLE(values('o##_execution_build_num'))
                     ac(FIELD_NAME)
        ON (ac.field_name=fcm_field_definition.field_name)
when not matched then
insert   (SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT) VALUES 
((select segment_id from fcm_Segment_definition where segment_acronym='O##') , 24,8,ac.field_name 
,  'o## Execution Build Number','o## Execution Build Number'  ,  'o##ExecutionBuildNum'  
,  'Executing Build Number returned from the OSE, if the segment data defined by o##_build_num provided by the customer does not match the segment data definition currently executing within the OSE'  ,null,'Numeric', '8.', 'Z8.', '0', NULL, NULL, 'NUMBER(10)', NULL, 4, '0', '0', '0', '0'
, 'o##_excution_build_num', NULL, NULL, NULL, NULL, NULL, 'system', current_timestamp, NULL, NULL, 0, '0', NULL, NULL)
ELSE IGNORE;
commit;

---------------------------------------------------------------------------------
--
-- shift segments sort order 
--
---------------------------------------------------------------------------------
update FCM_SEGMENT_DEFINITION set segment_sort_order=157 where segment_acronym='Z##';
update FCM_SEGMENT_DEFINITION set segment_sort_order=192 where segment_acronym='L##';
update FCM_SEGMENT_DEFINITION set segment_sort_order=227 where segment_acronym like 'V%' and segment_sort_order=157;
update FCM_SEGMENT_DEFINITION set segment_sort_order=segment_sort_order+70 where segment_acronym like 'V%' and segment_sort_order>=157 and segment_sort_order <> 227 ;
update FCM_SEGMENT_DEFINITION set segment_sort_order=262 where segment_acronym='CQF';
update FCM_SEGMENT_DEFINITION set segment_sort_order=263 where segment_acronym='WAX';
update FCM_SEGMENT_DEFINITION set segment_sort_order=264 where segment_acronym='RUX';
commit;


---------------------------------------------------------------------------------
--
-- Insert new FCM Component Segments 
--
---------------------------------------------------------------------------------

INSERT INTO FCM_COMPONENT_SEGMENT(
   COMPONENT_VALUE_ID
  ,SEGMENT_ID
  ,CREATE_TIMESTAMP
  ,CREATE_USER
  ,LSTUPDT_NBR
  ,LSTUPDT_USER
  ,LSTUPDT_TIMESTAMP
  ,LOGICAL_DEL_IND
) VALUES (
   (select component_value_id from fcm_component_value where component_value='CMD')
   ,(select segment_id from fcm_segment_definition where segment_acronym='L##')
  ,CURRENT_TIMESTAMP
  ,CURRENT_USER
  ,0
  ,CURRENT_USER
  ,CURRENT_TIMESTAMP
  ,'0' 
);

INSERT INTO FCM_COMPONENT_SEGMENT(
   COMPONENT_VALUE_ID
  ,SEGMENT_ID
  ,CREATE_TIMESTAMP
  ,CREATE_USER
  ,LSTUPDT_NBR
  ,LSTUPDT_USER
  ,LSTUPDT_TIMESTAMP
  ,LOGICAL_DEL_IND
) VALUES (
   (select component_value_id from fcm_component_value where component_value='TRX')
   ,(select segment_id from fcm_segment_definition where segment_acronym='I##')
  ,CURRENT_TIMESTAMP
  ,CURRENT_USER
  ,0
  ,CURRENT_USER
  ,CURRENT_TIMESTAMP
  ,'0' 
);
INSERT INTO FCM_COMPONENT_SEGMENT(
   COMPONENT_VALUE_ID
  ,SEGMENT_ID
  ,CREATE_TIMESTAMP
  ,CREATE_USER
  ,LSTUPDT_NBR 
  ,LSTUPDT_USER
  ,LSTUPDT_TIMESTAMP
  ,LOGICAL_DEL_IND
) VALUES (
   (select component_value_id from fcm_component_value where component_value='TRX')
   ,(select segment_id from fcm_segment_definition where segment_acronym='O##')
  ,CURRENT_TIMESTAMP
  ,CURRENT_USER
  ,0
  ,CURRENT_USER
  ,CURRENT_TIMESTAMP
  ,'0' 
);
commit;

---------------------------------------------------------------------------------
--
-- Delete Transaction Components 
--
---------------------------------------------------------------------------------
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DEE' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraEntity') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DCH' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ChargeDet') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMM'  and transaction_name = 'Terminal Owner (Merchant) Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMM'  and transaction_name = 'Terminal Owner (Merchant) Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DEE' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraEntity') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMM'  and transaction_name = 'Terminal Owner (Merchant) Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMT'  and transaction_name = 'Terminal Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMT'  and transaction_name = 'Terminal Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DEE' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraEntity') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMT'  and transaction_name = 'Terminal Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DNX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='NMonEntTxf') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DNX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NMonEntTxf') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DEE' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraEntity') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
commit;


---------------------------------------------------------------------------------
--
-- Insert New Transaction Components 
--
---------------------------------------------------------------------------------
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCBF'  and transaction_name = 'Credit Card Account Bill Payment/Fund Transfer to Third Party or self account' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCDP'  and transaction_name = 'Credit Card Account Deposit/Payment' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCUK'  and transaction_name = 'Credit Card Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCUK'  and transaction_name = 'Credit Card Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCUK'  and transaction_name = 'Credit Card Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCSH'  and transaction_name = 'Credit Card Account Bill Payment/Fund Transfer Scheduling & Cancellation' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSBF'  and transaction_name = 'Checking/Savings Account Bill Payment/Fund Transfer to Third Party or self account' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSDP'  and transaction_name = 'Checking/Savings Account Deposit/Payment' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSUK'  and transaction_name = 'Checking/Savings Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSUK'  and transaction_name = 'Checking/Savings Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSUK'  and transaction_name = 'Checking/Savings Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSSH'  and transaction_name = 'Checking/Savings Account Bill Payment/Fund Transfer Scheduling & Cancellation' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'N' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='NonAppChan'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSAE'  and transaction_name = 'Checking/Savings Account Batch ACH submission Entry Records' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCBF'  and transaction_name = 'Line of Credit Account Bill Payment/Fund Transfer to Third Party or self account' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCDP'  and transaction_name = 'Line of Credit Account Deposit/Payment' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCUK'  and transaction_name = 'Line of Credit Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCUK'  and transaction_name = 'Line of Credit Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCUK'  and transaction_name = 'Line of Credit Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCSH'  and transaction_name = 'Line of Credit Account Bill Payment/Fund Transfer Scheduling & Cancellation' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NAUK'  and transaction_name = 'N/A Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NAUK'  and transaction_name = 'N/A Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NAUK'  and transaction_name = 'N/A Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLBF'  and transaction_name = 'Secured Loan Account Bill Payment/Fund Transfer to Third Party or self account' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLDP'  and transaction_name = 'Secured Loan Account Deposit/Payment' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLUK'  and transaction_name = 'Secured Loan Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLUK'  and transaction_name = 'Secured Loan Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLUK'  and transaction_name = 'Secured Loan Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLSH'  and transaction_name = 'Secured Loan Account Bill Payment/Fund Transfer Scheduling & Cancellation' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUS' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='OnUsTranDet'),(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DCH' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ChargeDet'),(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1'), current_timestamp, current_user,0);
commit;

---------------------------------------------------------------------------------
--
-- Insert new OXX Purge Days properties
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY USING TABLE(values('FCM_BRST_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_BRST_OXX'  ,'Retention days of FCM_BRST_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CCBF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CCBF_OXX'  ,'Retention days of FCM_CCBF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CCCA_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CCCA_OXX'  ,'Retention days of FCM_CCCA_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CCCP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CCCP_OXX'  ,'Retention days of FCM_CCCP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CCDP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CCDP_OXX'  ,'Retention days of FCM_CCDP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CCMF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CCMF_OXX'  ,'Retention days of FCM_CCMF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CCNM_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CCNM_OXX'  ,'Retention days of FCM_CCNM_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CCSH_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CCSH_OXX'  ,'Retention days of FCM_CCSH_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSAB_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSAB_OXX'  ,'Retention days of FCM_CSAB_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSAE_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSAE_OXX'  ,'Retention days of FCM_CSAE_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSBF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSBF_OXX'  ,'Retention days of FCM_CSBF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSCA_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSCA_OXX'  ,'Retention days of FCM_CSCA_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSCK_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSCK_OXX'  ,'Retention days of FCM_CSCK_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSCP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSCP_OXX'  ,'Retention days of FCM_CSCP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSCW_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSCW_OXX'  ,'Retention days of FCM_CSCW_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSDP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSDP_OXX'  ,'Retention days of FCM_CSDP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSMF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSMF_OXX'  ,'Retention days of FCM_CSMF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSNM_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSNM_OXX'  ,'Retention days of FCM_CSNM_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_CSSH_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_CSSH_OXX'  ,'Retention days of FCM_CSSH_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCBF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCBF_OXX'  ,'Retention days of FCM_LCBF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCCA_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCCA_OXX'  ,'Retention days of FCM_LCCA_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCCK_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCCK_OXX'  ,'Retention days of FCM_LCCK_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCCP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCCP_OXX'  ,'Retention days of FCM_LCCP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCCW_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCCW_OXX'  ,'Retention days of FCM_LCCW_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCDP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCDP_OXX'  ,'Retention days of FCM_LCDP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCMF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCMF_OXX'  ,'Retention days of FCM_LCMF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCNM_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCNM_OXX'  ,'Retention days of FCM_LCNM_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_LCSH_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_LCSH_OXX'  ,'Retention days of FCM_LCSH_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_MAFM_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_MAFM_OXX'  ,'Retention days of FCM_MAFM_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_MAMF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_MAMF_OXX'  ,'Retention days of FCM_MAMF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_MANM_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_MANM_OXX'  ,'Retention days of FCM_MANM_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_NAME_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_NAME_OXX'  ,'Retention days of FCM_NAME_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_NAMF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_NAMF_OXX'  ,'Retention days of FCM_NAMF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_NAMO_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_NAMO_OXX'  ,'Retention days of FCM_NAMO_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_NAMP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_NAMP_OXX'  ,'Retention days of FCM_NAMP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_NANM_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_NANM_OXX'  ,'Retention days of FCM_NANM_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLBF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLBF_OXX'  ,'Retention days of FCM_SLBF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLCA_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLCA_OXX'  ,'Retention days of FCM_SLCA_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLCK_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLCK_OXX'  ,'Retention days of FCM_SLCK_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLCP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLCP_OXX'  ,'Retention days of FCM_SLCP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLCW_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLCW_OXX'  ,'Retention days of FCM_SLCW_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLDP_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLDP_OXX'  ,'Retention days of FCM_SLDP_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLMF_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLMF_OXX'  ,'Retention days of FCM_SLMF_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLNM_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLNM_OXX'  ,'Retention days of FCM_SLNM_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
merge into FCM_PROPERTY USING TABLE(values('FCM_SLSH_OXX_PURGE_DAYS')) ac(PROPERTY_NAME) ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME) when not matched then INSERT (PROPERTY_NAME,PROPERTY_VALUE,PROPERTY_DESC,PROPERTY_LABEL,PROPERTY_TYPE,PROPERTY_SUB_TYPE,PROPERTY_SUB_TYPE_LABEL,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND,CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND)        VALUES (ac.PROPERTY_NAME ,'180' ,'Retention days of FCM_SLSH_OXX'  ,'Retention days of FCM_SLSH_OXX'  ,'tdrdbmaint'  , 'DEFAULT'  ,'DEFAULT' ,'1'  ,'1'  ,CURRENT_TIMESTAMP,'sas',0,'0') ELSE IGNORE;      
commit;
---------------------------------------------------------------------------------
--
-- Insert version release 4.4.0.2 
--
---------------------------------------------------------------------------------

merge into FCM_VERSION p
USING TABLE(values('SOR Base DDL', '4.4.0.2'))
                     ac(VERSION_NAME , VERSION_NUM)
                  ON (p.VERSION_NAME = ac.VERSION_NAME
                      AND p.VERSION_NUM=ac.VERSION_NUM)
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT)
VALUES (
        'SOR Base DDL', '4.4.0.2', current_date, '4.4 M0 HF2 DDL', 'SOR DDL')
;

commit;

merge into FCM_VERSION p
USING TABLE(values('Message API', '04.04.03'))
                     ac(VERSION_NAME , VERSION_NUM)
                  ON (p.VERSION_NAME = ac.VERSION_NAME
                      AND p.VERSION_NUM=ac.VERSION_NUM)
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT)
VALUES 
	('Message API', '04.04.03', current date, 'API for MetaData and Transaction tables ', 'DDL');

commit;
