---------------------------------------------------------------------------------
--
-- UPDATE FCM_PROPERTY 
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY
USING TABLE(values('analyst.maxNumberOfCheckouts'))
                     ac(PROPERTY_NAME)
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, PROPERTY_SUB_TYPE,  PROPERTY_SUB_TYPE_LABEL
,CREATE_USER,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND)
VALUES
('analyst.maxNumberOfCheckouts', '3'
,'Specifies the maximum number of contacts that an analyst can have alerts checked out at one time. Each alert without contact counts 1 towards the total. A value of 0 means unlimited checkouts.'
, 'Analyst Maximum Checkouts', 'AnalystWorkstation', 'DEFAULT', 'DEFAULT','system','1','1')
ELSE IGNORE;

update fcm_property set logical_del_ind='1' where PROPERTY_NAME='analyst.maxNumberOfAlerts';
commit;

---------------------------------------------------------------------------------
--
-- Insert version release 4.4.0.3 
--
---------------------------------------------------------------------------------

merge into FCM_VERSION p
USING TABLE(values('SOR Base DDL', '4.4.0.3'))
                     ac(VERSION_NAME , VERSION_NUM)
                  ON (p.VERSION_NAME = ac.VERSION_NAME
                      AND p.VERSION_NUM=ac.VERSION_NUM)
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT)
VALUES (
        'SOR Base DDL', '4.4.0.3', current_date, '4.4 M0 HF3 DDL', 'SOR DDL')
;

commit;


