
with dpname as (  select tabname,datapartitionname 
        from syscat.datapartitions a
        where ( tabname in ( 'FCM_BRST',
							'FCM_CCBF',
							'FCM_CCCA',
							'FCM_CCCP',
							'FCM_CCDP',
							'FCM_CCMF',
							'FCM_CCNM',
							'FCM_CCSH',
							'FCM_CSAB',
							'FCM_CSAE',
							'FCM_CSBF',
							'FCM_CSCA',
							'FCM_CSCK',
							'FCM_CSCP',
							'FCM_CSCW',
							'FCM_CSDP',
							'FCM_CSMF',
							'FCM_CSNM',
							'FCM_CSSH',
							'FCM_LCBF',
							'FCM_LCCA',
							'FCM_LCCK',
							'FCM_LCCP',
							'FCM_LCCW',
							'FCM_LCDP',
							'FCM_LCMF',
							'FCM_LCNM',
							'FCM_LCSH',
							'FCM_MAFM',
							'FCM_MAMF',
							'FCM_MANM',
							'FCM_NAME',
							'FCM_NAMF',
							'FCM_NAMO',
							'FCM_NAMP',
							'FCM_NANM',
							'FCM_SLBF',
							'FCM_SLCA',
							'FCM_SLCK',
							'FCM_SLCP',
							'FCM_SLCW',
							'FCM_SLDP',
							'FCM_SLMF',
							'FCM_SLNM',
							'FCM_SLSH')        
                  and datapartitionname not like '%CF%' 
                          and  datapartitionname not like '%THE_END%' 
                          and tabschema = CURRENT_SCHEMA 
                          and status != 'I' )
        and tabschema = CURRENT_SCHEMA 
        and lowvalue = ( select max(lowvalue) 
                         from syscat.datapartitions b
                         where a.tabschema = b.tabschema 
                         and a.tabname = b.tabname 
                         and b.datapartitionname not like '%CF%' 
                         and b.datapartitionname not like '%THE_END%' 
                         and tabschema = CURRENT_SCHEMA 
                         and status != 'I'))
  select 'ALTER TABLE ' || rtrim(CURRENT_SCHEMA) || '.'||tabname||' DETACH PARTITION ' 
                  || ''  || datapartitionname || ''  
                  || ' INTO ' || rtrim(CURRENT_SCHEMA) || '.'||tabname||'_DTCH_' || datapartitionname  || ';'
                  from dpname;
        