  
BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_BRST_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_BRST_OX_PART1 INDEX IN IX_BRST_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_BRST_OX_PART2 INDEX IN IX_BRST_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_BRST_OX_PART3 INDEX IN IX_BRST_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_BRST_OX_PART4 INDEX IN IX_BRST_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CCBF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCBF_OX_PART1 INDEX IN IX_CCBF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCBF_OX_PART2 INDEX IN IX_CCBF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCBF_OX_PART3 INDEX IN IX_CCBF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCBF_OX_PART4 INDEX IN IX_CCBF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CCCA_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCCA_OX_PART1 INDEX IN IX_CCCA_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCCA_OX_PART2 INDEX IN IX_CCCA_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCCA_OX_PART3 INDEX IN IX_CCCA_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCCA_OX_PART4 INDEX IN IX_CCCA_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CCCP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCCP_OX_PART1 INDEX IN IX_CCCP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCCP_OX_PART2 INDEX IN IX_CCCP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCCP_OX_PART3 INDEX IN IX_CCCP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCCP_OX_PART4 INDEX IN IX_CCCP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CCDP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCDP_OX_PART1 INDEX IN IX_CCDP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCDP_OX_PART2 INDEX IN IX_CCDP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCDP_OX_PART3 INDEX IN IX_CCDP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCDP_OX_PART4 INDEX IN IX_CCDP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CCMF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCMF_OX_PART1 INDEX IN IX_CCMF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCMF_OX_PART2 INDEX IN IX_CCMF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCMF_OX_PART3 INDEX IN IX_CCMF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCMF_OX_PART4 INDEX IN IX_CCMF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CCNM_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCNM_OX_PART1 INDEX IN IX_CCNM_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCNM_OX_PART2 INDEX IN IX_CCNM_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCNM_OX_PART3 INDEX IN IX_CCNM_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCNM_OX_PART4 INDEX IN IX_CCNM_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CCSH_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCSH_OX_PART1 INDEX IN IX_CCSH_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCSH_OX_PART2 INDEX IN IX_CCSH_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCSH_OX_PART3 INDEX IN IX_CCSH_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CCSH_OX_PART4 INDEX IN IX_CCSH_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSAB_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSAB_OX_PART1 INDEX IN IX_CSAB_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSAB_OX_PART2 INDEX IN IX_CSAB_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSAB_OX_PART3 INDEX IN IX_CSAB_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSAB_OX_PART4 INDEX IN IX_CSAB_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSAE_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSAE_OX_PART1 INDEX IN IX_CSAE_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSAE_OX_PART2 INDEX IN IX_CSAE_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSAE_OX_PART3 INDEX IN IX_CSAE_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSAE_OX_PART4 INDEX IN IX_CSAE_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSBF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSBF_OX_PART1 INDEX IN IX_CSBF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSBF_OX_PART2 INDEX IN IX_CSBF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSBF_OX_PART3 INDEX IN IX_CSBF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSBF_OX_PART4 INDEX IN IX_CSBF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSCA_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCA_OX_PART1 INDEX IN IX_CSCA_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCA_OX_PART2 INDEX IN IX_CSCA_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCA_OX_PART3 INDEX IN IX_CSCA_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCA_OX_PART4 INDEX IN IX_CSCA_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSCK_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCK_OX_PART1 INDEX IN IX_CSCK_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCK_OX_PART2 INDEX IN IX_CSCK_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCK_OX_PART3 INDEX IN IX_CSCK_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCK_OX_PART4 INDEX IN IX_CSCK_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSCP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCP_OX_PART1 INDEX IN IX_CSCP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCP_OX_PART2 INDEX IN IX_CSCP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCP_OX_PART3 INDEX IN IX_CSCP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCP_OX_PART4 INDEX IN IX_CSCP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSCW_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCW_OX_PART1 INDEX IN IX_CSCW_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCW_OX_PART2 INDEX IN IX_CSCW_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCW_OX_PART3 INDEX IN IX_CSCW_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSCW_OX_PART4 INDEX IN IX_CSCW_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSDP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSDP_OX_PART1 INDEX IN IX_CSDP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSDP_OX_PART2 INDEX IN IX_CSDP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSDP_OX_PART3 INDEX IN IX_CSDP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSDP_OX_PART4 INDEX IN IX_CSDP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSMF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSMF_OX_PART1 INDEX IN IX_CSMF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSMF_OX_PART2 INDEX IN IX_CSMF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSMF_OX_PART3 INDEX IN IX_CSMF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSMF_OX_PART4 INDEX IN IX_CSMF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSNM_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSNM_OX_PART1 INDEX IN IX_CSNM_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSNM_OX_PART2 INDEX IN IX_CSNM_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSNM_OX_PART3 INDEX IN IX_CSNM_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSNM_OX_PART4 INDEX IN IX_CSNM_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_CSSH_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSSH_OX_PART1 INDEX IN IX_CSSH_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSSH_OX_PART2 INDEX IN IX_CSSH_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSSH_OX_PART3 INDEX IN IX_CSSH_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_CSSH_OX_PART4 INDEX IN IX_CSSH_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCBF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCBF_OX_PART1 INDEX IN IX_LCBF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCBF_OX_PART2 INDEX IN IX_LCBF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCBF_OX_PART3 INDEX IN IX_LCBF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCBF_OX_PART4 INDEX IN IX_LCBF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCCA_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCA_OX_PART1 INDEX IN IX_LCCA_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCA_OX_PART2 INDEX IN IX_LCCA_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCA_OX_PART3 INDEX IN IX_LCCA_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCA_OX_PART4 INDEX IN IX_LCCA_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCCK_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCK_OX_PART1 INDEX IN IX_LCCK_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCK_OX_PART2 INDEX IN IX_LCCK_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCK_OX_PART3 INDEX IN IX_LCCK_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCK_OX_PART4 INDEX IN IX_LCCK_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCCP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCP_OX_PART1 INDEX IN IX_LCCP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCP_OX_PART2 INDEX IN IX_LCCP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCP_OX_PART3 INDEX IN IX_LCCP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCP_OX_PART4 INDEX IN IX_LCCP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCCW_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCW_OX_PART1 INDEX IN IX_LCCW_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCW_OX_PART2 INDEX IN IX_LCCW_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCW_OX_PART3 INDEX IN IX_LCCW_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCCW_OX_PART4 INDEX IN IX_LCCW_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCDP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCDP_OX_PART1 INDEX IN IX_LCDP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCDP_OX_PART2 INDEX IN IX_LCDP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCDP_OX_PART3 INDEX IN IX_LCDP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCDP_OX_PART4 INDEX IN IX_LCDP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCMF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCMF_OX_PART1 INDEX IN IX_LCMF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCMF_OX_PART2 INDEX IN IX_LCMF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCMF_OX_PART3 INDEX IN IX_LCMF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCMF_OX_PART4 INDEX IN IX_LCMF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCNM_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCNM_OX_PART1 INDEX IN IX_LCNM_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCNM_OX_PART2 INDEX IN IX_LCNM_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCNM_OX_PART3 INDEX IN IX_LCNM_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCNM_OX_PART4 INDEX IN IX_LCNM_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_LCSH_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCSH_OX_PART1 INDEX IN IX_LCSH_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCSH_OX_PART2 INDEX IN IX_LCSH_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCSH_OX_PART3 INDEX IN IX_LCSH_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_LCSH_OX_PART4 INDEX IN IX_LCSH_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_MAFM_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MAFM_OX_PART1 INDEX IN IX_MAFM_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MAFM_OX_PART2 INDEX IN IX_MAFM_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MAFM_OX_PART3 INDEX IN IX_MAFM_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MAFM_OX_PART4 INDEX IN IX_MAFM_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_MAMF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MAMF_OX_PART1 INDEX IN IX_MAMF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MAMF_OX_PART2 INDEX IN IX_MAMF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MAMF_OX_PART3 INDEX IN IX_MAMF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MAMF_OX_PART4 INDEX IN IX_MAMF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_MANM_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MANM_OX_PART1 INDEX IN IX_MANM_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MANM_OX_PART2 INDEX IN IX_MANM_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MANM_OX_PART3 INDEX IN IX_MANM_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_MANM_OX_PART4 INDEX IN IX_MANM_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_NAME_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAME_OX_PART1 INDEX IN IX_NAME_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAME_OX_PART2 INDEX IN IX_NAME_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAME_OX_PART3 INDEX IN IX_NAME_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAME_OX_PART4 INDEX IN IX_NAME_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_NAMF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMF_OX_PART1 INDEX IN IX_NAMF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMF_OX_PART2 INDEX IN IX_NAMF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMF_OX_PART3 INDEX IN IX_NAMF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMF_OX_PART4 INDEX IN IX_NAMF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_NAMO_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMO_OX_PART1 INDEX IN IX_NAMO_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMO_OX_PART2 INDEX IN IX_NAMO_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMO_OX_PART3 INDEX IN IX_NAMO_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMO_OX_PART4 INDEX IN IX_NAMO_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_NAMP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMP_OX_PART1 INDEX IN IX_NAMP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMP_OX_PART2 INDEX IN IX_NAMP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMP_OX_PART3 INDEX IN IX_NAMP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NAMP_OX_PART4 INDEX IN IX_NAMP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_NANM_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NANM_OX_PART1 INDEX IN IX_NANM_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NANM_OX_PART2 INDEX IN IX_NANM_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NANM_OX_PART3 INDEX IN IX_NANM_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_NANM_OX_PART4 INDEX IN IX_NANM_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLBF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLBF_OX_PART1 INDEX IN IX_SLBF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLBF_OX_PART2 INDEX IN IX_SLBF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLBF_OX_PART3 INDEX IN IX_SLBF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLBF_OX_PART4 INDEX IN IX_SLBF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLCA_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCA_OX_PART1 INDEX IN IX_SLCA_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCA_OX_PART2 INDEX IN IX_SLCA_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCA_OX_PART3 INDEX IN IX_SLCA_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCA_OX_PART4 INDEX IN IX_SLCA_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLCK_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCK_OX_PART1 INDEX IN IX_SLCK_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCK_OX_PART2 INDEX IN IX_SLCK_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCK_OX_PART3 INDEX IN IX_SLCK_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCK_OX_PART4 INDEX IN IX_SLCK_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLCP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCP_OX_PART1 INDEX IN IX_SLCP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCP_OX_PART2 INDEX IN IX_SLCP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCP_OX_PART3 INDEX IN IX_SLCP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCP_OX_PART4 INDEX IN IX_SLCP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLCW_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCW_OX_PART1 INDEX IN IX_SLCW_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCW_OX_PART2 INDEX IN IX_SLCW_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCW_OX_PART3 INDEX IN IX_SLCW_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLCW_OX_PART4 INDEX IN IX_SLCW_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLDP_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLDP_OX_PART1 INDEX IN IX_SLDP_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLDP_OX_PART2 INDEX IN IX_SLDP_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLDP_OX_PART3 INDEX IN IX_SLDP_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLDP_OX_PART4 INDEX IN IX_SLDP_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLMF_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLMF_OX_PART1 INDEX IN IX_SLMF_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLMF_OX_PART2 INDEX IN IX_SLMF_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLMF_OX_PART3 INDEX IN IX_SLMF_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLMF_OX_PART4 INDEX IN IX_SLMF_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLNM_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLNM_OX_PART1 INDEX IN IX_SLNM_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLNM_OX_PART2 INDEX IN IX_SLNM_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLNM_OX_PART3 INDEX IN IX_SLNM_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLNM_OX_PART4 INDEX IN IX_SLNM_OX_PART4
 ) 
 COMPRESS YES ';
 end@
 BEGIN
 EXECUTE IMMEDIATE 'CREATE TABLE FCM_SLSH_OXX (
	RQO_PROC_UTC_DATETIME TIMESTAMP NOT NULL   
,	CMX_TRAN_ID BIGINT NOT NULL   
,	CMX_CREATE_TIMESTAMP TIMESTAMP    
,	SMH_MULTI_ORG_NODE_KEY CHARACTER(6) NOT NULL   
,	ENCODING CHARACTER(1)    
,	OXX_ID CHARACTER(2) NOT NULL   
,	OXX_SEG_ID_VERSION CHARACTER(8)    
,	OXX_VARIABLE_DATA_LENGTH INTEGER    
,	OXX_BUILD_NUM INTEGER    
,	OXX_EXECUTION_BUILD_NUM INTEGER    
,	SEGMENT_DATA VARCHAR(31545) FOR BIT DATA    
) PARTITION BY RANGE(RQO_PROC_UTC_DATETIME) ( 
   PART PART1 STARTING('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-2 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLSH_OX_PART1 INDEX IN IX_SLSH_OX_PART1
 ,   PART PART2 STARTING('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date-1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLSH_OX_PART2 INDEX IN IX_SLSH_OX_PART2
 ,   PART PART3 STARTING('''||to_Char(current_date,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLSH_OX_PART3 INDEX IN IX_SLSH_OX_PART3
 ,   PART PART4 STARTING('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-00.00.00.000000'') ENDING ('''||to_Char(current_date+1 DAYS,'YYYY-MM-DD')||'-23.59.59.999999'') IN TS_SLSH_OX_PART4 INDEX IN IX_SLSH_OX_PART4
 ) 
 COMPRESS YES ';
 end@
