-----------------------------------------------
-- DDL Statements for table FCM_LOOKUP_LIST_FIELD
------------------------------------------------

CREATE TABLE FCM_LOOKUP_LIST_FIELD (
        HOTLIST_ID NUMERIC(19)  NOT NULL
,       FIELD_ID NUMERIC(19)  NOT NULL
,       SORT_ORDER NUMERIC(5) NOT NULL
,       ANALYST_DISPLAY_IND VARCHAR2(1)   DEFAULT '0' NOT NULL
,       CREATE_TIMESTAMP TIMESTAMP   DEFAULT CURRENT_TIMESTAMP NOT NULL
,       CREATE_USER VARCHAR2(60)  NOT NULL
) TABLESPACE TS_CORE_32K
/
show errors;

ALTER TABLE FCM_LOOKUP_LIST_FIELD
     ADD CONSTRAINT CK_LOOKUP_LIST_FIELD1
    CHECK (ANALYST_DISPLAY_IND IN ('0', '1')) ENABLE
/
show errors;



ALTER TABLE FCM_LOOKUP_LIST_FIELD
  ADD ( CONSTRAINT FK_LKUPLSTFLD_FLDDEF FOREIGN KEY
     (FIELD_ID)
  REFERENCES FCM_FIELD_DEFINITION
    (FIELD_ID)
     ENABLE VALIDATE)
/
show errors;

ALTER TABLE FCM_LOOKUP_LIST_FIELD
  ADD ( CONSTRAINT FK_FIELD_LKUPLDEF FOREIGN KEY
     (HOTLIST_ID)
  REFERENCES FCM_LOOKUP_LIST_DEFINITION
    (HOTLIST_ID)
    ON DELETE CASCADE ENABLE VALIDATE)
/
show errors;

CREATE UNIQUE INDEX PKX_LOOKUP_FIELD
 ON FCM_LOOKUP_LIST_FIELD ( HOTLIST_ID,FIELD_ID,SORT_ORDER  )
TABLESPACE IX_CORE_32K
/
show errors;

ALTER TABLE FCM_LOOKUP_LIST_FIELD
     ADD CONSTRAINT PKX_LOOKUP_FIELD PRIMARY KEY ( HOTLIST_ID,FIELD_ID,SORT_ORDER )
/
show errors;








GRANT INSERT ON FCM_LOOKUP_LIST_FIELD TO SAS_SOR_APP ;
GRANT SELECT ON FCM_LOOKUP_LIST_FIELD TO SAS_SOR_APP ;
GRANT UPDATE ON FCM_LOOKUP_LIST_FIELD TO SAS_SOR_APP ;
GRANT DELETE ON FCM_LOOKUP_LIST_FIELD TO SAS_SOR_APP ;
GRANT SELECT ON FCM_LOOKUP_LIST_FIELD TO SAS_SOR_BATCH ;
GRANT SELECT ON FCM_LOOKUP_LIST_FIELD TO SAS_SOR_ODE ;
GRANT SELECT ON FCM_LOOKUP_LIST_FIELD TO SAS_SOR_TAS ;
