---------------------------------------------------------------------------------
--
-- Insert new FCM_PROPERTY 
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY
USING (select 'ANALYTIC_EXTRACT_RECLAIM_PATH' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_id,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_USER,PROPERTY_EDITABLE_IND)
VALUES
(property_seq.nextval,'ANALYTIC_EXTRACT_RECLAIM_PATH', '', 'Full path to the analytic extract backup directory', 'Full path to the analytic extract backup directory', 'etl', 'system','1')
;
commit;
 
merge into FCM_PROPERTY
USING (select 'webapp.decimal.format' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(Property_id,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_USER,PROPERTY_EDITABLE_IND,property_visible_ind)
VALUES
(property_seq.nextval,'webapp.decimal.format', '#.##'
, 'Specifies the pattern to be applied to decimal formats'
, 'Decimal pattern', 'WebApplication', 'system','1','1')
;
commit;

merge into FCM_PROPERTY
USING (select 'DBMAINT_BLOCK_LABEL_FILE' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_id,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_USER,PROPERTY_EDITABLE_IND)
VALUES
(property_seq.nextval,'DBMAINT_BLOCK_LABEL_FILE', ''
, 'Name and Location for language-specific FCM_BLOCK_CODE.BLOCK_LABEL properties'
, 'file	Name and Location for language-specific FCM_BLOCK_CODE.BLOCK_LABEL properties file', 'sordbmaint',  'system','1')
;
commit;

merge into FCM_PROPERTY
USING (select 'DBMAINT_COMP_VALUE_DESC_FILE' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_id,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_USER,PROPERTY_EDITABLE_IND)
VALUES
(property_seq.nextval,'DBMAINT_COMP_VALUE_DESC_FILE', ''
, 'Name and Location for language-specific FCM_COMPONENT_VALUE.COMPONENT_VALUE_DESC properties'
, 'file	Name and Location for language-specific FCM_COMPONENT_VALUE.COMPONENT_VALUE_DESC properties file', 'sordbmaint', 'system','1')
;

commit;
---------------------------------------------------------------------------------
--
-- Insert new ECM Event 
--
---------------------------------------------------------------------------------

merge into FCM_ECM_EVENT p
USING (select 0 as ECM_EVENT_ID from dual) ac
                  ON (p.ECM_EVENT_ID = ac.ECM_EVENT_ID )
when not matched then
insert (
 	ECM_EVENT_ID, EVENT_NAME, EVENT_TYPE, SEND_ECM_IND, SEND_ACTION_IND, SEND_TRAN_IND, CREATE_USER) 
VALUES (
 		0, 'CHECKIN.UPDATE', 'CHECKIN', '0', '0', '0', 'system')
;
commit;

merge into FCM_ECM_EVENT p
USING (select -3 as ECM_EVENT_ID from dual) ac
                  ON (p.ECM_EVENT_ID = ac.ECM_EVENT_ID )
when not matched then
insert (
 	ECM_EVENT_ID, EVENT_NAME, EVENT_TYPE, SEND_ECM_IND, SEND_ACTION_IND, SEND_TRAN_IND, CREATE_USER) 
VALUES (
 		-3, 'AUTOFULFILLMENT', 'CHECKIN', '0', '0', '0', 'system')
;
commit;

---------------------------------------------------------------------------------
--
-- Update dbms_variable_type to Oracle datatypes in  FCM_FIELD_DEFINITION
--
---------------------------------------------------------------------------------
update FCM_FIELD_DEFINITION set dbms_variable_type = case 
when dbms_variable_type ='VARCHAR(1500) FOR BIT DATA' then 'VARCHAR2(3000)' 
when substr(dbms_variable_type,1,8) ='VARCHAR(' then replace(dbms_variable_type,'VARCHAR(','VARCHAR2(') 
when substr(dbms_variable_type,1,10) ='CHARACTER(' then replace(dbms_variable_type,'CHARACTER(','VARCHAR2(') 
when dbms_variable_type ='DECIMAL(19,5)' then 'BINARY_DOUBLE'
when dbms_variable_type ='BIGINT' then 'NUMBER(19)'
when dbms_variable_type ='INTEGER' then 'NUMBER(10)'
when dbms_variable_type ='SMALLINT' then 'NUMBER(5)'
when dbms_variable_type ='TIME' then 'TIMESTAMP'
when dbms_variable_type ='DOUBLE' then 'BINARY_DOUBLE'
when dbms_variable_type ='FLOAT' then 'BINARY_DOUBLE'
else dbms_variable_type
end;
commit;
---------------------------------------------------------------------------------
--
-- Insert version release 4.4.0.1 
--
---------------------------------------------------------------------------------

merge into fcm_version p
USING (select 'SOR Base DDL' as VERSION_NAME,'4.4.0.1' as VERSION_NUM from dual) ac
                  ON (p.VERSION_NAME = ac.VERSION_NAME AND p.VERSION_NUM=ac.VERSION_NUM )
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) 
VALUES (
 	'SOR Base DDL', '4.4.0.1', current_date, '4.4 M0 HF 1DDL', 'SOR DDL')
;
commit;