set define off;
---------------------------------------------------------------------------------
--
-- UPDATES FOR FCM_UI_TABLE_DEFINITIONS 
--
---------------------------------------------------------------------------------
UPDATE FCM_UI_TABLE_DEFINITIONS SET TABLE_ALLOW_EDIT =1, TABLE_ALLOW_DELETE =1 WHERE TABLE_NAME IN ('FCM_ENUM', 'FCM_LOV', 'FCM_BLOCK_CODE');
commit;

---------------------------------------------------------------------------------
--
-- UPDATES FOR FCM_UI_COLUMN_DEFINITIONS 
--
---------------------------------------------------------------------------------
UPDATE FCM_UI_COLUMN_DEFINITIONS SET COLUMN_DISPLAY_NAME='Data Pop Name', COLUMN_DISPLAY_TYPE='INPUT:AUTO' WHERE COLUMN_NAME='ENUM_SEGMENT_VARIABLE';
UPDATE FCM_UI_COLUMN_DEFINITIONS SET COLUMN_DISPLAY_NAME='Code' WHERE COLUMN_NAME='ENUM_SEGMENT_CODE';
UPDATE FCM_UI_COLUMN_DEFINITIONS SET COLUMN_DISPLAY_NAME='Description' WHERE COLUMN_NAME='ENUM_SEGMENT_DESC';
UPDATE FCM_UI_COLUMN_DEFINITIONS SET COLUMN_VISIBLE_IND='0' WHERE COLUMN_NAME='ENUM_LOCALE';
commit;

---------------------------------------------------------------------------------
--
-- UPDATE FCM_PROPERTY for  analyst.alert.uncheckout.interval
--
---------------------------------------------------------------------------------
UPDATE FCM_PROPERTY SET PROPERTY_DESC = 'The maximum time interval (in minutes) that an alert can be checked out. If this time is exceeded, then the alert is automatically checked in.'
WHERE PROPERTY_NAME= 'analyst.alert.uncheckout.interval';
commit;

---------------------------------------------------------------------------------
--
-- UPDATE FCM_PROPERTY for ose_os_type make property visible
--
---------------------------------------------------------------------------------
UPDATE FCM_PROPERTY SET PROPERTY_VISIBLE_IND='1'
WHERE PROPERTY_NAME= 'ose_os_type';
commit;
 
---------------------------------------------------------------------------------
--
-- UPDATE FCM_PROPERTY change YXX properties to IXX
--
---------------------------------------------------------------------------------
UPDATE FCM_PROPERTY
SET PROPERTY_NAME = REPLACE(PROPERTY_NAME,'YXX','IXX'),
	PROPERTY_DESC = REPLACE(PROPERTY_DESC,'YXX','IXX'),
	PROPERTY_LABEL = REPLACE(PROPERTY_LABEL,'YXX','IXX')
WHERE PROPERTY_NAME LIKE '%YXX%';
commit;

---------------------------------------------------------------------------------
--
-- UPDATE FCM_FIELD_DEFINITION XML_FIELD_NAME from NOT SUPPORTED for User variables 
--
---------------------------------------------------------------------------------
UPDATE FCM_FIELD_DEFINITION 
	SET FIELD_BUSINESSNAME_EDIT = FIELD_BUSINESSNAME
	, XML_FIELD_NAME = FIELD_BUSINESSNAME
	, FIELD_VISIBLE_IND='1'
	WHERE SEGMENT_ID IN (SELECT SEGMENT_ID FROM FCM_SEGMENT_DEFINITION WHERE TENANT_MULTI_ORG_ID IS NOT NULL);
commit;
---------------------------------------------------------------------------------
--
-- Insert new FCM_ENTITY_DETAIL_METADATA 
--
---------------------------------------------------------------------------------
merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'verification' as GROUP_NAME,'DOBLastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert   (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('verification',      'DOBLastUpdateDate', 'date',     null,       0,            0,            0, 'system');
commit;

merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'contact' as GROUP_NAME,'addressLastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'addressLastUpdateDate', 'date',              null,       0,            0,            0, 'system');
commit;

merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'contact' as GROUP_NAME,'homePhone1LastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'homePhone1LastUpdateDate', 'date',  null,       0,            0,            0, 'system');
commit;

merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'contact' as GROUP_NAME,'homePhone2LastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'homePhone2LastUpdateDate', 'date',  null,       0,            0,            0, 'system');
commit;

merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'contact' as GROUP_NAME,'workPhone1LastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'workPhone1LastUpdateDate', 'date',    null,       0,            0,            0, 'system');
commit;

merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'contact' as GROUP_NAME,'workPhone2LastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'workPhone2LastUpdateDate', 'date',    null,       0,            0,            0, 'system');
commit;

merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'contact' as GROUP_NAME,'mobilePhone1LastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'mobilePhone1LastUpdateDate', 'date', null,       0,            0,            0, 'system');
commit;

merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'contact' as GROUP_NAME,'mobilePhone2LastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'mobilePhone2LastUpdateDate', 'date', null,       0,            0,            0, 'system');
commit;

merge into FCM_ENTITY_DETAIL_METADATA 
USING (select 'contact' as GROUP_NAME,'emailLastUpdateDate' as PROPERTY from dual) ac
                  ON (FCM_ENTITY_DETAIL_METADATA.GROUP_NAME = ac.GROUP_NAME and FCM_ENTITY_DETAIL_METADATA.PROPERTY=ac.PROPERTY)
when not matched then
insert  (GROUP_NAME, PROPERTY, TYPE, MASKING_TYPE, SECURED, FULFILLMENT_VAR, CALL_SCRIPT_VAR, CREATE_USER)
values ('contact',              'emailLastUpdateDate', 'date',   null,       0,            0,            0, 'system');
commit;

---------------------------------------------------------------------------------
--
-- Insert new FCM_LOV 
--
---------------------------------------------------------------------------------
merge into FCM_LOV
USING (select 'verification.DOBLastUpdateDate' as LOV_CODE,'entityDetail' as LOV_TYPE from dual) ac
                  ON (FCM_LOV.LOV_CODE = ac.LOV_CODE and FCM_LOV.LOV_TYPE=ac.LOV_TYPE)
when not matched then
INSERT
(LOV_ID,   LOV_CODE,        LOV_TYPE,          LOV_LOCALE,    LOV_SORT_ORDER,        LOV_DESC,                LOV_STATUS_IND,          LOV_INTERNAL_USE_IND,          CREATE_USER)
VALUES
(LOV_SEQ.nextval, 'verification.DOBLastUpdateDate', 'entityDetail', 'en_US', 72, 'DOB Last Update Date',                '1',            '0',            'system');
commit;



---------------------------------------------------------------------------------
--
-- Update FCM_PROPERTY with new API Version Number
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY
USING (select 'msg_api_version' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when  matched then
UPDATE 
 set PROPERTY_VALUE='M040403'
;
commit;

---------------------------------------------------------------------------------
--
-- Insert new FCM_PROPERTY 
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY
USING (select 'analyst.disableRealTimeFetch' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_id,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, PROPERTY_SUB_TYPE,  PROPERTY_SUB_TYPE_LABEL,CREATE_USER,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND)
VALUES
(property_seq.nextval,'analyst.disableRealTimeFetch', 'false', 'Turn off real time fetch of demographics if value is set to true.', 'Disable Real Time Fetch', 'AnalystWorkstation', 'DEFAULT', 'DEFAULT','system','0','1')
;
commit;

merge into FCM_PROPERTY
USING (select 'max_client_input_segment_length' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_id,property_type,property_label,property_name,property_value,property_desc,property_editable_ind,property_visible_ind,property_sub_type,property_sub_type_label,CREATE_USER)
VALUES
(property_seq.nextval,'RuleTesting','Maximum client input variable segment length','max_client_input_segment_length','22000','The maximum client input variable segment length','0','1','DEFAULT','DEFAULT','system')
;
commit;

merge into FCM_PROPERTY
USING (select 'max_client_input_segments' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_id,property_type,property_label,property_name,property_value,property_desc,property_editable_ind,property_visible_ind,property_sub_type,property_sub_type_label,CREATE_USER)
VALUES
(property_seq.nextval,'RuleTesting','Maximum # of client input variable segments','max_client_input_segments','8','The maximum # of client input variable segments','0','1','DEFAULT','DEFAULT','system')
;
commit;

merge into FCM_PROPERTY
USING (select 'max_client_input_segments_total_length' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_id,property_type,property_label,property_name,property_value,property_desc,property_editable_ind,property_visible_ind,property_sub_type,property_sub_type_label,CREATE_USER)
VALUES
(property_seq.nextval,'RuleTesting','The overall maximum total length for all client input segments','max_client_input_segments_total_length','22000','The overall maximum total length for all client input segments','0','1','DEFAULT','DEFAULT','system')
;
commit;

---------------------------------------------------------------------------------
--
-- Insert I## segment into FCM_SEGMENT_DEFINITION 
--
---------------------------------------------------------------------------------
merge into FCM_SEGMENT_DEFINITION p
USING (select 'I##' as SEGMENT_ACRONYM from dual) ac
                  ON (p.SEGMENT_ACRONYM = ac.SEGMENT_ACRONYM  )
when not matched then
insert (
    SEGMENT_ID, SEGMENT_ID_VERSION, SEGMENT_SORT_ORDER, SEGMENT_LENGTH, SEGMENT_ACRONYM, 
    BASE_SEGMENT_ID, SEGMENT_DESC, SEGMENT_RULE_ACCESSIBLE_IND, SEGMENT_PREFIX_CHAR, SEGMENT_USC_IO_TYPE, 
    SEGMENT_OSE_IO_TYPE, SEGMENT_AGS_IO_TYPE, SEGMENT_TDR_IO_TYPE, SEGMENT_CONSORT_IO_TYPE, TENANT_MULTI_ORG_ID, 
    BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_NBR, LSTUPDT_USER, 
    LSTUPDT_TIMESTAMP, LOGICAL_DEL_IND) 
VALUES (
 	SEGMENT_DEFINITION_SEQ.nextval, '1400##00', 87, 32, ac.SEGMENT_ACRONYM, 
    NULL, 'Client Input Flexible Variable Segment ##', '1', NULL, 'r', 
    'r', 'r', 'r', 'r', NULL, 
    NULL, 'system', CURRENT_TIMESTAMP, 0, 'system', 
    CURRENT_TIMESTAMP, '0')
;

---------------------------------------------------------------------------------
--
-- Insert I## segment fields into FCM_FIELD_DEFINITION 
--
---------------------------------------------------------------------------------
MERGE INTO FCM_FIELD_DEFINITION A USING
 (SELECT
  (select segment_id from fcm_Segment_definition where segment_acronym='I##') as SEGMENT_ID,
  '0' as FIELD_STARTING_POS,
  '8' as FIELD_LENGTH,
  'i##_seg_id_version' as FIELD_NAME,
  'i##_seg_id_version' as FIELD_BUSINESSNAME,
  'i##_seg_id_version' as FIELD_BUSINESSNAME_EDIT,
  'i##SegIdVersion' as XML_FIELD_NAME,
  '""1400##xx" - Uniquely identifies the Ixx segment where xx is the version' as FIELD_DESC,
  '"1400##00"' as EX_SAS_VALUE,
  'Character' as VARIABLE_TYPE,
  '$char8.' as SAS_INFORMAT,
  '$char8.' as SAS_FORMAT,
  '0' as SAS_AGS_BIN_INFORMAT_IND,
  '' as C_VARIABLE_TYPE,
  '' as JAVA_VARIABLE_TYPE,
  'VARCHAR2(8)' as DBMS_VARIABLE_TYPE,
  '' as FIELD_INITIAL_VALUE,
  '1' as SORT_ORDER,
  '0' as FIELD_RULE_ACCESSIBLE_IND,
  '0' as DATA_POP_ENABLED_IND,
  '0' as FIELD_VISIBLE_IND,
  '0' as FIELD_PERMANENT_SELECTION_IND,
  'i##_seg_id_version' as DATA_POP_ATTR_VALUE,
  '' as BEGIN_BUILD_ID,
  '' as END_BUILD_ID,
  '' as MASKING_TYPE,
  '' as CCSPLITCODE,
  '' as BUSINESS_UNIT_ID,
  'system' as CREATE_USER,
  current_timestamp as CREATE_TIMESTAMP,
  '' as LSTUPDT_USER,
  '' as LSTUPDT_TIMESTAMP,
  '0' as LSTUPDT_NBR,
  '0' as LOGICAL_DEL_IND,
  '' as SAS_DISPLAY_FORMAT,
  '' as FIELD_DESC_EDIT
  FROM DUAL) B
ON (A.FIELD_NAME = B.FIELD_NAME )
WHEN NOT MATCHED THEN 
INSERT (
  FIELD_ID, SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, 
  FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, 
  VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, 
  JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, 
  DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, 
  END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, 
  CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
  SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT)
VALUES (
   field_definition_seq.nextval, B.SEGMENT_ID, B.FIELD_STARTING_POS, B.FIELD_LENGTH, B.FIELD_NAME, 
  B.FIELD_BUSINESSNAME, B.FIELD_BUSINESSNAME_EDIT, B.XML_FIELD_NAME, B.FIELD_DESC, B.EX_SAS_VALUE, 
  B.VARIABLE_TYPE, B.SAS_INFORMAT, B.SAS_FORMAT, B.SAS_AGS_BIN_INFORMAT_IND, B.C_VARIABLE_TYPE, 
  B.JAVA_VARIABLE_TYPE, B.DBMS_VARIABLE_TYPE, B.FIELD_INITIAL_VALUE, B.SORT_ORDER, B.FIELD_RULE_ACCESSIBLE_IND, 
  B.DATA_POP_ENABLED_IND, B.FIELD_VISIBLE_IND, B.FIELD_PERMANENT_SELECTION_IND, B.DATA_POP_ATTR_VALUE, B.BEGIN_BUILD_ID, 
  B.END_BUILD_ID, B.MASKING_TYPE, B.CCSPLITCODE, B.BUSINESS_UNIT_ID, B.CREATE_USER, 
  B.CREATE_TIMESTAMP, B.LSTUPDT_USER, B.LSTUPDT_TIMESTAMP, B.LSTUPDT_NBR, B.LOGICAL_DEL_IND, 
  B.SAS_DISPLAY_FORMAT, B.FIELD_DESC_EDIT)
;

MERGE INTO FCM_FIELD_DEFINITION A USING
 (SELECT
  (select segment_id from fcm_Segment_definition where segment_acronym='I##') as SEGMENT_ID,
  '8' as FIELD_STARTING_POS,
  '8' as FIELD_LENGTH,
  'i##_variable_data_length' as FIELD_NAME,
  'Length of the Ixx_variable_data field' as FIELD_BUSINESSNAME,
  'Length of the Ixx_variable_data field' as FIELD_BUSINESSNAME_EDIT,
  'i##VariableDataLength' as XML_FIELD_NAME,
  'Length of the ixx_variable_data field' as FIELD_DESC,
  '"16000"' as EX_SAS_VALUE,
  'Numeric' as VARIABLE_TYPE,
  '8.' as SAS_INFORMAT,
  'Z8.' as SAS_FORMAT,
  '0' as SAS_AGS_BIN_INFORMAT_IND,
  '' as C_VARIABLE_TYPE,
  '' as JAVA_VARIABLE_TYPE,
  'NUMBER(10)' as DBMS_VARIABLE_TYPE,
  '' as FIELD_INITIAL_VALUE,
  '3' as SORT_ORDER,
  '0' as FIELD_RULE_ACCESSIBLE_IND,
  '0' as DATA_POP_ENABLED_IND,
  '0' as FIELD_VISIBLE_IND,
  '0' as FIELD_PERMANENT_SELECTION_IND,
  'i##_variable_data_length' as DATA_POP_ATTR_VALUE,
  '' as BEGIN_BUILD_ID,
  '' as END_BUILD_ID,
  '' as MASKING_TYPE,
  '' as CCSPLITCODE,
  '' as BUSINESS_UNIT_ID,
  'system' as CREATE_USER,
  CURRENT_TIMESTAMP as CREATE_TIMESTAMP,
  '' as LSTUPDT_USER,
  '' as LSTUPDT_TIMESTAMP,
  '0' as LSTUPDT_NBR,
  '0' as LOGICAL_DEL_IND,
  '' as SAS_DISPLAY_FORMAT,
  '' as FIELD_DESC_EDIT
  FROM DUAL) B
ON (A.FIELD_NAME = B.FIELD_NAME )
WHEN NOT MATCHED THEN 
INSERT (
  FIELD_ID, SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, 
  FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, 
  VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, 
  JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, 
  DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, 
  END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, 
  CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
  SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT)
VALUES (
  field_definition_seq.nextval, B.SEGMENT_ID, B.FIELD_STARTING_POS, B.FIELD_LENGTH, B.FIELD_NAME, 
  B.FIELD_BUSINESSNAME, B.FIELD_BUSINESSNAME_EDIT, B.XML_FIELD_NAME, B.FIELD_DESC, B.EX_SAS_VALUE, 
  B.VARIABLE_TYPE, B.SAS_INFORMAT, B.SAS_FORMAT, B.SAS_AGS_BIN_INFORMAT_IND, B.C_VARIABLE_TYPE, 
  B.JAVA_VARIABLE_TYPE, B.DBMS_VARIABLE_TYPE, B.FIELD_INITIAL_VALUE, B.SORT_ORDER, B.FIELD_RULE_ACCESSIBLE_IND, 
  B.DATA_POP_ENABLED_IND, B.FIELD_VISIBLE_IND, B.FIELD_PERMANENT_SELECTION_IND, B.DATA_POP_ATTR_VALUE, B.BEGIN_BUILD_ID, 
  B.END_BUILD_ID, B.MASKING_TYPE, B.CCSPLITCODE, B.BUSINESS_UNIT_ID, B.CREATE_USER, 
  B.CREATE_TIMESTAMP, B.LSTUPDT_USER, B.LSTUPDT_TIMESTAMP, B.LSTUPDT_NBR, B.LOGICAL_DEL_IND, 
  B.SAS_DISPLAY_FORMAT, B.FIELD_DESC_EDIT)
;

MERGE INTO FCM_FIELD_DEFINITION A USING
 (SELECT
  (select segment_id from fcm_Segment_definition where segment_acronym='I##') as SEGMENT_ID,
  '16' as FIELD_STARTING_POS,
  '8' as FIELD_LENGTH,
  'i##_build_num' as FIELD_NAME,
  'I## Build Number' as FIELD_BUSINESSNAME,
  'I## Build Number' as FIELD_BUSINESSNAME_EDIT,
  'i##BuildNum' as XML_FIELD_NAME,
  'Incoming Build Number from the Customer. This build number is used to read the variable' as FIELD_DESC,
  '' as EX_SAS_VALUE,
  'Numeric' as VARIABLE_TYPE,
  '8.' as SAS_INFORMAT,
  'Z8.' as SAS_FORMAT,
  '0' as SAS_AGS_BIN_INFORMAT_IND,
  '' as C_VARIABLE_TYPE,
  '' as JAVA_VARIABLE_TYPE,
  'NUMBER(10)' as DBMS_VARIABLE_TYPE,
  '' as FIELD_INITIAL_VALUE,
  '4' as SORT_ORDER,
  '0' as FIELD_RULE_ACCESSIBLE_IND,
  '0' as DATA_POP_ENABLED_IND,
  '0' as FIELD_VISIBLE_IND,
  '0' as FIELD_PERMANENT_SELECTION_IND,
  'i##_build_num' as DATA_POP_ATTR_VALUE,
  '' as BEGIN_BUILD_ID,
  '' as END_BUILD_ID,
  '' as MASKING_TYPE,
  '' as CCSPLITCODE,
  '' as BUSINESS_UNIT_ID,
  'system' as CREATE_USER,
  CURRENT_TIMESTAMP as CREATE_TIMESTAMP,
  '' as LSTUPDT_USER,
  '' as LSTUPDT_TIMESTAMP,
  '0' as LSTUPDT_NBR,
  '0' as LOGICAL_DEL_IND,
  '' as SAS_DISPLAY_FORMAT,
  '' as FIELD_DESC_EDIT
  FROM DUAL) B
ON (A.FIELD_NAME = B.FIELD_NAME )
WHEN NOT MATCHED THEN 
INSERT (
  FIELD_ID, SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, 
  FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, 
  VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, 
  JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, 
  DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, 
  END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, 
  CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
  SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT)
VALUES (
  field_definition_seq.nextval, B.SEGMENT_ID, B.FIELD_STARTING_POS, B.FIELD_LENGTH, B.FIELD_NAME, 
  B.FIELD_BUSINESSNAME, B.FIELD_BUSINESSNAME_EDIT, B.XML_FIELD_NAME, B.FIELD_DESC, B.EX_SAS_VALUE, 
  B.VARIABLE_TYPE, B.SAS_INFORMAT, B.SAS_FORMAT, B.SAS_AGS_BIN_INFORMAT_IND, B.C_VARIABLE_TYPE, 
  B.JAVA_VARIABLE_TYPE, B.DBMS_VARIABLE_TYPE, B.FIELD_INITIAL_VALUE, B.SORT_ORDER, B.FIELD_RULE_ACCESSIBLE_IND, 
  B.DATA_POP_ENABLED_IND, B.FIELD_VISIBLE_IND, B.FIELD_PERMANENT_SELECTION_IND, B.DATA_POP_ATTR_VALUE, B.BEGIN_BUILD_ID, 
  B.END_BUILD_ID, B.MASKING_TYPE, B.CCSPLITCODE, B.BUSINESS_UNIT_ID, B.CREATE_USER, 
  B.CREATE_TIMESTAMP, B.LSTUPDT_USER, B.LSTUPDT_TIMESTAMP, B.LSTUPDT_NBR, B.LOGICAL_DEL_IND, 
  B.SAS_DISPLAY_FORMAT, B.FIELD_DESC_EDIT)
;

MERGE INTO FCM_FIELD_DEFINITION A USING
 (SELECT
  (select segment_id from fcm_Segment_definition where segment_acronym='I##') as SEGMENT_ID,
  '24' as FIELD_STARTING_POS,
  '8' as FIELD_LENGTH,
  'i##_execution_build_num' as FIELD_NAME,
  'i## Execution Build Number' as FIELD_BUSINESSNAME,
  'i## Execution Build Number' as FIELD_BUSINESSNAME_EDIT,
  'i##ExecutionBuildNum' as XML_FIELD_NAME,
  'Executing Build Number returned from the OSE, if the segment data defined by i##_build_num provided by the customer does not match the segment data definition currently executing within the OSE' as FIELD_DESC,
  '' as EX_SAS_VALUE,
  'Numeric' as VARIABLE_TYPE,
  '8.' as SAS_INFORMAT,
  'Z8.' as SAS_FORMAT,
  '0' as SAS_AGS_BIN_INFORMAT_IND,
  '' as C_VARIABLE_TYPE,
  '' as JAVA_VARIABLE_TYPE,
  'NUMBER(10)' as DBMS_VARIABLE_TYPE,
  '' as FIELD_INITIAL_VALUE,
  '4' as SORT_ORDER,
  '0' as FIELD_RULE_ACCESSIBLE_IND,
  '0' as DATA_POP_ENABLED_IND,
  '0' as FIELD_VISIBLE_IND,
  '0' as FIELD_PERMANENT_SELECTION_IND,
  'i##_build_num' as DATA_POP_ATTR_VALUE,
  '' as BEGIN_BUILD_ID,
  '' as END_BUILD_ID,
  '' as MASKING_TYPE,
  '' as CCSPLITCODE,
  '' as BUSINESS_UNIT_ID,
  'system' as CREATE_USER,
  CURRENT_TIMESTAMP as CREATE_TIMESTAMP,
  '' as LSTUPDT_USER,
  '' as LSTUPDT_TIMESTAMP,
  '0' as LSTUPDT_NBR,
  '0' as LOGICAL_DEL_IND,
  '' as SAS_DISPLAY_FORMAT,
  '' as FIELD_DESC_EDIT
  FROM DUAL) B
ON (A.FIELD_NAME = B.FIELD_NAME )
WHEN NOT MATCHED THEN 
INSERT (
  FIELD_ID, SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, 
  FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, 
  VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, 
  JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, 
  DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, 
  END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, 
  CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
  SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT)
VALUES (
  field_definition_seq.nextval, B.SEGMENT_ID, B.FIELD_STARTING_POS, B.FIELD_LENGTH, B.FIELD_NAME, 
  B.FIELD_BUSINESSNAME, B.FIELD_BUSINESSNAME_EDIT, B.XML_FIELD_NAME, B.FIELD_DESC, B.EX_SAS_VALUE, 
  B.VARIABLE_TYPE, B.SAS_INFORMAT, B.SAS_FORMAT, B.SAS_AGS_BIN_INFORMAT_IND, B.C_VARIABLE_TYPE, 
  B.JAVA_VARIABLE_TYPE, B.DBMS_VARIABLE_TYPE, B.FIELD_INITIAL_VALUE, B.SORT_ORDER, B.FIELD_RULE_ACCESSIBLE_IND, 
  B.DATA_POP_ENABLED_IND, B.FIELD_VISIBLE_IND, B.FIELD_PERMANENT_SELECTION_IND, B.DATA_POP_ATTR_VALUE, B.BEGIN_BUILD_ID, 
  B.END_BUILD_ID, B.MASKING_TYPE, B.CCSPLITCODE, B.BUSINESS_UNIT_ID, B.CREATE_USER, 
  B.CREATE_TIMESTAMP, B.LSTUPDT_USER, B.LSTUPDT_TIMESTAMP, B.LSTUPDT_NBR, B.LOGICAL_DEL_IND, 
  B.SAS_DISPLAY_FORMAT, B.FIELD_DESC_EDIT)
;

COMMIT;

---------------------------------------------------------------------------------
--
-- Insert O## segment into FCM_SEGMENT_DEFINITION 
--
---------------------------------------------------------------------------------
merge into FCM_SEGMENT_DEFINITION p
USING (select 'O##' as SEGMENT_ACRONYM from dual) ac
                  ON (p.SEGMENT_ACRONYM = ac.SEGMENT_ACRONYM  )
when not matched then
insert (
    SEGMENT_ID, SEGMENT_ID_VERSION, SEGMENT_SORT_ORDER, SEGMENT_LENGTH, SEGMENT_ACRONYM, 
    BASE_SEGMENT_ID, SEGMENT_DESC, SEGMENT_RULE_ACCESSIBLE_IND, SEGMENT_PREFIX_CHAR, SEGMENT_USC_IO_TYPE, 
    SEGMENT_OSE_IO_TYPE, SEGMENT_AGS_IO_TYPE, SEGMENT_TDR_IO_TYPE, SEGMENT_CONSORT_IO_TYPE, TENANT_MULTI_ORG_ID, 
    BUSINESS_UNIT_ID, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_NBR, LSTUPDT_USER, 
    LSTUPDT_TIMESTAMP, LOGICAL_DEL_IND) 
VALUES (
 	SEGMENT_DEFINITION_SEQ.nextval, '1500##00', 122, 32, ac.SEGMENT_ACRONYM, 
    NULL, 'Client Output Flexible Variable Segment ##', '1', NULL, 'r', 
    'u', 'r', 'r', NULL, NULL, 
    NULL, 'system', CURRENT_TIMESTAMP, 0, 'system', 
    CURRENT_TIMESTAMP, '0')
;

---------------------------------------------------------------------------------
--
-- Insert O## segment fields into FCM_FIELD_DEFINITION 
--
---------------------------------------------------------------------------------
MERGE INTO FCM_FIELD_DEFINITION A USING
 (SELECT
  (select segment_id from fcm_Segment_definition where segment_acronym='O##') as SEGMENT_ID,
  '0' as FIELD_STARTING_POS,
  '8' as FIELD_LENGTH,
  'o##_seg_id_version' as FIELD_NAME,
  'o##_seg_id_version' as FIELD_BUSINESSNAME,
  'o##_seg_id_version' as FIELD_BUSINESSNAME_EDIT,
  'o##SegIdVersion' as XML_FIELD_NAME,
  '"1500##xx" - Uniquely identifies the Oxx segment where xx is the version' as FIELD_DESC,
  '"1500##00"' as EX_SAS_VALUE,
  'Character' as VARIABLE_TYPE,
  '$char8.' as SAS_INFORMAT,
  '$char8.' as SAS_FORMAT,
  '0' as SAS_AGS_BIN_INFORMAT_IND,
  '' as C_VARIABLE_TYPE,
  '' as JAVA_VARIABLE_TYPE,
  'VARCHAR2(8)' as DBMS_VARIABLE_TYPE,
  '' as FIELD_INITIAL_VALUE,
  '1' as SORT_ORDER,
  '0' as FIELD_RULE_ACCESSIBLE_IND,
  '0' as DATA_POP_ENABLED_IND,
  '0' as FIELD_VISIBLE_IND,
  '0' as FIELD_PERMANENT_SELECTION_IND,
  'o##_seg_id_version' as DATA_POP_ATTR_VALUE,
  '' as BEGIN_BUILD_ID,
  '' as END_BUILD_ID,
  '' as MASKING_TYPE,
  '' as CCSPLITCODE,
  '' as BUSINESS_UNIT_ID,
  'system' as CREATE_USER,
  current_timestamp as CREATE_TIMESTAMP,
  '' as LSTUPDT_USER,
  '' as LSTUPDT_TIMESTAMP,
  '0' as LSTUPDT_NBR,
  '0' as LOGICAL_DEL_IND,
  '' as SAS_DISPLAY_FORMAT,
  '' as FIELD_DESC_EDIT
  FROM DUAL) B
ON (A.FIELD_NAME = B.FIELD_NAME )
WHEN NOT MATCHED THEN 
INSERT (
  FIELD_ID, SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, 
  FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, 
  VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, 
  JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, 
  DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, 
  END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, 
  CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
  SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT)
VALUES (
   field_definition_seq.nextval, B.SEGMENT_ID, B.FIELD_STARTING_POS, B.FIELD_LENGTH, B.FIELD_NAME, 
  B.FIELD_BUSINESSNAME, B.FIELD_BUSINESSNAME_EDIT, B.XML_FIELD_NAME, B.FIELD_DESC, B.EX_SAS_VALUE, 
  B.VARIABLE_TYPE, B.SAS_INFORMAT, B.SAS_FORMAT, B.SAS_AGS_BIN_INFORMAT_IND, B.C_VARIABLE_TYPE, 
  B.JAVA_VARIABLE_TYPE, B.DBMS_VARIABLE_TYPE, B.FIELD_INITIAL_VALUE, B.SORT_ORDER, B.FIELD_RULE_ACCESSIBLE_IND, 
  B.DATA_POP_ENABLED_IND, B.FIELD_VISIBLE_IND, B.FIELD_PERMANENT_SELECTION_IND, B.DATA_POP_ATTR_VALUE, B.BEGIN_BUILD_ID, 
  B.END_BUILD_ID, B.MASKING_TYPE, B.CCSPLITCODE, B.BUSINESS_UNIT_ID, B.CREATE_USER, 
  B.CREATE_TIMESTAMP, B.LSTUPDT_USER, B.LSTUPDT_TIMESTAMP, B.LSTUPDT_NBR, B.LOGICAL_DEL_IND, 
  B.SAS_DISPLAY_FORMAT, B.FIELD_DESC_EDIT)
;

MERGE INTO FCM_FIELD_DEFINITION A USING
 (SELECT
  (select segment_id from fcm_Segment_definition where segment_acronym='O##') as SEGMENT_ID,
  '8' as FIELD_STARTING_POS,
  '8' as FIELD_LENGTH,
  'o##_variable_data_length' as FIELD_NAME,
  'Length of the Oxx_variable_data field' as FIELD_BUSINESSNAME,
  'Length of the Oxx_variable_data field' as FIELD_BUSINESSNAME_EDIT,
  'o##VariableDataLength' as XML_FIELD_NAME,
  'Length of the Oxx_variable_data field' as FIELD_DESC,
  '"16000"' as EX_SAS_VALUE,
  'Numeric' as VARIABLE_TYPE,
  '8.' as SAS_INFORMAT,
  'Z8.' as SAS_FORMAT,
  '0' as SAS_AGS_BIN_INFORMAT_IND,
  '' as C_VARIABLE_TYPE,
  '' as JAVA_VARIABLE_TYPE,
  'NUMBER(10)' as DBMS_VARIABLE_TYPE,
  '' as FIELD_INITIAL_VALUE,
  '3' as SORT_ORDER,
  '0' as FIELD_RULE_ACCESSIBLE_IND,
  '0' as DATA_POP_ENABLED_IND,
  '0' as FIELD_VISIBLE_IND,
  '0' as FIELD_PERMANENT_SELECTION_IND,
  'o##_variable_data_length' as DATA_POP_ATTR_VALUE,
  '' as BEGIN_BUILD_ID,
  '' as END_BUILD_ID,
  '' as MASKING_TYPE,
  '' as CCSPLITCODE,
  '' as BUSINESS_UNIT_ID,
  'system' as CREATE_USER,
  CURRENT_TIMESTAMP as CREATE_TIMESTAMP,
  '' as LSTUPDT_USER,
  '' as LSTUPDT_TIMESTAMP,
  '0' as LSTUPDT_NBR,
  '0' as LOGICAL_DEL_IND,
  '' as SAS_DISPLAY_FORMAT,
  '' as FIELD_DESC_EDIT
  FROM DUAL) B
ON (A.FIELD_NAME = B.FIELD_NAME )
WHEN NOT MATCHED THEN 
INSERT (
  FIELD_ID, SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, 
  FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, 
  VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, 
  JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, 
  DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, 
  END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, 
  CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
  SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT)
VALUES (
  field_definition_seq.nextval, B.SEGMENT_ID, B.FIELD_STARTING_POS, B.FIELD_LENGTH, B.FIELD_NAME, 
  B.FIELD_BUSINESSNAME, B.FIELD_BUSINESSNAME_EDIT, B.XML_FIELD_NAME, B.FIELD_DESC, B.EX_SAS_VALUE, 
  B.VARIABLE_TYPE, B.SAS_INFORMAT, B.SAS_FORMAT, B.SAS_AGS_BIN_INFORMAT_IND, B.C_VARIABLE_TYPE, 
  B.JAVA_VARIABLE_TYPE, B.DBMS_VARIABLE_TYPE, B.FIELD_INITIAL_VALUE, B.SORT_ORDER, B.FIELD_RULE_ACCESSIBLE_IND, 
  B.DATA_POP_ENABLED_IND, B.FIELD_VISIBLE_IND, B.FIELD_PERMANENT_SELECTION_IND, B.DATA_POP_ATTR_VALUE, B.BEGIN_BUILD_ID, 
  B.END_BUILD_ID, B.MASKING_TYPE, B.CCSPLITCODE, B.BUSINESS_UNIT_ID, B.CREATE_USER, 
  B.CREATE_TIMESTAMP, B.LSTUPDT_USER, B.LSTUPDT_TIMESTAMP, B.LSTUPDT_NBR, B.LOGICAL_DEL_IND, 
  B.SAS_DISPLAY_FORMAT, B.FIELD_DESC_EDIT)
;

MERGE INTO FCM_FIELD_DEFINITION A USING
 (SELECT
  (select segment_id from fcm_Segment_definition where segment_acronym='O##') as SEGMENT_ID,
  '16' as FIELD_STARTING_POS,
  '8' as FIELD_LENGTH,
  'o##_build_num' as FIELD_NAME,
  'o## Build Number' as FIELD_BUSINESSNAME,
  'o## Build Number' as FIELD_BUSINESSNAME_EDIT,
  'o##BuildNum' as XML_FIELD_NAME,
  'Build Number from the Customer. This build number is used by the OSE to know the structure to serialize back' as FIELD_DESC,
  '' as EX_SAS_VALUE,
  'Numeric' as VARIABLE_TYPE,
  '8.' as SAS_INFORMAT,
  'Z8.' as SAS_FORMAT,
  '0' as SAS_AGS_BIN_INFORMAT_IND,
  '' as C_VARIABLE_TYPE,
  '' as JAVA_VARIABLE_TYPE,
  'NUMBER(10)' as DBMS_VARIABLE_TYPE,
  '' as FIELD_INITIAL_VALUE,
  '4' as SORT_ORDER,
  '0' as FIELD_RULE_ACCESSIBLE_IND,
  '0' as DATA_POP_ENABLED_IND,
  '0' as FIELD_VISIBLE_IND,
  '0' as FIELD_PERMANENT_SELECTION_IND,
  'o##_build_num' as DATA_POP_ATTR_VALUE,
  '' as BEGIN_BUILD_ID,
  '' as END_BUILD_ID,
  '' as MASKING_TYPE,
  '' as CCSPLITCODE,
  '' as BUSINESS_UNIT_ID,
  'system' as CREATE_USER,
  CURRENT_TIMESTAMP as CREATE_TIMESTAMP,
  '' as LSTUPDT_USER,
  '' as LSTUPDT_TIMESTAMP,
  '0' as LSTUPDT_NBR,
  '0' as LOGICAL_DEL_IND,
  '' as SAS_DISPLAY_FORMAT,
  '' as FIELD_DESC_EDIT
  FROM DUAL) B
ON (A.FIELD_NAME = B.FIELD_NAME )
WHEN NOT MATCHED THEN 
INSERT (
  FIELD_ID, SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, 
  FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, 
  VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, 
  JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, 
  DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, 
  END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, 
  CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
  SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT)
VALUES (
  field_definition_seq.nextval, B.SEGMENT_ID, B.FIELD_STARTING_POS, B.FIELD_LENGTH, B.FIELD_NAME, 
  B.FIELD_BUSINESSNAME, B.FIELD_BUSINESSNAME_EDIT, B.XML_FIELD_NAME, B.FIELD_DESC, B.EX_SAS_VALUE, 
  B.VARIABLE_TYPE, B.SAS_INFORMAT, B.SAS_FORMAT, B.SAS_AGS_BIN_INFORMAT_IND, B.C_VARIABLE_TYPE, 
  B.JAVA_VARIABLE_TYPE, B.DBMS_VARIABLE_TYPE, B.FIELD_INITIAL_VALUE, B.SORT_ORDER, B.FIELD_RULE_ACCESSIBLE_IND, 
  B.DATA_POP_ENABLED_IND, B.FIELD_VISIBLE_IND, B.FIELD_PERMANENT_SELECTION_IND, B.DATA_POP_ATTR_VALUE, B.BEGIN_BUILD_ID, 
  B.END_BUILD_ID, B.MASKING_TYPE, B.CCSPLITCODE, B.BUSINESS_UNIT_ID, B.CREATE_USER, 
  B.CREATE_TIMESTAMP, B.LSTUPDT_USER, B.LSTUPDT_TIMESTAMP, B.LSTUPDT_NBR, B.LOGICAL_DEL_IND, 
  B.SAS_DISPLAY_FORMAT, B.FIELD_DESC_EDIT)
;

MERGE INTO FCM_FIELD_DEFINITION A USING
 (SELECT
  (select segment_id from fcm_Segment_definition where segment_acronym='O##') as SEGMENT_ID,
  '24' as FIELD_STARTING_POS,
  '8' as FIELD_LENGTH,
  'o##_execution_build_num' as FIELD_NAME,
  'o## Execution Build Number' as FIELD_BUSINESSNAME,
  'o## Execution Build Number' as FIELD_BUSINESSNAME_EDIT,
  'o##ExecutionBuildNum' as XML_FIELD_NAME,
  'Executing Build Number returned from the OSE, if the segment data defined by o##_build_num provided by the customer does not match the segment data definition currently executing within the OSE' as FIELD_DESC,
  '' as EX_SAS_VALUE,
  'Numeric' as VARIABLE_TYPE,
  '8.' as SAS_INFORMAT,
  'Z8.' as SAS_FORMAT,
  '0' as SAS_AGS_BIN_INFORMAT_IND,
  '' as C_VARIABLE_TYPE,
  '' as JAVA_VARIABLE_TYPE,
  'NUMBER(10)' as DBMS_VARIABLE_TYPE,
  '' as FIELD_INITIAL_VALUE,
  '4' as SORT_ORDER,
  '0' as FIELD_RULE_ACCESSIBLE_IND,
  '0' as DATA_POP_ENABLED_IND,
  '0' as FIELD_VISIBLE_IND,
  '0' as FIELD_PERMANENT_SELECTION_IND,
  'o##_execution_build_num' as DATA_POP_ATTR_VALUE,
  '' as BEGIN_BUILD_ID,
  '' as END_BUILD_ID,
  '' as MASKING_TYPE,
  '' as CCSPLITCODE,
  '' as BUSINESS_UNIT_ID,
  'system' as CREATE_USER,
  CURRENT_TIMESTAMP as CREATE_TIMESTAMP,
  '' as LSTUPDT_USER,
  '' as LSTUPDT_TIMESTAMP,
  '0' as LSTUPDT_NBR,
  '0' as LOGICAL_DEL_IND,
  '' as SAS_DISPLAY_FORMAT,
  '' as FIELD_DESC_EDIT
  FROM DUAL) B
ON (A.FIELD_NAME = B.FIELD_NAME )
WHEN NOT MATCHED THEN 
INSERT (
  FIELD_ID, SEGMENT_ID, FIELD_STARTING_POS, FIELD_LENGTH, FIELD_NAME, 
  FIELD_BUSINESSNAME, FIELD_BUSINESSNAME_EDIT, XML_FIELD_NAME, FIELD_DESC, EX_SAS_VALUE, 
  VARIABLE_TYPE, SAS_INFORMAT, SAS_FORMAT, SAS_AGS_BIN_INFORMAT_IND, C_VARIABLE_TYPE, 
  JAVA_VARIABLE_TYPE, DBMS_VARIABLE_TYPE, FIELD_INITIAL_VALUE, SORT_ORDER, FIELD_RULE_ACCESSIBLE_IND, 
  DATA_POP_ENABLED_IND, FIELD_VISIBLE_IND, FIELD_PERMANENT_SELECTION_IND, DATA_POP_ATTR_VALUE, BEGIN_BUILD_ID, 
  END_BUILD_ID, MASKING_TYPE, CCSPLITCODE, BUSINESS_UNIT_ID, CREATE_USER, 
  CREATE_TIMESTAMP, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
  SAS_DISPLAY_FORMAT, FIELD_DESC_EDIT)
VALUES (
  field_definition_seq.nextval, B.SEGMENT_ID, B.FIELD_STARTING_POS, B.FIELD_LENGTH, B.FIELD_NAME, 
  B.FIELD_BUSINESSNAME, B.FIELD_BUSINESSNAME_EDIT, B.XML_FIELD_NAME, B.FIELD_DESC, B.EX_SAS_VALUE, 
  B.VARIABLE_TYPE, B.SAS_INFORMAT, B.SAS_FORMAT, B.SAS_AGS_BIN_INFORMAT_IND, B.C_VARIABLE_TYPE, 
  B.JAVA_VARIABLE_TYPE, B.DBMS_VARIABLE_TYPE, B.FIELD_INITIAL_VALUE, B.SORT_ORDER, B.FIELD_RULE_ACCESSIBLE_IND, 
  B.DATA_POP_ENABLED_IND, B.FIELD_VISIBLE_IND, B.FIELD_PERMANENT_SELECTION_IND, B.DATA_POP_ATTR_VALUE, B.BEGIN_BUILD_ID, 
  B.END_BUILD_ID, B.MASKING_TYPE, B.CCSPLITCODE, B.BUSINESS_UNIT_ID, B.CREATE_USER, 
  B.CREATE_TIMESTAMP, B.LSTUPDT_USER, B.LSTUPDT_TIMESTAMP, B.LSTUPDT_NBR, B.LOGICAL_DEL_IND, 
  B.SAS_DISPLAY_FORMAT, B.FIELD_DESC_EDIT)
;

COMMIT;

---------------------------------------------------------------------------------
--
-- shift segments sort order 
--
---------------------------------------------------------------------------------
update FCM_SEGMENT_DEFINITION set segment_sort_order=157 where segment_acronym='Z##';
update FCM_SEGMENT_DEFINITION set segment_sort_order=192 where segment_acronym='L##';
update FCM_SEGMENT_DEFINITION set segment_sort_order=227 where segment_acronym like 'V%' and segment_sort_order=157;
update FCM_SEGMENT_DEFINITION set segment_sort_order=segment_sort_order+70 where segment_acronym like 'V%' and segment_sort_order>=157 and segment_sort_order <> 227 ;
update FCM_SEGMENT_DEFINITION set segment_sort_order=262 where segment_acronym='CQF';
update FCM_SEGMENT_DEFINITION set segment_sort_order=263 where segment_acronym='WAX';
update FCM_SEGMENT_DEFINITION set segment_sort_order=264 where segment_acronym='RUX';
commit;

---------------------------------------------------------------------------------
--
-- Insert new FCM Component Segments 
--
---------------------------------------------------------------------------------

INSERT INTO FCM_COMPONENT_SEGMENT(
   COMPONENT_VALUE_ID
  ,SEGMENT_ID
  ,CREATE_TIMESTAMP
  ,CREATE_USER
  ,LSTUPDT_NBR
  ,LSTUPDT_USER
  ,LSTUPDT_TIMESTAMP
  ,LOGICAL_DEL_IND
) VALUES (
   (select component_value_id from fcm_component_value where component_value='CMD')
   ,(select segment_id from fcm_segment_definition where segment_acronym='L##')
  ,CURRENT_TIMESTAMP
  ,'system'
  ,0
  ,'system'
  ,CURRENT_TIMESTAMP
  ,'0' 
);
INSERT INTO FCM_COMPONENT_SEGMENT(
   COMPONENT_VALUE_ID
  ,SEGMENT_ID
  ,CREATE_TIMESTAMP
  ,CREATE_USER
  ,LSTUPDT_NBR
  ,LSTUPDT_USER
  ,LSTUPDT_TIMESTAMP
  ,LOGICAL_DEL_IND
) VALUES (
   (select component_value_id from fcm_component_value where component_value='TRX')
   ,(select segment_id from fcm_segment_definition where segment_acronym='I##')
  ,CURRENT_TIMESTAMP
  ,'system'
  ,0
  ,'system'
  ,CURRENT_TIMESTAMP
  ,'0' 
);
INSERT INTO FCM_COMPONENT_SEGMENT(
   COMPONENT_VALUE_ID
  ,SEGMENT_ID
  ,CREATE_TIMESTAMP
  ,CREATE_USER
  ,LSTUPDT_NBR 
  ,LSTUPDT_USER
  ,LSTUPDT_TIMESTAMP
  ,LOGICAL_DEL_IND
) VALUES (
   (select component_value_id from fcm_component_value where component_value='TRX')
   ,(select segment_id from fcm_segment_definition where segment_acronym='O##')
  ,CURRENT_TIMESTAMP
  ,'system'
  ,0
  ,'system'
  ,CURRENT_TIMESTAMP
  ,'0' 
);
commit;

---------------------------------------------------------------------------------
--
-- Delete Transaction Components 
--
---------------------------------------------------------------------------------

delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DEE' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraEntity') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DCH' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ChargeDet') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMM'  and transaction_name = 'Terminal Owner (Merchant) Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMM'  and transaction_name = 'Terminal Owner (Merchant) Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DEE' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraEntity') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMM'  and transaction_name = 'Terminal Owner (Merchant) Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMT'  and transaction_name = 'Terminal Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMT'  and transaction_name = 'Terminal Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DEE' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraEntity') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MAMT'  and transaction_name = 'Terminal Masterfile' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DNX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='NMonEntTxf') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DNX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NMonEntTxf') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DMX' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraModling') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DEE' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ExtraEntity') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
delete from fcm_transaction_component where component_value_id =  (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm') and transaction_id=(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1');
commit;

---------------------------------------------------------------------------------
--
-- Insert New Transaction Components 
--
---------------------------------------------------------------------------------
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCBF'  and transaction_name = 'Credit Card Account Bill Payment/Fund Transfer to Third Party or self account' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCDP'  and transaction_name = 'Credit Card Account Deposit/Payment' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCUK'  and transaction_name = 'Credit Card Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCUK'  and transaction_name = 'Credit Card Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCUK'  and transaction_name = 'Credit Card Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCNM'  and transaction_name = 'Credit Card Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CCSH'  and transaction_name = 'Credit Card Account Bill Payment/Fund Transfer Scheduling & Cancellation' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSBF'  and transaction_name = 'Checking/Savings Account Bill Payment/Fund Transfer to Third Party or self account' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSDP'  and transaction_name = 'Checking/Savings Account Deposit/Payment' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSUK'  and transaction_name = 'Checking/Savings Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSUK'  and transaction_name = 'Checking/Savings Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSUK'  and transaction_name = 'Checking/Savings Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSNM'  and transaction_name = 'Checking/Savings Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSSH'  and transaction_name = 'Checking/Savings Account Bill Payment/Fund Transfer Scheduling & Cancellation' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'N' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='NonAppChan'),(select transaction_id from fcm_transaction_definition where transaction_acronym='CSAE'  and transaction_name = 'Checking/Savings Account Batch ACH submission Entry Records' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCBF'  and transaction_name = 'Line of Credit Account Bill Payment/Fund Transfer to Third Party or self account' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCDP'  and transaction_name = 'Line of Credit Account Deposit/Payment' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCUK'  and transaction_name = 'Line of Credit Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCUK'  and transaction_name = 'Line of Credit Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCUK'  and transaction_name = 'Line of Credit Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCNM'  and transaction_name = 'Line of Credit Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='LCSH'  and transaction_name = 'Line of Credit Account Bill Payment/Fund Transfer Scheduling & Cancellation' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NAUK'  and transaction_name = 'N/A Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NAUK'  and transaction_name = 'N/A Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NAUK'  and transaction_name = 'N/A Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='NANM'  and transaction_name = 'N/A Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLBF'  and transaction_name = 'Secured Loan Account Bill Payment/Fund Transfer to Third Party or self account' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLDP'  and transaction_name = 'Secured Loan Account Deposit/Payment' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLUK'  and transaction_name = 'Secured Loan Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLUK'  and transaction_name = 'Secured Loan Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLUK'  and transaction_name = 'Secured Loan Account Unknown Activity' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #2' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DPP' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='NewPayeeItm'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLNM'  and transaction_name = 'Secured Loan Account Non-mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'E' and  component_type = 'CHANNEL' and component_type_desc='Channel' and component_value_name='PayCardODTLS'),(select transaction_id from fcm_transaction_definition where transaction_acronym='SLSH'  and transaction_name = 'Secured Loan Account Bill Payment/Fund Transfer Scheduling & Cancellation' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUS' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='OnUsTranDet'),(select transaction_id from fcm_transaction_definition where transaction_acronym='MAFM'  and transaction_name = 'Merchant Account Financial Transaction' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DUA' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #1' and component_value_name='UserAuthReq'),(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
insert into fcm_transaction_component (component_value_id,transaction_id,create_timestamp,create_user,LSTUPDT_NBR) values ( (select component_value_id from fcm_component_value where component_value = 'DCH' and  component_type = 'ACTIVITY' and component_type_desc='Activity Details #3' and component_value_name='ChargeDet'),(select transaction_id from fcm_transaction_definition where transaction_acronym='MANM'  and transaction_name = 'Merchant Account Non-Mon' and STOCK_DEFINITION_IND='1'), current_timestamp, 'system',0);
commit;

---------------------------------------------------------------------------------
--
-- Insert new OXX Purge Days properties
--
---------------------------------------------------------------------------------

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLSH_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLSH_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLSH_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLNM_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLNM_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLNM_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLMF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLMF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLMF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLDP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLDP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLDP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLCW_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLCW_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLCW_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLCP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLCP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLCP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLCK_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLCK_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLCK_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLCA_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLCA_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLCA_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_SLBF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_SLBF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_SLBF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_NANM_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_NANM_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_NANM_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_NAMP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_NAMP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_NAMP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_NAMO_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_NAMO_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_NAMO_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_NAMF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_NAMF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_NAMF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_NAME_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_NAME_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_NAME_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_MANM_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_MANM_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_MANM_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_MAMF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_MAMF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_MAMF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_MAFM_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_MAFM_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_MAFM_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCSH_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCSH_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCSH_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCNM_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCNM_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCNM_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCMF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCMF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCMF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCDP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCDP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCDP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCCW_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCCW_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCCW_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCCP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCCP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCCP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCCK_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCCK_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCCK_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCCA_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCCA_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCCA_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_LCBF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_LCBF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_LCBF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSSH_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSSH_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSSH_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSNM_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSNM_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSNM_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSMF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSMF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSMF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSDP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSDP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSDP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSCW_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSCW_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSCW_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSCP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSCP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSCP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSCK_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSCK_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSCK_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSCA_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSCA_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSCA_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSBF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSBF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSBF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSAE_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSAE_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSAE_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CSAB_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CSAB_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CSAB_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CCSH_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CCSH_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CCSH_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CCNM_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CCNM_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CCNM_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CCMF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CCMF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CCMF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CCDP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CCDP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CCDP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CCCP_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CCCP_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CCCP_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CCCA_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CCCA_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CCCA_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_CCBF_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_CCBF_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_CCBF_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');

MERGE INTO FCM_PROPERTY A
     USING (SELECT 'FCM_BRST_OXX_PURGE_DAYS' AS PROPERTY_NAME,
                   '180' AS PROPERTY_VALUE,
                   'Retention days of FCM_BRST_OXX' AS PROPERTY_DESC,
                   'Retention days of FCM_BRST_OXX' AS PROPERTY_LABEL,
                   'tdrdbmaint' AS PROPERTY_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE,
                   'DEFAULT' AS PROPERTY_SUB_TYPE_LABEL,
                   '1' AS PROPERTY_EDITABLE_IND,
                   '1' AS PROPERTY_VISIBLE_IND
              FROM DUAL) B
        ON (A.PROPERTY_NAME = B.PROPERTY_NAME)
WHEN NOT MATCHED
THEN
   INSERT     (PROPERTY_ID,
               PROPERTY_NAME,
               PROPERTY_VALUE,
               PROPERTY_DESC,
               PROPERTY_LABEL,
               PROPERTY_TYPE,
               PROPERTY_SUB_TYPE,
               PROPERTY_SUB_TYPE_LABEL,
               PROPERTY_EDITABLE_IND,
               PROPERTY_VISIBLE_IND,
               CREATE_TIMESTAMP,
               CREATE_USER,
               LSTUPDT_NBR,
               LOGICAL_DEL_IND)
       VALUES (property_seq.NEXTVAL,
               B.PROPERTY_NAME,
               B.PROPERTY_VALUE,
               B.PROPERTY_DESC,
               B.PROPERTY_LABEL,
               B.PROPERTY_TYPE,
               B.PROPERTY_SUB_TYPE,
               B.PROPERTY_SUB_TYPE_LABEL,
               B.PROPERTY_EDITABLE_IND,
               B.PROPERTY_VISIBLE_IND,
               CURRENT_TIMESTAMP,
               'sas',
               0,
               '0');
commit;
---------------------------------------------------------------------------------
--
-- Insert version release 4.4.0.2 
--
---------------------------------------------------------------------------------

merge into fcm_version p
USING (select 'SOR Base DDL' as VERSION_NAME,'4.4.0.2' as VERSION_NUM from dual) ac
                  ON (p.VERSION_NAME = ac.VERSION_NAME AND p.VERSION_NUM=ac.VERSION_NUM )
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) 
VALUES (
 	'SOR Base DDL', '4.4.0.2', current_date, '4.4 M0 HF2 DDL', 'SOR DDL')
;
commit;
