---------------------------------------------------------------------------------
--
-- UPDATE FCM_PROPERTY 
--
---------------------------------------------------------------------------------
merge into FCM_PROPERTY
USING (select 'analyst.maxNumberOfCheckouts' as PROPERTY_NAME from dual) ac
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT
(property_id,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, PROPERTY_SUB_TYPE,  PROPERTY_SUB_TYPE_LABEL,CREATE_USER,PROPERTY_EDITABLE_IND,PROPERTY_VISIBLE_IND)
VALUES
(property_seq.nextval,'analyst.maxNumberOfCheckouts', '3'
, 'Specifies the maximum number of contacts that an analyst can have alerts checked out at one time. Each alert without contact counts 1 towards the total. A value of 0 means unlimited checkouts.'
, 'Analyst Maximum Checkouts', 'AnalystWorkstation', 'DEFAULT', 'DEFAULT','system','1','1')
;
commit;


update fcm_property set logical_del_ind='1' where PROPERTY_NAME='analyst.maxNumberOfAlerts';
commit;

---------------------------------------------------------------------------------
--
-- Insert version release 4.4.0.3
--
---------------------------------------------------------------------------------
merge into fcm_version p
USING (select 'SOR Base DDL' as VERSION_NAME,'4.4.0.3' as VERSION_NUM from dual) ac
                  ON (p.VERSION_NAME = ac.VERSION_NAME AND p.VERSION_NUM=ac.VERSION_NUM )
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) 
VALUES (
 	'SOR Base DDL', '4.4.0.3', current_date, '4.4 M0 HF3 DDL', 'SOR DDL')
;
commit;