/*
 * Parsing SAS EFM Analytics Report Configuration File
 * 
 * Author: Song, Qiang <qiang.song@sas.com> 2014
 * 
 */

options nocenter ps=max ls=max compress=yes obs=max;

options mprint;

%let xmlfile=%sysget(xmlfile);

%include "macros/rptcfg_extract_param_dst.mac";
%include "macros/rptcfg_extract_frh_table_info.sas";
%include "macros/rptcfg_extract_recode_text.mac";
%include "macros/rptcfg_create_dirs.sas";

%let report_root=../;
%rptcfg_create_dirs(xmlfile = &xmlfile);

libname devdata "&report_root./production_reports/development_data/";

%rptcfg_extract_param_dst(xmlfile = &xmlfile,
                          out = devdata.parameters_daily,
                          type = daily);

%rptcfg_extract_frh_table_info(xmlfile = &xmlfile,
                               frh_table_info = devdata.frh_table_info_daily,
                               type = daily);

%rptcfg_extract_recode_master(xmlfile = &xmlfile,
                              recodedir = ../production_reports/sas/include/,
                              type = daily);

title "daily report specification";
proc print width = min
    data = devdata.parameters_daily;
run;

proc sql;
    select * from devdata.frh_table_info_daily;
run;


%rptcfg_extract_param_dst(xmlfile = &xmlfile,
                          out = devdata.parameters_monthly,
                          type = monthly);

%rptcfg_extract_frh_table_info(xmlfile = &xmlfile,
                               frh_table_info = devdata.frh_table_info_monthly,
                               type = monthly);

%rptcfg_extract_recode_master(xmlfile = &xmlfile,
                              recodedir = ../production_reports/sas/include/,
                              type = monthly);


title "monthly report specification";
proc print width = min
    data = devdata.parameters_monthly;
run;

proc sql;
    select * from devdata.frh_table_info_monthly;
quit;
