%macro add_nobs_to_config2;

data _temp_config;
 set &config_ds;
      length type merge_var1 merge_var2 $32;
      TYPE=upcase(strip("&TYPE"));  **create type as a ds variable to resolve timing issues;
  merge_var1=STRIP(TYPE)||"_REPORT_VAR_"||STRIP(VARCOUNT);
  IF DRILL_NUMBER NE . THEN MERGE_VAR2="TD_"||STRIP(TYPE)||"_REPORT_VAR_"||STRIP(VARCOUNT)||"_DV_"||STRIP(DRILL_NUMBER);
 run;

data _null_;
  set _temp_config END=LAST;
	IF DRILL_NUMBER NE . THEN DO;
	  call execute("DATA TD_"||STRIP(TYPE)||"_REPORT_VAR_"||STRIP(VARCOUNT)||"_DV_"||STRIP(DRILL_NUMBER)||";");
	  call execute(" SET "||STRIP(TYPE)||"_REPORT_VAR_"||STRIP(VARCOUNT)||"_DV_"||STRIP(DRILL_NUMBER)||";");
	  call execute("by drill_var_"||strip(drill_number)||";");
	  call execute("if first.drill_var_"||strip(DRILL_NUMBER)||" then COUNT+1;"); 
	  call execute("if count=2 then stop; drop count;");
	  call execute("run;");
	END;
run;

*----- The code below adds the number of levels for variables in the main reports and drill reports -----*;

data _temp_config2;
  set _temp_config;
  length nobs nobs2 8; call missing(nobs,nobs2);

  if _n_=1 then do;
     declare hash addmain(dataset: 'sashelp.vtable(where=(libname="WORK") keep=libname memname nobs rename=(memname=merge_var1))');
        addmain.definekey('merge_var1');
        addmain.definedata('nobs');
        addmain.definedone();
  end;

  rc=addmain.find(); 

    if _n_=1 then do;
     declare hash adddrill(dataset: 'sashelp.vtable(where=(libname="WORK") keep=libname memname nobs rename=(memname=merge_var2 nobs=nobs2))');
        adddrill.definekey('merge_var2');
        adddrill.definedata('nobs2');
        adddrill.definedone();
  end;

  rc2=adddrill.find();

  rename nobs=number_obs_main
         nobs2=number_obs_drill;
run;

%mend add_nobs_to_config2;
