%macro cfpr_table(inds= ,title= ,cellwidth=1.0in, fontsize=2, cfpr_cutoff=160);


%delit(ds=temp_qqq);

data temp_qqq;
 set &inds;
 cfpr_string=cats(cfpr,":1");
 if cfpr=0 then delete;
 holder=1;
 run;

ods proclabel "Model Performance Overview";

proc report data=temp_qqq contents="";
 title "VDR, CDR, Outsort Rate at Specified CFPR Values";
 title2 "&title";
 columns CFPR_String  CDR VDR Outsort holder;
 define CFPR_string/"CFPR" style(column)=[just=center  font_weight=bold font_size=&fontsize cellwidth=&cellwidth];
 define CDR/display format=10.2 style(column)=[font_size=&fontsize font_weight=bold cellwidth=&cellwidth];
 define VDR/display format=10.2 style(column)=[font_size=&fontsize  font_weight=bold cellwidth=&cellwidth];
 define Outsort/display "Outsort Rate" format=percent10.2 style(column)=[font_size=&fontsize  font_weight=bold cellwidth=&cellwidth];
 define holder/order noprint;
 break before holder/page contents='';
 where CFPR<=&cfpr_cutoff;
 run;

 %delit(ds=temp_qqq);

 %mend cfpr_table;
