/*
 * Database Specific data conversion
 *
 * Author: Song, Qiang <qiang.song@sas.com> 2015
 *
 */

%macro db_specific_data_conversion;
    /* Oracle database */
    /* In oracle database, any fields with date or time format are
        converted to datetime values. When we retrieve those values,
        we need to convert them back */
    %if %lowcase(&rh_db_source) eq oracle %then %do;
        RHX_DATE_KEY=DATEPART(RHX_DATE_KEY);
        RQO_TRAN_DATE=DATEPART(RQO_TRAN_DATE);
        RQO_TRAN_TIME=TIMEPART(RQO_TRAN_TIME);
    %end;
%mend db_specific_data_conversion;
