%macro drillprep2;
*-----------------------------------------------------------------------*
|  Define Report Level Variables Into Macro Variable List               |
*-----------------------------------------------------------------------*;

*** I do not think I need the following - need to verify ;

proc sql noprint;
 select distinct report_variable
 into :report_variable separated by " "
 from &config_ds;

%put report_variable:  &report_variable;

*-----------------------------------------------------------------------*
|  Subset Card Level Reporting Variables for Special Processing         |
*-----------------------------------------------------------------------*;

proc sql;
 create table Card_Level_Vars as
 select distinct report_variable, report_variable_label, aggregation_type, aggregation_function, aggregation_variable, varcount
 from &config_ds
 where upcase(aggregation_type) in('G','R')
 order by varcount;

proc sql;
create table card_level_vars_prod as
select one.*, two.*
from work.card_level_vars as one,
     work.date_range(keep=start end label where=(start ne '**OTHER**')) as two
order by varcount, label;  ***label should be date sequenced;

*** the following seqno is added for variable names used in tabulate output ***;

data date_range;
 length seqno 8;
  set date_range;
  seqno=_n_;
run;

*-----------------------------------------------------------------------*
|  Index by Drill Variables for Subsequent By Group Processing          |
*-----------------------------------------------------------------------*;


data &output_recode_ds(index=(%do j=1 %to &numdrill; drill_var_&j %end;));
 set work.report_in_recode;

format rqo_tran_date date7. rqo_tran_time time8.2;
/***** The following code will likely not be used since
  %if %sysfunc(exist(work.report_in_drillout)) and &numdrill ge 1 %then %str(set work.report_in_drillout;);
  %else set work.report_in_recode;   **** use report_in_drillout if drill variables exist, otherwise use report_in_recode;
****/

************ need to put drill card after definition for all drill code created;

%do j=1 %to &numdrill;
  drill_var_&j=put(&&drill_var_&j,&&drill_down_format_&j);
%end;

run;


*---------------------------------------------------------------------------------*
|  Put the Format on the Drill Down Variable - but Could Just Use New Alias - TBD |
*---------------------------------------------------------------------------------*;


%if &numdrill ge 1 %then %do;  ***only format if drill down variables exist; 
%if %index(&output_recode_ds,.) %then %do; %let libref=%scan(&output_recode_ds,1,.); %let dsname=%scan(&output_recode_ds,2,.); %end;
                                %else %do; %let libref=WORK; %let dsname=&output_recode_ds; %end;
data _null_;
 set work.drill_list end=last;

if _n_=1 then do;       
        call execute("proc datasets library=&libref nolist nodetails;");
        call execute("modify &dsname;");
        call execute("format");
end;

call execute(Strip(Drill_Down_Variable)||" "||Drill_Down_Format);

if last then do;
        call execute(";");
        call execute("run;");
        call execute("quit;");
end;
run;

proc sql;
 create table drill_labels as
 select distinct drill_vname, drill_down_label
 from &config_ds
 where drill_vname ne " ";

data _null_;
 set work.drill_labels end=last;

 if _n_=1 then do;       
        call execute("proc datasets library=&libref nolist nodetails;");
        call execute("modify &dsname;");
        call execute("label");
end;

call execute(Strip(drill_vname)||"="||quote(strip(Drill_Down_Label)));

if last then do;
        call execute(";");
        call execute("run;");
        call execute("quit;");
end;
run;

%end;

%mend drillprep2;
