 %macro final_reports_quarterly(qtrlib= , reportfile=, portid =  );

*---------------------------------------------------* 
| Setup Parameters                                  | 
*---------------------------------------------------*; 

%let qtrlib=%upcase(&qtrlib);
%let keep_temp_ds=N;  **debugging parameter;

%prep_driver_ds_interpolate_ds(qtrlib=&qtrlib);

*---------------------------------------------------* 
| Report Generation                                 | 
*---------------------------------------------------*; 


ods pdf body="&reportfile" contents=no style=analysis  pdftoc=1 ;


options orientation=landscape;
%gen_parameter_page(portid=&portid);

%basic_stats(driver_ds=stat_current, interior_cellwidth=1.5in, title=Descriptive Statistics, dollar_fmt=dollar15.);

%cfpr_table(inds=&qtrlib..&current_ds,title=%str(&current_lab),cellwidth=1.0in,fontsize=3.0,cfpr_cutoff=160);

%plot_quarterly(ds=work.c_eval_driver,
                yaxis=CDR,
	            xaxis=CFPR,
				xaxis_options=%str( values=(0 to 100 by 10) minor grid),
				yaxis_options=%str(minor grid),
                title=CDR vs. CFPR,
	            where_statement=%str(CFPR<=100));

%cfpr_outsort_charts(base=CFPR,metrics=CDR,report_levels=10 to 200 BY 10, interior_cellwidth=1.5in, title2=);

%plot_quarterly(ds=work.c_eval_driver,
	            yaxis=VDR,
				xaxis=CFPR,
				xaxis_options=%str(values=(0 to 100 by 10) minor grid),
				yaxis_options=%str(minor grid),
                title=VDR vs. CFPR,
	            where_statement=%str(CFPR<=100));

%cfpr_outsort_charts(base=CFPR,metrics=VDR ,report_levels=10 to 200 BY 10, interior_cellwidth=1.5in, title2=);

%plot_quarterly(ds=work.o_eval_driver,
                yaxis=CDR,
	            xaxis=Outsort,
				xaxis_options=%str(label="Outsort Rate" values=(0.000 to 0.020 by 0.002) minor tickvalueformat=percent10.2 grid),
				yaxis_options=%str(minor grid),
                title=CDR vs. OUTSORT,
	            where_statement=%str(outsort<=0.02));
%cfpr_outsort_charts(base=outsort,metrics=CDR,report_levels=0.001 to 0.020 by 0.001, interior_cellwidth=1.5in, title2=);

%plot_quarterly(ds=work.o_eval_driver,
	            yaxis=VDR,
				xaxis=Outsort,
				xaxis_options=%str(label="Outsort Rate" values=(0.000 to 0.020 by 0.002) minor tickvalueformat=percent10.2 grid),
				yaxis_options=%str(minor grid),
                title=VDR vs. OUTSORT,
	            where_statement=%str(outsort<=0.020));

%cfpr_outsort_charts(base=outsort,metrics=VDR,report_levels=0.001 to 0.020 by 0.001, interior_cellwidth=1.5in, title2=);



%gain_table_onepage(inds =&qtrlib..&current_ds_raw, cwidth=0.60in, blankwidth=0.40in);

ods pdf close;

%if %upcase(&keep_temp_ds) eq N %then %do;
%delit(ds=eval);
%delit(ds=eval_current);
%delit(ds=stat);
%delit(ds=stat_current);
%delit(ds=work.functions);
%delit(ds=check_format);

proc datasets library=work memtype=view nodetails nolist kill; run; quit;
%end;

%mend final_reports_quarterly;
