/*
 * Generate summary page of evaluation parameters
 * 
 * Author: Song, Qiang <qiang.song@sas.com> 2015
 * 
 */


%macro gen_parameter_page(portid = );
    data _tmp_params_;
        length parameter $30 description $60;
		holder=1;
        label parameter = "Parameter";
        label description = "Value";        

        %if %length(&portid) ne 0 %then %do;
        parameter = "Portfolio";
        description = "&portid";
        output;
        %end;    

        parameter = "Replacement window days cutoff";
        description = "&replacement_win_days";
        output;

        parameter = "Replacement window transaction cutoff";
        description = "&replacement_win_trans";
        output;

        parameter = "No recontact days";
        description = "&no_recontact_days";
        output;

        parameter = "Evaluation window begin date";
        description = "&TSTART";
        output;

        parameter = "Evaluation window end date";
        description = "&TEND";
        output;
        
        parameter = "Maximum amount cutoff";
        description = "&MAXAMT";
        output;

    run;

ods proclabel "Report Parameters";

    proc report data = _tmp_params_ contents="";
        column parameter description holder;
        define parameter / display;
        define description / display;
		define holder/order noprint;
		break before holder/page contents='';

        title "Report Parameters";
    run;

    %delete_dataset(_tmp_params_);
    
%mend gen_parameter_page;
    
