%macro groupeddata_prep;

*-----------------------------------------------------------------------*
|  Create a Card Level Summary Files to be used for separate reports    |
*-----------------------------------------------------------------------*;

%numobs(data=card_level_vars_prod,macrovar=num_card_vars);   *** handle the case with no card level variables;

********************* the following is overall - need to create a ds for each drill down level ********************************;
%if &num_card_vars ge 1 %then %do;
        data Card_Level_Vars_prod;
         set Card_Level_Vars_prod END=LAST;
         by report_variable NOTSORTED;
    aggregation_type=upcase(aggregation_type);
     if first.report_variable then count=0;
         Count+1;  *** counter of card level variables variable **;
      ***if first.report_variable then varcount+1;
     if aggregation_type='R' then suffix='_R'; else suffix=" ";
         label count="Sequence of Time Period - Based on Format and spacing within Format";

     length rv_short_name $27 vname $32;
     rv_short_name=report_variable; DROP rv_short_name;
     vname=cats(rv_short_name,"_TP_",count);

                call execute("proc sql  undopolicy=NONE;");
                call execute(" create table work.temp_clev_var_"||strip(varcount)||"_period_"||strip(count)||" as");
                call execute(" select "||strip(aggregation_variable)||",");       
                                if aggregation_variable in('rqo_card_num','hqo_card_num') and aggregation_type='R' then call execute("max(wts_var) as wts_var,"); 
                                else call execute("sum(wts_var) as wts_var,");  *** other aggregations need sum of weights; **card level aggregations get 1 weight per card**;
                call execute(strip(aggregation_function)||" as "||strip(rv_short_name)||"_TP_"||strip(count));
                call execute("label='"||strip(label)||"'");
                call execute("from &output_recode_ds");
                if start=end then call execute("where rqo_tran_date="||strip(start));
                             else call execute("where "||start||"<=rqo_tran_date<="||left(end));
                call execute("group by "||strip(aggregation_variable));
                call execute("order by "||strip(aggregation_variable)||";");

       if aggregation_type='R' then do;
                 call execute(" create table Temp_clev_var_"||strip(varcount)||"_period_"||strip(count)||"_R as ");
                 call execute(" select "||strip(vname)||" as "||strip(report_variable)||" label=' ', ");
                 call execute("         sum(wts_var) as "||strip(vname));
                 call execute("label='"||strip(label)||"'");
                 call execute(" from work.temp_clev_var_"||strip(varcount)||"_period_"||strip(count));
                 call execute(" group by "||strip(report_variable));
                 call execute(" order by "||strip(report_variable)||";"); 
                end;

               if last then call execute("quit;");

       if last.report_variable then do;

        

            call execute("Data report_in_clev_var"||strip(varcount)||";");
                call execute("Merge ");
                   do k=1 to count;
                     call execute("work.temp_clev_var_"||strip(varcount)||"_period_"||strip(k)||strip(suffix));
                   end;
                    call execute(";");
                if aggregation_type='G' then call execute("by "||strip(aggregation_variable)||";");
                                if aggregation_type='R' then call execute("by "||strip(report_variable)||";");
                call execute(" run;");

                        if aggregation_type='R' then do; **this parts create merged interim datasets of type='R' that are needed for plots and percentile reports**;
            
            call execute("Data percentile_in_clev_var"||strip(varcount)||";");
                call execute("Merge ");
                   do k=1 to count;
                     call execute("work.temp_clev_var_"||strip(varcount)||"_period_"||strip(k));
                   end;
                    call execute(";");
                call execute("by "||strip(aggregation_variable)||";");
                call execute(" run;");
                        end;

       end;
         drop k; 
       run;
%****end; *** move this to end of this macro;
********************************* end of overall coding ******************************************************************************;

*-----------------------------------------------------------------------*
|  Derive a separate Parameter File for Card Level Drill Downs          |
*-----------------------------------------------------------------------*;
%if &numdrill GE 1 %then %do;
%if %sysfunc(exist(card_level_vars_prod_drill)) %then %do; proc delete data=card_level_vars_prod_drill; run; %end;

proc sql;
create table card_level_vars_prod_drill as
select one.*, two.drill_vname, two.drill_down_label
from card_level_vars_prod as one
inner join &config_ds as two
on one.report_variable=two.report_variable
where drill_vname ne " "
order by varcount, drill_vname, count;

%numobs(data=card_level_vars_prod_drill,macrovar=clevel_drills);   *** handle the case with no card level variables;

********************* the following is or each drill down level ********************************;
%if &clevel_drills ge 1 %then %do;

data _null_;
  set card_level_vars_prod_drill END=LAST;
   by report_variable NOTSORTED;
   aggregation_type=upcase(aggregation_type);
    length drill_number 8;  *** SHOULD NOT HAVE TO REDERIVE THIS HERE ANYMORE - VERIFY THIS;
   drill_number=scan(drill_vname,3,"_");

                call execute("proc sql  undopolicy=NONE;");
                call execute(" create table clevl_var_"||strip(varcount)||"_dv_"||strip(drill_number)||"_tp_"||strip(count)||" as ");
                call execute(" select "||strip(Aggregation_Variable)||", "||strip(drill_vname)||",");          
                if aggregation_variable in('rqo_card_num','hqo_card_num') AND aggregation_type='R' then call execute("max(wts_var) as wts_var,"); 
                                else call execute("sum(wts_var) as wts_var,");  *** other aggregations need sum of weights; **card level aggregations get 1 weight per card**;
                call execute(strip(aggregation_function)||" as "||strip(vname)||" ");
                  call execute("label='"||strip(label)||"'");
                call execute("from &output_recode_ds");
        if start=end then call execute("where rqo_tran_date="||strip(start));
                             else call execute("where "||start||"<=rqo_tran_date<="||left(end));
                call execute("group by "||strip(Aggregation_Variable)||", "||strip(drill_vname));
                call execute("order by "||strip(Aggregation_Variable)||", "||strip(drill_vname)||";");
           if last then call execute("quit;");

 **** NOTE reaggregation is currently only available for 'count' variables ***;
 **** Reaggregation is needed only for variables where we do not care about the specific values of aggregation variable ***;
                
                if aggregation_type='R' then do;
                 call execute("proc sql  undopolicy=NONE;");
                 call execute(" create table clevl_var_"||strip(varcount)||"_dv_"||strip(drill_number)||"_tp_"||strip(count)||"_R as ");
                 call execute(" select "||strip(vname)||" as "||strip(report_variable)||" label=' ', "||strip(drill_vname)||", ");
                 call execute("         sum(wts_var) as "||strip(vname));
                 call execute("label='"||strip(label)||"'");
                 call execute(" from clevl_var_"||strip(varcount)||"_dv_"||strip(drill_number)||"_tp_"||strip(count));
                 call execute(" group by "||strip(report_variable)||", "||strip(drill_vname));
                 call execute(" order by "||strip(report_variable)||", "||strip(drill_vname)||";");
                 if last then call execute("quit;");

                end;
 run;

*-----------------------------------------------------------------------*
|  Need to Loop Back Through to Creat the final Merged Dataset          |
*-----------------------------------------------------------------------*;

data _null_;
  set card_level_vars_prod_drill END=LAST;
   by report_variable drill_vname NOTSORTED;
   aggregation_type=upcase(aggregation_type);

    length drill_number 8;
    drill_number=scan(drill_vname,3,"_");

        if aggregation_type='R' then suffix='_R'; else suffix=" ";


                 if first.drill_vname then do;
            call execute("Data clev_var_"||strip(varcount)||"_dv_"||strip(drill_number)||"(index=("||strip(drill_vname)||"));");
                call execute("Merge ");
                 end;

       
             call execute("work.clevl_var_"||strip(varcount)||"_dv_"||strip(drill_number)||"_tp_"||strip(count)||strip(suffix));
        

         if last.drill_vname then do;
                   call execute(";");
                   if aggregation_type='G' then call execute("by "||strip(aggregation_variable)||" "||strip(drill_vname)||";");
                                   if aggregation_type='R' then call execute("by "||strip(report_variable)||" "||strip(drill_vname)||";");
                   call execute(" run;");
         end;
run;

data _null_;
  set card_level_vars_prod_drill END=LAST;
   by report_variable drill_vname NOTSORTED;
   aggregation_type=upcase(aggregation_type);

    length drill_number 8;
    drill_number=scan(drill_vname,3,"_");

       if aggregation_type='R' and last.drill_vname then do; **this parts create merged interim datasets of type='R' that are needed for plots and   reports**;
            
            call execute("Data percentile_in_clev_var"||strip(varcount)||"_dv_"||strip(drill_number)||"(index=("||strip(drill_vname)||"));");
                call execute("Merge ");
                   do k=1 to count;
                      call execute("work.clevl_var_"||strip(varcount)||"_dv_"||strip(drill_number)||"_tp_"||strip(k));
                   end;
                    call execute(";");
                call execute("by "||strip(aggregation_variable)||" "||strip(drill_vname)||";");
                call execute(" run;");
                 end;

      
run;

%end;

%end;
%end;  *** moved overall loop end here;
%mend groupeddata_prep;
