/*
 * Macro to parse analytic report configuration file
 * 
 * Author: Song, Qiang <qiang.song@sas.com> 2014
 * 
 */

%macro rptcfg_extract_recode_master(xmlfile = , recodedir = , type = );
/* DOCSSTRING
#input
- xmlfile: path to the location of the XML configuration file; do not include quotations

#output
- recodefile: path to the location of an include file containing recoding statements
   END DOCSTRING */

    proc sql noprint;
        create view _frh_table_list_ as
            select distinct frh_table
            from rptcfg.reports(where = (type in  ("all", "&type")));
    quit;

    data _null_;
        set _frh_table_list_;
        call execute('%nrstr(%rptcfg_extract_recode_text)'
                     || '('
                     || catx(", ", "recodefile=" || cats("&recodedir","/","recode_",frh_table,"_","&type..sas"),
                                   "frh_table=" || strip(frh_table),
                                   "type=&type",
                                   "rptcfg=rptcfg")
                     || ');');
    run;    
    
%mend;
