%macro run_evaluation_mac(
    in = ,
    out = ,
    rh_sampling_rate = 1,          /* non-fraud case sampling rate */    
    rh_sampling_rate_fraud = 1          /* fraud case sampling rate */    
    );

    %local srate;
    %let srate = %sysevalf(&rh_sampling_rate / &rh_sampling_rate_fraud);
    
    %evalData(&in,
              &out,
              SRATE = &srate.,
              RECONTACT_DAYS = &no_recontact_days,
              MAX_AMOUNT = &MAXAMT,
/*              TRAN_FILTER = %quote(&tran_filter), */
/*              EXCLUDE_PREFRAUD = 99999,  */
/*              RESCALE_SCORE = &RESCALE_SCORE,   ???? */
/*              INCLUDE_POSTINGS = 0, */
              ALL_TRAN_TYPES = 0);

    proc sort data = &out;
        by cutoff;
    run;

%mend run_evaluation_mac;
